# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands
package require dialogs

Declare addcommand -variable cmdUpdateModel -name "Update Model" -statusmessage "Update model based on the selected elements" -tooltip "Update model from selection" -accelerator "Ctrl+U" -imagefile "" -onactivatecommand OnUpdateModel -onenablecommand OnEnableUpdateModel


# Adds menus and registers commands and sources all update model scripts
proc Init {} {
	AddCommand cmdUpdateModel
	AddMenu -variable mn -commands { "separator" cmdUpdateModel } -path { &Tools} -position { last }
	AddContextMenu -variable cntxtMenu -commands { "separator" cmdUpdateModel } -onenablemenu OnEnableUpdateModel
	SourceScripts
}

# Initialises the Active Modeler output tab and calls update model for all
# elements is the current selection
proc OnUpdateModel { command } {
	global selection
	SetOption AutoCheck 0
	ReportInit "Active Modeler" -ident TTDACTIVEMODELLER Element 150 0 Action 100 0 Details 700 0
	UpdateModel $selection
	SetOption AutoCheck 1
}

# Calls all registered update model procedures for each supplied element
# If there are several procedures registered for a meta class, they are 
# sorted and called in ascending alphabetical order.
proc UpdateModel { elements } {
	foreach element $elements {
		set metaclass [Class $element]
		set updateCommands [lsort [info commands "UpdateModel$metaclass*"]]
		if {[llength $updateCommands] > 0} {
			foreach updateCommand $updateCommands {
				AMReport $element "Update Model" "Update $metaclass from $updateCommand"
				$updateCommand $element
			}
		}
	}
}

# The Update Model command is enabled when the selection contains only presentation elements,
# and there is a registered Update Model procedure for at least one of them.
proc OnEnableUpdateModel { ident } {
	global selection
	foreach element $selection {
		if { ([GetKind $element] == "U2") && [IsKindOf $element "PresentationElement"] } {
			set metaclass [Class $element]
			set updateCommands [info commands "UpdateModel$metaclass*"]
			if {[llength $updateCommands] > 0} {
				return 1
			}
		}
	}
	return 0
}

# Sources all tcl scripts found in the UpdateModelScripts folder of the addin.
# This means this folder can be used both for UpdateModel scripts and utilities.
# Each script can contain any number of UpdateModel procedures
proc SourceScripts {} {
	set dir [GetInstallationDirectory]addins/ActiveModeler/UpdateModelScripts
	foreach file [glob -nocomplain -directory $dir *.tcl] {
		if ![file isdirectory $file] {
			if [catch { source $file } err] {
				Output "\nWarning! Error during tcl evaluation:\n$err\n(file '$file')"
			}
		}
	}
}

# A reporting function for the Active Modeler framework.
proc AMReport { element action details } {
	Report $element -ident TTDACTIVEMODELLER $action "     $details"
}

Init
