# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# Updates the model from a InteractionOccurrenceSymbol (reference symbol)
# Creates a new use case with sequence diagram in the same context as
# the use case of the reference. The name of the symbol is used to name
# the new use case. If no name is supplied, the default name will be used.
#
# Known limitations: 
# 	Qualified names are not handled. The name of the new use case is
#	set to the full text of the symbol
#
proc UpdateModelInteractionOccurrenceSymbol { symbol } {
	if ![IsKindOf $symbol InteractionOccurrenceSymbol] {
		error "Element $symbol is a '[Class $symbol]', but should be a 'InteractionOccurrenceSymbol'"
	}

	# Do nothing if state name is already bound
	set me [GetA $symbol ModelElement]
	if {[GetA $me Operation] != 0} {
		return
	}

	set usecaseName [string trim [GetA $symbol Text] ']
	set diagram [GetA $symbol Owner]
	set interaction [GetA $diagram Owner]
	set operation [GetA $interaction Specification]
	if { $operation == 0 } {
		set operation [GetA $interaction ImplementedSignature]
	}
	set context [GetA $operation Owner]

	set usecase [CreateIn $context Operation]

	if { $usecaseName != "" } {
		SetA $usecase Name $usecaseName
	} else {
		SetText $symbol [GetA $usecase Name]
	}

	set newStereotype [u2::CreateInstance [u2::FindByGuid [GetSession $symbol] "@Predefined@usecase"]]
	u2::SetEntity $usecase StereotypeInstance $newStereotype
	
	AMReport $usecase "Create" "Created use case '[GetA $usecase Name]' in [Class $context] '[GetA $context Name]'"

	set interaction [CreateIn $usecase Interaction]
	CreateIn $interaction SequenceDiagram
}
