// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#ifdef TOR_USE_INSTRUMENTATION

#include "torPlatform.h"

#include "torCoders.h"
#include <stdio.h>

using namespace tor::meta;

void tor::meta::StringCoderBuffer::write(const Charstring& str) {
    buffer += str;
}

void tor::meta::StringCoderBuffer::clear() {
    buffer = _T("");
}

namespace {
    void writeIdent(const tor::Charstring& strIdent, CoderBuffer& buf) {
        bool bShouldWriteQuotes=(strIdent.length()>1); // single char can not be reserved ident and should be parsed ok
        if(bShouldWriteQuotes) buf.write(_T("'"));
        buf.write(strIdent);
        if(bShouldWriteQuotes) buf.write(_T("'"));
    }
}

void tor::meta::U2P_Coder::encode(const Value* value, CoderBuffer& buffer) {
    if (const StructuredValue* sv = dynamic_cast<const StructuredValue*>(value)) {
	Type* type = sv->getType();
	if (type) 
	    writeIdent(type->name, buffer);

	buffer.write(_T(" (."));
	for (StructuredValue::List::const_iterator it = sv->assignments.begin();
	     it != sv->assignments.end();) {

	    Assignment* a = *it;
	    StructuralFeature* lhs = a->LHS;
	    Value* rhs = a->RHS;
	    writeIdent(lhs->name, buffer);
	    buffer.write(_T("="));
	    encode(rhs, buffer);
	    it++;
	    if (it != sv->assignments.end())
		buffer.write(_T(", "));
	}
	buffer.write(_T(".)"));
    }
    else if (const SimpleValue* siv = dynamic_cast<const SimpleValue*>(value)) {
	if (siv->isInteger()) {
	    TCHAR buf[16]; // More than enough for the largest integer we can represent
            stprintf_number(buf, siv->m_integer);
	    buffer.write(Charstring(buf));
	}
	else if (siv->isBoolean()) {
	    if (siv->m_boolean == true)
		buffer.write(_T("true"));
	    else
		buffer.write(_T("false"));
	}
	else if (siv->isIdentifier()) {
	    Definition* def = siv->m_definition;
	    buffer.write(def->name);
	}
	else if (siv->isPointer()) {
	    TCHAR buf[16];
	    stprintf_address(buf, siv->m_pointer);
	    buffer.write(Charstring(buf));
	}
    }
}

Value* tor::meta::U2P_Coder::decode(CoderBuffer& buffer) {
    // TODO: Implement a simple expression parser here

    return 0;
}

#endif

