/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
///////////////////////////////////////////////////////////////////////////////
// torCoders.h
// ---------------
// Definition of the coder interface, realized by coder classes that can
// encode data of a TOR-based application into a string representation.
// The file also contains some predefined coder classes.
///////////////////////////////////////////////////////////////////////////////

#ifndef __TOR_METACODERS__H__
#define __TOR_METACODERS__H__

#ifdef TOR_USE_INSTRUMENTATION

#include "torPlatform.h"

#include "torTypes.h"
#include "torMetaData.h"

namespace tor {

    namespace meta {

	// Interface for coder buffers where the result of an encoding is put.
	class TOR_EXT_DEF CoderBuffer {
	public:
	    // Writes a string to the buffer.
	    virtual void write(const tor::Charstring& str) = 0;
	};

	// Standard string based coder buffer
	class TOR_EXT_DEF StringCoderBuffer : public CoderBuffer {
	public:
	    virtual void write(const tor::Charstring& str);

            virtual ~StringCoderBuffer() {}

	    void clear();

	    tor::Charstring buffer;
	};

	//////////////////////////////////////////////////////////////////////////
	
	// Each coder class shall implement this interface.
	class TOR_EXT_DEF Coder {
	public:
	    // Encodes the value into the buffer.
	    virtual void encode(const Value* value, CoderBuffer& buffer) = 0;

	    // Decodes the buffer contents into a value.
	    virtual Value* decode(CoderBuffer& buffer) = 0;
	};

	// Coder based on U2P instance syntax.
	class TOR_EXT_DEF U2P_Coder : public Coder {
	public:
	    virtual void encode(const meta::Value* value, CoderBuffer& buffer);

	    virtual meta::Value* decode(CoderBuffer& buffer);

            virtual ~U2P_Coder() {}
	};


    } // namespace meta

} // namespace tor

#endif

#endif // __TOR_METACODERS__H__

