// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torDispatchableClass.h"
#include "torDispatcher.h"
#include "torEvent.h"
#include "torEventQueue.h"
#include "torStateMachine.h"
#include "torPort.h"

#include "torMetaEvents.h"
#include "torEventManager.h"

tor::DispatchableClass::~DispatchableClass() 
{  
  if (m_dispatcher) {
    // Remove ourselves from the dispatcher
    m_dispatcher->remove(this);
    m_dispatcher = 0;
  }
}


// If this instance is associated with an event queue, mark
// it as the receiver of the event, insert it into the queue
// and mark it as consumed

bool tor::DispatchableClass::receive(Event *event)
{
    if (m_eventQueue != 0)
    {
        event->m_receiver = InstanceManager::instance().getIdFromExecutor(this);
        m_eventQueue->insert(event);
        return true; // Event consumed
    }
    return false; // Event not consumed
}

#if defined(TOR_USE_INSTRUMENTATION) && !defined(TOR_NO_EVENTMANAGER)
bool 
tor::DispatchableClass::receive(Event* e, const Entity& receiver, meta::Type* eventMetaType)
{
    if (!InternalEvent::isTypeOf(e)) // Do not trace internal events
        meta::EventManager::processEvent(new meta::EventReceived(e, receiver, new meta::StructuredValue(eventMetaType)));

    return DispatchableClass::receive(e);
}
#endif

void
tor::DispatchableClass::init()
{
  // Initialize the statemachine if found
  StateMachine* stateMachine = getClassifierBehavior();
  if (stateMachine)
    stateMachine->init();
}

void 
tor::DispatchableClass::finish()
{
  if (m_dispatcher) {
    // Remove ourselves from the dispatcher
    m_dispatcher->remove(this);
    m_dispatcher = 0;
  }
  
  // Disconnect the architecture
  disconnect();
}

void 
tor::DispatchableClass::start()
{
  StateMachine* stateMachine = getClassifierBehavior();
  if (stateMachine)
    stateMachine->start();
}

tor::Dispatchable::EventAction tor::DispatchableClass::execute(Event *event)
{
    m_currentEvent = event;
    Dispatchable::EventAction ea = Dispatchable::NoMatch;
    StateMachine *stateMachine = getClassifierBehavior();
    if (stateMachine) 
    {
        ea = stateMachine->execute(event);
    }
    m_currentEvent = 0;
    return ea;
}

void 
tor::DispatchableClass::disconnect()
{
  // EMPTY. Subclasses should disconnect all ports.    
}

bool tor::DispatchableClass::send(Event *e)
{
    std::list<Port *>::iterator i = m_listOutPorts.begin();
    while (i != m_listOutPorts.end())
    {
        Port *p = *i++;
        if (p == 0)
        {
            continue;
        }
        bool received = p->send(e, false /* deleteEvent */);
        if (received)
        {
            return true;
        }
    }
    
    // Not received. Delete the event.
    delete e;

    return false;
}

#if defined(TOR_USE_INSTRUMENTATION) && !defined(TOR_NO_EVENTMANAGER)
bool tor::DispatchableClass::send(Event *e, const Entity& sender, meta::Type* eventMetaType)
{
    if (!InternalEvent::isTypeOf(e)) // Do not trace internal events
        meta::EventManager::processEvent(new meta::EventSent(e, sender, new meta::StructuredValue(eventMetaType)));

    return send(e);
}
#endif

