/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
///////////////////////////////////////////////////////////////////////////////
// torEventMedia.h
// ---------------
// Definition of the EventMedia interface, realized by classes that represent
// medias onto which encoded meta events can be emitted.
// The file also contains some predefined event media classes.
///////////////////////////////////////////////////////////////////////////////

#ifndef __TOR_EVENTMEDIA__H__
#define __TOR_EVENTMEDIA__H__

#ifdef TOR_USE_INSTRUMENTATION

#include "torPlatform.h"

#include "torTypes.h"

namespace tor 
{
    namespace meta 
    {
	// A media to which encoded meta events can be emitted.
	class TOR_EXT_DEF EventMedia
        {
	public:
            // Construction of an event media. Set registerMedia to false in order to
            // register the event media at the EventManager at a later point in time.
            EventMedia(bool registerMedia);
	    virtual ~EventMedia() {}

	    // Emit a string to the event media
            virtual void emit(const Charstring& str) = 0;
        };

        //////////////////////////////////////////////////////////////////////////
        
        class TOR_EXT_DEF EventMediaImpl : public EventMedia
        {
	public:
            // Construction of an event media. Set registerMedia to false in order to
            // register the event media at the EventManager at a later point in time.
            EventMediaImpl(EventMedia *impl, bool registerMedia);
	    virtual ~EventMediaImpl() {delete m_impl;}

	    // Emit a string to the event media
            virtual void emit(const Charstring& str) {m_impl->emit(str);}

        protected:
            EventMedia *m_impl;
        };

	//////////////////////////////////////////////////////////////////////////
    
	// This event media writes each encoded meta event to a log file.
	class TOR_EXT_DEF LogFile : public EventMediaImpl
        {
	public:
	    LogFile(const Charstring &strFileName, bool registerMedia = true);
            void flush();
	};

        //////////////////////////////////////////////////////////////////////////
        
        // This event media sends each encoded meta event to a host Tau IDE.        
        class TOR_EXT_DEF TauHostTracer : public EventMediaImpl
        {
        public:
            TauHostTracer(bool registerMedia = true);
            ~TauHostTracer() {}
        };

    } // namespace meta

} // namespace tor

#endif

#endif // __TOR_EVENTMEDIA__H__

