// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torOs.h"
#include "torEventQueue.h"
#include "torEvent.h"
#include <algorithm>
#include <functional>
#include <assert.h>

namespace tor
{
    EventQueue::EventQueue()
    {}

    EventQueue::~EventQueue()
    {}

    void EventQueue::insert(Event *event)
    {
        if (event == 0)
            return;

        assert(find(m_list.begin(), m_list.end(), event) == m_list.end());

        m_list.push_back(event);
    }

    bool EventQueue::remove(Event *event)
    {
        if (event == 0)
            return false;

        List::iterator i = find(m_list.begin(), m_list.end(), event);
        if (i == m_list.end())
            return false;

        m_list.erase(i);
        return true;
    }

    Event *EventQueue::get()
    {
        if (m_list.empty())
            return 0;

        Event *event = m_list.front();
        m_list.pop_front();
        return event;
    }

    Event *EventQueue::get(os::Time timeout)
    {
        if (m_list.empty())
        {
            os::Thread::suspend(timeout);
            return 0;
        }

        return get();
    }

    bool EventQueue::empty() const
    {
        return m_list.empty();
    }
}
