/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
///////////////////////////////////////////////////////////////////////////////
// torExceptions.h
// ---------------
// C++ implementations of predefined UML2 exceptions
///////////////////////////////////////////////////////////////////////////////

#ifndef __TOR_EXCEPTIONS__H__
#define __TOR_EXCEPTIONS__H__

#include "torPlatform.h"

#include <exception>

// Exception type definitions
namespace tor 
{
    enum TOR_EXT_DEF ExceptionReason
    {
        out_of_range,

        failed_to_terminate_connection_thread,
        could_not_contact_the_communication_thread,

        indicates_that_the_underlying_network_subsystem_is_not_ready_for_network_communication,
        the_version_of_windows_sockets_support_requested_is_not_provided_by_this_particular_windows_sockets_implementation,
        a_blocking_windows_sockets_1_1_operation_is_in_progress,
        limit_on_the_number_of_tasks_supported_by_the_windows_sockets_implementation_has_been_reached,
        the_wsadata_is_not_a_valid_pointer,
        failed_to_load_ws2_32_dll,
        could_not_find_a_ws2_32_dll_with_the_correct_version,

        connectiondata__failed_to_set_up_internal_server,
        connectiondata__failed_to_set_up_internal_client,
        connectiondata__failed_accept_connection_from_internal_client
    };

#ifndef TOR_EXCEPTION
    class TOR_EXT_DEF Exception : public std::exception 
    {
    public:
        Exception(ExceptionReason r) : std::exception(), reason(r) {}

        ExceptionReason reason;
    };
#else
    typedef TOR_EXCEPTION Exception;
#endif

#ifndef TOR_OUTOFRANGEEXCEPTION
    class TOR_EXT_DEF EOutOfRange : public Exception 
    {
    public:
        EOutOfRange() : Exception(out_of_range) {}
    };
#else
    typedef TOR_OUTOFRANGEEXCEPTION EOutOfRange;
#endif

}

#endif // __TOR_EXCEPTIONS__H__

