// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#ifdef TOR_USE_INSTRUMENTATION
#include "torPlatform.h"

#include <stdio.h>

#include "torMetaEvents.h"
#include "torCoders.h"
#include "torEventManager.h"
#include "torTypes.h"

using namespace tor::meta;

namespace anonymous_torMetaEvents_cpp {
    const tor::Charstring str_main(_T("\"main\""));

    // Helper: Adds an encoded value for the attribute into encodedInfo.
    void addEncodedValue(const tor::Charstring& attribute, const tor::Charstring& value, 
        bool& firstValue, tor::Charstring& encodedInfo,
        const tor::Character quoteChar = 0) {
            if (!firstValue)
                encodedInfo += _T(", ");

            encodedInfo += attribute;
            encodedInfo += _T(" = ");

            if (quoteChar)
                encodedInfo.append(quoteChar);
            encodedInfo += value;
            if (quoteChar)
                encodedInfo.append(quoteChar);

            firstValue = false;
        }

        // Encodes the meta definition into str
        tor::Charstring& encodeMetaDefinition(const Definition* metaDef, tor::Charstring& str) {
            str = _T("Definition (. name = \"");
            str += metaDef->name;
            str += _T("\", 'guid' = \"");
            str += metaDef->guid;
            str += _T("\" .)");
            return str;
        }
}
using namespace anonymous_torMetaEvents_cpp;

tor::meta::Event::Event() : m_bSynchronouslySent(false)
{
#ifndef TOR_NO_EVENTMANAGER
    m_bSynchronouslySent = EventManager::isSynchronous();
#endif
}

void tor::meta::Create::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("Create (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (creator.first) {        
	stprintf_address(buf, creator.first);  
        val = buf;
    }
    addEncodedValue(_T("creator"), val, firstValue, encodedInfo);

    if (creator.second) {
        Charstring def;
        addEncodedValue(_T("creatorType"), encodeMetaDefinition(creator.second, def), firstValue, encodedInfo);
    }

    if (instantiatedType) {
        Charstring def;
        addEncodedValue(_T("instantiatedType"), encodeMetaDefinition(instantiatedType, def), firstValue, encodedInfo);
    }

    stprintf_number(buf, threadId);
    addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);

    ConstructorArgs::const_iterator it = actualConstructorArgs.begin(); 
    if (it != actualConstructorArgs.end()) {
        addEncodedValue(_T("constructorActualArguments"), _T("{"), firstValue, encodedInfo);
        while (it != actualConstructorArgs.end()) {
            encodedInfo += *it;
            it++;
            if (it != actualConstructorArgs.end())
                encodedInfo += _T(", ");
        }
        encodedInfo += _T("}");
    }

    encodedInfo += _T(" .)\n");
}

void tor::meta::Create::addArgument(tor::meta::Value* arg) {
    /*    Charstring str;
    tracer.encode(arg, str);
    actualConstructorArgs.push_back(str);*/
}

void tor::meta::Delete::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("Delete (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (deleter.first) {
        stprintf_address(buf, deleter.first);
        val = buf;
    }
    addEncodedValue(_T("deleter"), val, firstValue, encodedInfo);

    if (deleter.second) {
        Charstring def;
        addEncodedValue(_T("deleterType"), encodeMetaDefinition(deleter.second, def), firstValue, encodedInfo);
    }

    if (deletedType) {
        Charstring def;
        addEncodedValue(_T("deletedType"), encodeMetaDefinition(deletedType, def), firstValue, encodedInfo);
    }

    stprintf_number(buf, threadId);
    addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);

    encodedInfo += _T(" .)\n");
}

void tor::meta::Call::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("Call (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (caller.first) {
        stprintf_address(buf, caller.first);
        val = buf;
    }
    addEncodedValue(_T("caller"), val, firstValue, encodedInfo);

    if (caller.second) {
        Charstring def;
        addEncodedValue(_T("callerType"), encodeMetaDefinition(caller.second, def), firstValue, encodedInfo);
    }

    if (calledOperation) {
        Charstring def;
        addEncodedValue(_T("calledOperation"), encodeMetaDefinition(calledOperation, def), firstValue, encodedInfo);
    }

    stprintf_number(buf, threadId);
    addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);

    ActualArgs::const_iterator it = actualCallArgs.begin(); 
    if (it != actualCallArgs.end()) {
        addEncodedValue(_T("actualArguments"), _T("{"), firstValue, encodedInfo);
        while (it != actualCallArgs.end()) {
            encodedInfo += *it;
            it++;
            if (it != actualCallArgs.end())
                encodedInfo += _T(", ");
        }
        encodedInfo += _T("}");
    }

    encodedInfo += _T(" .)\n");
}

void tor::meta::Call::addArgument(tor::meta::Value* arg) {
    /*    Charstring str;
    tracer.encode(arg, str);
    actualCallArgs.push_back(str);*/
}

void tor::meta::Called::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("Called (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (called.first) {
        stprintf_address(buf, called.first);
        val = buf;
    }
    addEncodedValue(_T("called"), val, firstValue, encodedInfo);

    if (called.second) {
        Charstring def;
        addEncodedValue(_T("calledType"), encodeMetaDefinition(called.second, def), firstValue, encodedInfo);
    }

    if (calledOperation) {
        Charstring def;
        addEncodedValue(_T("calledOperation"), encodeMetaDefinition(calledOperation, def), firstValue, encodedInfo);
    }

    stprintf_number(buf, threadId);
    addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);

    ConstructorArgs::const_iterator it = actualConstructorArgs.begin(); 
    if (it != actualConstructorArgs.end()) {
        addEncodedValue(_T("actualArguments"), _T("{"), firstValue, encodedInfo);
        while (it != actualConstructorArgs.end()) {
            encodedInfo += *it;
            it++;
            if (it != actualConstructorArgs.end())
                encodedInfo += _T(", ");
        }
        encodedInfo += _T("}");
    }

    encodedInfo += _T(" .)\n");
}

void tor::meta::Called::addArgument(meta::Value* arg) {
    /*    Charstring str;
    tracer.encode(arg, str);
    actualConstructorArgs.push_back(str);*/
}

void tor::meta::Return::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("Return (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (called.first) {
        stprintf_address(buf, called.first);
        val = buf;
    }
    addEncodedValue(_T("called"), tor::Charstring(val), firstValue, encodedInfo);

    if (called.second) {
        Charstring def;
        addEncodedValue(_T("calledType"), encodeMetaDefinition(called.second, def), firstValue, encodedInfo);
    }

    if (calledOperation) {
        Charstring def;
        addEncodedValue(_T("calledOperation"), encodeMetaDefinition(calledOperation, def), firstValue, encodedInfo);
    }

    stprintf_number(buf, threadId);
    addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);

    encodedInfo += _T(" .)\n");
}

void tor::meta::Return::setReturnValue(meta::Value* val) {
    /*  Charstring str;
    tracer.encode(val, str);
    returnValue = str;*/
}

void tor::meta::Returned::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("Returned (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (returnedTo.first) {
        stprintf_address(buf, returnedTo.first);
        val = buf;
    }
    addEncodedValue(_T("returnedTo"), tor::Charstring(val), firstValue, encodedInfo);

    if (returnedTo.second) {
        Charstring def;
        addEncodedValue(_T("returnedToType"), encodeMetaDefinition(returnedTo.second, def), firstValue, encodedInfo);
    }

    if (returnedToOperation) {
        Charstring def;
        addEncodedValue(_T("returnedToOperation"), encodeMetaDefinition(returnedToOperation, def), firstValue, encodedInfo);
    }

    stprintf_number(buf, threadId);
    addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);

    encodedInfo += _T(" .)\n");
}

void tor::meta::EventSent::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("EventSent (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (sender.first) {
        stprintf_address(buf, sender.first);
        val = buf;
    }
    addEncodedValue(_T("'sender'"), val, firstValue, encodedInfo);

    if (sender.second) {
        Charstring def;
        addEncodedValue(_T("senderType"), encodeMetaDefinition(sender.second, def), firstValue, encodedInfo);
    }

    if (eventInstance && coder) {
        StringCoderBuffer buf;
        coder->encode(eventInstance, buf);
        addEncodedValue(_T("eventInstance"), buf.buffer, firstValue, encodedInfo);

        tor::meta::Type* eventType = eventInstance->getType();
        if (eventType) {
            tor::meta::Definition eventDef(eventType->name, eventType->guid, 0);
            Charstring def;
            addEncodedValue(_T("eventType"), encodeMetaDefinition(&eventDef, def), firstValue, encodedInfo);
        }
    }

    if (event) {
        TCHAR buf[16];
        stprintf_address(buf, event);
        addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);
    }

    encodedInfo += _T(" .)\n");
}

tor::meta::EventSent::~EventSent() {
    if (eventInstance)
        delete eventInstance;
}

void tor::meta::EventReceived::encode(tor::meta::Coder* coder) {
    bool firstValue = true;
    encodedInfo = _T("EventReceived (. ");

    TCHAR buf[16];
    tor::Charstring val = str_main;
    if (receiver.first) {
        stprintf_address(buf, receiver.first);
        val = buf;
    }
    addEncodedValue(_T("receiver"), val, firstValue, encodedInfo);

    if (receiver.second) {
        Charstring def;
        addEncodedValue(_T("receiverType"), encodeMetaDefinition(receiver.second, def), firstValue, encodedInfo);
    }

    /* NOT IMPLEMENTED: An event instance is not obtained when receiving a message.

    if (eventInstance && coder) {
    StringCoderBuffer buf;
    coder->encode(eventInstance, buf);
    addEncodedValue(_T("eventInstance"), buf.buffer, firstValue, encodedInfo);

    tor::meta::Type* eventType = eventInstance->getType();
    if (eventType) {
    tor::meta::Definition eventDef(eventType->name, eventType->guid);
    Charstring def;
    addEncodedValue(_T("eventType"), encodeMetaDefinition(eventDef, def), firstValue, encodedInfo);
    }
    }
    */

    if (event) {
        TCHAR buf[16];
        stprintf_address(buf, event);
        addEncodedValue(_T("messageId"), tor::Charstring(buf), firstValue, encodedInfo);
    }

    encodedInfo += _T(" .)\n");
}

tor::meta::EventReceived::~EventReceived() {
    if (eventInstance)
        delete eventInstance;
}

void tor::meta::Message::encode(tor::meta::Coder* coder) {
    encodedInfo += _T("Message (. message = \"");
    encodedInfo += message;
    encodedInfo += _T("  \".)\n");
}

//////////////////////////////////////////////////////////////////////////

tor::Charstring tor::meta::BreakpointInfo::encode(tor::meta::Coder* coder) const {
    bool firstValue = true;

    Charstring encodedInfo = _T("BreakpointInfo (. ");
    addEncodedValue(_T("actionGuid"), actionGuid, firstValue, encodedInfo, _T('"'));
    encodedInfo += _T(" .)");
    return encodedInfo;
}

namespace {
    void EncodeBreakpoints(const tor::String<tor::meta::BreakpointInfo>& breakpoints, 
        tor::Charstring& bpEncoding,
        tor::meta::Coder* coder) {
            bpEncoding = _T("{ ");

            for (tor::String<tor::meta::BreakpointInfo>::const_iterator it = breakpoints.begin(); it != breakpoints.end();) {
                const BreakpointInfo& bpInfo = *it;
                bpEncoding += bpInfo.encode(coder);
                it++;
                if (it != breakpoints.end())
                    bpEncoding += _T(", ");
            }

            bpEncoding += _T("} ");
        }
}

void tor::meta::RemoveBreakpoints_BreakpointInfo::encode(tor::meta::Coder* coder) {
    bool firstValue = true;

    encodedInfo = _T("RemoveBreakpoints (. ");
    Charstring bpEncoding;
    EncodeBreakpoints(breakpoints, bpEncoding, coder);
    addEncodedValue(_T("breakpoints"), bpEncoding, firstValue, encodedInfo);
    encodedInfo += _T(".)");
}

void tor::meta::SetBreakpoints_BreakpointInfo::encode(tor::meta::Coder* coder) {
    bool firstValue = true;

    encodedInfo = _T("SetBreakpoints (. ");
    Charstring bpEncoding;
    EncodeBreakpoints(breakpoints, bpEncoding, coder);
    addEncodedValue(_T("breakpoints"), bpEncoding, firstValue, encodedInfo);
    encodedInfo += _T(".)");
}

void tor::meta::Break::encode(tor::meta::Coder* coder) {
    encodedInfo = _T("Break (. .)");
}

void tor::meta::BreakpointHit_Charstring::encode(tor::meta::Coder* coder) {
    bool firstValue = true;

    encodedInfo = _T("BreakpointHit (. ");
    addEncodedValue(_T("actionGuid"), actionGuid, firstValue, encodedInfo, _T('"'));
    encodedInfo += _T(".)");
}

void tor::meta::Attach::encode(tor::meta::Coder* coder) {
    encodedInfo = _T("Attach (. .)");
}

tor::Charstring tor::meta::AppInfo::encode(tor::meta::Coder* coder) const {
    bool firstValue = true;

    Charstring encodedInfo = _T("AppInfo (. ");
    addEncodedValue(_T("buildArtifactGuid"), buildArtifactGuid, firstValue, encodedInfo, _T('"'));
    encodedInfo += _T(" .)");
    return encodedInfo;
}

void tor::meta::Attached_AppInfo::encode(tor::meta::Coder* coder) {
    bool firstValue = true;

    encodedInfo = _T("Attached (. ");
    addEncodedValue(_T("appInfo"), appInfo.encode(coder), firstValue, encodedInfo);
    encodedInfo += _T(".)");
}

void tor::meta::RunTo_Charstring::encode(tor::meta::Coder* coder) {
    bool firstValue = true;

    encodedInfo = _T("RunTo (. ");
    addEncodedValue(_T("actionGuid"), actionGuid, firstValue, encodedInfo, _T('"'));
    encodedInfo += _T(".)");
}

void tor::meta::Step::encode(tor::meta::Coder* coder) {
    encodedInfo = _T("Step (. .)");
}

void tor::meta::StepIn::encode(tor::meta::Coder* coder) {
    encodedInfo = _T("StepIn (. .)");
}

void tor::meta::StepOut::encode(tor::meta::Coder* coder) {
    encodedInfo = _T("StepOut (. .)");
}

void tor::meta::Go::encode(tor::meta::Coder* coder) {
    encodedInfo = _T("Go (. .)");
}

void tor::meta::ExecutionHalted_Charstring::encode(tor::meta::Coder* coder) {
    bool firstValue = true;    

    encodedInfo = _T("ExecutionHalted (. ");
    addEncodedValue(_T("actionGuid"), actionGuid, firstValue, encodedInfo, _T('"'));
    encodedInfo += _T(".)");
}

namespace {
    enum TokenKind {        
        tokIdent,                  // xyz
        tokCharstringValue,        // "abc"
        tokListOpen,               // {
        tokListClose,              // }
        tokInstanceOpen,           // (.
        tokInstanceClose,          // .)
        tokComma,                  // ,
        tokAssignment,             // =
        tokError
    };

    struct Token {
        Token(TokenKind k) : kind(k) {}
        Token(TokenKind k, tor::Charstring& s) : kind(k), str(s) {}

        TokenKind kind;
        tor::Charstring str;
    };

    typedef tor::String<Token*> Tokens;
    typedef tor::String<Token*>::const_iterator TokenIterator;

    Token* readToken(const tor::Charstring& str, tor::Charstring::StringRepType::const_iterator& it) {
        while (it != str.stringRep.end()) {
            if (*it == _T(' ')) {
                // Skip all white-space
                while (it != str.stringRep.end() && *it == _T(' '))
                    it++;
            }
            else if (*it == _T('{')) {
                it++;
                return new Token(tokListOpen);           
            }
            else if (*it == _T('}')) {
                it++;
                return new Token(tokListClose);            
            }
            else if (*it == _T(',')) {
                it++;
                return new Token(tokComma);
            }
            else if (*it == _T('=')) {
                it++;
                return new Token(tokAssignment);
            }
            else if (*it == _T('(')) {
                it++;
                if (it != str.stringRep.end() && *it == _T('.')) {
                    it++;
                    return new Token(tokInstanceOpen);
                }
                return new Token(tokError);
            }
            else if (*it == _T('.')) {
                it++;
                if (it != str.stringRep.end() && *it == _T(')')) {
                    it++;
                    return new Token(tokInstanceClose);
                }
                return new Token(tokError);
            }
            else if (*it == _T('"')) {
                it++;
                tor::Charstring stringLiteral;
                while (it != str.stringRep.end() && *it != _T('"'))
                    stringLiteral.append(*it++);
                if (it != str.stringRep.end())
                    it++;
                return new Token(tokCharstringValue, stringLiteral);
            }
            else {
                tor::Charstring ident;
                while (it != str.stringRep.end() && *it != _T(' '))
                    ident.append(*it++);
                return new Token(tokIdent, ident);
            }
        }
        return 0;
    }

    typedef int SyntaxError;

    // Returns the next token. If no next token exists or it is not of the expected kind
    // a SyntaxError exception is thrown.
    Token* getNextToken(Tokens& tokens, TokenIterator& tokenIterator, TokenKind expectedKind) throw(SyntaxError) 
    {
        if (tokenIterator == tokens.end())
            throw SyntaxError();
        tokenIterator++;
        if (tokenIterator == tokens.end())
            throw SyntaxError();
        Token* token = *tokenIterator;
        if (token->kind != expectedKind)
            throw SyntaxError();
        return token;
    }

    // As above, but for a token that is optional. That is, if the next token does not exist
    // or is of another kind, NULL is returned.
    Token* getNextOptToken(Tokens& tokens, TokenIterator& tokenIterator, TokenKind kind) 
    {
        if (tokenIterator == tokens.end())
            return 0;
        if (tokenIterator + 1 == tokens.end())
            return 0;
        Token* token = *(tokenIterator + 1);
        if (token->kind != kind)
            return 0;
        tokenIterator++; // Match. Consume token.
        return token;
    }

    tor::meta::Event* DecodeEventWithParameters(tor::Charstring& name, 
                                                Tokens& tokens,
                                                TokenIterator& tokenIterator) throw(SyntaxError)
    {
        getNextToken(tokens, tokenIterator, tokInstanceOpen); 

        if ((name == _T("SetBreakpoints")) || (name == _T("RemoveBreakpoints"))) {            
            tor::String<BreakpointInfo> breakpoints;

            Token* breakpointAtt = getNextToken(tokens, tokenIterator, tokIdent);
            if (breakpointAtt->str != _T("breakpoints"))
                return 0; // Unexpected attribute name

            getNextToken(tokens, tokenIterator, tokAssignment); 
            getNextToken(tokens, tokenIterator, tokListOpen); 

            if (!getNextOptToken(tokens, tokenIterator, tokListClose)) {
                // The list is not empty...

                while (true) {
                    Token* breakpointInfo = getNextToken(tokens, tokenIterator, tokIdent);
                    if (breakpointInfo->str != _T("BreakpointInfo"))
                        return 0; // Unexpected type name

                    getNextToken(tokens, tokenIterator, tokInstanceOpen); // Skip '(.'

                    Token* actionGuidAtt = getNextToken(tokens, tokenIterator, tokIdent);
                    if (actionGuidAtt->str != _T("actionGuid"))
                        return 0; // Syntax error, or unexpected type name

                    getNextToken(tokens, tokenIterator, tokAssignment); // Skip '='

                    Token* guidValue = getNextToken(tokens, tokenIterator, tokCharstringValue);
                    breakpoints.push_back(BreakpointInfo(guidValue->str));

                    getNextToken(tokens, tokenIterator, tokInstanceClose); // Skip '.)'

                    try {
                        getNextToken(tokens, tokenIterator, tokComma); 
                        continue; // Read next BreakpointInfo
                    }
                    catch (SyntaxError) {
                        break; // No more BreakpointInfos to read
                    }
                }
            }

            if (name == _T("SetBreakpoints")) 
                return new tor::meta::SetBreakpoints_BreakpointInfo(breakpoints);
            else
                return new tor::meta::RemoveBreakpoints_BreakpointInfo(breakpoints);
        }
        else if (name == _T("RunTo")) {
            Token* breakpointAtt = getNextToken(tokens, tokenIterator, tokIdent);
            if (breakpointAtt->str != _T("actionGuid"))
                return 0; // Unexpected attribute name

            getNextToken(tokens, tokenIterator, tokAssignment); 

            Token* guidValue = getNextToken(tokens, tokenIterator, tokCharstringValue);
            return new tor::meta::RunTo_Charstring(guidValue->str);
        }

        return 0;
    }
}

// Decoding of string to meta event
tor::meta::Event* tor::meta::Event::decode(const tor::Charstring& str) {        
    Tokens tokens;
    tor::MultiDeleter<Token> md(tokens);

    tor::Charstring::StringRepType::const_iterator it = str.stringRep.begin();

    while (it != str.stringRep.end()) {
        tokens.push_back(readToken(str, it));
    }

    if (tokens.empty())
        return 0; // Syntax error

    // Read event name
    Tokens::const_iterator tokenIterator = tokens.begin();
    Token* eventName = *tokenIterator;
    // Match parameterless events first...
    if (eventName->str == _T("Go"))
        return new Go;
    else if (eventName->str == _T("Attach"))
        return new Attach;
    else if (eventName->str == _T("Break"))
        return new Break;
    else if (eventName->str == _T("Step"))
        return new Step;
    else if (eventName->str == _T("StepIn"))
        return new StepIn;
    else if (eventName->str == _T("StepOut"))
        return new StepOut;

    // Then match events with parameters...
    tor::meta::Event* event = 0;
    try {
        event = DecodeEventWithParameters(eventName->str, tokens, tokenIterator);
    }
    catch (SyntaxError) { }

    return event;
}

#endif

