/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torMetaStackContext_h__
#define __torMetaStackContext_h__

#ifndef TOR_USE_INSTRUMENTATION
// Remove all instrumentation from the application by clearing TOR_INSTRUMENTATION
#define TOR_INSTRUMENTATION(x) do{}while(0) /* NOP */
#endif

#if defined(TOR_USE_INSTRUMENTATION) && !defined(TOR_NO_EVENTMANAGER)

#include "torPlatform.h"

#include "torMetaData.h"
#include "torOs.h"
#include <stack>
#include <map>

// Enable all instrumentation in the application
#define TOR_INSTRUMENTATION(x) x

namespace tor {

    namespace meta {

        // Representation of a stack context. Responsible for the actions performed when entering and leaving a stack frame.
	struct TOR_EXT_DEF StackContext {

            StackContext(Operation* metaDef,                   // The meta representation of the operation for which the stack context is created.
                         const Charstring& compoundActionGuid, // The GUID of the compound action of the operation (empty if synthesized during code generation)
                         void* objectContext = 0);             // The object that calls the operation, if the call is done from an object context.
 
	    ~StackContext();

            int m_id;            // Id of thread to which this stack context belongs.
            bool m_bTraceCall;   // Should the call corresponding to this stack context be traced?
            bool m_bSynthesized; // Does this stack context correspond to a call of a synthesized operation?
	};

        // Representation of an instrumented stack frame
        struct StackFrame {
            StackFrame(Entity& e, const Charstring& c) : m_calledOperation(e), m_actionGuid(c) {}

            Entity m_calledOperation;   // The operation that was called in order to yield this stack frame.
            Charstring m_actionGuid;    // The guid of the action that is currently being executed on this stack frame.
        };

        // Representation of an instrumented callstack        
        typedef std::stack<StackFrame> CallStack;

        // Representation of a thread in an instrumented application
        struct ThreadInfo {
            CallStack m_callstack;  // The callstack of the thread
            os::Gate m_gate;        // A gate used for controlling the execution of the thread during debugging
            int m_id;               // The id of the thread
            bool m_active;          // Tells if the thread is active in the current debug context            

            ThreadInfo(int id) : m_active(false), m_id(id) { }

        private:
            ThreadInfo(const ThreadInfo& ti) { } // No copying allowed
        };

        // Map between thread id and the ThreadInfo of the thread
        typedef std::map<int, ThreadInfo*> ThreadInfos;

    }

}

#endif

#endif // __torMetaStackContext_h__

