/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
///////////////////////////////////////////////////////////////////////////////
// torOperators.h
// --------------
// C++ implementations of predefined UML2 operators
///////////////////////////////////////////////////////////////////////////////

#ifndef __TOR_OPERATORS__H__
#define __TOR_OPERATORS__H__

#include "torPlatform.h"

#include "torTypes.h"
#include <math.h>

namespace tor {

    //////////////////////////////////////////////////////////////////////////
    // Integer operators
    //////////////////////////////////////////////////////////////////////////

    // Return the base raised to the power of the exponent.
    inline tor::Real power(tor::Real base, tor::Real exponent) {
	return pow(base, exponent);
    }

    // Returns true if i1 equals i2
    inline tor::Boolean equal(tor::Integer i1, tor::Integer i2) {
	return (i1 == i2);
    }

    inline tor::Integer mod(tor::Integer i1, tor::Integer i2) {
	i2 = abs(i2);
	Integer result = i1 % i2;
	return (result < 0) ? result + i2 : result;
    }

    //////////////////////////////////////////////////////////////////////////
    // Natural operators
    //////////////////////////////////////////////////////////////////////////

    // Returns true if n1 equals n2
    inline tor::Boolean equal(tor::Natural n1, tor::Natural n2) {
	return (n1 == n2);
    }

    //////////////////////////////////////////////////////////////////////////
    // Boolean operators
    //////////////////////////////////////////////////////////////////////////

    // Returns true if b1 equals b2
    inline tor::Boolean equal(tor::Boolean b1, tor::Boolean b2) {
	return (b1 == b2);
    }

    // Returns true if b1 implies b2. This is the implementation of
    // the predefined operator Boolean::'=>'(Boolean, Boolean).
    inline tor::Boolean implies(tor::Boolean b1, tor::Boolean b2) {
	if (b1 && !b2)
	    return false;
	else
	    return true;
    }

    //////////////////////////////////////////////////////////////////////////
    // Dynamic-cast operators
    //////////////////////////////////////////////////////////////////////////

    // Returns true if arg is of dynamic type T.
    template <class T, class ARG>
    inline tor::Boolean is(ARG arg) {
        return (dynamic_cast<T>(arg) != 0);
    }

    // Dynamic cast of arg to type T. Returns NULL if the cast fails.
    template <class T, class ARG>
    inline T as(ARG arg) {
        return dynamic_cast<T>(arg);
    }

};

#endif // __TOR_OPERATORS__H__

