/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __TOR_PORT__H__
#define __TOR_PORT__H__

#include "torPlatform.h"

#include <list>

namespace tor 
{  
    class Connector;
    class DispatchableClass;
    class Event;

    class TOR_EXT_DEF Port   
    {
    protected:

        // A list of ports connected with this port, i.e. potential targets of 
        // events sent through this port.
        std::list<Port *> portList;

    public:
        // A pointer to a dispatchable class that can receive events sent 
        // through this port.
        DispatchableClass *targetBehavior;

    public:
        // Connects the supplied port to this port using the supplied connector,
        void attach(Port * port, Connector * connector);

        // Disconnects port.
        void disconnect();

        // Sends an event through this port. The event is sent to one of the 
        // connected ports or to the target behavior. If the 'deleteEvent'
        // parameter is true the event will be deleted if it was received, 
        // otherwise not.
        bool send(Event * event, bool deleteEvent = true);

        enum PortKind { InPort, OutPort };

        // Constructor. Attaches the port to the specified owner dispatchable class,
        // as either an in- or outgoing port.
        Port(DispatchableClass *pOwner, PortKind portKind);
    };

} // namespace tor

#endif

