// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torProcess.h"
#include "torThread.h"
#include "torOs.h"

#include <iterator>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>
#include <sstream>
#if TGTOS == OS_LINUX || TGTOS == OS_SOLARIS
#include <unistd.h>
#endif

namespace
{
    using namespace tor::os;

    // helper
    tstring quote(const tstring &str)
    {
        tstring result;

        if (str.empty())
            return result;

        bool quote = *str.rbegin() != _T('\"') && str.find_first_of(_T(" \t")) != tstring::npos;

        if (quote) 
            result.append(_T("\""));

        result.append(str);
        if (quote) 
            result.append(_T("\""));

        return result;
    }
}

namespace tor
{
    namespace os
    {
        Process::Process() : m_impl(), m_bTerminateOnDelete(true)
        {
        }

        Process::~Process()
        {
            if (m_bTerminateOnDelete) 
                terminate();
        }

        bool Process::launch(const tstring &cmd, const std::vector<tstring> &argv, const ENV &env, const tstring &dir)
        {
            // Handle environment. Reuse the current process env block with
            // some additions.
#if TOR_USE_PUTENV
            ENV::const_iterator j = env.begin();
            while (j != env.end())
            {
                const ENV_var &v = *j++;

                std::string e = v.first;
                e.append("=");
                e.append(v.second);
#if TGTOS == OS_LINUX || TGTOS == OS_SOLARIS
                putenv(const_cast<std::string::pointer>(e.c_str()));
#else
                _putenv(const_cast<std::string::pointer>(e.c_str()));
#endif
            }
#endif
            return m_impl.launch(cmd, argv, dir);
        }

        void Process::setOptions(int options)
        {
            m_impl.setOptions(options);
        }

        bool Process::isTerminated(int& terminationValue)
        {
            return m_impl.isTerminated(terminationValue);
        }
    }
}

// End of File

