// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torSync.h"

namespace tor
{
    namespace os
    {
        //
        //
        //

        RWLock::RWLock() 
          : m_mutex(), 
            m_read(), 
            m_write(),
            m_read_count(0),
            m_pending_read(0), 
            m_pending_write(0) 
        {
            m_mutex.init();
            m_read.init();
            m_write.init();
        }

        RWLock::~RWLock()
        {}

        Status RWLock::read_lock()
        {
            if (m_mutex.lock() == StatusFAIL)
                return StatusFAIL;

            while (m_pending_write) 
            {
                ++m_pending_read;

                if (m_mutex.unlock() == StatusFAIL)
                    return StatusFAIL;

                if (m_read.get() == StatusFAIL) 
                {
                    --m_pending_read;
                    return StatusFAIL;
                }

                if (m_mutex.lock() == StatusFAIL)
                    return StatusFAIL;

                --m_pending_read;
            }

            ++m_read_count;

            if (m_mutex.unlock() == StatusFAIL)
                return StatusFAIL;

            return StatusOK;
        }

        Status RWLock::read_unlock()
        {
            if (m_mutex.lock() == StatusFAIL)
                return StatusFAIL;

            --m_read_count;

            if (m_pending_write && !m_read_count && m_write.put() == StatusFAIL)
                return StatusFAIL;

            if (m_mutex.unlock() == StatusFAIL)
                return StatusFAIL;

            return StatusOK;
        }

        Status RWLock::write_lock()
        {
            if (m_mutex.lock() == StatusFAIL)
                return StatusFAIL;

            ++m_pending_write;

            while (m_read_count) 
            {
                if (m_mutex.unlock() == StatusFAIL)
                    return StatusFAIL;

                if (m_write.get() == StatusFAIL)
                {
                    --m_pending_write;
                    return StatusFAIL;
                }

                if (m_mutex.lock() == StatusFAIL)
                    return StatusFAIL;
            }

            --m_pending_write;

            return StatusOK;
        }

        Status RWLock::write_unlock()
        {
            if (m_pending_write)
            {
                if (m_write.put() == StatusFAIL)
                    return StatusFAIL;
            }
            else if (m_pending_read)
            {
                if (m_read.put(m_pending_read) == StatusFAIL)
                    return StatusFAIL;
            }

            if (m_mutex.unlock() == StatusFAIL)
                return StatusFAIL;

            return StatusOK;
        }

        //
        //
        //
        
        Gate::Gate() 
          : m_mutex(),
            m_sem(), 
            m_locked(false)
        {
            m_sem.init(1); // Initially the gate is open.
        }

        Gate::~Gate() {}

        bool Gate::isLocked() 
        {
            auto_lock lock(m_mutex);
            return m_locked;
        }

        void Gate::setLocked(bool l) 
        {
            auto_lock lock(m_mutex);
            m_locked = l;
        }

        void Gate::unlock() 
        {
            if (!isLocked()) 
                return;
            m_sem.put();
            setLocked(false);
        }

        void Gate::lock() 
        {                
            if (isLocked())
                return;
            m_sem.get();
            setLocked(true);
        }

        void Gate::enter() 
        {                
            m_sem.get(); // Open gate
            m_sem.put(); // Close gate
        }
    }
}

