// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torTimer.h"
#include "torDispatcher.h"
#include "torDispatchable.h"
#include "torEventQueue.h"
#include <algorithm>

tor::TimerEvent::~TimerEvent()
{
    if ( m_pTimer ) {
    m_pTimer->softReset();
  }
}


tor::TimerEvent::TimerEvent()
  : m_pTimer(0)
{
  // EMPTY
}

void tor::TimerEvent::received() 
{
  if ( m_pTimer ) {
    m_pTimer->softReset();
    m_pTimer = 0;
  }
}


tor::TimerObject::~TimerObject()
{
  if ( isActive() )
    reset();
}


tor::TimerObject::TimerObject( Dispatchable& rOwner )
  : m_rOwner( rOwner ), m_pTimerEvent(0), m_pTimerQueue(0)
{
  // EMPTY
}


void tor::TimerObject::set(const tor::os::Time &time, TimerEvent *timerEvent)
{
    if (isActive())
        reset();

    Dispatcher *dispatcher = m_rOwner.m_dispatcher;
    if (dispatcher == 0) 
    {
        delete timerEvent;
        return;
    }

    m_pTimerQueue = dispatcher->getTimerQueue();
    if (m_pTimerQueue != 0) 
    {
        timerEvent->m_receiver = InstanceManager::instance().getIdFromExecutor(&m_rOwner);
        timerEvent->m_pTimer = this;
        m_t.set(time);
        m_pTimerEvent = timerEvent;
        m_pTimerQueue->insert(this);
    }
    else 
    {
        delete timerEvent;
    }
}


void
tor::TimerObject::reset()
{
  if ( m_pTimerEvent ) {
    TimerEvent* pE = m_pTimerEvent;
    bool b = softReset();
    if ( b )
      delete pE;
  }
}


bool
tor::TimerObject::softReset()
{
  bool b = false;
  if ( m_pTimerEvent ) {				// timer is active
    if ( m_pTimerQueue ) {				// .. has not expired
      m_pTimerQueue->remove( this );
      b = true;
    }
    else {						// .. has expired
      b = m_rOwner.m_eventQueue->remove( m_pTimerEvent );
    }
    m_pTimerEvent = 0;
  }
  return b;
}



tor::TimerQueue::~TimerQueue()
{
  clear();
}



tor::TimerQueue::TimerQueue()
{
  // EMPTY
}


void
tor::TimerQueue::clear()
{
  TimerObject* pT = get();
  while ( pT ) {
    pT->reset();
    pT = get();
  }
  m_t.zero();
}



void tor::TimerQueue::insert(TimerObject *pT)
{
    if (pT == 0)
        return;

    pT->m_pTimerQueue = this;
    m_list.push_front(pT);

    List::iterator i = m_list.begin();
    List::iterator j = i++;

    while (i != m_list.end() && (*i)->m_t > (*j)->m_t) 
        std::iter_swap(i++, j++);

    if (m_list.back() == pT)
        m_t = pT->m_t;
}


void
tor::TimerQueue::remove( TimerObject* pT )
{
  m_list.remove( pT );
  pT->m_pTimerQueue = 0;
  if ( !m_list.empty() ) {
    m_t = m_list.back()->m_t;
  }
  else {
    m_t.zero();
  }
}



tor::TimerObject*
tor::TimerQueue::get()
{
  if ( m_list.empty() )
    return 0;

  TimerObject* pT = m_list.back();
  m_list.pop_back();

  if ( !m_list.empty() ) {
    m_t = m_list.back()->m_t;
  }
  else {
    m_t.zero();
  }

  return pT;
}

