/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torTopRegion_h__
#define __torTopRegion_h__ (1)

#include "torPlatform.h"

#include "torRegion.h"

namespace tor {

    class StateMachine;

    // This class represents a top level region of a statemachine, i.e. a region
    // directly owned by a statemachine. It extends the Region class by adding
    // an operation to retrieve the enclosing statemachine.
    class TOR_EXT_DEF TopRegion : public Region {
    public:
        virtual ~TopRegion() {};
        TopRegion() : Region(0) {};
    
        // Overloaded to take care of events with special semantics for the top region.
        virtual Dispatchable::EventAction execute( Event* );

        // Overloaded to call the initialTransition function asynchronously.
        virtual void callInitialTransition();

        // Finishes this region. If an entry point is supplied, the region is finished
        // and the owning statemachine is left, passing on the exit point.
        // If all top level regions are finished after this call and the owning statemachine
        // is a top level statemachine, it is finished.
        void finish(ExitPoint* ep = 0);

        // Returns the statemachine owning the region. Implemented by subclasses.
        virtual StateMachine* getStateMachine() = 0;
    };

} // tor namespace

#endif // __torTopRegion_h__

