# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require dialogs

proc OnActivateImageSelector {cmdName} {
	global selection U2
	set newFile [FileOpenDialog -filter "Bitmaps (*.bmp)|*.bmp|Windows metafiles (*.emf)|*.emf|All image files (*.bmp, *.emf)|*.bmp;*.emf|All files (*.*)|*.*||"]
	if {$newFile != 0} {
		set newFile [string map {\\ /} $newFile]
		foreach elem $selection {
			if {[u2::GetTaggedValue $elem "icon (. .)"] == 0} {
			        set session [u2::GetEntity $elem Session]
				set stereotype [u2::FindByGuid "$session" "@TTDStereotypeDetails@stereotypeDetails"]
				set stereotypeInstance [u2::CreateInstance $stereotype]
				u2::SetEntity $elem StereotypeInstance $stereotypeInstance
				u2::SetTaggedValue $stereotypeInstance "icon (. IconFile .)" "\"$newFile\""
			} else {
				u2::SetTaggedValue $elem "icon (. IconFile .)" "\"$newFile\""
			}
			if [u2::IsKindOf $elem PresentationElement] {
				set pos [u2::GetValue $elem Position]
				SetA $elem Position "[expr [lindex $pos 0] + 1] [lindex $pos 1]"
				SetA $elem Position $pos
			}
		}
	}

}


proc OnActivateRemoveImage {cmdName} {
	global selection U2
	foreach elem $selection {
		set tv [u2::GetTaggedValue $elem "icon (. IconFile .)"]
		if {$tv != 0} {
			catch  { u2::Delete [u2::GetOwner [u2::GetOwner $tv]] }
		} elseif [IsKindOf $elem Symbol] {
			set modelElement [u2::GetEntity $elem "ModelElement"]
			set tv [u2::GetTaggedValue $modelElement "icon (. IconFile .)"]
			set metaClass [u2::GetMetaClassName $modelElement]
			set remove [MessageDialog -name "Removing image" -message "The image is applied to the $metaClass model element, not to the symbol.\nClicking OK will remove it from all symbols representing this $metaClass." -style okcancel -icon information]
			if {$remove == 1} {
				catch  { u2::Delete [u2::GetOwner [u2::GetOwner $tv]] }
			}
		}
	}
}

proc OnEnableImageSelector {cmdName} {
	global selection
	if {[llength $selection] == 0} {
		return 0
	}
	if [ catch {
		foreach elem $selection {
			if {(![u2::IsKindOf $elem Symbol] && ![u2::IsKindOf $elem ModelElement])} {
				return 0
			}
		}
	}] {
  		return 0
	}
	return 1
}
proc OnEnableRemoveImage {cmdName} {
	global selection
	if {[llength $selection] == 0} {
		return 0
	}
	if [ catch {
		foreach elem $selection {
			if {(![u2::IsKindOf $elem Symbol] && ![u2::IsKindOf $elem ModelElement]) } {
				return 0
			} 
			if {([u2::GetTaggedValue $elem "icon (. IconFile .)"] == 0)} {
				if [u2::IsKindOf $elem Symbol] {
					set modelElement [u2::GetEntity $elem "ModelElement"]
					if { $modelElement == 0 } {
						return 0
					}
					if {([u2::GetTaggedValue $modelElement "icon (. IconFile .)"] == 0)} {
						return 0
					}
				} else {
					return 0
				}
			} 
		}
	}] {
  		return 0
	}
	return 1
}

# Declaration and registration of commands/toolbar/menu
package require commands

Declare addcommand -variable cmdImageSelector -name "Load image..." -statusmessage "Loads an image to display instead of the selected element(s)" -tooltip "Load element image" -accelerator "" -imagefile "" -onactivatecommand OnActivateImageSelector -onenablecommand OnEnableImageSelector
Declare addcommand -variable cmdRemoveImage -name "Remove image" -statusmessage "Removes the image and displays the original symbol instead" -tooltip "Remove element image" -accelerator "" -imagefile "" -onactivatecommand OnActivateRemoveImage -onenablecommand OnEnableRemoveImage

AddCommand cmdImageSelector
AddCommand cmdRemoveImage

AddMenu -variable mnuImageSelector -commands { cmdImageSelector cmdRemoveImage} -path { &Tools} -position {last}
AddContextMenu -variable cntxtSelect -commands { cmdImageSelector cmdRemoveImage } -onenablemenu OnEnableImageSelector
AddContextMenu -variable cntxtRemove -commands { cmdRemoveImage } -onenablemenu OnEnableRemoveImage

