# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands
package require dialogs

source [file join [std::GetInstallationDirectory] addins J2EE Script J2EEMsg.tcl]

# return the text of a tagged value
proc getTagValue { el tag } {
	set tv [u2::GetTaggedValue $el $tag]
	if { $tv == 0 } {
		set infotext ""
	} else {
		if { [u2::IsKindOf $tv Ident] } {
			set infotext [u2::GetValue $tv Name]
		} elseif { [u2::IsKindOf $tv ListExpr] } {
			# combine the list values with \n
			set infotext [list]
			foreach e [u2::GetEntities $tv Expression] {
				lappend infotext "[u2::GetValue $e ValueString]"
			}
		} elseif { [u2::IsKindOf $tv CharstringValue] } {
			set infotext [u2::GetValue $tv Value]	
		} else {
			set infotext [u2::GetValue $tv ValueString]
		}
	}
	return $infotext
}

# Need to check to see that only a certain Java version is loaded
proc checkLibConflict {conflictVer} {
  set ActiveModel [std::GetModels -kind U2 -project $std::activeproject]
  set langVer [getTagValue $ActiveModel "javaSettings(.languageVersion.)"]
 
  if {$langVer == $conflictVer} {
    return true
  } else {
    return false
  }
}

proc BeforeUnload { } {
	global msg
	global U2
  std::Output $msg(UnloadMsg)


	# this is the list of profile package guids (first one is 1.4, rest are 1.3.1)
	set guids [list "J2EE@j2ee_1_4"]

	# they have to be unloaded from all loaded models
  set models [std::GetModels -kind U2]
  foreach model $models {
  	# first pass deletes all dependencies
  	foreach guid $guids {
	    set profile [u2::FindByGuid $model $guid]
	  	# std::Output "Checking model $model for guid $guid result '$profile'\n"
			if { 0 != $profile } {
				# std::Output "Found guid $guid\n"
				set deps [u2::GetReferringEntities $profile Supplier]
				foreach d $deps {
					u2::Delete $d
				}
			}
		}
		# second pass deletes the profile packages
  	foreach guid $guids {
	    set profile [u2::FindByGuid $model $guid]
	  	# std::Output "Checking1 model $model for guid $guid result '$profile'\n"
			if { 0 != $profile } {
				std::Output "."
		    u2::UnloadLibrary $profile
		  }
		}
  }
  std::Output $msg(DoneMsg)
}

# Load the J2EE library and re-bind the model.
proc Init { u2file } {
  global U2
  global msg

  set AddinPath [file join [std::GetInstallationDirectory] addins J2EE]

  # Suppress load errors, lots of binding messages printed, but then it's ok once NR runs...I think...
  catch { 
    u2::LoadLibrary [file join $AddinPath etc $u2file]
  } 
}

############################################################################################
# Main entry
############################################################################################
# Make sure Java 1.3 or 5 is not loaded

set errorMsg ""
set NoJavaProject ""

if { [checkLibConflict JAVA_1_3] } {
  std::Output $msg(LoadMsg)
  Init j2ee.u2
  std::Output $msg(DoneMsg)
} elseif { [checkLibConflict JAVA_1_4] } {
  std::Output $msg(LoadMsg)
  Init j2ee.u2
  std::Output $msg(DoneMsg)
} else {
  append errorMsg " $msg(VersionErrMsg)"
  std::MessageDialog -name $msg(dlgName) -message $errorMsg -style ok -icon warning
}
