# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands
package require dialogs

source [file join [std::GetInstallationDirectory] addins JEE5 Script JEE5Msg.tcl]
source [file join [std::GetInstallationDirectory] addins JEE5 Script JEE5Menus.tcl]
source [file join [std::GetInstallationDirectory] addins JEE5 Script JEE5Agents.tcl]
source [file join [std::GetInstallationDirectory] addins JEE5 Script JEE5Cmds.tcl]
source [file join [std::GetInstallationDirectory] addins JEE5 Script JEE5InitGlobals.tcl]

# Wrapper the U2 function in case we need to do more discrimination
proc JEE5HasStereotype {el st} {
  set val [u2::HasAppliedStereotype $el $st]

  return $val
}

# return the text of a tagged value
proc getTagValue { el tag } {
	set tv [u2::GetTaggedValue $el $tag]
	if { $tv == 0 } {
		set infotext ""
	} else {
		if { [u2::IsKindOf $tv Ident] } {
			set infotext [u2::GetValue $tv Name]
		} elseif { [u2::IsKindOf $tv ListExpr] } {
			# combine the list values with \n
			set infotext [list]
			foreach e [u2::GetEntities $tv Expression] {
				lappend infotext "[u2::GetValue $e ValueString]"
			}
		} elseif {[u2::IsKindOf $tvStr UnaryExpr]} {
			set infotext "[u2::GetValue $tv Operator][u2::GetValue $tv Operand]"
		} elseif { [u2::IsKindOf $tv CharstringValue] } {
			set infotext [u2::GetValue $tv Value]	
		} else {
			set infotext [u2::GetValue $tv ValueString]
		}
	}
	return $infotext
}

# Need to check to see that only a certain Java version is loaded
proc checkLibConflict {conflictVer} {
 
  set ActiveModel [std::GetModels -kind U2 -project $std::activeproject]
  set langVer [getTagValue $ActiveModel "javaSettings(.languageVersion.)"]
  if {$langVer == $conflictVer} {
    return true
  } else {
    return false
  }
}

proc BeforeUnload { } {

	set curProject [std::GetActiveProject]
    set model [std::GetModels -kind "U2" -project $curProject]

    set agent [u2::FindByGuid $model "@JavaAgent@UnloadJEE5Profiles"]
    
    # invoke agent to make some unloading
    if { 0 != $agent } {
        set param ""

        if { [catch {
          u2::InvokeAgent $model $agent $model param
         } e ] } {
                std::Output "Error when invoking Unload JEE5 profiles agent : $e\n"
         }
    }	
}

# Load the JEE5 library and re-bind the model.
proc Init {} {
  global U2
  global msg
  
  set AddinPath [file join [std::GetInstallationDirectory] addins JEE5]

  # Suppress load errors, lots of binding messages printed, but then it's ok once NR runs...I think...
  catch { 
    u2::LoadLibrary [file join $AddinPath etc javaee.u2]
  }
  catch {
    u2::LoadLibrary [file join $AddinPath etc AgileEE.u2]
  }

  # bind the model to establish references to JEE5 elements... 
  set curProject [std::GetActiveProject]
  set model [std::GetModels -kind "U2" -project $curProject]
  foreach e [u2::GetEntities $model OwnedMember] {
    u2::Bind $e
  }
}

############################################################################################
# Main entry
############################################################################################
# Make sure Java 1.3 or 1.4 is not loaded

  std::Output $msg(LoadMsg)
set errorMsg ""
set NoJavaProject ""

if {[checkLibConflict JAVA_1_4] || [checkLibConflict JAVA_1_3] ||[checkLibConflict $NoJavaProject] } {
  append errorMsg " $msg(VersionErrMsg)"
  std::MessageDialog -name $msg(dlgName) -message $errorMsg -style ok -icon warning
  std::Output $msg(AddinNotLoaded)
  return
} 
  
#Init
  
if { [ JEE5InitGlobals ] } {
  std::Output $msg(AddinNotLoaded)
  return
} else {  
  InitJEE5Menus
  std::Output $msg(DoneMsg)
}

  
