# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
################################################################################################
#
# Compare 2 lists
#
################################################################################################
proc listcomp4 {list1 list2 outVar1 outVar2} {

    set A [list]
    set B [list]

    set i 0
    set j 0

    set list1 [lsort $list1]
    set list2 [lsort $list2]
    set l1 [llength $list1]
    set l2 [llength $list2]

    while {($i < $l1) && ($j < $l2)} {
        if {[set w [string compare [lindex $list1 $i] [lindex $list2 $j]]] == 0} {
            # equal
            incr i
            incr j
        } else {
            if {$w < 0} {
                # list1 < list2
                lappend A [lindex $list1 $i]
                incr i
            } else {
                lappend B [lindex $list2 $j]
                incr j
            }
        }
    }

    if {$i < $l1} {
        #not finished with list1 yet
        #add the remaining parts to A as unique
        set A [concat $A [lrange $list1 $i end]]
        # B is complete
    } else {
        if {$j < $l2} {
          #not finished list2 yet
          set B [concat $B [lrange $list2 $j end]]
        }
    }

    upvar $outVar1 x
    set x $A
    upvar $outVar2 y
    set y $B
    return
 }

################################################################################################
#
# See if a named element already exists inside the scope of parent element
#
################################################################################################
proc JEE5Exists {el subName} {
# FindByName too slow, only look at OwnedMembers, 1st level down only
#  set sub [u2::FindByName $el $subName]
#  if {$sub == 0} {return 0}

#  return 1
 foreach child [u2::GetEntities $el OwnedMember] {
    if {[u2::GetValue $child Name] == $subName} {
      return 1
    }
  }

  return 0
}

################################################################################################
#
# Dupe the owned members list
#
################################################################################################
proc JEE5CreateOrUpdate { master copy el } {
  global agileeegenerated
 
  # TODO, Name should be changed to Create ...
  
  set newEl [u2::Clone $el]
  u2::SetEntity $copy OwnedMember $newEl
  
  u2::ApplyStereotype $newEl $agileeegenerated minimalQualifier

  return $newEl
}

################################################################################################
#
# Look for an implementation of the element ("<elName>Bean")
#
################################################################################################
proc JEE5ImplExists {el} {
  #global U2
  
  set lookFor "[u2::GetValue $el Name]Bean"
  foreach gen [u2::GetReferringEntities $el Parent] {
    set child [u2::GetEntity $gen Child]
    if {[u2::GetValue $child Name] == $lookFor} {
      return 1
    }
  }

  return 0
}

################################################################################################
#
# Look for an interface of the element ("Ifc_<elName>")
#
################################################################################################
proc JEE5IfcExists {el} {
  #global U2
  
  set lookFor "Ifc_[u2::GetValue $el Name]"
  foreach gen [u2::GetEntities $el Generalization] {
    set parent [u2::GetEntity $gen Parent]
    if {[u2::GetValue $parent Name] == $lookFor} {
      return 1
    }
  }
  
  return 0
}

################################################################################################
#
# Create an implemenation class from the selection (expects one Interface)
#
################################################################################################
proc JEE5CreateImpl { loc } {
  #global U2
  global msg
  global agileeegenerated
  global session
  
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  
  # If an InterfaceSymbol, get the model element
  set intfc ""
  if {[u2::IsKindOf $sel InterfaceSymbol]} {
    set intfc $sel
    set sel [u2::GetEntity $sel Definition]
  }
  
  # See if there is already an implementation class for this Interface
  if {[JEE5ImplExists $sel]} {
    std::MessageDialog -name $msg(dlgName) -message $msg(ClsExists) -style ok -icon stop
    return
  }
  
  set newClass [u2::Create [u2::GetEntity $sel Owner] Class]
  u2::SetValue $newClass Name "[u2::GetValue $sel Name]Bean"
  u2::ApplyStereotype $newClass $agileeegenerated minimalQualifier
  
  # Set the class as Public
  u2::SetValue $newClass Visibility VkPublic

  # Create Generalization
  set gens [u2::Create $newClass Generalization]
  u2::SetEntity $gens Parent $sel
    
  # Update the OwnedMembers list
  foreach op [u2::GetEntities $sel OwnedMember] {
    JEE5CreateOrUpdate $sel $newClass $op
  }
  
  # Add to diagram if we clicked on an InterfaceSymbol
  if {$intfc != ""} {
    set err ""
    set myDiag [u2::GetEntity $intfc Diagram]
    
    # Get current list of diagram elements
    set preDiagElements [u2::GetEntities $myDiag DiagramElement]
    
    # Populate diagram
    set a [u2::FindByGuid $session "@TTDDiagramAgents@ClassDiagramPopulator"]
    set p [list [list $gens 0] 0 1 1 1]
    set err [u2::InvokeAgent $session $a $myDiag p]

    set postDiagElements [u2::GetEntities $myDiag DiagramElement]
    listcomp4 $preDiagElements $postDiagElements dummyList newSymbols
    
    set lines   [list]
    set symbols [list]
    # Get returned list of symbols and lines
    foreach sym $newSymbols {
      if { [u2::IsKindOf $sym Line] } { lappend lines $sym }
      if { [u2::IsKindOf $sym Symbol] } { lappend symbols $sym }
    }
    
    # Append a 0 to ensure these remain as lists even when there is only one element
    if {[llength $lines] <= 1} {lappend lines 0}
    if {[llength $symbols] <= 1} {lappend symbols 0}
    
    # Refresh symbols
    set a [u2::FindByGuid $session "@TTDDiagramAgents@RefreshSymbol"]
    set p $symbols
    set err [u2::InvokeAgent $session $a $myDiag p]
    
    # Layout 
    set a [u2::FindByGuid $session "@TTDDiagramAgents@SugiyamaLayout"]
    set p [list $lines $symbols 50]
    set err [u2::InvokeAgent $session $a $myDiag p]

    # Route lines
    set a [u2::FindByGuid $session "@TTDDiagramAgents@LineRouter"]
    set p $lines
    set err [u2::InvokeAgent $session $a $myDiag p]
  }
}

################################################################################################
#
# Create an Interface for the selection (copies public methods)
#  -- almost the same as the create implementation routine in this same file
################################################################################################
proc JEE5CreateInterface { cntxt } {
  #global U2
  global agileeegenerated
  global session
  global msg
  
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  
  # If a ClassSymbol, get the model element
  set cls ""
  if {[u2::IsKindOf $sel ClassSymbol]} {
    set cls $sel
    set sel [u2::GetEntity $sel Definition]
  }
  
  # See if there is already an Interface for this Implementation class
  if {[JEE5IfcExists $sel]} {
    std::MessageDialog -name $msg(dlgName) -message $msg(IfcExists) -style ok -icon stop
    return
  }
  
  # Create the Interface
  set newIfc [u2::Create [u2::GetEntity $sel Owner] Interface]
  u2::SetValue $newIfc Name "Ifc_[u2::GetValue $sel Name]"
  if {$agileeegenerated == 0 } { return 0 }
  u2::ApplyStereotype $newIfc $agileeegenerated minimalQualifier
  
  # Set the class as Public
  u2::SetValue $newIfc Visibility VkPublic

  # Create Generalization
  set gens [u2::Create $sel Generalization]
  u2::SetEntity $gens Parent $newIfc
    
  # Copy only non-static ordinary public methods (skip e.g. constructors)
  foreach op [u2::GetEntities $sel OwnedMember] {
    if {[u2::IsKindOf $op Operation] && ([u2::GetValue $op Visibility] == "VkPublic") && ([u2::GetValue $op OwnerScope] == "OskInstance") && ([u2::GetValue $op OperationKind] == "OkNormal")} {
      JEE5CreateOrUpdate $sel $newIfc $op
    }
  }
  
  # Add to diagram if we clicked on an InterfaceSymbol
  if {$cls != ""} {
    set err ""
    set myDiag [u2::GetEntity $cls Diagram]
    
    # Get current list of diagram elements
    set preDiagElements [u2::GetEntities $myDiag DiagramElement]
    
    # Populate diagram
    set a [u2::FindByGuid $session "@TTDDiagramAgents@ClassDiagramPopulator"]
    set p [list [list $gens 0] 0 1 1 1]
    set err [u2::InvokeAgent $session $a $myDiag p]

    set postDiagElements [u2::GetEntities $myDiag DiagramElement]
    listcomp4 $preDiagElements $postDiagElements dummyList newSymbols
    
    set lines   [list]
    set symbols [list]
    # Get returned list of symbols and lines
    foreach sym $newSymbols {
      if { [u2::IsKindOf $sym Line] } { lappend lines $sym }
      if { [u2::IsKindOf $sym Symbol] } { lappend symbols $sym }
    }
    
    # Append a 0 to ensure these remain as lists even when there is only one element
    if {[llength $lines] <= 1} {lappend lines 0}
    if {[llength $symbols] <= 1} {lappend symbols 0}
    
    # Refresh symbols
    set a [u2::FindByGuid $session "@TTDDiagramAgents@RefreshSymbol"]
    set p $symbols
    set err [u2::InvokeAgent $session $a $myDiag p]
    
    # Layout 
    set a [u2::FindByGuid $session "@TTDDiagramAgents@SugiyamaLayout"]
    set p [list $lines $symbols 50]
    set err [u2::InvokeAgent $session $a $myDiag p]

    # Route lines
    set a [u2::FindByGuid $session "@TTDDiagramAgents@LineRouter"]
    set p $lines
    set err [u2::InvokeAgent $session $a $myDiag p]
  }
}

################################################################################################
# Check all paremeters of source and destination operation
# Returns 1 if operations are identical, 0 if not
################################################################################################

proc CheckParameters {src dst} {
	set allAttr 0
	set sameAttr 0
	
	foreach srcPar [u2::GetEntities $src Parameter ] {
		set srcName [u2::GetValue $srcPar Name ]
		set srcType [u2::GetValue $srcPar Type] 
		set srcDir [u2::GetValue $srcPar Direction ] 
			foreach dstPar [u2::GetEntities $dst Parameter] {				
				set dstName [u2::GetValue $dstPar Name ]
				set dstType [u2::GetValue $dstPar Type ]
				set dstDir  [u2::GetValue $dstPar Direction ]
					if {($srcName == $dstName) && ($srcType == $dstType) &&  ( ($srcDir == $dstDir) || ( $srcDir=="" && $dstDir == "" ) ) } {
						set sameAttr [expr $sameAttr + 1] 
						continue
					} 
			}		
		set allAttr [expr $allAttr + 1] 
	}
	if {$allAttr == $sameAttr} {
		return 1
	} else {
	return 0
	}
}

################################################################################################
# Copy operations to the Class at the end of a Realization and
# Push Operations from Interface to Class (from Interface pop-up)
################################################################################################
proc JEE5PropagateOperations { cntxt } {
  #global U2
  global msg
  global session
  
  set sel [std::GetSelection]
  set src ""
  set dst ""
  set clsSym ""

  # If selection is a symbol we will work at the Diagram level so we can update the symbol's contents later
  if {[u2::IsKindOf $sel Symbol]} {
    # Get class symbol at other end of Realization Line
    # If more than one, the clsSym variable will stay null because we 
    # can't figure out which symbol to update. Error will get thrown later
    set realizes [u2::GetReferringEntities $sel Src]
    if {[llength $realizes] == 1} {
      set clsSym [u2::GetEntity $realizes Dst]
    }
    # Now change sel variable so it's the model element
    set sel [u2::GetEntity $sel ModelElement]
  }

  # Child may not be directly linked diagrammatically, need to look at referring entities
  # and work there for creating model elements, then we will come back and update
  # the diagram if we found only one line & class symbol
  set realizes ""
  set gens [u2::GetReferringEntities $sel Parent]
  foreach gen $gens {
    if {[u2::GetValue $gen isRealization]} {
      lappend realizes $gen
    }
  }
  
  # Nothing to copy from!
  if {([llength $gens] == 0) || ([llength $realizes] == 0)} {
    std::MessageDialog -name $msg(dlgName) -message $msg(NoGens) -icon warning -style ok
    return
  }
  
 
  foreach gen3 $gens {
      if { [u2::GetValue $gen3 isRealization] } {
	  
	  set cls [u2::GetEntity $gen3 Child]
	  
	  # Now, copy operations to the class and update the class symbol
	  # Copy only public methods and methods without visibility 
	  set isAlready 0
	  
	  foreach op [u2::GetEntities $sel OwnedMember] {
	      
	      if {[u2::IsKindOf $op Operation] && ( ( [u2::GetValue $op Visibility] == "VkPublic" ) || ( [u2::GetValue $op Visibility] == "VkNoVisibility" ) ) } {
		  #loop all operations inside a class and if there is on inside a name 
		  foreach classOperation [u2::GetEntities $cls OwnedMember] {
		      if { [u2::GetValue $classOperation Name] == [u2::GetValue $op Name] } {
			  if { [ CheckParameters $op $classOperation ] } {
			      std::Output "Operation [u2::GetValue $classOperation Name ] already exist, skipping ... \n"
			      set isAlready 1
			      break
			  }
		      } 
		  } 
		  if { $isAlready == 0 } {
		      set newOp [JEE5CreateOrUpdate $sel $cls $op]
		      # Set the opration as Public
		      u2::SetValue $newOp Visibility VkPublic
		      # if we were called from a symbol then add to symbol
		      if {$clsSym != ""} {
			  set opLbl [u2::Create $clsSym OperationLabel]
			  u2::SetEntity $opLbl Definition $newOp
		      }
		  }
		  set isAlready 0
	      }  
	  }
      }
  }	
  
  if {$clsSym != ""} {  
      # Refresh symbols
      set myDiag [u2::GetEntity $clsSym Diagram]
      set a [u2::FindByGuid $session "@TTDDiagramAgents@RefreshSymbol"]
      set p [list $clsSym 0]
      set err [u2::InvokeAgent $session $a $myDiag p]
  }
  
}

################################################################################################
# Copy operations from a Realized Interface and
# Copy Operations from Interface to Class (from Class pop-up)
################################################################################################
proc JEE5GetOperations { cntxt } {  
  global msg
  #global U2
  global session
  
  set clsSym ""
  set sel [std::GetSelection]
  if {[u2::IsKindOf $sel Symbol]} {
    set clsSym $sel
    set sel [u2::GetEntity $sel ModelElement]
  }
  
  # Get operations from other end of realized interface
  set gens [u2::GetEntities $sel Generalization]

  set realizes ""
  foreach gen $gens {
    if {[u2::GetValue $gen isRealization]} {
      lappend realizes $gen
    }
  }
  
  # Nothing to copy from!
  if {([llength $gens] == 0) || ([llength $realizes] == 0)} {
    std::MessageDialog -name $msg(dlgName) -message $msg(NoGens) -icon warning -style ok
     return
  }
  
   foreach gen3 $gens {
    if { [u2::GetValue $gen3 isRealization] } {
    
 	 # Copy only public and without visibility methods
 	 set ifc [u2::GetEntity $gen3 Parent]
 	 set isAlready 0
  	 foreach op [u2::GetEntities $ifc OwnedMember] {
   		 if {[u2::IsKindOf $op Operation] && ( ( [u2::GetValue $op Visibility] == "VkPublic" ) || ( [u2::GetValue $op Visibility] == "VkNoVisibility" ) ) } {
      
  			foreach classOperations [u2::GetEntities $sel OwnedMember] {
				if { [u2::GetValue $classOperations Name] == [u2::GetValue $op Name] } {
					if { [ CheckParameters $op $classOperations ] } {
					std::Output "Operation [u2::GetValue $classOperations Name ] already exist, skipping ... \n"
					set isAlready 1
					break
				}
			}
		}
    
      		if { $isAlready == 0 } {
      	      		set newOp [JEE5CreateOrUpdate $ifc $sel $op]
      			# Set the opration as Public
      			u2::SetValue $newOp Visibility VkPublic
      			# if we were called from a symbol then add to symbol
      			if {$clsSym != ""} {
        			set opLbl [u2::Create $clsSym OperationLabel]
        			u2::SetEntity $opLbl Definition $newOp
      			}
    		} else {
			std::Output "[u2::GetValue $classOperations Name] already exist in class, skipping ... \n"
		}
		set isAlready 0
 	 }
    }
   } 
  }
 
  if {$clsSym != ""} {  
    # Refresh symbols
    set myDiag [u2::GetEntity $clsSym Diagram]
    set a [u2::FindByGuid $session "@TTDDiagramAgents@RefreshSymbol"]
    set p [list $clsSym 0]
    set err [u2::InvokeAgent $session $a $myDiag p]
  }
}

################################################################################################
#
# Return the multiplicity as a string that is the name of the global
# variable. 
#
################################################################################################
proc JEE5GetMult { attr } {
  global msg
  
  set mult ""
  # Abort if "informalMultiplicity" is set...
  if {[u2::GetValue $attr InformalMultiplicity] == "true"} {
    std::Output "*** [u2::GetValue $attr Name]: $msg(InformalWarning)\n"
    return $mult
  }

	set assoc [u2::GetEntity $attr ParticipatesIn]
if { $assoc == 0 } {
	set oneway true
} else {
	
	set assocEnds [u2::GetEntities $assoc AssociationEnd]

	if { [llength $assocEnds] > 1 } { 
		set oneway false
	} else {
		set oneway true
	}
}
	
  # "far" multiplicity (what if any multiplicity is on the "opposite" end -- closest to the class)
  set farRanges [u2::GetEntity $attr Remote]
  # for oneway associations we should always generate "ManyTo..." annotation
  
  if {$farRanges == 0 || $oneway } {
    set mult "manyto"
  } else {
    # this needs to be checked ## 05.06.2007
     set nMult [u2::GetEntity $farRanges Multiplicity]
     foreach range $nMult {
         if { $range == 0 } {
			set mult "manyto"
         } elseif { [u2::IsKindOf $range OpenRange] }  {
				# [1] is OpenRange!!!!
				set Bound [u2::GetEntity $range Boundary]
                set value [u2::GetValue $Bound Value]
				if { $value == 1 && $mult != "manyto" } {
					set mult "oneto"
				} else {
					set mult "manyto"
				}
		 } elseif { [u2::IsKindOf $range ClosedRange] } {
				  set upperBound [u2::GetEntity $range UpperBound]
				  set value [u2::GetValue $upperBound Value]
				  if { $value == 1 && $mult != "manyto" } {
					set mult "oneto"
				  } else {
					set mult "manyto"
				  }
		 }
     }
  }
  # "near" multiplicity
  set nearMult ""
  set nearRanges [u2::GetEntities $attr Multiplicity]
  if {$nearRanges == 0 || $nearRanges == ""} {
    if { $oneway } {
		set nearMult "one"
	} else {
	   set nearMult "many"
	}
  } else {
	foreach range $nearRanges {
         if { [u2::IsKindOf $range OpenRange] }  {
				# [1] is OpenRange!!!!
				set Bound [u2::GetEntity $range Boundary]
                set value [u2::GetValue $Bound Value]
					if { $value == 1 && $nearMult != "many" } {
						set nearMult "one"
					} else {
						set nearMult "many"
					}
            } elseif { [u2::IsKindOf $range ClosedRange] } {
                set upperBound [u2::GetEntity $range UpperBound]
                set value [u2::GetValue $upperBound Value]
				if { $value == 1 && $nearMult != "many" } {
					set nearMult "one"
				} else {
					set nearMult "many"
				}
			}
  		} 
  }
  append mult $nearMult
  return $mult
}


################################################################################################
# Apply appropriate EE stereotypes to the operation depending on the attribute
# Mupltiplicity of attributes in entities are mapped to stereotypes on the 
# associated get operations. The following stereotypes should be applied (all in 
# javax::persistence) OneToOne, OneToMany and ManyToMany. 
################################################################################################
#
# Look at the type, if it's a Class we have to look at the association on both ends
#
proc JEE5SetMult {op attr} {
  global onetoone onetomany manytomany manytoone 
	
  # TRICKY: GetMult returns the name of the variable to use from the global list above
  # onetoone onetomany, etc.
  set mult [JEE5GetMult $attr]  
  if {$mult != ""} {
        u2::ApplyStereotype $op [eval set $mult] fullQualifier
  }
}

################################################################################################
# Create get/set operation from one attribute (from Attribute pop-up) and
# Create get/set operation from a class (list of attributes) from Class pop-up
################################################################################################
proc JEE5CreateOps { cntxt } {
  #global U2
  global session
  global msg
  global agileeegenerated
  global persEntity
  
  # could be one of Class, ClassSymbol or Attribute
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}

  set warnMsg ""  
 
  # If a Class Symbol, save pointer and get model element
  set clsSym ""
  if {[u2::IsKindOf $sel Symbol]} {
    set clsSym $sel
    set sel [u2::GetEntity $sel ModelElement]
  }
    
  # if a Class, get list of Attributes from Model Element
  if {[u2::IsKindOf $sel Class]} {
    set sel [u2::GetEntities $sel Attribute]
  }
  
  set warnMsg ""
  foreach attr $sel {
    # Cache for performance
    set attrName [u2::GetValue $attr Name]
   
    if {$attrName == "" } {
   append warnMsg "$msg(MandatoryAssociation)"
	break
    }
    if {$attr == 0} {
    append warnMsg "$msg(NoAttributeToCopy)"
    	break
    }
    # Uppercase the first letter of the attribute name (convention for Get/Set operations)
    set funcName [string totitle $attrName 0 0]
  
    # See if there is already a Get for this Attribute 
    if {[JEE5Exists [u2::GetEntity $attr Owner] get$funcName ]} {
      if {$warnMsg != ""} {append warnMsg "\n"}
      append warnMsg "$attrName: $msg(GetExists)"
    } else {
      # Create the operation and the body
      if { [u2::GetEntity $attr Type] == 0 } {
      		## TODO add an error or pop-up message
      		append warnMsg "$msg(AttributeShouldHaveAType)"
		break
      }
      
      set body "public [u2::GetValue [u2::GetEntity $attr Type] Name] get${funcName}() { return this.$attrName; }\n"
      set newOp [u2::Parse $session $body  -parseAs Definition]
      # Fix multiplicity...
      set par [u2::GetEntity $newOp Return]
      if {[u2::GetEntity $attr Multiplicity] != 0} {
          u2::SetEntity $par Multiplicity [u2::Clone [u2::GetEntity $attr Multiplicity]]
      }
      u2::SetValue $par InformalMultiplicity [u2::GetValue $attr InformalMultiplicity]
      # Add to Class' list
      u2::SetEntity [u2::GetEntity $attr Owner] OwnedMember $newOp
      u2::Create $newOp TextDiagram
      if {$agileeegenerated == 0 } { return 0 }
      u2::ApplyStereotype $newOp $agileeegenerated minimalQualifier

      # Set the Operation's multiplicity
      # Only add multiplicity IF both ends of the association are <<Entity>>
	  set type [u2::GetEntity $attr Type]		
      if {   [u2::HasAppliedStereotype [u2::GetEntity $attr Owner] [u2::GetValue $persEntity Name]] 
          && [u2::HasAppliedStereotype $type [u2::GetValue $persEntity Name]] } { 
          JEE5SetMult $newOp $attr
      }
   
      
      # if we were called from a symbol then add to symbol
      if {$clsSym != ""} {
        set opLbl [u2::Create $clsSym OperationLabel]
        u2::SetEntity $opLbl Definition $newOp
      }
    }
  
    # See if there is already a Set for this Attribute 
    if {[JEE5Exists [u2::GetEntity $attr Owner] set$funcName ]} {
      if {$warnMsg != ""} {append warnMsg "\n"}
      append warnMsg "$attrName: $msg(SetExists)" 
    } else {
      # Create the operation and the body
      set body "public void set${funcName}( [u2::GetValue [u2::GetEntity $attr Type] Name] val ) { this.$attrName = val; }"
      set newOp [u2::Parse $session $body -parseAs Definition]
      # Fix multiplicity...
      set par [u2::GetEntity $newOp Parameter -index 1]
      if {[u2::GetEntity $attr Multiplicity] != 0} {
          u2::SetEntity $par Multiplicity [u2::Clone [u2::GetEntity $attr Multiplicity]]
      }
      u2::SetValue $par InformalMultiplicity [u2::GetValue $attr InformalMultiplicity]
      #
      u2::SetEntity [u2::GetEntity $attr Owner] OwnedMember $newOp
      u2::Create $newOp TextDiagram
      u2::ApplyStereotype $newOp $agileeegenerated minimalQualifier 

      # Don't set the Operation's multiplicity for "set" functions
#      JEE5SetMult $newOp $attr
      
      # if we were called from a symbol then add to symbol
      if {$clsSym != ""} {
        set opLbl [u2::Create $clsSym OperationLabel]
        u2::SetEntity $opLbl Definition $newOp
      }
    }
  }

  # Refresh symbols
  if {$clsSym != ""} {  
    set myDiag [u2::GetEntity $clsSym Diagram]
    set a [u2::FindByGuid $session "@TTDDiagramAgents@RefreshSymbol"]
    set p [list $clsSym 0]
    set err [u2::InvokeAgent $session $a $myDiag p]
  }

  if {$warnMsg != ""}  {
    std::MessageDialog -name $msg(dlgName) -message $warnMsg -style ok -icon warning
  }
}

################################################################################################
# Update get/set operations (create get/set operations for all attributes on <<Entity>> and Package pop-up)
# (not used)
################################################################################################
proc JEE5SyncOperations {cntxt} {
  std::MessageDialog -name "AgileEE" -message "Not yet implemented" -icon stop -style ok
}
