# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
###################################################################################
#
# This is all commands to apply different stereotypes
#
###################################################################################

###################################################################################
#
# <<Local>>
#
###################################################################################
proc JEE5ApplyLocal { cntxt } {
  #global U2
  global ejbLocal
  
  set sel [std::GetSelection]
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}
    if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }
  
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbLocal Name]]} { return }
  u2::ApplyStereotype $sel $ejbLocal fullQualifier  

  # Set the class as Public
  u2::SetValue $sel Visibility VkPublic
}

###################################################################################
#
# <<Remote>>
#
###################################################################################
proc JEE5ApplyRemote { cntxt } {
  #global U2
  global ejbRemote
  
  set sel [std::GetSelection]
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}
  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }
  
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbRemote Name]]} { return }
  u2::ApplyStereotype $sel $ejbRemote fullQualifier  

  # Set the class as Public
  u2::SetValue $sel Visibility VkPublic
}

###################################################################################
#
# <<Stateful>>
#
###################################################################################
proc JEE5ApplyStateful { cntxt } {
  #global U2
  global ejbStateful
  
  set sel [std::GetSelection]
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}
  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }

  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbStateful Name]]} { return }
  
  u2::ApplyStereotype $sel $ejbStateful fullQualifier  

  # Set the class as Public
  u2::SetValue $sel Visibility VkPublic
}

###################################################################################
#
# <<Stateless>>
#
###################################################################################
proc JEE5ApplyStateless { cntxt } {
  #global U2
  global ejbStateless
  
  set sel [std::GetSelection]
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}
  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }
  
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbStateless Name]]} { return }
  
  u2::ApplyStereotype $sel $ejbStateless fullQualifier  

  # Set the class as Public
  u2::SetValue $sel Visibility VkPublic
}

###################################################################################
#
# <<MessageDriven>>
#
###################################################################################
proc JEE5ApplyMessageDriven { cntxt } {
  #global U2
  global ejbMessageDriven
  
  set sel [std::GetSelection]
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}
  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }
  
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbMessageDriven Name]]} { return }
  
  u2::ApplyStereotype $sel $ejbMessageDriven fullQualifier  

  # Set the class as Public
  u2::SetValue $sel Visibility VkPublic
}

###################################################################################
#
# <<Entity>>
#
###################################################################################
proc JEE5ApplyEntity { cntxt } {
  #global U2
  global persEntity
  global agileeegenerated
  global session

  set sel [std::GetSelection]
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}

  set clsSym ""
  if {[u2::IsKindOf $sel Symbol]} {
    set clsSym $sel
    set sel [u2::GetEntity $sel ModelElement]
  }
  
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $persEntity Name]]} { return }
  
  u2::ApplyStereotype $sel $persEntity fullQualifier  
  
  # Create a default constructor
  # Create the operation and the body
  set clName [u2::GetValue $sel Name]
  set newOp [u2::Create $sel Operation]
  u2::SetValue $newOp Name $clName
  u2::SetValue $newOp Visibility VkPublic
  u2::Create $newOp TextDiagram
  u2::ApplyStereotype $newOp $agileeegenerated minimalQualifier
  
  # Add operation to the class symbol if we were called from there
  if {$clsSym != ""} {
    set opLbl [u2::Create $clsSym OperationLabel]
    u2::SetEntity $opLbl Definition $newOp
    set myDiag [u2::GetEntity $clsSym Diagram]
    set a [u2::FindByGuid $session "@TTDDiagramAgents@RefreshSymbol"]
    set p [list $clsSym 0]
    set err [u2::InvokeAgent $session $a $myDiag p]
    if {$err != ""} {std::Output "Refresh-Err: $err\n"}
  }

  # Set the class as Public
  u2::SetValue $sel Visibility VkPublic
}

################################################################################################
#
# See if a named element already exists inside the scope of parent element
#
################################################################################################
proc JEE5FindOp {el subName} {
 foreach child [u2::GetEntities $el OwnedMember] {
    if {[u2::GetValue $child Name] == $subName} {
      return $child
    }
  }

  return 0
}


###################################################################################
#
# Show all generated elements
# called from Edit menu
###################################################################################
proc JEE5FindGenerated { cntxtr } {
  #global U2
  global session

  set query "GetAllEntities().select(HasAppliedStereotype(\"AgileEEGenerated\"))"
  set s [std::GetSelection]
  set a [u2::FindByGuid $session "@TTDQuery@ExecuteQueryExpression"]
  set p [lappend p {} $query]
  u2::InvokeAgent $session $a $s p

  std::ReportInit "Agile EE" -ident agilee "Element" 200 0 "Kind" 100 0 "Location" 400 0
  
  foreach el [lindex $p 0] {
    std::Report $el -ident agilee [u2::GetMetaClassName $el] [u2::GetValue [u2::GetEntity $el Owner] Name]
  }
  
}

###################################################################################
#
# <<PK>>
# called from Attribute pop-up
###################################################################################
proc JEE5SetPK { cntxt } {
  #global U2
  global persId
  global agileeegenerated
  global session
  
  # Save selection if we were called from a symbol pop-up
  set sel [std::GetSelection]
  set clsSym ""
  if {[llength $sel] > 1} {set sel [lindex $sel 0]}
  if {[u2::IsKindOf $sel Symbol]} {
    set clsSym $sel
    set sel [u2::GetEntity $sel ModelElement]
  }

  # Apply the stereotype to the corresponding "get" operation, create it if it doesn't exist
  set attrName [u2::GetValue $sel Name]
  # Uppercase the first letter of the attribute name (convention for Get/Set operations)
  set funcName [string totitle $attrName 0 0]

  # See if there is already a Get for this Attribute, if not create it
  set newOp [JEE5FindOp [u2::GetEntity $sel Owner] get$funcName]
  if {$newOp == 0} {
    # Create the operation and the body
    set body "public [u2::GetValue [u2::GetEntity $sel Type] Name] get${funcName}() { return this.$attrName; }\n"
    set newOp [u2::Parse $session $body Definition]
    # Add to Class' list
    u2::SetEntity [u2::GetEntity $sel Owner] OwnedMember $newOp
    u2::Create $newOp TextDiagram
    u2::ApplyStereotype $newOp $agileeegenerated minimalQualifier

    # Set the Operation's multiplicity
    JEE5SetMult $newOp $sel
    
    # if we were called from a symbol then add to symbol
    if {$clsSym != ""} {
      set opLbl [u2::Create $clsSym OperationLabel]
      u2::SetEntity $opLbl Definition $newOp
    }
  }
  
  # Got to here then we have an operaiton 
  if {[u2::HasAppliedStereotype $newOp [u2::GetValue $persId Name]]} { return }
  
  u2::ApplyStereotype $newOp $persId fullQualifier  
}
