# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#############################################################
#############################################################
#
# Menu strings externalized in the file JEE5Msg.tcl
#
#############################################################
#############################################################
#
# Create menus
#
proc JEE5IsInterface {ident} {
  
  # Only allow 1 selection
  set sel [std::GetSelection]
  set allProjs [std::GetProject]
  foreach p $allProjs {
  if { $sel == $p } {return 0 }
  }
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }

  # Make sure is right kind of element
  if [catch {
    if {!([u2::IsKindOf $sel Interface])} {
      return 0
    }
  } err] {return 0}
  
  return 1
}

proc JEE5IsUnStInterface {ident} {
  global ejbLocal ejbRemote
  
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  
  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }

  # Enable only if no "Local" or "Remote" is already present 
  # otherwise fall through for more processing
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbLocal Name]]} { return 0 }
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $ejbRemote Name]]} { return 0}

  # Make sure is right kind of element
  if [catch {
    if {!([u2::IsKindOf $sel Interface])} {
      return 0
    }
  } err] {return 0}
  
  return 1
}

proc JEE5IsClass {ident} {
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  if [catch {
    if {!([u2::IsKindOf $sel Class] || [u2::IsKindOf $sel ClassSymbol])} {
      return 0
    }
  } err] {return 0}
  return 1
}

# Only enable if class and no EJB stereotypes
proc JEE5NotEjbClass {ident} {
  global ejbStateless ejbStateful ejbMessageDriven
  
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}

  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }

  # Enable only if no ejb sterotypes are already present 
  # otherwise fall through for more processing
  foreach st [list $ejbStateless $ejbStateful $ejbMessageDriven] { 
    if {[u2::HasAppliedStereotype $sel [u2::GetValue $st Name]]} { return 0 }
  }
  
  if [catch {
    if {!([u2::IsKindOf $sel Class])} {
      return 0
    }
  } err] {return 0}
  return 1
}

# Only enable if class and not Entity stereotypes
proc JEE5ClassNotEntity {ident} {
  global persEntity
  
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}

  if {[u2::IsKindOf $sel Symbol]} {
    set sel [u2::GetEntity $sel ModelElement]
  }

  # Enable only if no Entity sterotypes are already present 
  # otherwise fall through for more processing
  if {[u2::HasAppliedStereotype $sel [u2::GetValue $persEntity Name]]} { return 0 }
  
  if [catch {
    if {!([u2::IsKindOf $sel Class])} {
      return 0
    }
  } err] {return 0}
  return 1
}


proc JEE5IsAttribute {ident} {
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  if [catch {
    if {!([u2::IsKindOf $sel Attribute])} {
      return 0
    }
  } err] {return 0}
  return 1
}

proc JEE5IsOperation {ident} {
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} { return 0}
  if {$sel == ""} {return 0}
  if [catch {
    if {!([u2::IsKindOf $sel Operation])} {
      return 0
    }
  } err] {return 0}
  return 1
}

proc JEE5IsEntityOrPkg {ident} {
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} {return 0}
  if {$sel == ""} {return 0}

  # TODO: Add check for <<Entity>> here
  if [catch {
    if {!([u2::IsKindOf $sel Class] || [u2::IsKindOf $sel Package])} {
      return 0
    }
  } err] {return 0}
  return 1
}

proc JEE5IsPackage {ident} {
  # Only allow 1 selection
  set sel [std::GetSelection]
  if {[llength $sel] != 1} {return 0}
  if {$sel == ""} {return 0}

  if [catch {
    if {!([u2::IsKindOf $sel Package])} {
      return 0
    }
  } err] {return 0}
  return 1
}

################################################################################################
#
#  Init
#
################################################################################################
proc InitJEE5Menus {} {
  global msg
  
  # Menus for applying stereotypes
  std::AddCommand -variable vJEE5ApplyStateful -name $msg(StatefulMenu) -statusmessage  $msg(StatefulStatus) -accelerator "" -imagefile "" -tooltip  $msg(StatefulTip) -OnActivateCommand "JEE5ApplyStateful" -OnEnableCommand JEE5NotEjbClass
  
  std::AddCommand -variable vJEE5ApplyStateless -name $msg(StatelessMenu) -statusmessage  $msg(StatelessStatus) -accelerator "" -imagefile "" -tooltip $msg(StatelessTip) -OnActivateCommand "JEE5ApplyStateless" -OnEnableCommand JEE5NotEjbClass
  
  std::AddCommand -variable vJEE5ApplyMessageDriven -name $msg(MDMenu) -statusmessage  $msg(MDStatus) -accelerator "" -imagefile "" -tooltip $msg(MDTip) -OnActivateCommand "JEE5ApplyMessageDriven" -OnEnableCommand JEE5NotEjbClass
  
  std::AddCommand -variable vJEE5ApplyEntity -name $msg(EntityMenu) -statusmessage $msg(EntityStatus) -accelerator "" -imagefile "" -tooltip $msg(EntityTip) -OnActivateCommand "JEE5ApplyEntity" -OnEnableCommand JEE5ClassNotEntity

  # Only allow if an unstereotyped interface
  std::AddCommand -variable vJEE5ApplyLocal -name $msg(LocalMenu) -statusmessage $msg(LocalStatus) -accelerator "" -imagefile "" -tooltip $msg(LocalTip) -OnActivateCommand "JEE5ApplyLocal" -OnEnableCommand JEE5IsUnStInterface
  
  # Only allow if an unstereotyped interface
  std::AddCommand -variable vJEE5ApplyRemote -name $msg(RemoteMenu) -statusmessage $msg(RemoteStatus) -accelerator "" -imagefile "" -tooltip $msg(RemoteTip) -OnActivateCommand "JEE5ApplyRemote" -OnEnableCommand JEE5IsUnStInterface
  
  # PopUp to create an implementation class from an Interface
  # Allow on any interface
  std::AddCommand -variable vJEE5Impl -name $msg(ImplMenu) -statusmessage $msg(ImplStatus) -accelerator "" -imagefile "" -tooltip $msg(ImplTip) -OnActivateCommand "JEE5CreateImpl" -OnEnableCommand JEE5IsInterface

  std::AddCommand -variable vJEE5CreateInterface -name $msg(IntfcMenu) -statusmessage $msg(IntfcStatus) -accelerator "" -imagefile "" -tooltip $msg(IntfcTip) -OnActivateCommand "JEE5CreateInterface" -OnEnableCommand JEE5IsClass

  # Menus to manage Operations
  # Push Operations from Interface to Class (from Interface pop-up)
  std::AddCommand -variable vJEE5PropagateOperations -name $msg(PropagateMenu) -statusmessage $msg(PropagateStatus) -accelerator "" -imagefile "" -tooltip $msg(PropagateTip) -OnActivateCommand "JEE5PropagateOperations" -OnEnableCommand JEE5IsInterface

  # Copy Operations from Interface to Class (from Class pop-up)
  std::AddCommand -variable vJEE5GetOperations -name $msg(GetMenu) -statusmessage $msg(GetStatus) -accelerator "" -imagefile "" -tooltip $msg(GetTip) -OnActivateCommand "JEE5GetOperations" -OnEnableCommand JEE5IsClass

  # Update get/set operations (create get/set operations for all attributes on <<Entity>> and Package pop-up)
#  std::AddCommand -variable vJEE5SyncOps -name $msg(SyncMenu) -statusmessage $msg(SyncStatus) -accelerator "" -imagefile "" -tooltip $msg(SyncTip) -OnActivateCommand "JEE5SyncOperations" -OnEnableCommand JEE5IsEntityOrPkg

  # Create get/set operation from attribute (from Attribute pop-up)
  std::AddCommand -variable vJEE5CreateOps -name $msg(COpsMenu) -statusmessage $msg(COpsStatus) -accelerator "" -imagefile "" -tooltip $msg(COpsTip) -OnActivateCommand "JEE5CreateOps" -OnEnableCommand JEE5IsAttribute

  std::AddCommand -variable vJEE5CreateOpsFromClass -name $msg(COpsMenu) -statusmessage $msg(COpsStatus) -accelerator "" -imagefile "" -tooltip $msg(COpsTip) -OnActivateCommand "JEE5CreateOps" -OnEnableCommand JEE5IsClass

  # Set Primary Key
  std::AddCommand -variable vJEE5SetPK -name $msg(PKMenu) -statusmessage $msg(PKStatus) -accelerator "" -imagefile "" -tooltip $msg(PKTip) -OnActivateCommand "JEE5SetPK" -OnEnableCommand JEE5IsAttribute

  # Find
  std::AddCommand -variable vFind -name $msg(FindMenu) -statusmessage $msg(FindStatus) -accelerator "" -imagefile "" -tooltip $msg(FindTip) -OnEnableCommand JEE5IsPackage -OnActivateCommand "JEE5FindGenerated"

  std::AddMenu -variable mFind -commands {separator vFind} -path {&Edit} -position last
    
  #Class Pop-up menu
  std::AddContextMenu -variable vClassMenu -commands { separator vJEE5ApplyStateful vJEE5ApplyStateless vJEE5ApplyMessageDriven vJEE5ApplyEntity vJEE5CreateInterface vJEE5CreateOpsFromClass vJEE5GetOperations} -onenablemenu JEE5IsClass

  # Interface pop-up menu
  std::AddContextMenu -variable vIntfcMenu -commands { separator vJEE5Impl vJEE5ApplyLocal vJEE5ApplyRemote vJEE5PropagateOperations} -onenablemenu JEE5IsInterface
    
  # Attribute pop-up menu
  std::AddContextMenu -variable vAttrMenu -commands { separator vJEE5SetPK vJEE5CreateOps } -onenablemenu JEE5IsAttribute
    
  # Package or <<Entity>>Class pop-up menu
#  std::AddContextMenu -variable vAttrMenu -commands { separator vJEE5SyncOps } -onenablemenu JEE5IsEntityOrPkg

}
