package com.telelogic.tau.tor;

public interface EventExecutor
{
	public enum EventAction
	{
		NoMatch,      // Event was not handled by receiver
        Defer,        // Event was saved by receiver
        Consumed      // Event was consumed by receiver  
	};
	
	// Executes the supplied event and returns the status to indicate 
    // how the event was handled.
    public EventAction execute(Event event);
    
    // Get the unique ID of this event executor
    public long getExecutorId();
}
