package com.telelogic.tau.tor;

import com.telelogic.tau.tor.os.Time;

public abstract class Utilities
{
	public static boolean sendTo(Event e, EventReceiver receiver)
	{
		if (receiver == null)
		      return false; // No receiver specified!

		  // Send the event to the receiver.
		  return receiver.receive(e); 
	}

	// Sends an event via a port.
    // Returns true if the event was consumed by the receiver, false otherwise.
	public static boolean sendTo(Event e, Port p) 
	{
		  if (p == null)
		      return false; // No port specified!

		  // Send the event to the port.
		  return p.send(e);
	}
	
	// Sets the unit of time to be used by the run-time library.
    // The time unit is specified in seconds. 
    // Example: To specify a time unit of 1 millisecond, call 
    // setTimeUnit(0.001)
	public static void setTimeUnit(double seconds)
	{
		Time.setUnit(seconds);
	}
}
