package com.telelogic.tau.tor.os;

import java.util.concurrent.TimeUnit;

public class Semaphore 
{    
    public Status init(int initialCount) 
    { 
    	m_rep = new java.util.concurrent.Semaphore(initialCount);
    	return Status.StatusOK;
    }

    public Status init() 
    { 
    	return init(0);
    }
   
    public Status destroy() 
    { 
    	m_rep = null; 
    	return Status.StatusOK;
    }

    public Status put() 
    { 
    	m_rep.release(); 
    	return Status.StatusOK;
    }
    
    public Status get() 
    { 
    	m_rep.acquireUninterruptibly();
    	return Status.StatusOK;
    }

    // Get with time-out
    public Status get(Time timeout)
    {
    	long duration = 0;
    	
    	Time now = Time.now();
    	if (timeout.compareTo(now) > 0) // timeout > now
            duration = new Time(timeout, now).to_ms();
        
    	try
    	{
    		if (!m_rep.tryAcquire(duration, TimeUnit.MILLISECONDS))
    			return Status.StatusTIMEOUT;
    	}
    	catch (InterruptedException e)
    	{
    		return Status.StatusFAIL;
    	}
    	
    	return Status.StatusOK;
    }
    
    private java.util.concurrent.Semaphore m_rep;
};

