# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
Output "\nJava support loading ... \n"

package require commands
package require dialogs

set installDir [std::GetInstallationDirectory]
if { (2 == [string length $installDir]) && (":" == [string index $installDir end]) } {
        set installDir ${installDir}/
}

source  [file join $installDir addins/JavaApplication/Script/nameUtils.tcl]
source  [file join $installDir addins/JavaApplication/Script/JavaUtils.tcl]

proc EnabledAlways {e} {
  return 1
}    

proc EnabledIfProfileLoaded { cmd } {
        if [IsProfileLoaded [GetActiveSession]] {
                return 1
        } else {
                return 0
        }
}

proc OnImportDirectory {command} {
  output "\n----------------------------------------\n"
  set dir [DirectoryDialog]
  if {$dir == 0} {
     return
  }
  #output "\n\nUpdating model from directory: $dir ... \n"
  StoreAutoCheckOptions
  
  ##################### Invokation of agent ###############
        set curProject [std::GetActiveProject]
        set model [std::GetModels -kind "U2" -project $curProject]
        set agent [u2::FindByGuid $model "@JavaAgent@ImportDirectory"]
        
        if { 0 == $agent } {
                std::Output "Failed to find Import Java agent \n"
                # failed to find agent
                return 0
        }
        set param [lappend param $dir [GetProjectDir $curProject]]

        if { [catch {
          u2::InvokeAgent $model $agent $model param
         } e ] } {
                std::Output "Error when invoking Import Java agent : $e\n"
        }
        RestoreAutoCheckOptions  
        Output "\nDone\n"
        return
}

proc OnExportPackage {command} {
    set elem [std::GetSelection] 
    if [u2::IsKindOf $elem PackageSymbol] {
        set target [u2::GetEntity $elem ModelElement]
    } else {
        set target $elem
    }

    set dir [DirectoryDialog -filter "Select directory (*.*)|*.*||"]
    if {($dir == 0) || ![file exists $dir]} {
        return
    }


    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set model [std::GetModels -kind "U2" -project $activeProject]
        set agent [u2::FindByGuid $model @TTDJavaModelCodeSync@Menu@ExportToDirectory]
        
        if { 0 == $agent } {
            std::Output "Failed to find ExportToDirectory agent \n"
            # failed to find agent
            return 0
        }

        set param [list $dir]

        if { [catch {
            u2::InvokeAgent $model $agent $target param
        } e ] } {
            std::Output "Error when invoking Generate Java agent : $e\n"
        }
    }
}

proc OnConvertToJavaPackage { command } {
  set elem [std::GetSelection] 
  if [u2::IsKindOf $elem PackageSymbol] {
    set target [u2::GetEntity $elem ModelElement]
  } else {
    set target $elem
  }
  if {[u2::IsKindOf $target Package]} {
  	ConvertToJavaPackage $target
  }
}

###################  Update Java from Model #####################

proc OnUpdateJava {command} {
  output "\n----------------------------------------\n"
  Output "\n\nUpdating files from model ...\n"
  foreach elem [std::GetSelection] {
        set target $elem
        if [u2::IsKindOf $elem PresentationElement] {
                set target [u2::GetEntity $elem ModelElement]
        }
        
        set curProject [std::GetActiveProject]
        set model [std::GetModels -kind "U2" -project $curProject]
        set agent [u2::FindByGuid $model "@JavaAgent@UpdateJava"]
        
        if { 0 == $agent } {
                std::Output "Failed to find Import Java agent \n"
                # failed to find agent
                return 0
        }
        set param [lappend param [GetProjectDir $curProject]]

        if { [catch {
          u2::InvokeAgent $model $agent $elem param
         } e ] } {
                std::Output "Error when invoking Update Java agent : $e\n"
        }
  }
  Output "\nDone\n"
}


# Update model from files
proc OnUpdateModel {command} {
  output "\n----------------------------------------\n"
  Output "\n\nUpdating model from files ...\n"
  StoreAutoCheckOptions

        set curProject [std::GetActiveProject]
        set model [std::GetModels -kind "U2" -project $curProject]
        set agent [u2::FindByGuid $model "@JavaAgent@UpdateModel"]
        if { 0 == $agent } {
                std::Output "Failed to find Update Java agent \n"
                # failed to find agent
                return 0
        }
        set param [lappend param [GetProjectDir $curProject]]



  foreach elem [std::GetSelection] {
        set target $elem
        if [u2::IsKindOf $elem PresentationElement] {
                set target [u2::GetEntity $elem ModelElement]
        }
        
        ########### Invoke Agent ################
        if { [catch {
          u2::InvokeAgent $model $agent $elem param
         } e ] } {
                std::Output "Error when invoking Update Java agent : $e\n"
        }
  }
  RestoreAutoCheckOptions
  Output "\nDone\n"
}

proc OnUpdateModelProject {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set model [std::GetModels -kind "U2" -project $activeProject]
        set agent [u2::FindByGuid $model @TTDJavaModelCodeSync@Menu@UpdateAll]
        
        if { 0 == $agent } {
            std::Output "Failed to find Update Java agent \n"
            # failed to find agent
            return 0
        }
        set param {1}

        if { [catch {
            u2::InvokeAgent $model $agent $model param
        } e ] } {
            std::Output "Error when invoking Update Java agent : $e\n"
        }
    }
}

proc OnUpdateModelProjectForce {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set model [std::GetModels -kind "U2" -project $activeProject]
        set agent [u2::FindByGuid $model @TTDJavaModelCodeSync@Menu@UpdateAll]
        
        if { 0 == $agent } {
            std::Output "Failed to find Update Java agent \n"
            # failed to find agent
            return 0
        }
        set param {0}

        if { [catch {
            u2::InvokeAgent $model $agent $model param
        } e ] } {
            std::Output "Error when invoking Update Java agent : $e\n"
        }
    }
}

proc OnUpdateJavaProject {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set model [std::GetModels -kind "U2" -project $activeProject]
        set agent [u2::FindByGuid $model @TTDJavaModelCodeSync@Menu@GenerateAll]
        
        if { 0 == $agent } {
            std::Output "Failed to find Generate Java agent \n"
            # failed to find agent
            return 0
        }
        set param {1}

        if { [catch {
            u2::InvokeAgent $model $agent $model param
        } e ] } {
            std::Output "Error when invoking Generate Java agent : $e\n"
        }
    }
}

proc OnUpdateJavaProjectForce {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set model [std::GetModels -kind "U2" -project $activeProject]
        set agent [u2::FindByGuid $model @TTDJavaModelCodeSync@Menu@GenerateAll]
        
        if { 0 == $agent } {
            std::Output "Failed to find Generate Java agent \n"
            # failed to find agent
            return 0
        }

        set param {0}

        if { [catch {
            u2::InvokeAgent $model $agent $model param
        } e ] } {
            std::Output "Error when invoking Generate Java agent : $e\n"
        }
    }
}

###################  Trace #####################

proc OnNewTraceSessionCommand {command} {

    set session [GetActiveSession]
    set resource [GetResource $session]
    if {$resource == 0} {
        output "\nError: Unable to get resource!"
        return 0

    }
    
    set packageNameTemplate "JavaTrace"
    set packageNumber 0
    set foundPackage 0
    
    set members [u2::GetEntities $session OwnedMember]
    while {1} {
      foreach element $members {
        if {0 == $element} {
          continue
        }
        if {[u2::IsKindOf $element Package]} {
          set pkgName [u2::GetValue $element Name]
          
          #output "\nFound package $pkgName"
          
          if {$packageNumber == 0} {
            if { "$pkgName" == "$packageNameTemplate" } {
              
              #output "\nIncrement because of $pkgName"               
              
              set packageNumber [ expr $packageNumber+1 ]
              set foundPackage 1
              break              
            } else {
            
              #output "\nNot found at all"
              
              set foundPackage 0
            }
          } else {
             if { "$pkgName" == "$packageNameTemplate$packageNumber" } {
              
              #output "\nIncrement because of $pkgName"
              
              set packageNumber [ expr $packageNumber+1 ]
              set foundPackage 1
              break              
            } else {
            
              #output "\nNot found with number $packageNumber"
            
              set foundPackage 0
            } 
          }
        }
     }
     
     #output "\nNew Iteration with number $packageNumber"
     
     if {$foundPackage == 0} {
      
        #output "\nVerdikt: $packageNumber"
     
       break
     }
   }


    set package [u2::Create $resource Package]
    
    if { $packageNumber == 0 } {
      u2::SetValue $package Name "$packageNameTemplate"
    } else {
      u2::SetValue $package Name "$packageNameTemplate$packageNumber"      
    }
  
    set javaTraceStereotype [FindByGuid $session "@TTDJavaModelCodeSync@javaTrace"]
    set javaTraceStereotypeInstance [ApplyStereotype $package $javaTraceStereotype]
    
    u2::Save $session
    
    set agent [u2::FindByGuid $session @TTDAgent@ActivatePropertiesEditor ]
        
    if { 0 == $agent } {
        std::Output "Failed to find Activate Properties Editor agent \n"
        # failed to find agent
        return 0
    }
    
    if { [catch {
        u2::InvokeAgent $session $agent $javaTraceStereotypeInstance
    } e ] } {
        std::Output "Error when invoking Activate Properties Editor agent : $e\n"
    }
}

proc OnCompileJava {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set model [std::GetModels -kind "U2" -project $activeProject]
        set agent [u2::FindByGuid $model @TTDJavaModelCodeSync@Menu@CompileAll]
        
        if { 0 == $agent } {
            std::Output "Failed to find Compile Java agent \n"
            # failed to find agent
            return 0
        }

        set param {}

        if { [catch {
            u2::InvokeAgent $model $agent $model param
        } e ] } {
            std::Output "Error when invoking Compile Java agent : $e\n"
        }
    }
}

###################  Execute Java File #####################

proc OnExecuteJava {command} {
  output "\n----------------------------------------\n"
  set elem [std::GetSelection]
  if [u2::IsKindOf $elem PresentationElement] {
    set target [u2::GetEntity $elem ModelElement]
  } else {
    set target $elem
  }
  if [u2::IsKindOf $target Class] {
    ExecuteJavaClass $target
  } elseif [u2::IsKindOf $target Artifact] {
        # OnExecuteJava is only enabled if there's only one manifested element
        ExecuteJavaClass [lindex [GetManifested $target] 0]
  }
}

proc OnExecuteJavaWithOptions { command } {
  package require dialogs
  Dialog -variable "ExecuteJavaWithOptions" -name "Execute Java class" -w 365 -h 160 -onbuilddialog CreateExecuteOptionsDialog -oninitdialog InitDialog -onclosedialog DialogCloseDummy -closecmddialog CloseDialog
}

###################  Execute Java Applet #####################

proc OnExecuteJavaApplet {command} {
  output "\n----------------------------------------\n"
  set elem [std::GetSelection]
  if [u2::IsKindOf $elem PresentationElement] {
    set target [u2::GetEntity $elem ModelElement]
  } else {
    set target $elem
  }
  if [u2::IsKindOf $target Class] {
    set dir [GetJavaDirectory $target]
    ExecuteJavaApplet $dir $target
  } elseif [u2::IsKindOf  $target Artifact] {
        set dir [GetJavaDirectory $target]
        # OnExecuteJava is only enabled if there's only one manifested element
        ExecuteJavaApplet $dir [lindex [GetManifested $target] 0]
  }
}


###################  Export JAR File #####################

proc OnExportToJarFile {command} {
  output "\n----------------------------------------\n"
  set elem [std::GetSelection]
  if [u2::IsKindOf $elem PackageSymbol] {
    set target [u2::GetEntity $elem ModelElement]
  } else {
    set target $elem
  }
  set destinationDir [DirectoryDialog -filter "Select destination directory (*.*)|*.*||"]
  if {$destinationDir == 0} {
    return
  }
  set destinationFile [file join $destinationDir "[u2::GetValue $target Name].jar"]

  output "Starting generation of JAR file ...\n"
  output [ExportPackageToJAR $target $destinationFile]

  output "\nDone\n"
}


###################  Import JAR file #####################

proc OnUpdateModelFromJarFile {command} {
  output "\n----------------------------------------\n"
  set jarFile [FileOpenDialog -filter "JAR files (*.jar)|*.jar||"]
  if {$jarFile == 0} {
     return
  }

  output "\nUpdating model from .jar file: $jarFile ... "
  StoreAutoCheckOptions
  
  ######################## invoke agent ###################
  set curProject [std::GetActiveProject]
  set model [std::GetModels -kind "U2" -project $curProject]
  set agent [u2::FindByGuid $model "@JavaAgent@ImportJar"]
        
  if { 0 == $agent } {
        std::Output "Failed to find Import Java agent \n"
        # failed to find agent
        return 0
  }
  set param [lappend param $jarFile [GetProjectDir $curProject]]
  if { [catch {
    u2::InvokeAgent $model $agent $model param
   } e ] } {
        std::Output "Error when invoking Import Java agent : $e\n"
  }
  RestoreAutoCheckOptions
  output "Done\n"
}

proc OnReimportJar {command} {
    set curProject [std::GetActiveProject]
    set model [std::GetModels -kind "U2" -project $curProject]
    set agent [u2::FindByGuid $model "@JavaAgent@ReimportJar"]
    set agentRep [u2::FindByGuid $model @TTDImporter@GetErrorReporter]
    
    if { 0 == $agentRep } {
        std::Output "Failed to find GetErrorReporter agent \n"
        return 0
    }
    
    set param {}
    if { [catch {
        u2::InvokeAgent $model $agentRep $model param
    } e ] } {
        std::Output "Error when invoking GetErrorReporter agent : $e\n"
    }
    set errRep [lindex $param 0]
   

    if { 0 == $agent } {
        std::Output "Failed to find Reimport agent \n"
        return 0
    }

    StoreAutoCheckOptions

    set param [list $errRep]
    foreach elem [std::GetSelection] {  # there is will be only one elem
        if { [catch {
            u2::InvokeAgent $model $agent $elem param
        } e ] } {
            std::Output "Error when invoking Import Java agent : $e\n"
        }
    }

    RestoreAutoCheckOptions
}

###################  Create JavaDoc #####################

proc OnCreateJavaDoc {command} {
    output "\n----------------------------------------\n"
    set elem [std::GetSelection]
    if [u2::IsKindOf $elem PackageSymbol] {
        set target [u2::GetEntity $elem ModelElement]
    } else {
        set target $elem
    }

    set destinationDir [DirectoryDialog -filter "Select destination directory (*.*)|*.*||"]
    if {$destinationDir == 0} {
        return
    }


    set destinationFile [file join $destinationDir "[u2::GetValue $target Name]_doc"]
    file mkdir $destinationFile

    GenerateJavaDoc $target $destinationFile


#  if ![IsUnnamedPackage $target] {
#    set subPackages ${packageName}.*
#    eval "catch {exec << [pid] javadoc -private -d \"${destinationFile}\" -subpackages $subPackages [GetJavaQualifiedName $target]} result"
#    eval "catch {exec << [pid] javadoc -private -d \"${destinationFile}\" [GetJavaQualifiedName $target]} result"
#  } else {
     # unnamed package has name 'defaultPackage' in model, but in the file system it corresponds directory with other name
#     set targetName [file tail [GetJavaDirectory $target]]
#     eval "catch {exec << [pid] javadoc -private -d \"${destinationFile}\" -sourcepath $targetName [file join $targetName *.java]} result"
#  }

}

###################  Use Java syntax #####################

proc OnChangeJavaSyntax {command} {
  if {[llength [std::GetSelection]] == 0} {
        return 0
  }
  foreach elem [std::GetSelection] {
    if {[GetKind $elem] == "U2"} {
        if [u2::IsKindOf $elem PackageSymbol] {
                set target [u2::GetEntity $elem ModelElement]
        } else {
                set target $elem
        }
        if ![JavaSyntax $target] {
                return 0
        }
    } else {
        return 0
    }
  }
  return 1
}

proc OnEnableJavaSyntax { command } {
  if {[llength [std::GetSelection]] == 0} {
        return 0
  }
  foreach elem [std::GetSelection] {
        # PackageSymbol should be changed to PresentationElement when presentationLanguage overrides packageLanguage
        if {([GetKind $elem] != "U2") || (![u2::IsKindOf $elem Package] && ![u2::IsKindOf $elem PackageSymbol])} {
                return 0
        }
  }
  return 1
}

proc OnUseJavaSyntax {command} {
  foreach elem [std::GetSelection] {
        if [u2::IsKindOf $elem PackageSymbol] {
                set target [u2::GetEntity $elem ModelElement]
        } else {
                set target $elem
        }
        if [JavaSyntax $target] {
                JavaSyntax $target 0
                Output "Syntax for '[u2::GetValue $elem Name]' set to U2.\n"
        } else {
                JavaSyntax $target 1
                Output "Syntax for '[u2::GetValue $elem Name]' set to Java.\n"
        }
   }
}

###################  UI Initialization #####################

proc OnEnablePackageContext { command } {
   if {[llength [std::GetSelection]] == 0} {
        return 0
   }
   foreach elem [std::GetSelection] {
     if {[GetKind $elem] == "U2"} {
        set target $elem
        if [u2::IsKindOf $elem PackageSymbol] {
                set target [u2::GetEntity $elem ModelElement]
        }
        if {![u2::IsKindOf $target Package] || [InJar $target]} {
                return 0
        }
     } else {
        return 0
     }
   }
   return 1
}

proc OnMappedPackageSelected {command} {
    if { [llength [std::GetSelection]] == 1 } {
        if { [GetKind [std::GetSelection]] == "U2" } {
            set target [std::GetSelection]
            if [u2::IsKindOf [std::GetSelection] PackageSymbol] {
                set target [u2::GetEntity [std::GetSelection] ModelElement]
            }
            if ![IsProfileLoaded [GetSession $target]] {
                return 0
            }
            if [u2::IsKindOf $target Package] {
                if { [GetBuildArtifact $target] != 0 } { 
                    return 1 
                }
            }
        }
    }
    return 0
}

proc OnTopLevelPackageSelected {command} {
    set element [std::GetSelection]
    if { [llength $element] == 1 } {
        if { [GetKind $element] == "U2" } {
            if { [u2::IsKindOf $element Package] || [u2::IsKindOf $element PackageSymbol]} {
                set target $element
                if [u2::IsKindOf $element PackageSymbol] {
                    set target [u2::GetEntity $element ModelElement]
                }
                if ![IsProfileLoaded [GetSession $target]] {
                    return 0
                }
                
                set owner [u2::GetEntity $target Owner]
                if [IsJarPackage $target] {
                    return 0
                }
                if [u2::IsKindOf $owner Session] {
                    return 1
                }
                return 0
            }
        }
    }
    return 0
}

proc OnEnableEditJava {command} {
    if {[llength [std::GetSelection]] == 0} {
        return 0
    }
    foreach elem [std::GetSelection] {
        if {[GetKind $elem] == "U2"} {
            set target $elem
            if [u2::IsKindOf $elem PresentationElement] {
                set target [u2::GetEntity $elem ModelElement]
            }
            if ![IsProfileLoaded [GetSession $target]] {
                return 0
            }
            if ![IsElementRef $target] {
                return 0
            }
            if {[u2::IsKindOf $target Package] || [InJar $target]} {
                return 0
            }
        } else {
            return 0
        }
        if { [GetBuildArtifact $target] == 0 } {
            return 0
        }
    }
    return 1
}

proc OnEnableExecute {command} {
    if { [llength [std::GetSelection]] != 1 } {
        return 0
    }
    if {![OnEnableEditJava $command]} {
        return 0
    }

    set target [std::GetSelection]

    if { [u2::IsKindOf $target PresentationElement] } {
        set target [u2::GetEntity $target ModelElement]
    }
    if { [u2::GetTaggedValue $target "javaFile(..)"] != 0 } {
        set m [GetManifested $target]
        if { [llength $m] != 1 } {
            return 0
        }
        set target [lindex $m 0]
    }
    if { ![u2::IsKindOf $target Class] } {
        return 0
    }
    if { [GetBuildArtifact $target] == 0 } {
        return 0
    }
    return 1
}

proc OnEnableJavaUpdate {command} {
   if {[llength [std::GetSelection]] == 0} {
        return 0
   }
   foreach elem [std::GetSelection] {
        if {[GetKind $elem] == "U2"} {
                set target $elem
                if [u2::IsKindOf $elem PresentationElement] {
                        set target [u2::GetEntity $elem ModelElement]
                }
                if ![IsProfileLoaded [GetSession $target]] {
                        return 0
                }
                set javaDir [GetJavaDirectory $target]
                if {("" == $javaDir) || [InJar $target]} {
                        return 0
                }
        } else {
                return 0
        }
  }
  return 1
}

proc OnEnableContextMenu { command } {
   if {[llength [std::GetSelection]] == 0} {
        return 0
   }
   foreach elem [std::GetSelection] {
        if {[GetKind $elem] == "U2"} {
                set target $elem
                if {[u2::IsKindOf $elem PresentationElement] && ![u2::IsKindOf $elem Diagram]} {
                        set target [u2::GetEntity $elem ModelElement]
                }
                if {(0 == $target) || [u2::IsKindOf $target Package] || ![HasJavaFileMapping $target] || [InJar $target]} {
                        return 0
                }
        } else {
                return 0
        }
   }
   return 1
}

proc OnEnableClassElementContextMenu { command } {
	if { [llength [std::GetSelection]] != 1 } {
		return 0
	}
   foreach elem [std::GetSelection] {
        if {[GetKind $elem] == "U2"} {
                set target $elem
                if {[u2::IsKindOf $elem PresentationElement] && ![u2::IsKindOf $elem Diagram]} {
                        set target [u2::GetEntity $elem ModelElement]
                }
                if {(0 == $target) || ![HasOwnerJavaFileMapping $target] || [InJar $target]} {
                        return 0
                }
                if {[u2::IsKindOf $target Attribute] || [u2::IsKindOf $target Operation] } {
					return 1
				}
        } else {
                return 0
        }
   }
   return 0
	
}

proc OnEnableConvertToJavaPackage { command } {
	if { [llength [std::GetSelection]] != 1 } {
		return 0
	}
   foreach elem [std::GetSelection] {
        if {[GetKind $elem] == "U2"} {
                set target $elem
                if ![IsProfileLoaded [GetSession $target]] {
                        return 0
                }
			    if [u2::IsKindOf $elem Package] {
					if { [IsJavaPackage $elem] || [IsJarPackage $elem]} {
						# it is already java package or jar package
						return 0
					}
					
					# should be top level package or package-owner is java package
					return [ShouldConvertToJavaFile $elem]					
				} else {
					return 0
				}
        } else {
                return 0
        }
   }
   return 0

}

proc OnEnableNonJavaPackageContextMenu {command } {
	if { [llength [std::GetSelection]] != 1 } {
		return 0
	}
	foreach elem [std::GetSelection] {
        if {[GetKind $elem] == "U2"} {
                set target $elem
                if ![IsProfileLoaded [GetSession $target]] {
                        return 0
                }
			    if [u2::IsKindOf $elem Package] {
					if { ![IsJavaPackage $elem] && ![IsJarPackage $elem]} {
						return 1
					}
					return 0
				} else {
					return 0
				}
        } else {
                return 0
        }
   }
   return 0
}

proc OnEnableJarContextMenu {command} {
	if { [llength [std::GetSelection]] != 1 } {
		return 0
	}
	foreach elem [std::GetSelection] {
                if ![IsProfileLoaded [GetSession $elem]] {
                        return 0
		}
		if {[IsJarArtifact $elem]} {
			return 1
		}
	}
	return 0
}
#########################################################################
#       
#       Code for managing the Execute with options... dialog
#
#########################################################################

proc CreateExecuteOptionsDialog {dialog} {
  global executeOptions

  # Source file controls
  Label -name "Options:" -parent $dialog -x 10 -y 25 -w 150 -h 25
  Edit -variable editOptions -name "" -parent $dialog -x 60 -y 20 -w 280 -h 23

  
  Button -name "OK" -parent $dialog -x 203 -y 100 -w 60 -h 25 -command ExecuteOptionsDialogOK
  Button -name "Cancel" -parent $dialog -x 283 -y 100 -w 60 -h 25 -command DialogCancel

  set executeOptions $editOptions
}

proc ExecuteOptionsDialogOK {} {
        global executeOptions
        set elem [std::GetSelection]
        if [u2::IsKindOf $elem PresentationElement] {
                set target [u2::GetEntity $elem ModelElement]
        } else {
                set target $elem
        }
        if [u2::IsKindOf $target Class] {
                output "[$executeOptions -name]"
                ExecuteJavaClass $target [$executeOptions -name]
        } elseif [u2::IsKindOf $target Artifact] {
                # OnExecuteJava is only enabled if there's only one manifested element
                ExecuteJavaClass [lindex [GetManifested $target] 0] [$executeOptions -name]
        }
        CloseDialog
}

proc DialogCancel {} {
        CloseDialog
}

proc InitDialog {dialog} {
}

proc DialogCloseDummy {} {
}

proc BeforeUnload { } {
     UnloadJavaProfiles
}


################################################################
proc Init {} {
    # Contextual update commands
    AddCommand -variable cmdUpdateJava -name "Update source code" -statusmessage "Update java source code for selected elements." -tooltip "Update source from model" -accelerator "" -imagefile "" -OnActivateCommand OnUpdateJava -OnEnableCommand OnEnableJavaUpdate
    AddCommand -variable cmdUpdateModel -name "Update model from Java" -statusmessage "Update the selected element from java file." -tooltip "Update model from source" -accelerator "" -imagefile "" -OnActivateCommand OnUpdateModel -OnEnableCommand OnEnableJavaUpdate
    
    # Non contextual update commands
    AddCommand -variable cmdUpdateAllClasses -name "Update model" -statusmessage "Update the entire model from java source files." -tooltip "Update model" -accelerator "Ctrl+Alt+M" -imagefile "" -OnActivateCommand OnUpdateModelProject -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdUpdateAllClassesForce -name "Force update model" -statusmessage "Update the entire model from java source files. Up-to-date entitied are also updated." -tooltip "Force update model" -accelerator "Ctrl+Alt+Shift+M" -imagefile "" -OnActivateCommand OnUpdateModelProjectForce -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdUpdateAllFiles -name "Update source code" -statusmessage "Update all classes from changed java files." -tooltip "Update source code" -accelerator "Ctrl+Alt+S" -imagefile "" -OnActivateCommand OnUpdateJavaProject -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdUpdateAllFilesForce -name "Force update source code" -statusmessage "Update all classes from changed java files. Up-to-date files are also updated." -tooltip "Force update source code" -accelerator "Ctrl+Alt+Shift+S" -imagefile "" -OnActivateCommand OnUpdateJavaProjectForce -OnEnableCommand EnabledIfProfileLoaded
    
    # Trace session
    AddCommand -variable cmdNewTraceSession -name "New Trace Session..." -statusmessage "Creates new trace session" -tooltip "New Trace Session" -accelerator "" -imagefile "" -OnActivateCommand OnNewTraceSessionCommand -OnEnableCommand EnabledIfProfileLoaded

    # Import commands
    #AddCommand -variable cmdImportDir -name "Source code from directory..." -statusmessage "Import package from directory structure." -tooltip "Import package from directory structure" -imagefile "" -OnActivateCommand OnImportDirectory -OnEnableCommand EnabledIfProfileLoaded
    #AddCommand -variable cmdUpdateJar -name "JAR file..." -statusmessage "Import contents of a JAR file into model." -tooltip "Import from .jar file" -imagefile "" -OnActivateCommand OnUpdateModelFromJarFile -OnEnableCommand EnabledIfProfileLoaded

	# Contextual export / convert commands
	AddCommand -variable cmdExportNonJavaPkg -name "Generate Java Code" -statusmessage "Export package to directory" -tooltip "Export package to directory" -imagefile "" -OnActivateCommand OnExportPackage -OnEnableCommand OnTopLevelPackageSelected
	AddCommand -variable cmdConvertNonJavaPkg -name "Convert to Java Package" -statusmessage "Export package to directory" -tooltip "Export package to directory" -imagefile "" -OnActivateCommand OnConvertToJavaPackage -OnEnableCommand OnEnableConvertToJavaPackage

    # Export commands
    AddCommand -variable cmdExportPkg -name "Package..." -statusmessage "Export package to directory" -tooltip "Export package to directory" -imagefile "" -OnActivateCommand OnExportPackage -OnEnableCommand OnTopLevelPackageSelected

    # Generation commands
    AddCommand -variable cmdCreateJavaDoc -name "Javadoc..." -statusmessage "Create JavaDoc files." -tooltip "Create JavaDoc files" -imagefile "" -OnActivateCommand OnCreateJavaDoc -OnEnableCommand OnMappedPackageSelected
    AddCommand -variable cmdExportToJar -name "JAR file..." -statusmessage "Export package to .jar file." -tooltip "Export package to .jar file" -imagefile "" -OnActivateCommand OnExportToJarFile -OnEnableCommand OnMappedPackageSelected

    # Java syntax
    AddCommand -variable cmdUseJavaSyntax -name "Use Java syntax" -statusmessage "Toggles the syntax used in text diagrams and text symbols between Java and U2." -tooltip "Toggle syntax" -imagefile "" -OnActivateCommand OnUseJavaSyntax -OnEnableCommand OnEnableJavaSyntax -oncheckcommand OnChangeJavaSyntax

    # Compilation and execution
    AddCommand -variable cmdCompileJava -name "Compile" -statusmessage "Compile source code." -tooltip "Compile java file" -imagefile "" -OnActivateCommand OnCompileJava -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdExecuteJava -name "Execute" -statusmessage "Execute .class file." -tooltip "Execute java file" -imagefile "" -OnActivateCommand OnExecuteJava -OnEnableCommand OnEnableExecute
    AddCommand -variable cmdExecuteJavaWithOptions -name "Execute with options..." -statusmessage "Execute .class file using specified options." -tooltip "Execute java file with options" -imagefile "" -OnActivateCommand OnExecuteJavaWithOptions -OnEnableCommand OnEnableExecute
    AddCommand -variable cmdExecuteJavaApplet -name "Execute applet" -statusmessage "Execute Java class as an applet in a HTML file." -tooltip "Execute Java class as an applet in a HTML file" -imagefile "" -OnActivateCommand OnExecuteJavaApplet -OnEnableCommand OnEnableExecute
    
    # Jar reimport
    AddCommand -variable cmdJarReimport -name "&Reimport jar file" -statusmessage "Import this jar file again" -tooltip "Reimport jar file" -imagefile "" -OnActivateCommand OnReimportJar -onEnableCommand EnabledIfProfileLoaded

    # Menu definitions
    
    # Add menus in reverse order since -after doesn't seem to work for nested menus
    AddMenu -variable GenJava -commands {cmdUpdateAllClasses cmdUpdateAllClassesForce cmdUpdateAllFiles cmdUpdateAllFilesForce cmdCompileJava cmdExecuteJava cmdExecuteJavaWithOptions cmdExecuteJavaApplet cmdUseJavaSyntax cmdNewTraceSession} -path { &Java } -position {after &Tools} 
    AddMenu -variable javaGenerate -commands { cmdExportToJar cmdCreateJavaDoc } -path { &Java Generate}
    AddMenu -variable javaExport -commands { cmdExportPkg } -path { &Java Export } -position {after &Java Import}
    #AddMenu -variable javaImport -commands { cmdImportDir cmdUpdateJar } -path { &Java Import }

    AddContextMenu -variable cmnJarImport -commands { separator cmdJarReimport } -onenablemenu { OnEnableJarContextMenu }
    AddContextMenu -variable cmnJavaElement -commands { separator cmdUpdateJava cmdUpdateModel cmdCompileJava cmdExecuteJava cmdExecuteJavaApplet } -onenablemenu { OnEnableContextMenu }
    #AddContextMenu -variable cmnPackage -commands { separator cmdUpdateJava cmdUpdateModel cmdCompileJava cmdUseJavaSyntax } -onenablemenu { OnEnablePackageContext}
    AddContextMenu -variable cmnJavaSyntaxForPackage -commands { separator cmdUseJavaSyntax } -onenablemenu { OnEnablePackageContext}
    AddContextMenu -variable cmnGeneratePackage -commands { separator cmdConvertNonJavaPkg} -onenablemenu { OnEnableNonJavaPackageContextMenu }

}

Init

output "Done.\n"
