# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands
Declare addcommand -variable cmdLocateInSource -name "Locate in source" -statusmessage "Locate an element in the generated source files." -tooltip "Locate element in source files" -accelerator "" -onactivatecommand OnActivateLocateInSource -onenablecommand OnEnableLocateInSource
AddCommand cmdLocateInSource 
AddMenu -variable mnuLocateInSource -commands { separator cmdLocateInSource } -path {&Tools} -position {last}
AddContextMenu -variable cmnuLocateInSource -commands { separator cmdLocateInSource } -onenablemenu OnEnableLocateInSource

proc OnEnableLocateInSource {cmdName} {
	global selection
	if {[llength $selection] == 0} {
		return 0
	} 
	foreach elem $selection {
		if {([GetKind $elem] != "U2") || ([u2::IsKindOf $elem Session] || [u2::IsKindOf $elem Resource] || ![u2::IsKindOf $elem PersistentEntity])} {
			return 0
		}
	}
  	return 1
}

proc OnActivateLocateInSource {cmdName} {
  global selection activeproject
  OutputTab clear Script
  set files [GetFiles [GetProjDir] [GetExtensions] ""]
  foreach elem $selection {
	if {[GetKind $elem] != "U2"} {
		continue
	}
	if {[catch { set elemName [u2::GetValue $elem Name]} ]} {
		set elemName ""
	}
	if ![u2::IsKindOf $elem PersistentEntity] {
		continue	
	}
	set guid [u2::GetValue $elem Guid]
	if [u2::IsKindOf $elem PresentationElement] {
		set me [u2::GetEntity $elem ModelElement]
		if {0 == $me} {
			continue
		}
		set guid [u2::GetValue $me Guid]
	}
	Output "\nLocating element: $elemName\n"
	foreach file $files {
		set fileId [open $file]
		set lineCounter 1
		while {[gets $fileId line] >= 0} {
			if {[string match *${guid}* $line]} {
				Output $file
				Output "($lineCounter):\t$elemName\n"
			}
			set lineCounter [expr $lineCounter + 1]
		}
		close $fileId

	}
  } 
}

proc GetExtensions {} {
	set fileName [GetInstallationDirectory]addins/LocateInSource/etc/extensions.dat
	if {[catch { set fileId [open $fileName] } ]} {
		Output "Warning: Can't find valid extensions, using *\n"
		return "*"
	}
	set extList [read $fileId]
	close $fileId
	return $extList
}

proc GetFiles { startDir extensions files } {
	foreach file [glob -nocomplain -directory $startDir *] {
		if [file isdirectory $file] {
		 	set files [GetFiles $file $extensions $files]
		} else {
			foreach ext $extensions {
				if {[string match $ext $file]} {
					lappend files $file
				}
			}
		}
	}
	return $files
}

proc GetProjDir {} {
	global selection
	return [file dir [Get [GetProject [lindex $selection 0]] pathname]]
}
