# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ========= HTML Report Generator Addin for Tau G2 v2.4.0 =========

proc ReportClass { c } {

  global flag_ClassTextualDef
  global cbxTrue cbxFalse

  global flag_Debug
  if { $flag_Debug == 1 } { output "(Debug)\tReportEachClass!\n" }

  set flag_ClassStereotypes $cbxTrue
  set flag_ClassComments $cbxTrue
  set flag_ClassConstraints $cbxTrue

  set flag_ClassAbstract $cbxTrue
  set flag_ClassExternal $cbxTrue
  set flag_ClassVisibility $cbxTrue
  set flag_ClassParents $cbxTrue
  set flag_ClassActive $cbxTrue
  set flag_ClassPorts $cbxTrue
  set flag_ClassAttributes $cbxTrue
  set flag_ClassOperations $cbxTrue

  ReportStdElement $c $flag_ClassAbstract $flag_ClassExternal $flag_ClassVisibility $flag_ClassParents $flag_ClassStereotypes $flag_ClassComments $flag_ClassConstraints

  if { $flag_ClassPorts == $cbxTrue } {
    ReportPort $c
  };#end_if Class Ports have to be reported

  if { $flag_ClassAttributes == $cbxTrue } {
    ReportAttribute $c
  };#end_if Class user-defined attributes have to be reported

  if { $flag_ClassOperations == $cbxTrue } {
    ReportOperations $c
  };#end_if Class Operations have to be reported

  if { $flag_ClassTextualDef == $cbxTrue } {
    ReportTextualDef $c
  };#end_if Class textual definition is to be reported

};#end_proc ReportEachClass


proc ReportPort { c } {

  global cbxTrue cbxFalse

  global flag_Debug
  if { $flag_Debug == 1 } { output "(Debug)\tReportPort!\n" }

  set flag_PortAbstract $cbxFalse   ;# Abstract attribute doesn't exist for Port
  set flag_PortExternal $cbxTrue
  set flag_PortVisibility $cbxTrue
  set flag_PortParents $cbxFalse    ;# Parent attribute doesn't exist for Port
  set flag_PortStereotypes $cbxTrue
  set flag_PortComments $cbxTrue
  set flag_PortConstraints $cbxTrue

  set portList [u2::GetEntities $c Port]

  if { [llength $portList] == 0 } { return };#end_if there are no ports to report

  html_heading 3 "" "Ports"

  html_start_paragraph

  foreach p [u2::GetEntities $c Port] {

    # Report general attributes
    ReportStdElement $p 4 $flag_PortAbstract $flag_PortExternal $flag_PortVisibility $flag_PortParents $flag_PortStereotypes $flag_PortComments $flag_PortConstraints

    # Report Port-specific attributes
    html_print "Required: [get_interfaces [u2::GetEntities $p Required]]"
    html_br
    html_print "Realized: [get_interfaces [u2::GetEntities $p Realized]]"
    html_br

  };#end_foreach port

  html_end_paragraph

};#end_proc ReportPort


proc get_interfaces { p } {

  global flag_Debug
  if { $flag_Debug == 1 } { output "(Debug)\tget_interfaces!\n" }

  set result ""

  foreach i $p {
    set result "$result, [GetReference $i]"
  };#end_foreach interface

  return [string trim $result " ,"]

};#end_proc get_interfaces
