# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
proc ReportStereotypes { elmt } {

    # Extract list of stereotypes
    if { [catch { set stereotypesList [u2::GetEntities $elmt StereotypeInstance] } ] } { return };

    set listLength [llength $stereotypesList]

    if { $listLength == 0 } { return };#end_if there are NO stereotypes to report

    # Remove "system" stereotypes, ie stereotypes we don't want to report
    for {set i 0} {$i < $listLength} {incr i} {

        # Get instance of stereotype
        if { [ catch { set instOfStereotype [u2::GetEntity [lindex $stereotypesList $i] InstanceOf] } ] } { continue };# user-stereotype??

        if { $instOfStereotype == 0 } { continue };#end_if instance of stereotype is null (stereotype not loaded)

        set stereotypeInstanceName [u2::GetValue $instOfStereotype "Name"]

        switch $stereotypeInstanceName {
            activity -
            actor -
            component -
            componentDiagram -
            deploymentDiagram -
            executionEnvironment -
            packageDiagram -
            interactionOverviewDiagram -
            subject -
            interaction -
            usecase {
                set stereotypesList [lreplace $stereotypesList $i $i]
            }
        };#end_if stereotype is system

    };#end_for each stereotype instance of element

    if { [llength $stereotypesList] == 0 } { return };#end_if there are NO MORE stereotypes to report

    # Report "user" stereotypes
    html_paragraph ""
    html_table_start

    html_table_row_start
    html_table_heading_colspan "Stereotypes" "3"  ;# 3 columns: Stereotype Name, Tagged Name, Tagged Value
    html_table_row_end

    html_table_row_start
    html_table_heading "Stereotype Name"
    html_table_heading "Tagged Name"
    html_table_heading "Tagged Value"
    html_table_row_end

    # Report each "user" stereotype instance
    foreach instOfStereotype $stereotypesList {

        # Find corresponding stereotype
        if { [set stereotype [u2::GetEntity $instOfStereotype "InstanceOf"]] == 0 } {
            set stereotype [u2::GetReference $instOfStereotype "InstanceOf"]
        }

        if { $stereotype == 0 } {

            # Stereotype not loaded
            set stereotypeName "** Not loaded **"

        } else {

            # Stereotype loaded
            set stereotypeName [u2::GetValue $stereotype "Name"]

        }

        # Find tagged values
        set theExpressions [u2::GetEntities $instOfStereotype "Expression"]
        set nbExpressions [llength $theExpressions]

        if { $nbExpressions <1 } { set nbExpressions 1 }  ;# For rowspan correctness

        # Report stereotype & tagged values
        html_table_row_start
        html_table_heading_rowspan $stereotypeName $nbExpressions

        foreach thisExpression $theExpressions {
            
            if { ![u2::IsKindOf $thisExpression BinaryExpr] ||
                 [u2::GetValue $thisExpression Operation] != "ref:'\\='" } {
                continue
            }

            set lo [u2::GetEntity $thisExpression "LeftOperand"]
            set taggedName [u2::GetValue $lo "Name"]
            html_table_cell $taggedName

            set ro [u2::GetEntity $thisExpression "RightOperand"]
            set taggedValue [u2::Unparse $ro]

            html_table_cell_start

            foreach txtline [split $taggedValue "\n"] {
                html_print $txtline
                html_br
            };#end_foreach line

            html_table_cell_end

            html_table_row_end
            html_table_row_start

        };#end_foreach

        html_table_row_end

        # At the end of the table, there is an extra empty row

    };#end_foreach stereotype instance of element

    html_table_end

};#end_proc ReportStereotypes
