# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#---------------------------------------------------------------------------------------------
# Check constraints for RTinterval
#---------------------------------------------------------------------------------------------
proc CheckRTinterval { me } {
  #Output "$me\n"
  #set instances [GetTaggedValue $me "RTinterval"]
  #Output "\n$instances"
# CheckTimeOrder { 1 2}
# CheckTimeOrder { 2 1}
#  Output "CheckedRTinterval\n"
}

#---------------------------------------------------------------------------------------------
# Check that the start time occurs before the end time
#---------------------------------------------------------------------------------------------
proc CheckTimeOrder { start end } {   
   if { $end - $start < 0 } then {
     SemMessage warning "\nThe start time must occur before the end time."
   }
   Output "CheckedTimeOrder\n"
}

#---------------------------------------------------------------------------------------------
# Check that the duration is equal to the difference between the end time and the start time
#---------------------------------------------------------------------------------------------
proc CheckDuration { start end duration } {
  if { $end - $start != $duration } then {
    SemMessage warning "The time between start and end must be equal to the duration.\n"
  }
  Output "CheckedDuration\n"
}

#---------------------------------------------------------------------------------------------
# Force the unloading of the RTProfile add-in when it is de-selected
#---------------------------------------------------------------------------------------------
proc BeforeUnload {} {
	# Clean-up
	u2::DeleteSemEntity "/" "RTProfile"
	Output "Unloaded real-time profile\n"
}

#---------------------------------------------------------------------------------------------
# Initialize
#---------------------------------------------------------------------------------------------
proc Init {} {
	# Calculate the base paths for the RTProfile add-in
	set RTProfileAddInEtcPath [file join [std::GetInstallationDirectory] addins RTProfile Etc]
	set RTProfilePath [file join $RTProfileAddInEtcPath RTProfile.u2]

	# Load the RTProfile general profile
	output "Loading the real-time profile: $RTProfilePath\n"
	u2::LoadLibrary $RTProfilePath
	u2::CreateSemGroup "/" "RTProfile"

	#-------------------------------------------------------------------------------
	# Semantic checks of the Resource sub-profile
	#-------------------------------------------------------------------------------
	u2::CreateSemGroup "/RTProfile" "Resource"

	#-------------------------------------------------------------------------------
	# Semantic checks of the Time sub-profile
	#-------------------------------------------------------------------------------
	u2::CreateSemGroup "/RTProfile" "Time"
	u2::CreateSemRule "/RTProfile/Time" "T1" Classifier 1 CheckRTinterval
#	u2::CreateSemRule "/RTProfile/Time" "T1" -type check -attach Classifier -command CheckRTinterval
	u2::CreateSemRule "/RTProfile/Time" "T2" Attribute 1 CheckRTinterval
#	u2::CreateSemRule "/RTProfile/Time" "T2" -type check -attach Attribute -command CheckRTinterval
	u2::CreateSemRule "/RTProfile/Time" "T3" InstanceExpr 1 CheckRTinterval
#	u2::CreateSemRule "/RTProfile/Time" "T3" -type check -attach InstanceExpr -command CheckRTinterval
#	u2::CreateSemRule "/RTProfile/Time" "T1" -type check -attach Class -command CheckTimeOrder
#	u2::CreateSemRule "/RTProfile/Time" "T2" -type check -attach Class -command CheckDuration

	#-------------------------------------------------------------------------------
	# Semantic checks of the Concurrency sub-profile
	#-------------------------------------------------------------------------------
	u2::CreateSemGroup "/RTProfile" "Concurrency"

	#-------------------------------------------------------------------------------
	# Semantic checks of the Scheduling sub-profile
	#-------------------------------------------------------------------------------
	u2::CreateSemGroup "/RTProfile" "Scheduling"

	#-------------------------------------------------------------------------------
	# Semantic checks of the Performance sub-profile
	#-------------------------------------------------------------------------------
	u2::CreateSemGroup "/RTProfile" "Performance"

	#-------------------------------------------------------------------------------
	# Semantic checks of the CORBA sub-profile
	#-------------------------------------------------------------------------------
	u2::CreateSemGroup "/RTProfile" "CORBA"

	Output "Loaded real-time profile\n"
}

Init

