# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Returns the session of the active project.
proc GetActiveSession {} {
   set activeProject [std::GetActiveProject]
   return [lindex [std::GetModels -kind U2 -project $activeProject] 0]
}

# Executes the query expression on context and returns the result
proc ExecuteQueryExpression { queryExpr context } {
	set p [list {} $queryExpr]
	if [catch  {u2::InvokeAgent [GetActiveSession] [GetExecuteQueryExpression] $context p} errMsg] {
		std::OutputTab activate Script
		output \n$errMsg
	}
	return [lindex $p 0]
}

# Helper for ExecuteQueryExpression
proc GetExecuteQueryExpression {} {
	return [u2::FindByGuid [GetActiveSession] "@TTDQuery@ExecuteQueryExpression"]
}

proc ReportRequirements { requirements {format basic} } {

	if {"basic" == $format} {
		std::ReportInit Requirements -ident reqTab "Requirement" 150 0 "Id" 80 0 "Heading" 200 0 "Text" 800 0

		foreach req $requirements {
			if {0 == $req} {
				continue
			}

			set idValue [u2::GetTaggedValue $req "requirement (. Id .)"]
			set idString ""
			if {0 != $idValue} {
				set idString [u2::GetValue $idValue Value]
			}

			set headingValue [u2::GetTaggedValue $req "requirement (. Heading .)"]
			set headingString ""
			if {0 != $headingValue} {
				set headingString [u2::GetValue $headingValue Value]
			}

			set textValue [u2::GetTaggedValue $req "requirement (. Text .)"]
			set textString ""
			if {0 != $textValue} {
				set textString [u2::GetValue $textValue Value]
			}

			std::Report $req $idString $headingString $textString
		}
	} else {
		set requirementAttributes 0
		set attributeNames [list]
                set reportInitialized 0
                
		foreach req $requirements {
			if {0 == $req} {
				continue
			}

			if {0 == $requirementAttributes && 0 == $reportInitialized} {
                                set initCommandPart1 "std::ReportInit \"Requirements (Detailed)\" -ident reqTabDetailed \"Requirement\" 100 0"
				set initCommandPart2 ""
				set initCommandPart3 " \"Heading\" 200 0 \"Text\" 200 0"
				
				set objectNumberPresent 0

				set attrIE [u2::GetTaggedValue $req "requirementAttributes (. .)"]
				if {0 != $attrIE} {
					set requirementAttributes [u2::GetEntity $attrIE InstanceOf]	
				}
				if {0 != $requirementAttributes} {
					set attributes [u2::GetEntities $requirementAttributes Attribute]
					foreach attr $attributes {
						if {0 == $attr} {
							continue
						}

						set attributeName [u2::GetValue $attr Name]
						if {"Object Number" == $attributeName} {
							set initCommandPart2 " \"$attributeName\" 100 0"
							set objectNumberPresent 1
						} else {
							lappend attributeNames [u2::GetValue $attr Name]
							set initCommandPart3 "$initCommandPart3 \"[u2::GetValue $attr Name]\" 100 0"
						}
					}
				}
                                set initCommand $initCommandPart1$initCommandPart2$initCommandPart3
				eval $initCommand
                                set reportInitialized 1

			}


			set headingValue [u2::GetTaggedValue $req "requirement (. Heading .)"]
			set headingString "\"\""
			if {0 != $headingValue} {
				set headingString {[u2::GetValue $headingValue Value]}
			}
		
			set textValue [u2::GetTaggedValue $req "requirement (. Text .)"]
			set textString "\"\""
			if {0 != $textValue} {
				set textString {[u2::GetValue $textValue Value]}
			}
		
			if {1 == $objectNumberPresent} {
				set objectNumberValue [u2::GetTaggedValue $req "requirementAttributes (. 'Object Number' .)"]
				set objectNumberString "\"\""
				if {0 != $objectNumberValue} {
					set objectNumberString {[u2::GetValue $objectNumberValue Value]}
				}
				set reportCommand "std::Report $req $objectNumberString $headingString $textString"
			} else {
				set reportCommand "std::Report $req $headingString $textString"
			}


			foreach attrName $attributeNames {
				if {$attrName == "Object Number"} {
					continue
				}

				set tv [u2::GetTaggedValue $req "requirementAttributes (. '$attrName' .)"]
				set attrValue ""
				if {0 != $tv} {
					set attrValue [u2::GetValue $tv Value] 
				}
				set reportCommand "$reportCommand \{$attrValue\}"
			}
			eval $reportCommand		 
		}
	}
}

# Checks if the element has a name. Note: Only checks the most common ones, not all
proc HasName { element } {
	return [expr [u2::IsKindOf $element Definition] || [u2::IsKindOf $element Diagram] || [u2::IsKindOf $element ActionNode]]
}

proc GetNameAndKind { element name kind } {
	upvar $name elemName
	upvar $kind elemKind

	set result 0
	if [HasName $element] {
		set elemName [u2::GetValue $element Name]
		set result 1
	}
	set elemKind [GetBrowserMetaClassName $element]

	set descValue [u2::GetTaggedValue $element "requirement (. Heading .)"]
	set descString ""
	if {0 != $descValue} {
		set descString [u2::GetValue $descValue Value]
	}

	if {"" == $descString} {
		set descValue [u2::GetTaggedValue $element "requirement (. Text .)"]
		if {0 != $descValue} {
			set descString [u2::GetValue $descValue Value]
		}
	}
	set elemName "$elemName $descString"
	return $result
}

proc ReportDependencies { dependencies } {
	std::ReportInit "Requirement Relations" -ident depTab "Relation" 150 0 "Kind" 100 0 "Source Name" 200 0 "Source Kind" 100 0 "Target Name" 200 0 "Target Kind" 100 0
	foreach dep $dependencies {
		if {0 == $dep} {
			continue
		}

		set client [ExternalReferences::GetClient $dep]
		set clientName ""
		set clientKind ""


		set hasName 0
		if {0 != $client && "U2" == [GetKind $client]} {
			set hasName [GetNameAndKind $client clientName clientKind]
		}
		if {!$hasName} {
			set clientRef [ExternalReferences::GetSourceReference $dep]
			set dataserver ""
			ExternalReferences::DecodeURL $clientRef dataserver clientName
			if {"Doors" == $dataserver} {
				set clientKind "Requirement"
			}
		}

		set supplier [ExternalReferences::GetSupplier $dep]
		set supplierName ""
		set supplierKind ""
		set hasName 0
		if {0 != $supplier && "U2" == [GetKind $supplier]} {
			set hasName [GetNameAndKind $supplier supplierName supplierKind]
		}
		if {!$hasName} {
			set supplierRef [ExternalReferences::GetTargetReference $dep]
			set dataserver ""
			ExternalReferences::DecodeURL $supplierRef dataserver supplierName
			if {"Doors" == $dataserver} {
				set supplierKind "Requirement"
			}
		}

		std::Report $dep [join [GetDependencyKinds $dep] ", "] $clientName $clientKind $supplierName $supplierKind
	}
}

proc GetDependencyKinds { dependency } {
	set result [list]
	if {[u2::HasAppliedStereotype $dependency "@Requirements@verify" -guid 1]} {
		lappend result "verify"
	}
	if {[u2::HasAppliedStereotype $dependency "@Requirements@satisfy" -guid 1]} {
		lappend result "satisfy"
	}
	if {[u2::HasAppliedStereotype $dependency "@Requirements@deriveReqt" -guid 1]} {
		lappend result "deriveReqt"
	}
	if {[u2::HasAppliedStereotype $dependency "@Requirements@copy" -guid 1]} {
		lappend result "copy"
	}
	
	if {0 == [llength $result]} {
		if {[u2::HasAppliedStereotype $dependency "@Predefined@trace" -guid 1]} {
			lappend result "trace"
		}
	}

	if {[u2::HasAppliedStereotype $dependency "@Predefined@refine" -guid 1]} {
		lappend result "refine"
	}

	return $result
}
