// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

void WriteObjectCreated(Stream s, Date d, Object o)
{
    string id = getTAUID(o)
    string parentId = getParentTAUIDInTree(o)
    string afterId = getPreviousTAUIDInTree(o)
    int i = intOf(d)
    string ttype = getObjectTableType(o)
    
    writeToStream(s, "ObjectCreated (. time = " i ", id = \"" id "\", tabletype = \"" ttype "\", owner = \"" parentId "\", insertAfter = \"" afterId "\"") 
    
    //UML Kind
    string umlKindString = probeAttr_(o, "UML Kind")//HCS    
    
    if(umlKindString=="")
    {
		writeToStream(s, " .)\n")
	}
	else
	{
		writeToStream(s, ", umlKind = \""  umlKindString "\".)\n")
	}

    //string tmps_type=u2p2pString(TAU_ATTR_NUMBER_NAME)
    //string tmps_value=u2p2pString(getTAUNumber(o))
    //writeToStream(s, "ObjectAttributeChanged (. time = " i ", doorsID = \"" id "\", reqAttr = true, name = \"" tmps_type "\", value = \"" tmps_value "\" .)\n")
}

void WriteObjectMoved(Stream s, Date d, Object o)
{
    string id = getTAUID(o)
    string parentId = getParentTAUIDInTree(o)
    string afterId = getPreviousTAUIDInTree(o)
    int i = intOf(d)

    writeToStream(s, "ObjectMoved (. time = " i ", id = \"" id "\", newOwner = \"" parentId "\", insertAfter = \"" afterId "\" .)\n")

    //string tmps_type=u2p2pString(TAU_ATTR_NUMBER_NAME)
    //string tmps_value=u2p2pString(getTAUNumber(o))
    //writeToStream(s, "ObjectAttributeChanged (. time = " i ", doorsID = \"" id "\", reqAttr = true, name = \"" tmps_type "\", value = \"" tmps_value "\" .)\n")
}

void WriteObjectChanged(Stream s, Date d, Object o, Array attributes)
{
    int attrCount = get(attributes,0,0)
    int i = intOf(d)
        
    string obj_name = u2pString(getTAUName(o))
    string ttype = getObjectTableType(o)
        
    writeToStream(s, "ObjectChanged (. time = " i ", id = \"" getTAUID(o) "\", name = \"" obj_name "\", tabletype = \"" ttype "\"")

    if(!table(o) && !row(o))
    {
        string obj_text = u2p2pString(getTAUText(o))
        string obj_short_text = u2p2pString(getShortText(o))
        string obj_heading = u2p2pString(getTAUHeading(o))
        string obj_taunumber = u2p2pString(getTAUNumber(o))
        string obj_taunumber_name = u2pStringQuoted(TAU_ATTR_NUMBER_NAME)
        writeToStream(s, ", text = \"" obj_text "\", shorttext = \"" obj_short_text "\", heading = \"" obj_heading "\"")
        writeToStream(s, ", " obj_taunumber_name " = \"" obj_taunumber "\"")

        for (i = 0; i < attrCount; i++)
        {
            string attrTmpName = get(attributes, i + 1, 0)
            if(IsValidTAUAttribute(attrTmpName))
            {
                string obj_attrname=u2pStringQuoted(attrTmpName)
                string obj_attrvalue=u2p2pString(probeAttr_(o, attrTmpName))
                string attrExpr = ", " obj_attrname " = \"" obj_attrvalue "\""
                writeToStream(s, attrExpr)
            }
        }
    }
    
    writeToStream(s, " .)\n")
}

void WriteObjectDeleted(Stream s, Date d, Object o)
{
    int i = intOf(d)
    writeToStream(s, "ObjectDeleted (. time = " i ", id = \"" getTAUID(o) "\" .)\n")
}

// The value is out as sequence of pairs "ID, newAttrValue"

void WriteModuleObjectNumberAttributes(Stream s, Module m, Date d)
{
    int i = intOf(d)
    string tmps_type=u2p2pString(TAU_ATTR_NUMBER_NAME)
    writeToStream(s, "ObjectListChangeAttribute (. time = " i ", name = \"" tmps_type "\", 'value' = {" )
    bool wasOut=false
    Object o = null
    for o in entire m do
    {
        if(isProcessedObject(o) && canRead(o))
        {
            if(wasOut)
            {
                writeToStream(s, ", ")
            }
            wasOut=true
            //string tmps_value=u2p2pString(getTAUNumber(o))
            string tmps_id=u2pString(getTAUID(o))
            string tmps_value=u2pString(getTAUNumber(o))
            writeToStream(s, "\"" tmps_id "\", \"" tmps_value "\"")
        }
    }
    writeToStream(s, "} .)\n")
}

/***************************************************************
/* Not handled change types:
/*
/*  unknown 
/*  copyObject 
/*  createType 
/*  modifyType 
/*  deleteType 
/*  createAttr 
/*  modifyAttr 
/*  deleteAttr 
/*  clipCutObject 
/*  createModule 
/*  baselineModule 
/*  partitionModule 
/*  acceptModule 
/*  returnModule 
/*  rejoinModule 
/*  insertOLE 
/*  removeOLE 
/*  changeOLE 
/*  pasteOLE 
/*  cutOLE 
/*  readLocked 
/*    
/*  modifyLink 
/*
/*
/* NOTE: clipCutObject is potentially problemeatic. It's a kind of implicit delete
/* depending on the following action. If we also synchronize deleted object
/* we don't have to care though.
/* RETURN true if position of object in the tree was changed
/* (the changes of Links is not take into account)
/***************************************************************/
bool WriteChangedObject(Stream s, Object o, Date d, Array attributes)
{
    bool result=false
	if (null o || !canRead(o))
            return result

	bool bCreated = false;
	bool bChanged = false;
	bool bMoved = false;
	bool bDeleted = false;

	bool bLinkCreated = false;
	bool bLinkDeleted = false;

	Date dateCreated = null
	Date dateChanged = null
	Date dateMoved = null
	Date dateDeleted = null
	
	Date modDate = o."Last Modified On"
	if (modDate > d)
	{
	    bChanged = true;
	}

	History h
	for h in o do
	{
	    if (h.date < d)
		continue
	    
	    HistoryType type = h.type
    
	    if (type == modifyObject)
	    {
		bChanged = true
		dateChanged = h.date
	    }
	    else if (type == createObject)
	    {
		bCreated = true
		dateCreated = h.date
	    }
	    else if (type == deleteObject || type == purgeObject)
	    {
		bDeleted = true
		dateDeleted = h.date
	    }
	    else if (type == unDeleteObject)
	    {
		bDeleted = false
		bCreated = true
		dateCreated = h.date
		bChanged = true
		dateChanged = h.date
	    }
	    else if (type == clipMoveObject)
	    {
		bMoved = true
		dateMoved = h.date
	    }
	    else if (type == createLink)
	    {
		// Note: I can't find a way to get more information than
		// the fact a link was created. Therefore we need to look 
		// at all links to find the new one.
		bLinkCreated = true;
	    }
	    else if (type == deleteLink)
	    {
		// Note: I can't find a way to get more information than
		// the fact a link was deleted, and deleted links can't be accessed.
		// There's not much to do here, but this case is here for completeness.
		
		bLinkDeleted = true;
	    }
	    else if (type == clipCopyObject)
	    {
                bCreated = true
                dateCreated = h.date
                bChanged = true
                dateChanged = h.date
	    }
	}

	if (!bDeleted)
	{
	    // Check if this object is currently visible. In that case track any changes.
	    // If it's not, it means some change made it dissapear, e.g. a name change
	    // removed it according to the current filter. In that case treat it as deleted.
	    if (isVisible(o))
	    {
		if (bCreated)
		{
		    WriteObjectCreated(s, dateCreated, o)
		    result=true
		}

		if (bMoved && !bCreated)
		{
		    WriteObjectMoved(s, dateMoved, o)
		    result=true
		}
        	
		if (bChanged)
		{
		    WriteObjectChanged(s, dateChanged, o, attributes)
		    //result=true
		}

		WriteChangedLinks(s, o, d)
	    }
	    else
	    {
		// Object was made hidden by some property or filter change
		// TODO: Use date of latest filter change/application if possible when it's
		// later than modDate
		
		if(table(o) || row(o)) 
		{
        		if (bCreated)
	        	{
		                WriteObjectCreated(s, dateCreated, o)
		                result=true
		        }

		        if (bMoved && !bCreated)
		        {
		                WriteObjectMoved(s, dateMoved, o)
		                result=true
		        }
	        }
		
		if(!table(o) && !row(o))  // ? must I delete the tables?
		{
		    WriteObjectDeleted(s, modDate, o)
		    result=true
		}
	    }
	}
	else
	{
	    // Object was deleted and may or may not be shown
	    WriteObjectDeleted(s, dateDeleted, o)
	    result=true
	}
    return result
}

// RETURN true if at least one object change position in module object tree
// (the changes of Links is not take into account)

bool WriteModuleChanges(Stream s, Module m, Date d)
{
    Array attributes = create(10,1)

    int attrCount = 0
    
    Column c 
    for c in m do 
    {
        string attributeName = ""
        if (!IsValidColumn(c, attributeName))
            continue
                        
        attrCount += 1
	put(attributes, attributeName, attrCount, 0)        
    }

    put(attributes, attrCount, 0, 0)

    bool result = false
    Object o = null
    for o in entire m do
    {
        if(WriteChangedObject(s, o, d, attributes))
        {
            result = true
        }
    }
    return result
}

void getChanges(string moduleID, string viewName, string baselineName, string changesAfterDate)
{
    string errMsg = null
    bool bWasOpened;

    openedModules = create
    
    Item i = itemFromID(moduleID)
    Module m = openModule(i, READ_MODE, viewName, baselineName, bWasOpened, true, errMsg)
    
    if (!null errMsg)
    { 
        if (!null m && bWasOpened)
            close(m)
        returnResult(errMsg)
	return
    }
    
    if (null m)
    { 
        return // Should never happen
    } 
    else if (bWasOpened)
    {
        put(openedModules, m, m)
    }
    
    string strU2File = tempFileName() ".u2p"

    Stream out = getStream(strU2File)
    if (null out)
    {
        delete openedModules
        returnResult("IDS_CANNOT_OPEN_FILE: " lastError())
        return            
    }

    Date d = convertDate(changesAfterDate)
	        
    if(WriteModuleChanges(out,m,d))
    {
        // write this values as changed in this moment to be sure that all 
        // changes in TAU will after 'creation'
        Date at_this_moment = dateAndTime(today)
        WriteModuleObjectNumberAttributes(out,m,at_this_moment)
    }

    Module tmpModule
    for tmpModule in openedModules do
    {
        if (!null tmpModule)
            close(tmpModule)
    }
	
    delete openedModules
    close out

    returnResult(strU2File)
}
