// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

int write_time_last_number_in_tree = 0

void WriteAttributesSynchronize(Stream s, Date d, Array attrTypes, Array attributes)
{
    write_time_last_number_in_tree = write_time_last_number_in_tree + 1
    
    writeToStream(s, "ModuleAttributesSynchronize (. time = " write_time_last_number_in_tree ", attrTypes = {" )
    
    //write user deined enums
    int attrTypesCount = get(attrTypes,0,0)
    if(attrTypesCount>0)
    {
        string firstVal = get(attrTypes, 1, 0)
        writeToStream(s, "\"" firstVal "\"")
        int j
        for (j = 1; j < attrTypesCount; j++)
        {
            string val = get(attrTypes, j + 1, 0)
            writeToStream(s, ", \"" val "\"")
        }
    }
    
    writeToStream(s, "} , moduleAttributes = {" )

    // Hard import of "Object Number"
    string tmps_taunumber_name=u2pString(TAU_ATTR_NUMBER_NAME)
    string tmps_taunumber_type="_String_"
    writeToStream(s, "\"SINGLE\", \"" tmps_taunumber_type "\", \"" tmps_taunumber_name "\"")
        
    int attrCount = get(attributes,0,0)
    int i
    for (i = 0; i < attrCount; i++)
    {
        string attrTmpName = get(attributes, i + 1, 0)
        if (IsValidTAUAttribute(attrTmpName))
        {
            bool isAttributeMultivalue = get(attributes, i + 1, 1)
            string attrTmpPrefix = isAttributeMultivalue ? "MULTI" : "SINGLE"
            string u2pAttrName = u2pString(attrTmpName)
            string attrType = get(attributes, i + 1, 2)
            writeToStream(s, ", \"" attrTmpPrefix "\", \"" attrType "\", \"" u2pAttrName "\"")   
        }
    }
    
    writeToStream(s, "} .)\n")
}

void WriteObjectSynchronize(Stream s, Date d, Object o, Array attributes, Skip lastUpdatedChildInTheParentMap)
{
    write_time_last_number_in_tree = write_time_last_number_in_tree + 1
    
    string id = getTAUID(o)
    string parentId = getParentTAUIDInTree(o)
    // the object is inserted after last child or (if there are now such)
    // in first position into parent
    string afterId = "0"
    // find ID of the object which was last inserted for given 'parent'
    if (!null lastUpdatedChildInTheParentMap) {
        string lastChildInParent=""
        if(find(lastUpdatedChildInTheParentMap, parentId, lastChildInParent)) {
            if(lastChildInParent!="") {
                afterId=lastChildInParent
            }
            delete(lastUpdatedChildInTheParentMap, parentId)
        }
        // save that 'id' now is the last inserted for given 'parent'
        put(lastUpdatedChildInTheParentMap, parentId, id)
    }
    int i = intOf(d)
    string obj_name = u2pString(getTAUName(o))
    string ttype = getObjectTableType(o)
    
    // instead the real time (i), in this function the time is present as number of the object in the tree (the top object is - 1)
    // all such commands will be sorted in TAU in accordance with order of the object in the tree
    writeToStream(s, "ObjectSynchronize (. time = " write_time_last_number_in_tree ", id = \"" id "\", tabletype = \"" ttype "\", owner = \"" parentId "\", insertAfter = \"" afterId "\", name = \"" obj_name "\"")

    if(!table(o) && !row(o))
    {
        string obj_text = u2p2pString(getTAUText(o))
        string obj_heading = u2p2pString(getTAUHeading(o))
        string obj_taunumber=u2p2pString(getTAUNumber(o))
        string obj_taunumber_name=u2pStringQuoted(TAU_ATTR_NUMBER_NAME)
        writeToStream(s, ", text = \"" obj_text "\", heading = \"" obj_heading "\"")
        writeToStream(s, ", " obj_taunumber_name " = \"" obj_taunumber "\"")
        
        int attrCount = get(attributes,0,0)
        for (i = 0; i < attrCount; i++)
        {
            string attrTmpName = get(attributes, i + 1, 0)
            if (IsValidTAUAttribute(attrTmpName))
            {
                string u2pAttrName = u2pStringQuoted(attrTmpName)
                string attrValue = u2p2pString(probeAttr_(o, attrTmpName))
                writeToStream(s, ", " u2pAttrName " = \"" attrValue "\"")
            }
        }
    }
    
    writeToStream(s, " .)\n")
}

void WriteSynchronizeTreeObject(Stream s, Object o, Date d, Array attributes, Skip lastUpdatedChildInTheParentMap)
{
    if (null o || isDeleted(o) || !canRead(o))
        return

    if (isProcessedObject(o)) {
        Date objCreated = getCreatedOnDate(o)
        //Date modDate = o."Last Modified On"
        WriteObjectSynchronize(s, objCreated, o, attributes, lastUpdatedChildInTheParentMap)
        WriteChangedLinks(s, o, d)
    }

    if (!leaf(o)) {
        Object child        
        for child in o do 
        {
            WriteSynchronizeTreeObject(s, child, d, attributes, lastUpdatedChildInTheParentMap)
        }
    }
}

//changes for whole module
//now support only renaming
void WriteWholeModuleChanges(Stream s, Module m, Date date)
{
    int iDate = intOf(date)
    string mod_name = name m
    writeToStream(s, "ModuleChanged (. time = " iDate ", name = \"" mod_name "\" .)\n")
}

void WriteModuleFullChanges(Stream s, Module m, Date d)
{
    WriteWholeModuleChanges(s, m, d)
    
    // to save from duplicate attributes
    Skip writenAttrList=create
    
    //find all user defined enumerations
    Array attrTypes = create(100,1)
    int attrTypesCount = 0
    
    AttrType at
    for at in m do 
    {
        if(at.type == attrEnumeration)
        {
            if(at.name != "Boolean")
            {
                int enumSize = at.size
                if(attrTypesCount + enumSize + 1 < 100)//100 - size of array
                {
                    //FORMAT: <attr name>, <1-st value>, <2-nd value> ... <last value>, ";"                   
                    string typeName = at.name
                    attributeType = typeName
                    
                    put(attrTypes, attributeType, attrTypesCount + 1, 0)
                    ++attrTypesCount 
                    
                    int i
                    for(i=0;i<enumSize;++i)
                    {
                        put(attrTypes, at.strings[i], attrTypesCount + 1, 0)
                        ++attrTypesCount
                    }    
                    put(attrTypes, ";", attrTypesCount + 1, 0)
                    ++attrTypesCount              
                } 
            }
        }
    } 
    
    put(attrTypes, attrTypesCount, 0, 0)
    
    //find all attributes
    Array attributes = create(50,3)

    int attrCount = 0
    
    Column c 
    for c in m do 
    {
        string attributeName = ""
        bool  isAttributeMultivalue = false
        if (!IsValidColumn(c, attributeName))
            continue
    
        if(writenAttrList!=null)
        {
            if(find(writenAttrList, attributeName))
            {
                continue
            }
            put(writenAttrList, attributeName, false)
        }
            
        AttrDef ad = find(m, attributeName) 
        if(ad!=null && ad.multi==true && ad.type!=null && ad.type.type==attrEnumeration)
        {
            isAttributeMultivalue = true
        }
        
        attrCount += 1
        if(attrCount>=50)
            break
        put(attributes, attributeName, attrCount, 0)
        put(attributes, isAttributeMultivalue, attrCount, 1)
        
        string attributeType = "_String_" 
        if(ad!=null)
        {
            AttrType at = ad.type
            if(at != null)
            {
                if(at.type == attrString)
                {
                    attributeType = "_String_"
                }
                else if(at.type == attrInteger)
                {
                    attributeType = "_Integer_"
                }
                else if(at.type == attrReal)
                {
                    attributeType = "_Real_"
                }
                else if(at.name == "Boolean")
                {
                    attributeType = "_Boolean_"
                }
                else if(at.type == attrEnumeration)
                {
                    attributeType = "__udt_" at.name //udt - prefix for user defined attributes
                }
            }
        }
        put(attributes, attributeType, attrCount, 2)
    }

    if(writenAttrList!=null)
    {
        delete writenAttrList
        writenAttrList=null
    }

    put(attributes, attrCount, 0, 0)
    
    // Write list of current attributes
    WriteAttributesSynchronize(s, d, attrTypes, attributes)

    // this 'skip' is used to save the pairs:
    // ID of parent - ID of last child
    Skip lastUpdatedChildInTheParentMap = create
    Object o = null
    write_time_last_number_in_tree = 0
    for o in top(m) do 
    {
        WriteSynchronizeTreeObject(s, o, d, attributes, lastUpdatedChildInTheParentMap)
    }
    if(lastUpdatedChildInTheParentMap!=null)
    {
        delete lastUpdatedChildInTheParentMap
        lastUpdatedChildInTheParentMap = null
    }
}

void getFullChanges(string moduleID, string viewName, string baselineName, string changesAfterDate)
{
    string errMsg = null
    bool bWasOpened;

    openedModules = create

    Item i = itemFromID(moduleID)
    Module m = openModule(i, READ_MODE, viewName, baselineName, bWasOpened, true, errMsg)

    if (!null errMsg)
    { 
        if (!null m && bWasOpened)
            close(m)
        returnResult(errMsg)
        return
    }
    
    if (null m)
    { 
        return // Should never happen
    } 
    else if (bWasOpened)
    {
        put(openedModules, m, m)
    }
    
    string strU2File = tempFileName() ".u2p"

    Stream out = getStream(strU2File)
    if (null out)
    {
        delete openedModules
        returnResult("IDS_CANNOT_OPEN_FILE: " lastError())
        return            
    }

    Date d = convertDate(changesAfterDate)
                
    WriteModuleFullChanges(out,m,d)

    Module tmpModule
    for tmpModule in openedModules do
    {
        if (!null tmpModule)
            close(tmpModule)
    }
        
    delete openedModules
    close out

    returnResult(strU2File)
}
