// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//<

//////////////////////////////////////////////////
// Module
//////////////////////////////////////////////////
bool isModuleOpen(Item i)
{
    if (!null i)
    {
        string fmn = fullName(i)

        return (exists(module fmn) && open(module fmn))
    }
    return false
}

//return true if module was already opened in read only mode as visible
//return false if moduel wasn't open or was open in other modes (shareable or exclusive)
bool isModuleOpenInReadMode(Item i, bool mustBeVisible)
{
    if(isModuleOpen(i))
    {
        Module m = module i
        if(mustBeVisible && !isVisible(m))
            return false
        return isRead(m)
    }
    return false
}

//////////////////////////////////////////////////
//
// warning: if the given view do not equal the default one
//          and view not visible now - it will loaded as visible anyway
//          independed from parameter _bDisplay_
//          (the problem is that the _load(view)_ do not work with unvisible view
//
//////////////////////////////////////////////////
Module openModule(Item i, int nMode, string viewName, string baselineName, bool &bWasOpened, bool bDisplay, string &errMsg)
{
    Baseline baseLine=getBaseline(baselineName)
    if(baselineName!=null && baselineName!="" && baseLine==null)
    {
        errMsg = "IDS_BASELINE_NOT_FOUND"
        return null
    }
    if (null i)
    {
       errMsg = "IDS_MODULE_NOT_FOUND"
       return null
    }
    
    bool bLocalDisplay = (null baseLine) && bDisplay

    bWasOpened = !isModuleOpen(i)

    errMsg = lastError()
    errMsg = ""

    Module m = null

    if (nMode == READ_MODE)
    {
        m = read (fullName (i), bLocalDisplay)
    }
    else if (nMode == EDIT_MODE)
    {
        m = edit (fullName (i), bLocalDisplay)
    }
    else if (nMode == SHARE_MODE)
    {
        m = share (fullName (i), bLocalDisplay)
    }

    errMsg = GetLastError()

    if (null errMsg)
    {
        if (null m)
        {
            errMsg = "IDS_MODULE_NOT_FOUND"
            return null
        }
    }
    else
    {
        errMsg = "IDS_ERROR_OPENING_MODULE: " errMsg
        return null
    }

    if (!null baseLine)
    {
        // Load baseline
        if (!baselineExists(m, baseLine))
        {
            errMsg = "IDS_BASELINE_NOT_FOUND"
            return null
        }

        if (baselineInfo(m) != baseLine)
        {
            Module m2 = load(m, baseLine, bDisplay)
            if (!null m2)
            {
                if (bWasOpened)
                    close(m)

                m = m2
            }
        }
        
    }


    // Load the correct view
    string currView = currentView(m)
    
    if (null viewName) //use default view
        viewName = currView

    if (viewName != currView)
    {
        if (isVisible(m)) {
            // Note that the module must be visible in order to load a view
            if (!load (m, view(i, viewName)))
            {
	            if (bWasOpened)
                    close(m)
                errMsg = "IDS_VIEW_NOT_FOUND"
                return null
            }
        }
        else {
            // we may load given view only as reopen module in visible mode 
            // (additiona clecking to be sure that avoid recurse by some errors)
            if(!bDisplay) {
                bool tmpBWasOpened = false
                // this method must return the same value _m3_ as _m_
                Module m3=openModule(i, nMode, viewName, baselineName, tmpBWasOpened , true, errMsg)
                if (!null errMsg) {
	                if (bWasOpened)
                        close(m)
	                return null
                }
                if (null m3) {
	                if (bWasOpened)
                        close(m)
                    errMsg = "IDS_VIEW_NOT_FOUND"
	                return null
                }
                m=m3
            }
            else {
                // unpermitted situation probably some error take place
                if (bWasOpened)
                    close(m)
                errMsg = "IDS_UNKNOWN_DOORS_ERROR"
                return null
            }
        }
    }

    return m
}

void GetModuleName (string modID)
{
    Buffer mod_name = create
    Item i = itemFromID (modID)
    mod_name = name i
    returnResult(stringOf(mod_name))
    delete mod_name
}

void GetModuleId (string modLocation)
{
    Buffer modId = create
    string id = ""
    
    ModName_ modName = module modLocation
    if(exists modName)
    {
        id = uniqueID modName
    } 
    modId = id
    returnResult(stringOf(modId))
    delete modId
}

void DeleteAllObjects(string moduleID)
{
	Item i = itemFromID moduleID
	if (null i)
	    return
	    
	Module mod = edit (fullName (i),false)
	if (null mod)
	    return

	Object o
	for o in mod do {
	    Link l 
		for l in (o) <- "*" do {
			delete (l)
		} 
	}
	
	save (mod)//save module after deleting all links
	
	for o in mod do {
		softDelete (o)
	}

	purgeObjects_ (mod)
	save (mod)
	close (mod)
}

//function removes all appearence of c from str
//note: possibly this function will be removed to stringutils.inc in future
string removeCharFromString(string str, char c)
{
	string res = ""
	int i = 0
	int len = length str
	while (i<len) 
	{
		char ch = str[i]
		if( ch != c) 
		{
			 res = res ch ""
		}
		++i
	}
	
	return res
}

//return valid module name generated from originalName
void GetValidName(string originalName)
{
	string res = originalName
	while ( length res != 0)
	{
		char c = isValidName (res)
		if(null c)
		{
			break
		}
		
		res = removeCharFromString(res, c)
	}

	returnResult(res)
}

Item findModuleHelper(Item &parentItem, string moduleName)
{
    if (parentItem != null) {
        Item i
        for i in folder parentItem do {
            string itemType = type(i) 

            if (itemType == "Link" or itemType == "Descriptive") {
                // Nothing
                continue
            }
            if (itemType == "Formal" && name(i) == moduleName) {
                return i
            }

           if (itemType != "Formal") {
               Item result =  findModuleHelper(i, moduleName)			
               if (!null result)
                return result
           }
        }
    }
    
    return null
}

// Returns a ModName_ reference from a single name, e.g. "My Module"
ModName_ findModule(string moduleName)
{
    Item rootItem = item("/")
    Item i = findModuleHelper(rootItem, moduleName)
    if (!null i)
        return module(fullName(i))

    return null
}

void createFormalModule (string moduleLocation, string moduleTitle, string moduleDescription, string modulePrefix, string moduleStartObjectAbsno)
{
    int moduleStart = 1
    if (moduleStartObjectAbsno!="")
    {
        if(!isValidInt(moduleStartObjectAbsno))
        {
            returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: The attribute START_AT must be a positive number.")
            return
        }
        moduleStart = intOf(moduleStartObjectAbsno)
        if(moduleStart<1)
        {
            returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: The attribute START_AT must be a positive number.")
            return
        }
    }

    if(!isValidName(moduleTitle))
    {
        char c = isValidName(moduleTitle) 
		returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: The module name contains illegal character [" c "]")
		return
    }
    if(modulePrefix!="" && !isValidPrefix(modulePrefix))
    {
        returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: The illegal prefix [" modulePrefix "]")
        return
    }
    if(moduleDescription!="" && !isValidDescription(moduleDescription))
    {
        returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: The illegal description [" moduleDescription "]")
        return
    }
    
    Folder f = folder moduleLocation
    if (f != null) 
    {
        if (canCreate(Folder f)) 
        {
            string moduleFullName = moduleLocation "/" moduleTitle
			
            // check that such module exist now
            if(module(moduleFullName))
            {
                // such module exist
                returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: A module with this name already exists.")
                return
            }
            Module newModule = create(moduleFullName, moduleDescription, modulePrefix, moduleStart, false) 
            if(newModule!=null)
            {
                Item i = item fullName newModule
                string moduleId = uniqueID(i)
                if(moduleId!="")
                {
                    openPath(moduleLocation)
                    refreshDBExplorer()
                    save (newModule)
                    returnResult(moduleId)
                    return
                }
            }
        }
    }
    string strError = lastError()
    returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: " strError "")
}

void createProjectModule(string moduleLocation, string moduleTitle, bool createInExistingModule)
{
    string moduleFullName = moduleLocation "/" moduleTitle
    ModName_ modName = module(moduleFullName) 
    if(!null modName)//already exist
    {
        if(!createInExistingModule)
        {
            returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: A module with this name already exists.")
            return;
        }
    }
    else
    {
        createFormalModule(moduleLocation, moduleTitle, "", "", "1")
    }
    
    Item it = item(moduleFullName)
    if(null it)
    {
        //some error with createFormalModule
        return
    }
    
    //create attributes
    Module m = edit(moduleFullName)
    
    if(null m)
    {
        returnResult("IDS_DOORS_COULD_NOT_CREATE_MODULE: Error of opening of created module.")
        return
    }
    
    current = m
    create module type "Text" history false hidden true attribute "UML Project.ttp"
          
    Item i = item fullName m      
    string moduleId = uniqueID(i)
    if(moduleId!="")
    {  
        returnResult(moduleId) 
    }
       
    save (m)
}
