// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//<

//////////////////////////////////////////////////
//
// WARNING: The DOORS function object(absno, m) 
// don't give the object if it's 'table()' or 'row()'
// (by understandable reason)

Object findObject(Module m, string objectID, &errMsg)
{    
    Object o = null
    if (isValidInt(objectID) && !null m)
    {
        o = object(intOf(objectID), m)
        if (!null o && !isDeleted(o))
            return o
    }

    errMsg = "IDS_OBJECT_NOT_FOUND"
    return null
}

Object findObject (string modID, objID, &errMsg) 
{

    Module m = null

    Item i = itemFromID(modID)
    if (!null i)
        m = module(i)

    if (null m)
        m = read (fullName (i), false)

    return findObject (m, objID, errMsg)
}

Object findAnyObject(Module m, string objectID, &errMsg)
{    
    Object o = null
    
    string correctedObjectID = objectID
    if(!isValidInt(correctedObjectID))
    {
        //possible format of objectID is <Prefix><id>
        // - try to get id
        string prefix = m."Prefix"
        if(!null prefix)
        {
            int offset=0;
            int len=0;
            if(findPlainText(objectID, prefix, offset, len, true))
            {
                if(offset==0 && len>0 && (len<length(objectID)))
                {
                    correctedObjectID = objectID[len:]
                }
            }
        }
    }

    if (isValidInt(correctedObjectID) && !null m)
    {
        int intObjectID=intOf(correctedObjectID)
        o = object(intObjectID, m)
        // find inside of module
        if(o==null)
        {
            Object tmp_o = null
            for tmp_o in entire m do
            {
                if(!null tmp_o && !isDeleted(tmp_o))
                {
                    // the good way to use 'getTAUID' but current realization is essential more fast
                    int tmp_o_id=tmp_o."Absolute Number"
                    if(intObjectID==tmp_o_id)
                    {
                        return tmp_o
                    }
                }
            }
        }
        if (!null o && !isDeleted(o))
        {
            return o
        }
    }

    errMsg = "IDS_OBJECT_NOT_FOUND"
    return null
}

Object findAnyObject(string modID, objID, &errMsg) 
{

    Module m = null

    Item i = itemFromID(modID)
    if (!null i)
        m = module(i)

    if (null m)
        m = read (fullName (i), false)

    return findAnyObject(m, objID, errMsg)
}

// return null if the object is _root object
Object getParentInTree (Object o) 
{
    Object tmp = parent(o)
    if(row(o) || cell(o))
        return tmp
    while (null!=tmp && (!isVisible(tmp) || isDeleted(tmp)))
    {
        tmp = parent(tmp)
    }
    return tmp
}

// return previous visible sibling for given object
// Can be used only for full tree!
Object getPreviousSiblingInTree (Object o) 
{
    Object tmp = previous(sibling(o))
    
    while (null!=tmp && (!isVisible(tmp) || isDeleted(tmp)))
    {
        tmp = previous(sibling(tmp))
    }
    return tmp
}

// return true only if in given subbtree we stoped on 'stop_obj' object
bool GetLastVisibleOfFirstLevel(Object start_obj, Object stop_obj, Object &prev_visible)
{
    if(start_obj==null)
    {
        return false
    }
    if(start_obj==stop_obj)
    {
        // final stop
        return true
    }
    if(isVisible(start_obj) && !isDeleted(start_obj) && canRead(start_obj))
    {
        prev_visible=start_obj
        return false
    }
    Object ch = null
    for ch in start_obj do {
        bool rez=GetLastVisibleOfFirstLevel(ch, stop_obj, prev_visible)
        if(rez==true)
        {
            return true
        }
    }
    return false
}

// the function to work with filtered view (SLOW)

Object getPreviousSiblingInFilteredTree (Object o) 
{
    //return getPreviousSiblingInTree (o) 
    if(o==null)
        return null
    
    Object par = getParentInTree(o)
    Object ch = null
    Object prev_visible = null
    if(par!=null)
    {
        for ch in par do {
            bool rez=GetLastVisibleOfFirstLevel(ch, o, prev_visible)
            if(rez==true)
            {
                if(prev_visible!=null && cell(prev_visible))
                {
                    return getTable(prev_visible)
                }
                return prev_visible
            }
        }
    }
    else
    {
        Module m = module(o)
        // walk throw TOP level of objects (independent visibility)
        for ch in top(m) do {
            bool rez=GetLastVisibleOfFirstLevel(ch, o, prev_visible)
            if(rez==true)
            {
                if(prev_visible!=null && cell(prev_visible))
                {
                    return getTable(prev_visible)
                }
                return prev_visible
            }
        }
    }
    return null
}

// second realisarion - in some cases it can be more fast
//
Object getPreviousSiblingInFilteredTree2 (Object o) 
{
    //return getPreviousSiblingInTree (o) 
    if(o==null)
        return null
    
    Object par = getParentInTree(o)
    Object ch = null
    Object prev_visible = null
    Module m = module(o)
    // it's ordered list of visible object in module [entire(m) - it's full list]
    for ch in m do {
        if(ch==o)
        {
            if(prev_visible!=null && cell(prev_visible))
            {
                return getTable(prev_visible)
            }
            return prev_visible
        }
        if(isVisible(ch) && !isDeleted(ch))
        {
            Object tmp_par = getParentInTree(ch)
            if(tmp_par==par)
            {
                prev_visible=ch
            }
        }
    }
    return null
}


//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
void locate(string moduleID, objectID, viewName, strBaseline)
{
    string errMsg = null
    Baseline bl = getBaseline(strBaseline)
    if(strBaseline!=null && strBaseline!="" && bl==null)
    {
        errMsg = "IDS_BASELINE_NOT_FOUND"
        returnResult(errMsg)
        return 
    }

    Item i = itemFromID(moduleID)

    int nMode = EDIT_MODE
    if (!null bl || isModuleOpenInReadMode(i, true))
    {
        nMode = READ_MODE
    } 
 
    bool bWasOpened = false
    
    Module m = openModule(i, nMode, viewName, strBaseline, bWasOpened, true, errMsg)

    if (objectID!="" && null errMsg)
    { 
        Object tmp_obj = findAnyObject(m, objectID, errMsg)
        if (!null tmp_obj)
        {
            current = tmp_obj
            refresh current
        }
        else
        {
            current = m
            refresh current
        }
    }
    else 
    {
        if (null errMsg)
        { 
            current = m
            refresh current
        }
    }

    if (!null errMsg && !null m && bWasOpened)
        close(m)

    if (!null errMsg)
    {
        returnResult(errMsg)
        return
    }
    returnResult("true")
}

// Return 'true' only if moving take place

bool move_to_top(Module m, Object obj)
{    
    if(obj==null || m==null)
        return
    Object o = first (m)
    if(o==null)
    {
        for o in entire m do
        {
            if(o!=null)
            {
                break;
            }
        }
    }
    if(o!=null && cell(o)) 
    {
        o=getTable(o)
    }
    else if(o!=null && row(o)) 
    {
        o=getRow(o)
    }
    if (o==null || o==obj)
        return false
    move (obj, o)
    move (o, obj)
    return true
}

string getObjectTableType(Object o)
{
    if(table(o))
    {
        return "table"
    }
    else if(row(o))
    {
        return "row"
    }
    else if(cell(o))
    {
        return "cell"
    }
    else 
    {
        return "requirement"
    }
}

int getRowNumber(Object o)
{
    Object tab =  parent(o)
    if(!row(o) || !table(tab))
    {
        return 1
    }
    int index = 1
    Object tmp
    for tmp in table(tab) do
    {
        if(tmp==o)
            return index
        index++
    }
    return 1
}

Object getFirstVisibleTableCell(Object tab)
{
    if(!table(tab))
        return null
    Object ptrRow
    for ptrRow in table tab do 
    {
        Object ptrCell
        for ptrCell in row ptrRow do 
        {
            if(isVisible(ptrCell) && !isDeleted(ptrCell))
            {
                return ptrCell
            }
        }
    }
    return null
}

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
void deleteObjectsWithIncomingLinks(string moduleID, allObjectID)
{
    string errMsg = null

    Skip mapAllOpenedModules = create
    if(mapAllOpenedModules==null)
    {
        errMsg = "IDS_UNKNOWN_DOORS_ERROR"
        returnResult(errMsg)
        return 
    }
    Skip mapNeedSaveCloseModules = create
    if(mapNeedSaveCloseModules==null)
    {
        delete mapAllOpenedModules
        errMsg = "IDS_UNKNOWN_DOORS_ERROR"
        returnResult(errMsg)
        return 
    }
    
    bool bM_WasOpened = false

    Item i = itemFromID(moduleID)
    Module m = openModule(i, EDIT_MODE, "", "", bM_WasOpened, false, errMsg)
    if (!null errMsg || null m)
    {
        if (!null m && bM_WasOpened)
        {
            close(m)
        }
        delete mapAllOpenedModules
        delete mapNeedSaveCloseModules
        if(null errMsg)
        {
            errMsg = "IDS_MODULE_NOT_FOUND"
        }
        returnResult(errMsg)
        return
    }
    
    bool bWasLinkDeleted = false
    bool bWasObjectDeleted = false
    bool bWasError=false
    
    string rest_object_ID
    string objectID
    Regexp split_by_space=regexp "([^ ]*) (.*)"
    if (split_by_space allObjectID) 
    {
        objectID=allObjectID[match 1]
        rest_object_ID=allObjectID[match 2]
    }
    else
    {
        objectID=allObjectID
        rest_object_ID=""
    }
    
    //DXL error in Doors 8.2
    //delete split_by_space

    Skip mapUndeletedObjects=create
    bool wasUnfoundObjects=false
    
    while(objectID!="")
    {
        Object tmp_obj = findAnyObject(m, objectID, errMsg)
        if(tmp_obj==null)
        {
            wasUnfoundObjects=true
        }
        else
        {
            // preload all modules linked as sources (incoming links)
            ModName_ srcModRef 
            for srcModRef in tmp_obj<-"*" do {
                bool tmp_bOldWasOpened=false
                if(!find(mapAllOpenedModules, srcModRef, tmp_bOldWasOpened))
                {
                    Item iSMod = item(fullName srcModRef)
                    bool bWasOpened = false
                    Module tmp_module= openModule(iSMod, EDIT_MODE, "", "", bWasOpened, false, errMsg)
                    if(tmp_module!=null)
                    {
                        put(mapAllOpenedModules, srcModRef, bWasOpened)
                        if(bWasOpened)
                        {
                            put(mapNeedSaveCloseModules, tmp_module, bWasOpened)
                        }
                    }
                }
            } 
            // Delete links        
            Link curLink=null
            for curLink in tmp_obj<-"*" do {
                if(!canDelete(curLink))
                {
                    // if the link was rest the object will not be deleted and it must set bWasError later
                    continue
                }
                // delete the link
                delete(curLink)
                bWasLinkDeleted = true
            } 
            string tmp_canObjDelete=canDelete(tmp_obj)
            if(tmp_canObjDelete=="")
            {
                softDelete(tmp_obj)
                bWasObjectDeleted = true
            }
            else 
            {
                // always run this branch because if we not do 'flush' just after deletion 
                // of the links - than the object cannot be deleted anyway
                bWasError=true
                // do map of undeleted object
                put(mapUndeletedObjects, objectID, tmp_obj)
            }
        }
        if (split_by_space rest_object_ID) 
        {
            objectID=rest_object_ID[match 1]
            rest_object_ID=rest_object_ID[match 2]
        }
        else
        {
            objectID=rest_object_ID
            rest_object_ID=""
        }
    }

    if(bWasLinkDeleted)
    {
        flushDeletions()
    }
    
    if(bWasError)
    {
        // Process map of undeleted object
        //
        // do cicle to delete the object by reason 'descendants'
        // I don't know right order and do multy-pass while I can delete something
        bool wasSomethingDeleted=true
        bool allDeletedSuccessfull=true
        while (wasSomethingDeleted)
        {
            wasSomethingDeleted=false
            allDeletedSuccessfull=true
            Object tmpo
            for tmpo in mapUndeletedObjects do
            {
                if (tmpo==null)
                    continue
                string tmp_canObjDelete=canDelete(tmpo)
                if(tmp_canObjDelete!="")
                {
                    allDeletedSuccessfull=false
                    continue
                }
                string tmpID=(string key mapUndeletedObjects)
                softDelete(tmpo)
                delete(mapUndeletedObjects, tmpID)
                wasSomethingDeleted=true
                bWasObjectDeleted=true
            }
            purgeObjects_(m)
        }
        // check that there are at least one undeleted object
        if(allDeletedSuccessfull)
        {
            bWasError=false
        }
    }

    // purge deleted objects
    if(bWasObjectDeleted)
    {
        //flushDeletions()
        string purge_result=purgeObjects_(m)
    }

    bool tmp_b
    for tmp_b in mapNeedSaveCloseModules do
    {
        if (!tmp_b)
            continue
        Module tmp_m=(Module key mapNeedSaveCloseModules)
        if(!null tmp_m)
        {
            save(tmp_m)
            close(tmp_m)
        }
    }
    delete mapAllOpenedModules
    delete mapNeedSaveCloseModules
    
    if(bM_WasOpened)
    {
        save(m)
        close(m)
    }

    if(bWasError || wasUnfoundObjects)
    {
        errMsg = "IDS_DOORS_OBJ_DELETE_FILED"
        returnResult(errMsg)
        return 
    }
    
    returnResult("true")
    return 
}
