// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// ==================================================
// 
// MAPPRING of DOORS attributes to TAU stereotyped attributes (Requirement.u2)
//
// 'Name' 'Text' 'Id' 'Heading'
//
// Behaviour of 'setObjectName' function is defined by next global variables:
// if the new_name != old_name
// if 'isTAUNameValidated' set to 'true' the function will generate back command 
// to TAU to rename this entity back to original name
const bool isTAUNameValidated = true  // old-false, new-true
// else if 'isTAUNameEdited' set to 'true' the function will set the value
const bool isTAUNameEdited = false  // old-true, new-false
//
// if 'isTAUNameValidated' set to 'true' the function 'setObjectAttributeValue' 
// will generate for all unaccessed attrributes with changed in the TAU value
// the back command to TAU to set the value of this attribute back to original value
const bool isTAUAttributeValidated = true

// OLD REALIZATION of basic function to get 'Name' of object
// Returns the object name to be used in TAU
// Use object heading if not empty, otherwise absolute number
// Special processing of 'table' and 'row' types.

string getObjectNameOLD(Object o)
{    
    if(table(o))
    {
        return "Table[ID-" probeAttr_(o, "Absolute Number") "]"
    }
    else if(row(o))
    {
        return "Row[ID-" probeAttr_(o, "Absolute Number") "]"
    }
    else
    {
        string result = probeAttr_(o, "Object Heading")
        removeUnVisibleControlChar(result)
        if ("" == result)
	        return probeAttr_(o, "Absolute Number")
        return result
    }
}

//
// All work in our dxl function to set/put tau 'name/id/text/heading'
// must use this set of function
// Now the mapping is next:
// TAU       CanBeChangedInTAU CanBeChangedInDOORS DOORS
// ------------------------------------------------------------------
// id-Id     not(imported)     not                 "Absolute Number"
// Name      not(imported)     not                 identifier == (MODULE_PREFIX+object."Absolute Number")
// Text      yes               yes                 "Object Text"
// Heading   yes               yes                 "Object Heading"
//
// 'Name' and 'Id' - cannot be changed in TAU directly by user 
// ther received from DOORs during 'Commit/Import/Update'
//
// If the user change 'Name' for imported object - during 'Commit' the 
// warning will out and the 'Name' is restored from DOORS
//
// If the user change 'Id' for imported object - during 'Commit' the 
// object will either conflicted or considered as new one.
//
// If we need remaping we will change contents of this functions
// (possible feature - one function Set/Get - with 'type' as second parameter)
//
// 'Get*' procedures

string getTAUID(Object o)
{
    return probeAttr_(o, "Absolute Number")
}

string getTAUName(Object o)
{
    // old
    //return getObjectNameOLD(o)
    // new
    return identifier(o)
}

string getTAUText(Object o)
{
    return probeAttr_(o, "Object Text")
}

string getShortText(Object o)
{
    return probeAttr_(o, "Object Short Text")
}

string getTAUHeading(Object o)
{
    return probeAttr_(o, "Object Heading")
}

// 'Set*' procedures

bool setTAUText(Object o, string new_text)
{
    noError
    o."Object Text" = new_text
    if (lastError != null)
        return false
    return true
}

bool setShortText(Object o, string new_text)
{
    noError
    o."Object Short Text" = new_text
    if (lastError != null)
        return false
    return true
}

bool setTAUHeading(Object o, string new_heading)
{
    noError
    o."Object Heading" = new_heading
    if (lastError != null)
        return false
    return true
}
bool setTAUName(Object o, string new_name)
{
    // old
    //return setTAUHeading(o, new_name)
    // new
    return false
}

// Special attribute attached to any requirements inside of <requirementAttribute>
// by real it's value of TAU_ATTR_NUMBER_NAME

string getTAUNumber(Object o)
{
    return number(o)
}
