# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#############################
# Global variables

# The string representing a missing value/empty cell in reports
set EMPTY_CELL_STRING	"-"

# The string/character used to separate entrys in the file reports
set CELL_SEPARATOR	", "
     
# Returns the session of the active project. Should be used whenever the session
# is needed.
proc GetActiveSession {} {
   set activeProject [std::GetActiveProject]
   return [lindex [std::GetModels -kind U2 -project $activeProject] 0]
}

########################################################################################
# Report utilities

# Initializes the report tabs. A new tab with the name of the title parameter is
# created and one column is added for each entry in the headings list, and one for
# each attribute for each of the supplied stereotypes.
#
# If a file handle is supplied, the information is written to the file instead,
# using the separator in the CELL_SEPARATOR variable.
#
proc InitializeReport { title headings {fileHandle ""}} {

    global CELL_SEPARATOR

    set session [GetActiveSession]

    set reportHeadings $headings

    # Initialize the report title using the headings derived above
    if {"" != $fileHandle } {
      # Note: We assume that the headings doesn't contain any comma characters ','.
      # That would break the CSV format.
      puts $fileHandle [join $reportHeadings $CELL_SEPARATOR] 
    } else {
      set reportColumns \"[join $reportHeadings "\" 100 0 \""]
      set reportColumns "${reportColumns}\" 100 0"
      eval "ReportInit \"$title\" $reportColumns"
    }
}

# Writes the information in the args parameter to the report tab or to a file if the
# outFileHandle parameter is supplied. When writing to file, the entries are separated
# by the character in the CELL_SEPARATOR variable.
proc myReport { args {outFileHandle ""} } {
	global CELL_SEPARATOR
	if {$outFileHandle != ""} {
		# Replace the 1st element of the list with its name (Report requires ID)
		set args [lreplace $args 0 0 "Dependency"]

		# Put commas inbetween each list element.
		# Note: We assume that the elements doesn't contain any comma characters ','.
		# That would break the CSV format.
		puts $outFileHandle [join $args $CELL_SEPARATOR] 
	} else {
            eval "Report $args"
	}
}

# Returns all elements to which the supplied stereotype is applied
proc GetAllElementsWithStereotype { stereotypeGuid } {
	set result ""
	set stereotype [u2::FindByGuid [GetActiveSession] $stereotypeGuid]
	if {0 == $stereotype} {
		return $result
	}
	set instanceExpressions [u2::GetReferingEntities $stereotype InstanceOf]
	foreach expr $instanceExpressions {
		if {0 == $expr} {
			continue
		}
		set owner [u2::GetEntity $expr Owner]
		if {0 == $owner} {
			continue
		}
		lappend result $owner
	}
	return $result
}
