# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#########################################################################################

#  										   	#		
#	Name of Addin : XMI Export Addin for Tau G2					#
#	File Name     :	DialogBox.tcl							#
#	Date          : 02 FEB 2006							#
#      											#
#	Description   : This File contains the code for File save Dialog Box for 	#
#			selecting the XMI file path and it path. 			#
# 											#
#########################################################################################

global New_file 
global Export_Rose
global ModelNumber
set ModelNumber ""

set New_file "Abc.xml"

proc ExportSingleProject {} {
 

global  ModelNumber
set ModelNumber ""

global New_file 

set curProj [std::GetActiveProject]

if {$curProj==""} {
	 std::MessageDialog "Please select a project to export"  
} else {
	 set ProjPath [Get $curProj pathname]
	 set fileName [file rootname $ProjPath]
	 set XMIfileName [file tail $fileName]
	 set FileName [std::FileSaveDialog -filename $XMIfileName -fileext "xml" -filter "XML Files (*.xml)|*.xml|All files (*.*)|*.*||"]

  
	 if {$FileName!=0} {
 	      set Export_Rose 1
              set New_file $FileName
	      set curProject [std::GetActiveProject]
	      set model [std::GetModels -kind U2 -project $curProject]	
	      set ModelNumber $model
	      source [std::GetInstallationDirectory]/addins/XMIExport/Script/XMIexport.tcl
 	      global groupcombo 
	      std::MessageDialog "Export to XMI 1.1 completed"  
      }
   }
}

global MenuEnable
set MenuEnable 0 
 
global isu2File
global u2FileName
set u2FileName ""
set isu2File 0

proc OnActivateExport {cmdName} {
  package require dialogs
  global XMIfileName    
  set XMIfileName "" 
  global New_file 
  global selection
  global groupCombo
  global selected
  set selected "Rational Rose"  
  global Export_Rose
  set Export_Rose 1 
  global ModelNumber
  set ModelNumber ""

  global MenuEnable 

  global isu2File
  global u2FileName
  
  set sel [std::GetSelection]
 
  if {$sel!=""} {

	set bIsEntity "0"
	catch { set bIsEntity [u2::IsKindOf $sel Entity] }

	if { $bIsEntity } {
		# This is a U2 entity
		set resource [u2::GetEntity $sel Resource]
		set resourcePath [u2::GetValue $sel Uri]
		
	} else {
		set project ""
		catch { set project [std::GetProject $sel] }

	 	if { $project == "" } {
			#standalone file
			set filePath [Get $sel pathname]
			set model [std::GetModels -kind U2] 
			set isu2File 1

			set len [llength $model]
    			set len [expr $len -1]
			set model [lindex $model $len]

			set Export_Rose 1	
			set fileName [file rootname $filePath]
			set XMIfileName [file tail $fileName]
			set u2FileName $XMIfileName
		        set FileName [std::FileSaveDialog -filename $XMIfileName -fileext "xml" -filter "XML Files (*.xml)|*.xml|All files (*.*)|*.*||"]
 			 if {$FileName!=0} {	
				set New_file $FileName
				set ModelNumber $model

				source [std::GetInstallationDirectory]/addins/XMIExport/Script/XMIexport.tcl
				# this is the model - in the case of Analyst
			}
		 
		} else {
# --------------------------------- Code For Project Export -------------------------------
				set ProjPath [Get $project pathname]
				set fileName [file rootname $ProjPath]
			        set XMIfileName [file tail $fileName]
				set FileName [std::FileSaveDialog -filename $XMIfileName -fileext "xml" -filter "XML Files (*.xml)|*.xml|All files (*.*)|*.*||"]
		 
				 if {$FileName!=0} {
			 	      set Export_Rose 1
			              set New_file $FileName
 				      set model [std::GetModels -kind U2 -project $project]	
				      set ModelNumber $model
			              source [std::GetInstallationDirectory]/addins/XMIExport/Script/XMIexport.tcl
 				      global groupcombo 
				      std::MessageDialog -message "Export to XMI 1.1 completed"  
      				}	
					
# --------------------------------- Code For Project Export ------------------------------- 
			 
 		}
	}
   } 

} 
 
 


proc OnXMIExportCheck {cmdName} {
	global MenuEnable
  	set MenuEnable 0

	set bIsEntity "0"
        set selection [std::GetSelection]
	set Length [llength $selection]

	if {$Length>1 || $Length==0} {	
		set MenuEnable 0
	} else {
		
		catch { set bIsEntity [u2::IsKindOf $selection Entity] }
		if { $bIsEntity } {
			# This is a U2 entity
			set MenuEnable 0

		} else {
			set project ""
			catch { set project [std::GetProject $selection] }
	 		if { $project == "" } {
				#standalone file
				set MenuEnable 1
					
			} else {
				#project
				set MenuEnable 1 
			}
		}	
      }
     return $MenuEnable;
} 
 

 
# Declaration and registration of commands/toolbar/menu

package require commands

std::Declare addcommand -variable cmdSemCheck -name "Export Model to XMI..." -statusmessage "Export Model to XMI 1.1" -tooltip "Export Model to XMI 1.1..." -accelerator "" -onactivatecommand OnActivateExport -onenablecommand OnXMIExportCheck

std::AddCommand cmdSemCheck

std::AddMenu -variable mnuSemCheck -commands { separator cmdSemCheck } -path {&Tools} -position {last}
 
