/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "uml_kern.h"


/****+***************************************************************
     Variables
********************************************************************/

#if (CFG_NUMBER_THREADS > 0)
  xSystemData   xSysD[CFG_NUMBER_THREADS];
#elif defined(CFG_USED_DYNAMIC_THREADS)
  xSystemData   xSysD[1];
#else
  xSystemData   xSysD;
#endif

#ifdef USER_CFG_MAX_SIGNAL_INSTS
  /* Use the user value to scale the singal array */
  #define CFG_STATIC_SIGNAL_INSTS  USER_CFG_MAX_SIGNAL_INSTS
#else
  /* Use a predefined value to scale the timer array.  */
  #define CFG_STATIC_SIGNAL_INSTS  20
#endif

/* Signal array */
static xSignal xSignalArray[CFG_STATIC_SIGNAL_INSTS];

/* Pointer to first element in list of free signals */
static xSignal *xFreeSignalList;

#ifdef CFG_USED_TIMER
  #ifdef USER_CFG_MAX_TIMER_INSTS
    /* Use user value scale the timer array */
    #define CFG_STATIC_TIMER_INSTS  USER_CFG_MAX_TIMER_INSTS
  #else
    /* Use the automatically generated constant to scale the timer array  */
    #define CFG_STATIC_TIMER_INSTS  CFG_MAX_TIMER_INSTS
  #endif

  /* Timer array */
  static xTimer xTimerArray[CFG_STATIC_TIMER_INSTS];

  /* Pointer to first element in list of free timers */
  static xTimer *xFreeTimerList; 
#endif /* CFG_USED_TIMER */



#if (CFG_MAX_INSTANCES > 1)
  #define INSTANCE_VAR(INST)  \
    ((xInstanceData *)((char *)PartData->InstanceData + PartData->DataLength*(INST)))
#else
  #define INSTANCE_VAR(INST)  (PartData->InstanceData)
#endif


/****+***************************************************************
     Utility functions
********************************************************************/

#ifdef __cplusplus
void * operator new (size_t pp, xSpecial vv) {
  return (void *)vv;
}
#endif


/****+***************************************************************
     Execution API includes
********************************************************************/

#if defined(USER_CFG_RTAPIDEF)

  #include "rtapidef.c"

#else

  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    #if (defined(_MSC_VER)) || (defined(__BORLANDC__))
      #include "RTOS\Win32\rtapidef.c"
    #else
      #include "RTOS/POSIX/rtapidef.c"
    #endif
  #else
    #if (defined(_MSC_VER)) || (defined(__BORLANDC__))

      SDL_Time xNow (void)
      {
        SDL_Time Result;
        #ifdef _MSC_VER
          struct _timeb CurrentTime;
          _ftime((struct _timeb *) &CurrentTime);
        #else
          struct timeb CurrentTime;
          ftime((struct timeb *) &CurrentTime);
        #endif
        Result.s  = (xint32)(CurrentTime.time);
        Result.ns = (xint32)(CurrentTime.millitm * 1000000);
        return Result;
      }

    #else

      SDL_Time xNow (void)
      {
        SDL_Time Result;
        struct timespec ts;
        clock_gettime(CLOCK_REALTIME, &ts);
        Result.s  = ts.tv_sec;
        Result.ns = ts.tv_nsec;
        return Result;
      }

    #endif
  #endif

#endif


/****+***************************************************************
     static functions in this file
********************************************************************/

static xActionId xCheckSignal (
    xSignalId Sid, 
    xStateId StateId,
    XCONST_INST xPartTable *PartData);

/****+***************************************************************
     Signal functions
********************************************************************/

void xInsertSignal (xSignal *Signal)
{
  xSignal **tmp;
  int ToExternQueue;

  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xSystemData *xSysDP;
    XCONST_INST xPartTable *PartData;
    PartData = xPartData[XPART(Signal->Receiver)];
    #ifdef CFG_USED_DYNAMIC_THREADS
      if (PartData->ThreadNumber >= CFG_NUMBER_THREADS) {
        xSysDP = INSTANCE_VAR(XINST(Signal->Receiver))->xSysDInst;
      } else {
    #endif
        xSysDP = xSysD + PartData->ThreadNumber;
    #ifdef CFG_USED_DYNAMIC_THREADS
      }
    #endif
    if (Signal->Sender == ENV) {
      ToExternQueue = 1;
    } else {
      ToExternQueue = xSysDP != (xSysD + xPartData[XPART(Signal->Sender)]->ThreadNumber);
    }
    if (ToExternQueue) {
      xThreadLock(&xSysDP->ThreadVars.SignalQueueMutex);
      tmp = &XSYSD ExternSignalQueue;
    } else {
      tmp = &XSYSD SignalQueue;
    }
  #else
    ToExternQueue = Signal->Sender == ENV;
    if (ToExternQueue) {
      XBEGIN_CRITICAL_PATH
      tmp = &XSYSD ExternSignalQueue;
    } else {
      tmp = &XSYSD SignalQueue;
    }
  #endif

  /* Search for position to insert in queue */
  #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
    for (; *tmp != 0; tmp = &((*tmp)->Next)) {
      if (Signal->Prio < (*tmp)->Prio) {
        break;
      }
    }
  #else
    for (; *tmp != 0; tmp = &((*tmp)->Next)) {
      ; /* empty statement */
    }
  #endif

  /* Insert signal into queue */
  Signal->Next = *tmp;
  *tmp = Signal;
  if (ToExternQueue) {
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
      xThreadSignalUnlock(xSysDP);
    #else
      XEND_CRITICAL_PATH
    #endif
  }
}



void xRemoveSignal (xSignal *Signal)
{
  xSignal *tmp;
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xSystemData *xSysDP;
    XCONST_INST xPartTable *PartData;
    PartData = xPartData[XPART(Signal->Receiver)];
    #ifdef CFG_USED_DYNAMIC_THREADS
      if (PartData->ThreadNumber >= CFG_NUMBER_THREADS) {
        xSysDP = INSTANCE_VAR(XINST(Signal->Receiver))->xSysDInst;
      } else {
    #endif
        xSysDP = xSysD + PartData->ThreadNumber;
    #ifdef CFG_USED_DYNAMIC_THREADS
      }
    #endif
  #endif
  if (XSYSD SignalQueue == Signal) {
    XSYSD SignalQueue = XSYSD SignalQueue->Next;
  } else {
    for (tmp = XSYSD SignalQueue; tmp != 0; tmp = tmp->Next) {
      if (tmp->Next == Signal) {
        tmp->Next = tmp->Next->Next;
        break;
      }
    }
  }
}



#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  xSignal *xGetSignal(xSignalId Sid  XOUTPUT_SPARAM(int ParaLength), xSignal **InSig)
#else
  xSignal *xGetSignal(xSignalId Sid  XOUTPUT_SPARAM(int ParaLength))
#endif
{
  xSignal *Signal;

  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  /* Try first to reuse the signal passed as parameter. This optimization
     is only used in threaded soulutions */
  if ((InSig != 0) && (*InSig != 0)) {
    Signal = *InSig;
    *InSig = 0;
    #ifdef CFG_USED_SIGNAL_WITH_PARAMS
      if (Signal->ParPtr != 0) {
        #if (CFG_MSG_BORDER_LEN > 0)
          if (Signal->ParPtr != (void *)&Signal->ParArea) {
        #endif
            xFree((void **)&Signal->ParPtr);
        #if (CFG_MSG_BORDER_LEN > 0)
          }
        #endif
      }
    #endif
  } else {
  #endif
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
      xThreadLock(&xFreeSignalMutex);
    #else
      XBEGIN_CRITICAL_PATH
    #endif
    Signal = xFreeSignalList;
    if (Signal != 0) {
      xFreeSignalList = xFreeSignalList->Next;
      #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
        xThreadUnlock(&xFreeSignalMutex);
      #else
        XEND_CRITICAL_PATH
      #endif
    } else {
      #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
        xThreadUnlock(&xFreeSignalMutex);
      #else
        XEND_CRITICAL_PATH
      #endif
      #ifdef USER_CFG_NOUSE_DYNAMIC_SIGNALS
        #ifdef USER_CFG_ERR_CHECK_BASIC
          ErrorHandler(ERR_N_NO_FREE_SIGNAL_ERR);
        #endif
      #else
        Signal = (xSignal *)xAlloc(sizeof(xSignal));
        #ifdef USER_CFG_ERR_CHECK_BASIC
          if (Signal == 0) {
            ErrorHandler(ERR_N_NO_FREE_SIGNAL_ERR);
          }
        #endif
      #endif
    }
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  }
  #endif

  Signal->Sid = Sid;
  #ifdef CFG_USED_SAVE
    Signal->SaveState = 0;
    /* start state cannot be used as save state */
  #endif
  #ifdef CFG_USED_SIGNAL_WITH_PARAMS
    if (ParaLength > CFG_MSG_BORDER_LEN) {
      /* Allocate memory area */
      Signal->ParPtr = (xSignal *)xAlloc(ParaLength);
      /* if memory allocation failed, free signal and return errorcode */
      if (Signal->ParPtr == 0) {
        #ifdef USER_CFG_ERR_CHECK_BASIC
          ErrorHandler(ERR_N_PARAMETER_MEM_ALLOC);
        #endif
        xReturnSignal(Signal);
        return 0;
      }
    /* else if parameters can be stored within the signal itself */
    #if (CFG_MSG_BORDER_LEN > 0)
    } else if (ParaLength > 0) {
        Signal->ParPtr = (void *)&Signal->ParArea;
    #endif
    } else {
      Signal->ParPtr = 0;
    }
  #endif /* CFG_USED_SIGNAL_WITH_PARAMS */

  return Signal;
}



void xReturnSignal(xSignal *Signal)
{
  #ifdef CFG_USED_SIGNAL_WITH_PARAMS
    if (Signal->ParPtr != 0) {
      #if (CFG_MSG_BORDER_LEN > 0)
        if (Signal->ParPtr != (void *)&Signal->ParArea) {
      #endif
          xFree((void **)&Signal->ParPtr);
      #if (CFG_MSG_BORDER_LEN > 0)
        }
      #endif
    }
  #endif

  #ifndef USER_CFG_NOUSE_DYNAMIC_SIGNALS
    if ( (Signal < &xSignalArray[0]) ||
         (Signal >= &xSignalArray[CFG_STATIC_SIGNAL_INSTS]) ) {
      xFree((void **)&Signal);
    } else {
  #endif
      #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
        xThreadLock(&xFreeSignalMutex);
      #else
        XBEGIN_CRITICAL_PATH
      #endif
      Signal->Next = xFreeSignalList;
      xFreeSignalList = Signal;
      #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
        xThreadUnlock(&xFreeSignalMutex);
      #else
        XEND_CRITICAL_PATH
      #endif
  #ifndef USER_CFG_NOUSE_DYNAMIC_SIGNALS
    }
  #endif
}



void xOutputSimple(xSignalId Sid  XOUTPUT_PRIO(xuint8 Prio),
                   SDL_Pid Receiver  XSYSDPARA)
{
  xSignal *Signal;
  #ifdef USER_CFG_ERR_CHECK_BASIC
    XCONST_INST xPartTable *PartData;
  #endif

  xTraceOutput2(Receiver);
  #ifdef USER_CFG_ERR_CHECK_BASIC
    /* Check that receiver is not NULL */
    if (Receiver == SDL_NULL) {
      ErrorHandler(ERR_RECEIVER_IS_NULL);
      return;
    }
  #endif
  Signal = xGetSignal(Sid  XOUTPUT_SPARAM(0)  XOUTPUT_REUSE(&XSYSD CurrentSignal));
  if (Signal == 0) {
    return;
  }

  #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
    Signal->Prio = Prio;
  #endif
  Signal->Receiver = Receiver;
  Signal->Sender = XSYSD CurrentPid;

  /* Send to environment ? */
  if (Receiver == ENV) {
    #ifdef USER_CFG_USE_xOutEnv
      xOutEnv(Signal);
    #elif defined(USER_CFG_ERR_CHECK_BASIC)
      ErrorHandler(ERR_N_xOutEnv);
    #endif
    xReturnSignal(Signal);
    return;
  }

  #ifdef USER_CFG_ERR_CHECK_BASIC
    /* Check that receiver is running */
    PartData = xPartData[XPART(Receiver)];
    if (INSTANCE_VAR(XINST(Receiver))->State == XDORMANT) {
      ErrorHandler(ERR_RECEIVER_IS_NOT_RUNNING);
      return;
    }
  #endif

  xInsertSignal(Signal);
}



#ifdef CFG_USED_SIGNAL_WITH_PARAMS
void xOutput (xSignal *Signal  XOUTPUT_PRIO(xuint8 Prio),
              SDL_Pid Receiver  XSYSDPARA)
{
  #ifdef USER_CFG_ERR_CHECK_BASIC
    XCONST_INST xPartTable *PartData;
  #endif

  xTraceOutput2(Receiver);
  #ifdef USER_CFG_ERR_CHECK_BASIC
    /* Check that receiver is not NULL */
    if (Receiver == SDL_NULL) {
      ErrorHandler(ERR_RECEIVER_IS_NULL);
      xReturnSignal(Signal);
      return;
    }
  #endif

  #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
    Signal->Prio = Prio;
  #endif
  Signal->Receiver = Receiver;
  Signal->Sender = XSYSD CurrentPid;

  /* Send to environment ? */
  if (Receiver == ENV) {
    #ifdef USER_CFG_USE_xOutEnv
      xOutEnv(Signal);
    #elif defined(USER_CFG_ERR_CHECK_BASIC)
      ErrorHandler(ERR_N_xOutEnv);
    #endif
    xReturnSignal(Signal);
    return;
  }

  #ifdef USER_CFG_ERR_CHECK_BASIC
    /* Check that receiver is running */
    PartData = xPartData[XPART(Receiver)];
    if (INSTANCE_VAR(XINST(Receiver))->State == XDORMANT) {
      ErrorHandler(ERR_RECEIVER_IS_NOT_RUNNING);
      xReturnSignal(Signal);
      return;
    }
  #endif

  xInsertSignal(Signal);
}
#endif /* CFG_USED_SIGNAL_WITH_PARAMS */



void xENVOutput (xSignal *Signal  XOUTPUT_PRIO(xuint8 Prio),
                 SDL_Pid Receiver)
{
  #ifdef USER_CFG_ERR_CHECK_BASIC
    XCONST_INST xPartTable *PartData;
  #endif

  #ifdef USER_CFG_ERR_CHECK_BASIC
    /* Check that receiver is not NULL */
    if (Receiver == SDL_NULL) {
      ErrorHandler(ERR_RECEIVER_IS_NULL);
      xReturnSignal(Signal);
      return;
    }
  #endif

  #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
    Signal->Prio = Prio;
  #endif
  Signal->Receiver = Receiver;
  Signal->Sender = ENV;

  #ifdef USER_CFG_ERR_CHECK_BASIC
    /* Check that receiver is running */
    PartData = xPartData[XPART(Receiver)];
    if (INSTANCE_VAR(XINST(Receiver))->State == XDORMANT) {
      ErrorHandler(ERR_RECEIVER_IS_NOT_RUNNING);
      xReturnSignal(Signal);
      return;
    }
  #endif

  xInsertSignal(Signal);
}



#if (CFG_MAX_INSTANCES > 1)
SDL_Pid xFindReceiver (xPartId PartId)
{
  xInstanceId InstId;
  XCONST_INST xPartTable *PartData;
  PartData = xPartData[PartId];
  for (InstId=0; InstId < PartData->MaxInstances; InstId++) {
    if (INSTANCE_VAR(InstId)->State != XDORMANT) {
      return XPID(PartId, InstId);
    }
  }
  return SDL_NULL;
}
#endif


/****+***************************************************************
     Timer functions
********************************************************************/

#ifdef CFG_USED_TIMER
void xTimerSet (SDL_Time Time,
                xSignalId Sid
                TIMER_CPARA(SDL_Integer TimerParValue)
                XSYSDPARA)
{
  xTimer *Timer;
  xTimer **tmp;

  #ifdef USER_CFG_TIMER_SCALE
    Time = (Time-xNow())*USER_CFG_TIMER_SCALE + xNow();
  #endif
  xTimerReset(Sid TIMER_CPARA(TimerParValue) XSYSDP);
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadLock(&xFreeTimerMutex);
  #endif
  Timer = xFreeTimerList;
  if (Timer != 0) {
    xFreeTimerList = xFreeTimerList->Next;
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
      xThreadUnlock(&xFreeTimerMutex);
    #endif
  } else {
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
      xThreadUnlock(&xFreeTimerMutex);
    #endif
    #ifdef USER_CFG_NOUSE_DYNAMIC_TIMERS
      #ifdef USER_CFG_ERR_CHECK_BASIC
        ErrorHandler(ERR_N_NO_FREE_TIMER);
      #endif
      return;
    #else
      Timer = (xTimer *)xAlloc(sizeof(xTimer));
      if (Timer == 0) {
        #ifdef USER_CFG_ERR_CHECK_BASIC
          ErrorHandler(ERR_N_NO_FREE_TIMER);
        #endif
        return;
      }
    #endif
  }

  Timer->Time = Time;
  Timer->Sid = Sid;
  Timer->Owner = XSYSD CurrentPid;
  #ifdef CFG_USED_TIMER_WITH_PARAMS
    Timer->TimerParValue = TimerParValue;   
  #endif

    /* Insert timer in time order */
  for (tmp = &XSYSD TimerQueue;
       (*tmp != 0) && (xLT_SDL_Time((*tmp)->Time, Time));
       tmp = &((*tmp)->Next)) {
    ; /* Empty statement */
  }
  Timer->Next = *tmp;
  *tmp = Timer;
}



void xTimerReset (xSignalId Sid
                  TIMER_CPARA(SDL_Integer TimerParValue)
                  XSYSDPARA)
{
  xTimer *timer;
  xTimer **t;
  xSignal **tmp;
  xSignal *f;

  for (t = &XSYSD TimerQueue; *t != 0; t = &((*t)->Next)) {
    #ifdef CFG_USED_TIMER_WITH_PARAMS
      if ( ((*t)->Sid == Sid) &&
           ((*t)->Owner == XSYSD CurrentPid) &&
           ((*t)->TimerParValue == TimerParValue) ) {
        break;
      }
    #else
      if ( ((*t)->Sid == Sid) &&
           ((*t)->Owner == XSYSD CurrentPid) ) {
        break;
      }
    #endif
  }

  if (*t != 0) {
    /* search timer queue */
    timer = *t;
    *t    = (*t)->Next;
    #ifndef USER_CFG_NOUSE_DYNAMIC_TIMERS
      /* Deallocate memory for the timer, if it was allocated dynamically */
      if ( (timer < &xTimerArray[0]) ||
           (timer >= &xTimerArray[CFG_STATIC_TIMER_INSTS]) ) {
        xFree((void **)&timer);
      } else {
    #endif
        /* Put timer back into free list */
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          xThreadLock(&xFreeTimerMutex);
        #endif
        timer->Next = xFreeTimerList;
        xFreeTimerList = timer;
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          xThreadUnlock(&xFreeTimerMutex);
        #endif
    #ifndef USER_CFG_NOUSE_DYNAMIC_TIMERS
      }
    #endif
  } else {
    /* timer not found, search signal queue */
    tmp = &XSYSD SignalQueue;
    while (*tmp != 0) {
      if ( (*tmp != XSYSD CurrentSignal) &&
           ((*tmp)->Sid == Sid) &&
           ((*tmp)->Receiver == XSYSD CurrentPid) ) {
        #ifdef CFG_USED_TIMER_WITH_PARAMS
          if (*(SDL_Integer *)(*tmp)->ParPtr == TimerParValue) {
        #endif
            f = *tmp;
            *tmp = (*tmp)->Next;
            xReturnSignal(f);
            return;
        #ifdef CFG_USED_TIMER_WITH_PARAMS
          }
        #endif
      } else {
        tmp = &((*tmp)->Next);
      }
    }
  }
}



xbool xTimerActive (xSignalId Sid
                    TIMER_CPARA(SDL_Integer TimerParValue)
                    XSYSDPARA)
{
  xTimer *t;
  xSignal **tmp;

  for (t = XSYSD TimerQueue; t != 0; t = t->Next) {
    #ifdef CFG_USED_TIMER_WITH_PARAMS
      if ( (t->Sid == Sid) &&
           (t->Owner == XSYSD CurrentPid) &&
           (t->TimerParValue == TimerParValue) ) {
        return xTrue;
      }
    #else
      if ( (t->Sid == Sid) &&
           (t->Owner == XSYSD CurrentPid) ) {
        return xTrue;
      }
    #endif
  }

  /* if timer is not in the active list search the signal queue */
  tmp = &XSYSD SignalQueue;
  while (*tmp != 0) {
    if ( (*tmp != XSYSD CurrentSignal) &&
         ((*tmp)->Sid == Sid) &&
         ((*tmp)->Receiver == XSYSD CurrentPid) ) {
      #ifdef CFG_USED_TIMER_WITH_PARAMS
        if (*(SDL_Integer *)(*tmp)->ParPtr == TimerParValue) {
      #endif
          return xTrue;
      #ifdef CFG_USED_TIMER_WITH_PARAMS
        }
      #endif
    } else {
      tmp = &((*tmp)->Next);
    }
  }
  return xFalse;
}



void xCheckTimer(XSYSDPARA1)
{
  SDL_Time Time;
  xTimer **t;
  xTimer  *timer;
  xSignal *Signal;

  Time = xNow();
  t = &XSYSD TimerQueue;
  while (*t != 0) {
    if (xGT_SDL_Time((*t)->Time, Time)) {
      break;
    }

    /* Timer expired. Unchain from active list */
    timer = *t;
    *t = (*t)->Next;

    /* Send the timersignal */
    #ifdef CFG_USED_TIMER_WITH_PARAMS
      Signal = xGetSignal(timer->Sid  XOUTPUT_SPARAM(sizeof(SDL_Integer))
                          XOUTPUT_REUSE(0));
    #else
      Signal = xGetSignal(timer->Sid  XOUTPUT_SPARAM(0)  XOUTPUT_REUSE(0));
    #endif
    if (Signal == 0) {
      return;
    }
    #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
      Signal->Prio = CFG_TIMER_PRIO;
    #endif
    Signal->Receiver = timer->Owner;
    Signal->Sender = timer->Owner;
    #ifdef CFG_USED_TIMER_WITH_PARAMS
      *(SDL_Integer *)Signal->ParPtr = timer->TimerParValue;
    #endif
    xInsertSignal(Signal);

    #ifndef USER_CFG_NOUSE_DYNAMIC_TIMERS
      /* Deallocate memory for the expired timer,
         if it was allocated dynamically */
      if ( (timer < &xTimerArray[0]) ||
           (timer >= &xTimerArray[CFG_STATIC_TIMER_INSTS]) ) {
        xFree((void **)&timer);
      } else {
    #endif
        /* Put timer back into free list */
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          xThreadLock(&xFreeTimerMutex);
        #endif
        timer->Next = xFreeTimerList;
        xFreeTimerList = timer;
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          xThreadUnlock(&xFreeTimerMutex);
        #endif
    #ifndef USER_CFG_NOUSE_DYNAMIC_TIMERS
      }
    #endif
  }
}
#endif /* CFG_USED_TIMER */


/****+***************************************************************
     Create, Stop and RPC functions
********************************************************************/

#ifdef CFG_USED_CREATE
xInstanceId xCreate (xPartId PartId, xSignal *Signal  XSYSDPARA)
{
  xInstanceId InstId;
  XCONST_INST xPartTable *PartData;

  if (Signal == 0) {
    xTraceCreate2(SDL_NULL);
    #ifdef USER_CFG_ERR_CHECK_BASIC
      ErrorHandler(ERR_N_CREATE_NO_MEM);
    #endif
    /* Setting Offspring in the creating Process */
    #ifdef CFG_USED_OFFSPRING
      XSYSD CurrentData->Offspring = SDL_NULL;
    #endif
    return XINST(SDL_NULL);
  }

  PartData = xPartData[PartId];
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadLock(&xCreateMutex);
  #endif
  for (InstId = 0; InstId < PartData->MaxInstances; InstId++) {
    if (INSTANCE_VAR(InstId)->State == XDORMANT) {
      INSTANCE_VAR(InstId)->State = XCREATION;
      break;
    }
  }
  #ifdef CFG_USED_UNLIMITED_INSTANCES
    if ((InstId >= PartData->MaxInstances) && (PartData->DynamicInst)) {
      /* realloc the data area for instances */
      void *tmp;
      tmp = (void *)PartData->InstanceData;
      PartData->InstanceData =
        (xInstanceData *)xAlloc(PartData->DataLength*PartData->MaxInstances*2);
      memcpy((void *)PartData->InstanceData, tmp,
             PartData->DataLength*PartData->MaxInstances);
      for (InstId = PartData->MaxInstances+1;
           InstId < PartData->MaxInstances*2;
           InstId++) {
        INSTANCE_VAR(InstId)->State = XDORMANT;
      }
      InstId = PartData->MaxInstances;
      INSTANCE_VAR(InstId)->State = XCREATION;
      PartData->MaxInstances = PartData->MaxInstances*2;
    }
  #endif
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadUnlock(&xCreateMutex);
  #endif

  if (InstId >= PartData->MaxInstances) {
    xTraceCreate2(SDL_NULL);
    #ifdef USER_CFG_ERR_CHECK_BASIC
      ErrorHandler(ERR_N_CREATE_INSTANCE);
    #endif
    xReturnSignal(Signal);
    /* Setting Offspring in the creating Process */
    #ifdef CFG_USED_OFFSPRING
      XSYSD CurrentData->Offspring = SDL_NULL;
    #endif
    return XINST(SDL_NULL);
  }
  Signal->Receiver = XPID(PartId,InstId);
  xTraceCreate2(Signal->Receiver);
  #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
    Signal->Prio = CFG_CREATE_PRIO;
  #endif
  Signal->Sender = XSYSD CurrentPid;

  #ifdef CFG_USED_OFFSPRING
    XSYSD CurrentData->Offspring = XPID(PartId,InstId);
    INSTANCE_VAR(InstId)->Offspring = SDL_NULL;
  #endif
  #ifdef CFG_USED_PARENT
    INSTANCE_VAR(InstId)->Parent = XSYSD CurrentPid;
  #endif
  #ifdef CFG_USED_RPC
    INSTANCE_VAR(InstId)->ExpectedRPCReply = 0;
  #endif
  PartData->yIni_Function((void *)(INSTANCE_VAR(InstId)));

  #ifdef CFG_USED_DYNAMIC_THREADS
    if (PartData->ThreadNumber >= CFG_NUMBER_THREADS) {
      INSTANCE_VAR(InstId)->xSysDInst = (xSystemData *)xAlloc(sizeof(xSystemData));
      xThreadInitOneThread(INSTANCE_VAR(InstId)->xSysDInst);
      xThreadStartThread(INSTANCE_VAR(InstId)->xSysDInst,
                         ThreadData[PartData->ThreadNumber].StackSize,
                         ThreadData[PartData->ThreadNumber].Prio,
                         ThreadData[PartData->ThreadNumber].User1,
                         ThreadData[PartData->ThreadNumber].User2);

    }
  #endif

  xInsertSignal(Signal);
  return InstId;
}
#endif /* CFG_USED_CREATE */



#ifdef CFG_USED_STOP
void xStop (XSYSDPARA1)
{
  #ifdef CFG_USED_TIMER
    xTimer *timer;
    xTimer **t;
  #endif
  xSignal **tmp;
  xSignal *f;

  #ifdef CFG_USED_TIMER
    /* reset all timers for this process */
    t = &XSYSD TimerQueue;
    while (*t != 0) {
      if ((*t)->Owner == XSYSD CurrentPid) {
        timer = *t;
        *t    = (*t)->Next;
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          xThreadLock(&xFreeTimerMutex);
        #endif
        timer->Next = xFreeTimerList;
        xFreeTimerList = timer;
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          xThreadUnlock(&xFreeTimerMutex);
        #endif
      } else {
        t = &((*t)->Next);
      }
    }
  #endif /* CFG_USED_TIMER */
  /* remove all signals to this process */
  tmp = &XSYSD SignalQueue;
  while (*tmp != 0) {
    if ( (*tmp != XSYSD CurrentSignal) &&
         ((*tmp)->Receiver == XSYSD CurrentPid) ) {
      f = *tmp;
      *tmp = (*tmp)->Next;
      #if (defined(CFG_USED_SIGNAL_WITH_DYN_PARAMS)) && (!defined(USER_CFG_SIGNALS_NEVER_DISCARDED))
        xFreeSignalPara(f);
      #endif
      xReturnSignal(f);
    } else {
      tmp = &((*tmp)->Next);
    }
  }


  #ifdef CFG_USED_DYNAMIC_THREADS
  {
    XCONST_INST xPartTable *PartData;
    PartData = xPartData[XPART(xSysDP->CurrentPid)];
    if (PartData->ThreadNumber >= CFG_NUMBER_THREADS) {
      xThreadStopThread(xSysDP);
    }
  }
  #endif
}
#endif /* CFG_USED_STOP */


#ifdef CFG_USED_RPC
xStateId xRPCWaitState(xSignalId ExpectedRPCReply,
                       xActionId RPCReplyAction
                       XSYSDPARA)
{
  XCONST_INST xPartTable *PartData;
  PartData = xPartData[XPART(XSYSD CurrentPid)];
  INSTANCE_VAR(XINST(XSYSD CurrentPid))->ExpectedRPCReply = ExpectedRPCReply;
  INSTANCE_VAR(XINST(XSYSD CurrentPid))->RPCReplyAction = RPCReplyAction;
  return XDASHSTATE;
}
#endif /* CFG_USED_RPC */


/****+***************************************************************
     State-signal functions
********************************************************************/

xActionId xCheckSignal (
    xSignalId Sid, 
    xStateId StateId,
    XCONST_INST xPartTable *PartData)
{
  XCONST xStateIndexTable *StateIndexTable;
  XCONST xTransitionTable *TransitionTable;
  xStateIndexTable IndexToFirstEvent;
  xStateIndexTable IndexToLastEvent;
  #ifdef CFG_USED_STATE_STAR
    xStateIndexTable IndexToLastStarEvent;
  #endif

  #if defined(CFG_USED_DYNAMIC_THREADS)
    if (Sid == XCREATEID) {
      return 0;
    }
  #endif

  if (StateId == XDORMANT) {
    return XDISCARD;
  }
  StateIndexTable = PartData->StateIndexTable;
  TransitionTable = PartData->TransitionTable;

  /* Try first this state and explicitly mentioned signals */
  IndexToLastEvent = StateIndexTable[StateId] - 1;
  /* Ignore that TransitionTable[IndexToLastEvent].SignalID might be XASTERISK */
  for (IndexToFirstEvent = StateIndexTable[StateId-1];
       IndexToFirstEvent <= IndexToLastEvent;
       IndexToFirstEvent++) {
    if (Sid == TransitionTable[IndexToFirstEvent].SignalID) {
      return TransitionTable[IndexToFirstEvent].SymbolNr;
    }
  }

  #ifdef CFG_USED_STATE_STAR
    /* Check state *  */
    if (StateIndexTable[0]) {
      IndexToLastStarEvent = StateIndexTable[0] - 1;
      for (IndexToFirstEvent = 0;
           IndexToFirstEvent <= IndexToLastStarEvent;
           IndexToFirstEvent++) {
        if (Sid == TransitionTable[IndexToFirstEvent].SignalID) {
          return TransitionTable[IndexToFirstEvent].SymbolNr;
        }
      }
      #ifdef CFG_USED_INPUT_SAVE_STAR
        /* if input * or save * in the state * */
        if (TransitionTable[IndexToLastStarEvent].SignalID == XASTERISK) {
          return TransitionTable[IndexToLastStarEvent].SymbolNr;
        }
      #endif /* CFG_USED_INPUT_SAVE_STAR */
    }
  #endif /* CFG_USED_STATE_STAR */

  #ifdef CFG_USED_INPUT_SAVE_STAR
    /* Check input * or save * in current state */
    if (IndexToLastEvent >= StateIndexTable[StateId-1]) {
      if (TransitionTable[IndexToLastEvent].SignalID == XASTERISK) {
        return TransitionTable[IndexToLastEvent].SymbolNr;
      }
    }
  #endif
  /* Signal cannot be treated. Return implicit consumption. */
  return XDISCARD;
}


/****+***************************************************************
     Function used to find and access public attributes
********************************************************************/
void * xGetAttr(xRemoteVarDef *Attr, SDL_Pid P)
{
  xPartId PartId;
  XCONST_INST xPartTable *PartData;
  int pos;
  if (P == SDL_NULL) {
    ErrorHandler(ERR_ACCESS_ATTR_FROM_NULL);
    return 0;
  }
  PartId = XPART(P);
  for (pos=0; Attr[pos].Part != XPART(SDL_NULL); pos++) {
    if (Attr[pos].Part == PartId) {
      PartData = xPartData[PartId];
      return (void *)((xptrint)(INSTANCE_VAR(XINST(P))) + Attr[pos].Offset);
    }
  }
  ErrorHandler(ERR_ACCESS_ATTR_FROM_STOPPED);
  return 0;
}


void * xGetAttr2(xRemoteVarDef *Attr)
{
  XCONST_INST xPartTable *PartData;
  xInstanceId InstId;
  int pos;

  for (pos=0; Attr[pos].Part != XPART(SDL_NULL); pos++) {
    PartData = xPartData[Attr[pos].Part];
    for (InstId = 0; InstId < PartData->MaxInstances; InstId++) {
      if (INSTANCE_VAR(InstId)->State != XDORMANT) {
        return (void *)((xptrint)(INSTANCE_VAR(InstId)) + Attr[pos].Offset);
      }
    }
  }
  ErrorHandler(ERR_ACCESS_ATTR_NOT_FOUND);
  return 0;
}


/****+***************************************************************
     Main loop
********************************************************************/

#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  void xMainLoop (xSystemData *xSysDP)
#else
  void xMainLoop (void)
#endif
{
  XCONST_INST xPartTable *PartData;
  xPartId PartId;
  xStateId StateId;
  #if (CFG_MAX_INSTANCES > 1)
    xInstanceId InstId;
  #endif
  #ifdef CFG_USED_SAVE
    int savedsignal;
  #endif
  #if (defined(USER_CFG_USE_SYSTEM_STOP)) && (CFG_NUMBER_THREADS == 0) && (!defined(CFG_USED_DYNAMIC_THREADS)) && (defined(CFG_USED_SAVE))
    int Alive;
  #endif

  /* Execute start transitions */
  XSYSD CurrentSender = SDL_NULL;
  for (PartId=0; PartId<CFG_NUMBER_PARTS; PartId++) {
    PartData = xPartData[PartId];
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    if (xSysDP == (xSystemData *)(xSysD+PartData->ThreadNumber)) {
    #endif
      #if (CFG_MAX_INSTANCES > 1)
      for (InstId=0;
           (InstId < PartData->MaxInstances) &&
             (INSTANCE_VAR(InstId)->State == XSTARTUP);
           InstId++) {
      #else
      if (INSTANCE_VAR(InstId)->State == XSTARTUP) {
      #endif
        if (XSYSD CurrentSignal == 0) {
          XSYSD CurrentSignal = xGetSignal(XCREATEID  XOUTPUT_SPARAM(0)
                                           XOUTPUT_REUSE(0));
          XSYSD CurrentSignal->Sender = SDL_NULL;
        }
        XSYSD CurrentPid = XPID(PartId,InstId);
        XSYSD CurrentData = INSTANCE_VAR(InstId);
        INSTANCE_VAR(InstId)->State = PartData->yPAD_Function(XSYSDP1);
      }
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    }
    #endif
  }
  if (XSYSD CurrentSignal != 0) {
    xReturnSignal(XSYSD CurrentSignal);
  }

  /* Execute transitions */
  while (1) {
    #if (CFG_NUMBER_THREADS == 0) && (!defined(CFG_USED_DYNAMIC_THREADS))
      /* Read in signals from the environment. Not used in a threaded
         application, where xInEnv is executed in its own thread. */
      #ifdef USER_CFG_USE_xInEnv
        xInEnv();
      #endif
    #endif

    /* Check for signals in ExternSignalQueue */
    if (XSYSD ExternSignalQueue != 0) {
      xSignal *Signal;
      xSignal **tmp;
      #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
        xThreadLock(&xSysDP->ThreadVars.SignalQueueMutex);
      #else
        XBEGIN_CRITICAL_PATH
      #endif
      while (XSYSD ExternSignalQueue != 0) {
        Signal = XSYSD ExternSignalQueue;
        XSYSD ExternSignalQueue = Signal->Next;
        #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
          for (tmp = &XSYSD SignalQueue; *tmp != 0; tmp = &((*tmp)->Next)) {
            if (Signal->Prio < (*tmp)->Prio) {
              break;
            }
          }
        #else
          for (tmp = &XSYSD SignalQueue; *tmp != 0; tmp = &((*tmp)->Next)) {
            ; /* empty statement */
          }
        #endif
        /* Insert signal into queue */
        Signal->Next = *tmp;
        *tmp = Signal;
      }
      #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
        xThreadUnlock(&xSysDP->ThreadVars.SignalQueueMutex);
      #else
        XEND_CRITICAL_PATH
      #endif
    }

    /* Check if any timer is expired */
    #ifdef CFG_USED_TIMER
      xCheckTimer(XSYSDP1);
    #endif

    /* Process the signal */
    XSYSD CurrentSignal = XSYSD SignalQueue;
    #ifdef CFG_USED_SAVE
    do {
      savedsignal = 0;
    #endif
      if (XSYSD CurrentSignal != 0) {
        XSYSD CurrentPid = XSYSD CurrentSignal->Receiver;
        PartData = xPartData[XPART(XSYSD CurrentPid)];
        StateId = INSTANCE_VAR(XINST(XSYSD CurrentPid))->State;
        #ifdef CFG_USED_CREATE
          /* Handle start transition of dynamicly created processes */
          if (XSYSD CurrentSignal->Sid == XCREATEID) {
            XSYSD CurrentSymbolNr = XCREATE;
          } else {
        #endif
          #ifdef CFG_USED_SAVE
            if (XSYSD CurrentSignal->SaveState == StateId) {
              XSYSD CurrentSymbolNr = XSAVE;
            } else {
              XSYSD CurrentSignal->SaveState = StateId;
          #endif
              #ifdef CFG_USED_RPC
              if (INSTANCE_VAR(XINST(XSYSD CurrentPid))->ExpectedRPCReply != 0) {
                if (XSYSD CurrentSignal->Sid !=
                    INSTANCE_VAR(XINST(XSYSD CurrentPid))->ExpectedRPCReply) {
                  XSYSD CurrentSymbolNr = XSAVE;
                } else {
                  XSYSD CurrentSymbolNr =
                    INSTANCE_VAR(XINST(XSYSD CurrentPid))->RPCReplyAction;
                  INSTANCE_VAR(XINST(XSYSD CurrentPid))->ExpectedRPCReply = 0;
                }
              } else {
              #endif
                XSYSD CurrentSymbolNr = xCheckSignal(XSYSD CurrentSignal->Sid,
                                                   StateId, PartData);
              #ifdef CFG_USED_RPC
              }
              #endif
              #ifdef CFG_USED_GUARD
                if (XIS_GUARD(XSYSD CurrentSymbolNr)) {
                  XSYSD CurrentData = INSTANCE_VAR(XINST(XSYSD CurrentPid));
                  XSYSD CurrentSignal->SaveState = 0; /*always recalculate if guard*/
                  if (! PartData->GuardFunc(XSYSDP1)) {
                    XSYSD CurrentSymbolNr = XSAVE;
                  } else {
                    XSYSD CurrentSymbolNr = XGET_STMT(XSYSD CurrentSymbolNr);
                  }
                }
              #endif
          #ifdef CFG_USED_SAVE
            }
          #endif
        #ifdef CFG_USED_CREATE
          }
        #endif

        /* Perform action */
        if (XSYSD CurrentSymbolNr < XDISCARD) {
          XSYSD CurrentData = INSTANCE_VAR(XINST(XSYSD CurrentPid));
          XSYSD CurrentSender = XSYSD CurrentSignal->Sender;
          xRemoveSignal(XSYSD CurrentSignal);
          StateId = PartData->yPAD_Function(XSYSDP1);
          if (XSYSD CurrentSignal != 0) {
            xReturnSignal(XSYSD CurrentSignal);
          }
          if (StateId != XDASHSTATE) {
            INSTANCE_VAR(XINST(XSYSD CurrentPid))->State = StateId;
          }
        #ifdef CFG_USED_SAVE
        } else if (XSYSD CurrentSymbolNr == XSAVE) {
          XSYSD CurrentSignal = XSYSD CurrentSignal->Next;
          savedsignal = 1;
        #endif
        } else {
          #ifdef XTRACE
            xTraceDiscard(XSYSD CurrentSignal, XSYSD CurrentPid, StateId);
          #endif
          #if (defined(CFG_USED_SIGNAL_WITH_DYN_PARAMS)) && (!defined(USER_CFG_SIGNALS_NEVER_DISCARDED))
            xFreeSignalPara(XSYSD CurrentSignal);
          #endif
          xRemoveSignal(XSYSD CurrentSignal);
          xReturnSignal(XSYSD CurrentSignal);
          #ifdef USER_CFG_ERR_CHECK_BASIC
            ErrorHandler(ERR_SIGNAL_DISCARD);
          #endif
        }
      } else {
        /* SignalQ empty or only save signals in the SignalQ. */
        #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
          if (XSYSD ExternSignalQueue == 0) {
            xThreadLock(&xSysDP->ThreadVars.SignalQueueMutex);
            if (XSYSD ExternSignalQueue != 0) {                      /*???*/
              xThreadUnlock(&xSysDP->ThreadVars.SignalQueueMutex);
            } else {
              xThreadWaitUnlock(xSysDP);
            }
          }
        #endif
      }
    #ifdef CFG_USED_SAVE
    } while (savedsignal);
    #endif
    
    #if (defined(USER_CFG_USE_SYSTEM_STOP)) && (CFG_NUMBER_THREADS == 0) && (!defined(CFG_USED_DYNAMIC_THREADS))
      /* Stop execution if no signals or timers are present.
         Should NOT be used if there is a environment that can send signals.
         The code is indented for testing purposes.
         Does not work in multithreaded solution */
      #ifdef CFG_USED_TIMER
      if (XSYSD TimerQueue == 0) {
      #endif
      #ifdef CFG_USED_SAVE
        XSYSD CurrentSignal = XSYSD SignalQueue;
        Alive = 0;
        while ((XSYSD CurrentSignal != 0) && (!Alive)) {
          XSYSD CurrentPid = XSYSD CurrentSignal->Receiver;
          PartData = xPartData[XPART(XSYSD CurrentPid)];
          StateId = INSTANCE_VAR(XINST(XSYSD CurrentPid))->State;
          if (XSYSD CurrentSignal->SaveState != StateId) {
            Alive = 1;
          }
          XSYSD CurrentSignal = XSYSD CurrentSignal->Next;
        }
        if (!Alive) {
          return;
        }
      #else
        if (XSYSD SignalQueue == 0) {
          return;
        }
      #endif
      #ifdef CFG_USED_TIMER
      }
      #endif
    #endif
  } /* end while(1) */
  return;
}


/****+***************************************************************
     Initialization
********************************************************************/

void xInit (void)
{
  int i;
  XCONST_INST xPartTable *PartData;
  #if (CFG_MAX_INSTANCES > 1)
    xInstanceId InstId;
  #endif
  xInstanceData *CurrentData;
  xPartId PartId;

  #ifdef USER_CFG_USE_MEMORY_PACK
    xMemInit();
  #endif

  /* Init signal free list */
  (void)memset((void *)xSignalArray, 0, sizeof(xSignalArray));
  xFreeSignalList = &xSignalArray[0];
  for (i = 1; i < CFG_STATIC_SIGNAL_INSTS; i++) {
    xSignalArray[i-1].Next = &xSignalArray[i];
  }
  xSignalArray[CFG_STATIC_SIGNAL_INSTS-1].Next = 0;

  xInitSystime();
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadInit();
  #endif

  /* Init timer free list */
  #ifdef CFG_USED_TIMER
    xFreeTimerList = &xTimerArray[0];
    for (i=1; i<CFG_STATIC_TIMER_INSTS; i++) {
      xTimerArray[i-1].Next = &xTimerArray[i];
    }
    xTimerArray[CFG_STATIC_TIMER_INSTS-1].Next = 0;
  #endif

  #ifdef CFG_USED_INITFUNC
    yInit();  /* in generated code */
  #endif

  /* Init state for instances to be started at startup */
  for (PartId=0; PartId<CFG_NUMBER_PARTS; PartId++) {
    PartData = xPartData[PartId];
    #if (CFG_MAX_INSTANCES > 1)
      #ifdef CFG_USED_UNLIMITED_INSTANCES
        if (PartData->DynamicInst) {
          PartData->MaxInstances =
            PartData->InitialInstances+CFG_USE_NUMBER_FREE_INST;
          PartData->InstanceData = 
            (xInstanceData *)xAlloc(PartData->DataLength*PartData->MaxInstances);
        }
      #endif
      for (InstId=0; InstId < PartData->MaxInstances; InstId++) {
        CurrentData = INSTANCE_VAR(InstId);
        if (InstId < PartData->InitialInstances) {
          CurrentData->State = XSTARTUP;
          #ifdef CFG_USED_PARENT
            CurrentData->Parent = SDL_NULL;
          #endif
          #ifdef CFG_USED_OFFSPRING
            CurrentData->Offspring = SDL_NULL;
          #endif
          #ifdef CFG_USED_RPC
            CurrentData->ExpectedRPCReply = 0;
          #endif
          PartData->yIni_Function((void *)(CurrentData));
        } else {
          CurrentData->State = XDORMANT;
        }
      }
    #else
      CurrentData = INSTANCE_VAR(InstId);
      if (PartData->InitialInstances > 0) {
        CurrentData->State = XSTARTUP;
        #ifdef CFG_USED_PARENT
          CurrentData->Parent = SDL_NULL;
        #endif
        #ifdef CFG_USED_OFFSPRING
          CurrentData->Offspring = SDL_NULL;
        #endif
        #ifdef CFG_USED_RPC
          CurrentData->ExpectedRPCReply = 0;
        #endif
        PartData->yIni_Function((void *)(CurrentData));
      } else {
        CurrentData->State = XDORMANT;
      }
    #endif /* CFG_MAX_INSTANCES > 1 */
  }

  /* Initilize the complete xSysD to 0. Important for SignalQueue,
     TimerQueue, CurrentSymbolNr, ExternSignalQueue */
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    (void)memset((void *)&xSysD[0], 0, CFG_NUMBER_THREADS*sizeof(xSystemData));
  #else
    (void)memset((void *)&xSysD, 0, sizeof(xSystemData));
  #endif

  #ifdef USER_CFG_USE_xInitEnv
    xInitEnv();
  #endif
}


/****+***************************************************************
     main
********************************************************************/

#ifndef XMAIN_NAME
int main(void)
#else
int XMAIN_NAME(void)
#endif
{
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    int xTIndex;
  #endif
  #ifdef CFG_USED_DYNAMIC_THREADS
    XCONST_INST xPartTable *PartData;
    xInstanceId InstId;
    xPartId PartId;
    xSignal *Signal;
  #endif


  XBEGIN_CRITICAL_PATH
  xInit();
  XEND_CRITICAL_PATH

  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    for (xTIndex=0; xTIndex<CFG_NUMBER_THREADS; xTIndex++) {
      xThreadInitOneThread(&xSysD[xTIndex]);
      xThreadStartThread(&xSysD[xTIndex],
                         ThreadData[xTIndex].StackSize,
                         ThreadData[xTIndex].Prio,
                         ThreadData[xTIndex].User1,
                         ThreadData[xTIndex].User2);
    }

    #ifdef CFG_USED_DYNAMIC_THREADS
      for (PartId=0; PartId<CFG_NUMBER_PARTS; PartId++) {
        PartData = xPartData[PartId];
        if (PartData->ThreadNumber >= CFG_NUMBER_THREADS) {
          for (InstId=0; InstId < PartData->InitialInstances; InstId++) {
            INSTANCE_VAR(InstId)->xSysDInst = (xSystemData *)
              xAlloc(sizeof(xSystemData));
            xThreadInitOneThread(INSTANCE_VAR(InstId)->xSysDInst);
            xThreadStartThread(INSTANCE_VAR(InstId)->xSysDInst,
                               ThreadData[PartData->ThreadNumber].StackSize,
                               ThreadData[PartData->ThreadNumber].Prio,
                               ThreadData[PartData->ThreadNumber].User1,
                               ThreadData[PartData->ThreadNumber].User2);
            /* StartUp signal */
            Signal = xGetSignal(XCREATEID  XOUTPUT_SPARAM(0)  XOUTPUT_REUSE(0));
            Signal->Sender = SDL_NULL;
            Signal->Next = 0;
            Signal->Receiver = XPID(PartId,InstId);
            #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
              Signal->Prio = CFG_CREATE_PRIO;
            #endif
            /* Before threads are released, SignalQueue can be accessed directly */
            INSTANCE_VAR(InstId)->xSysDInst->SignalQueue = Signal;
          }
        }
      }
    #endif

    xThreadGo();
  #else
    xMainLoop();
  #endif

  #ifdef USER_CFG_USE_xCloseEnv
    xCloseEnv();
  #endif
  return 0;
}



/****+***************************************************************
     Predefined data types
********************************************************************/

#ifndef XSCT_CMICRO
  #define XSCT_CMICRO
  /* To select AgileC version in sctpred.c */
#endif

#include "sctpred.c"


/****+***************************************************************
     Error handling
********************************************************************/

#ifdef CFG_USE_ERR_CHECK

#ifdef XECSOP
void xSDLOpError (char *String1, char *String2)
{
  #ifdef USER_CFG_ERROR_MESS_STDOUT
    (void)printf("ERROR IN ADT:%s\n%s\n", String1, String2);
  #endif
  ErrorHandler(ERR_N_PREDEFINED_OPERATOR_CALL);  
}
#endif /* XECSOP */

#define XIS_FATAL(error)  (ErrorText[(error)][0] == 'E')

/* Error table */
#ifdef USER_CFG_USE_ERR_MESS
XCONST char *ErrorText [] = {
  /*  0 */  "",   /* Not used */
  /*  1 */  "ENo more memory for signal in output",
  /*  2 */  "ENo more memory for create signal",
  /*  3 */  "ENo more memory to allocate the parameters of a signal",
  /*  4 */  "WxOutEnv() is not present and signal is sent to the environment",
  /*  5 */  "WReceiver of signal is NULL, signal discarded",
  /*  6 */  "WReceiver of signal is not running, signal discarded",
  /*  7 */  "WSignal was discarded",
  /*  8 */  "ENo more memory for timer instance",
  /*  9 */  "WCannot create more instances as maximum limit reached",
  /* 10 */  "EAn error occurred in a predefined operator",
  /* 11 */  "ETrying to dereference a null pointer",
  /* 12 */  "EDecision without path for current value (fatal error)",
  /* 13 */  "WA range error in an assignment occured",
  /* 14 */  "EArray index out of range",
  /* 15 */  "EThere is no more memory available in the memory allocator",
  /* 16 */  "ETry to free a memory block that was never allocated",
  /* 17 */  "EAttempt to access public attribute from NULL",
  /* 18 */  "EAttempt to access public attribute from not executing instance",
  /* 19 */  "EAttempt to access public attribute, no provider found"
};
#else
XCONST char *ErrorText [] = {
  /*  0 */  "",
  /*  1 */  "E",
  /*  2 */  "E",
  /*  3 */  "E",
  /*  4 */  "W",
  /*  5 */  "W",
  /*  6 */  "W",
  /*  7 */  "W",
  /*  8 */  "E",
  /*  9 */  "W",
  /* 10 */  "E",
  /* 11 */  "E",
  /* 12 */  "E",
  /* 13 */  "W",
  /* 14 */  "E",
  /* 15 */  "E",
  /* 16 */  "E",
  /* 17 */  "E",
  /* 18 */  "E",
  /* 19 */  "E"
};
#endif

void ErrorHandler (unsigned char ErrorNumber)
{
  #ifdef USER_CFG_USE_ERR_MESS
    if (XIS_FATAL(ErrorNumber)) {
      #ifdef USER_CFG_ERROR_MESS_STDOUT
        (void)printf("ERROR %u %s\n", ErrorNumber, ErrorText[ErrorNumber]+1);
      #endif
      #ifdef USER_CFG_ERROR_MESS_STDERR
        (void)fprintf(STDERR, "\nERROR %u %s\n", ErrorNumber,
                      ErrorText[ErrorNumber]+1);
      #endif
      #ifdef USER_CFG_ERR_ACTION
        xUserErrAction(ErrorNumber);
      #endif
    } else {
      #ifdef USER_CFG_ERROR_MESS_STDOUT
        (void)printf("WARNING %u %s\n", ErrorNumber, ErrorText[ErrorNumber]+1);
      #endif
      #ifdef USER_CFG_ERROR_MESS_STDERR
        (void)fprintf(STDERR, "\nWARNING %u %s\n", ErrorNumber,
                      ErrorText[ErrorNumber]+1);
      #endif
      #ifdef USER_CFG_WARN_ACTION
        xUserWarnAction(ErrorNumber);
      #endif
    }
  #else
    if (XIS_FATAL(ErrorNumber)) {
      #ifdef USER_CFG_ERROR_MESS_STDOUT
        (void)printf("ERROR %u\n", ErrorNumber);
      #endif
      #ifdef USER_CFG_ERROR_MESS_STDERR
        (void)fprintf(STDERR, "\nERROR %u\n", ErrorNumber);
      #endif
      #ifdef USER_CFG_ERR_ACTION
        xUserErrAction(ErrorNumber);
      #endif
    } else {
      #ifdef USER_CFG_ERROR_MESS_STDOUT
        (void)printf("WARNING %u\n", ErrorNumber);
      #endif
      #ifdef USER_CFG_ERROR_MESS_STDERR
        (void)fprintf(STDERR, "\nWARNING %u\n", ErrorNumber);
      #endif
      #ifdef USER_CFG_WARN_ACTION
        xUserWarnAction (ErrorNumber);
      #endif
    }
  #endif /* USER_CFG_USE_ERR_MESS */
}
#endif /* CFG_USE_ERR_CHECK */


/****+***************************************************************
     Tracing
********************************************************************/

#ifdef USER_CFG_UML_TRACE_STDOUT

void xTraceTransition(char *P1  XSYSDPARA)
{
  SDL_Time T;
  #ifdef CFG_USED_TIMER
    T = xNow();
  #else
    T.s = 0; T.ns = 0;
  #endif
  (void)printf("*** PART %s(%u:%u) at %ld.%09ld\n",
               P1,
               (unsigned int)XPART(XSYSD CurrentPid),
               (unsigned int)XINST(XSYSD CurrentPid),
               (long)T.s, (long)T.ns);
}

void xTraceStart(void)
{
  (void)printf("*   START\n");
}

void xTraceTrigger(char *P1  XSYSDPARA)
{
  (void)printf("*   STATE %u, TRIGGER %s(%u), sender (%u:%u)\n",
               (unsigned int)xPartData[XPART(XSYSD CurrentPid)]->
                 InstanceData[XINST(XSYSD CurrentPid)].State,
               P1,
               (unsigned int)XSYSD CurrentSignal->Sid,
               (unsigned int)XPART(XSYSD CurrentSignal->Sender),
               (unsigned int)XINST(XSYSD CurrentSignal->Sender));
}

void xTraceSet(char *P1, xSignalId P2, SDL_Time T)
{
  (void)printf("*   SET %s(%u) at %ld.%09ld\n", P1, (unsigned int)P2,
               (long)T.s, (long)T.ns);
}

void xTraceReset(char *P1, xSignalId P2)
{
  (void)printf("*   RESET %s(%u)\n", P1, (unsigned int)P2);
}

void xTraceDiscard(xSignal *Sig, SDL_Pid Rec, xStateId State)
{
  (void)printf("*   DISCARD %u by process (%u:%u) in state %u, sender (%u:%u)\n",
               (unsigned int)Sig->Sid,
               (unsigned int)XPART(Rec),
               (unsigned int)XINST(Rec),
               (unsigned int)State,
               (unsigned int)XPART(Sig->Sender),
               (unsigned int)XINST(Sig->Sender));
}

void xTraceOutput(char *P1, xSignalId P2)
{
  (void)printf("*   OUTPUT %s(%u)", P1, (unsigned int)P2);
}

void xTraceOutput2(SDL_Pid Receiver)
{
  if (Receiver == ENV) {
    (void)printf(" to env\n");
  } else {
    (void)printf(" to (%u:%u)\n", (unsigned int)XPART(Receiver),
                 (unsigned int)XINST(Receiver));
  }
}

void xTraceCreate(char *P1)
{
  (void)printf("*   CREATE %s", P1);
}

void xTraceCreate2(SDL_Pid Created)
{
  if (Created == SDL_NULL) {
    (void)printf(" (NONE created)\n");
  } else {
    (void)printf(" (%u:%u)\n", (unsigned int)XPART(Created),
                 (unsigned int)XINST(Created));
  }
}

void xTraceTask(char *P1)
{
  (void)printf("*   TASK %s\n", P1);
}

void xTraceAssign(char *P1)
{
  (void)printf("*   ASSIGN %s\n", P1);
}

void xTraceAlg(char *P1)
{
  (void)printf("*   %s\n", P1);
}

void xTraceDecision(char *P1)
{
  (void)printf("*   DECISION: %s\n", P1);
}

void xTraceCall(char *P1)
{
  (void)printf("*   CALL %s\n", P1);
}

void xTraceNextstate(char *P1, xStateId P2)
{
  (void)printf("*** NEXTSTATE %s(%u)\n\n", P1, (unsigned int)P2);
}

void xTraceDashstate(void)
{
  (void)printf("*** NEXTSTATE -\n\n");
}

void xTraceStop(void)
{
  (void)printf("*** STOP\n\n");
}

#endif /* USER_CFG_UML_TRACE_STDOUT */


/****+***************************************************************
     Memory management
********************************************************************/

#if (!defined(USER_CFG_USE_MEMORY_PACK)) && (!defined(USER_CFG_USE_USER_MEMFUNC))

/* Use standard malloc/calloc and free */
void *xAlloc (unsigned int Size)
{
  void * Ptr;

  /* Use memory management from C Compiler or RTOS */
  /* It is assumed that the function malloc, calloc, free are threadsafe */
  #ifdef CFG_NO_CALLOC_AVAILABLE
    Ptr = (void *)malloc((unsigned)Size);
    if (Ptr != 0) {
      (void)memset(Ptr, 0, (int)Size);
    }
  #else
    Ptr = (void *)calloc((unsigned)1, (unsigned)Size);
  #endif
  return Ptr;
}
 
 
void xFree (void **Ptr)
{
  if (*Ptr != 0) {
    free(*Ptr);
    *Ptr = (void *)0;
  }
}

#elif defined(USER_CFG_USE_MEMORY_PACK)

/* Use the bist fit algorithm below for memory allocation */
#ifndef USER_CFG_MEMORY_SIZE
  #define USER_CFG_MEMORY_SIZE 8192
#endif

#if (USER_CFG_MEMORY_SIZE % 16)
  #error "USER_CFG_MEMORY_SIZE must be multiple of 16"
#endif
#ifdef USER_CFG_MEMORY_MIN_BLOCKSIZE
  #if (USER_CFG_MEMORY_MIN_BLOCKSIZE % 16)
    #error "USER_CFG_MEMORY_MIN_BLOCKSIZE must be multiple of 16"
  #endif
#endif

typedef struct _xMemBlock
{
  size_t             MemUsed;
  struct _xMemBlock *MemNext;
} xMemBlock;

static unsigned char _user_defined_Memory_Area[USER_CFG_MEMORY_SIZE];

void xMemInit (void)
{
  xMemBlock *FirstBlock;
  xMemBlock *LastBlock;
  FirstBlock = (xMemBlock *)&_user_defined_Memory_Area[0];
  LastBlock  = (xMemBlock *)&_user_defined_Memory_Area[USER_CFG_MEMORY_SIZE];
  LastBlock--;
  FirstBlock->MemNext = LastBlock;
  FirstBlock->MemUsed = 0;
  LastBlock->MemNext = 0;
  LastBlock->MemUsed = 1;
}


void *xMemMalloc (size_t MemSize)
{
  xMemBlock *tmp, *best;
  size_t tmpsize, bestsize;

  /* add size of header and apply minimum block size */
  MemSize += sizeof(xMemBlock);
  #ifdef USER_CFG_MEMORY_MIN_BLOCKSIZE  
    /* allocate blocks of size USER_CFG_MEMORY_MIN_BLOCKSIZE * 2^N */
    tmpsize = USER_CFG_MEMORY_MIN_BLOCKSIZE;
    while (tmpsize < MemSize) do {
      tmpsize *= 2;
    }
    MemSize = tmpsize;
  #else
    /* allocate blocks with a size that is a multiple of 8 bytes */
    tmpsize = MemSize % 8;
    if (tmpsize != 0) {
      MemSize += 8 - tmpsize;
    }
  #endif

  /* find block with best fit */
  best = 0;
  bestsize = USER_CFG_MEMORY_SIZE;
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadLock(&xMemoryMutex);
  #else
    XBEGIN_CRITICAL_PATH
  #endif
  tmp = (xMemBlock *)&_user_defined_Memory_Area[0];
  while (tmp != 0) {
    if (tmp->MemUsed == 0) {
      tmpsize = (size_t)tmp->MemNext - (size_t)tmp;
      if ((tmpsize >= MemSize) && (tmpsize < bestsize)) {
        best = tmp;                     /* best so far */
        bestsize = tmpsize;
        if (tmpsize == MemSize) {
          break;  /* exact fit */
        }
      }
    }
    tmp = tmp->MemNext;
  }
  if (best == 0) {
    #ifdef USER_CFG_ERR_CHECK_MEMORY_PACK
      ErrorHandler(ERR_MEM_NO_FREE);
    #endif
    #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
      xThreadUnlock(&xMemoryMutex);
    #else
      XEND_CRITICAL_PATH
    #endif
    return (void *)0;
  }

  /* If the current block size is larger than needed, cut the
     block in two pieces */
  #ifdef USER_CFG_MEMORY_MIN_BLOCKSIZE  
  if (bestsize >= MemSize + USER_CFG_MEMORY_MIN_BLOCKSIZE) {
  #else
  if (bestsize >= MemSize + 16) {
  #endif
    tmp = (xMemBlock *)((size_t)best + MemSize);
    tmp->MemNext = best->MemNext;
    tmp->MemUsed = 0;
    best->MemNext = tmp;
  }
  best->MemUsed = 1;
  best++;
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadUnlock(&xMemoryMutex);
  #else
    XEND_CRITICAL_PATH
  #endif
  return best;
}


void *xMemCalloc (size_t MemSize)
{
  void *tmp;
  tmp = xMemMalloc(MemSize);
  if (tmp != 0) {
    (void)memset(tmp, 0, MemSize);
  }
  return tmp;
}


void xMemFree (void *Mem)
{
  xMemBlock *prev, *thisblock;

  thisblock = (xMemBlock *)Mem;
  thisblock--;
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadLock(&xMemoryMutex);
  #else
    XBEGIN_CRITICAL_PATH
  #endif
  if (thisblock->MemUsed == 0) {
    #ifdef USER_CFG_ERR_CHECK_MEMORY_PACK
      ErrorHandler(ERR_MEM_ILLMBLOCK);
    #endif
  } else {
    prev = (xMemBlock *)&_user_defined_Memory_Area[0];
    if (prev == thisblock) {
      prev = 0;
    } else {
      while ((prev != 0) && (prev->MemNext != thisblock)) {
        prev = prev->MemNext;
      }
      #ifdef USER_CFG_ERR_CHECK_MEMORY_PACK
        if (prev == 0) {
          ErrorHandler(ERR_MEM_ILLMBLOCK);
        }
      #endif
    }

    thisblock->MemUsed = 0;
    /* add to next block */
    if (thisblock->MemNext->MemUsed == 0) {
      thisblock->MemNext = thisblock->MemNext->MemNext;
    }
    /* add to previous block */
    if ((prev != 0) && (prev->MemUsed == 0)) {
      prev->MemNext = thisblock->MemNext;
    }
  }
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadUnlock(&xMemoryMutex);
  #else
    XEND_CRITICAL_PATH
  #endif
}

#else  /* defined(USER_CFG_USE_USER_MEMFUNC) */

/* The user should implement the functions xAlloc and xFree, if
   the functions are needed */

#endif /* USER_CFG_USE_MEMORY_PACK */


/****+***************************************************************
     Standard C library functions
********************************************************************/

#ifdef USER_CFG_USE_memset
void *memset (void *mem_p, int val, size_t length)
{
  char *mem_p1;
  mem_p1 = (char *)mem_p;
  while (length-- != 0) {
    *mem_p1++ = val;
  }
  return mem_p;
}
#endif /* USER_CFG_USE_memset */


#ifdef USER_CFG_USE_memcpy
void *memcpy (void *dest, XCONST void *source, size_t length)
{
  char *mem_d;
  char *mem_s;
  mem_d = (char *)dest;
  mem_s = (char *)source;
  while (length-- != 0) {
    *mem_d++ = *mem_s++;
  }
  return dest;
}
#endif /* USER_CFG_USE_memcpy */


#ifdef USER_CFG_USE_strlen
size_t strlen (XCONST char *mem_p)
{
  int cnt = 0;
  while (*mem_p++ != 0) {
    cnt++;
  }
  return cnt;
}
#endif /* USER_CFG_USE_strlen */


#ifdef USER_CFG_USE_strcpy
char * strcpy (char *pdest, XCONST char *psource)
{
  char *p_return;
  p_return = pdest;
  while (*psource != 0) {
    *pdest++ = *psource++;
  }
  *pdest ='\0';
  return p_return;
}
#endif /* USER_CFG_USE_strcpy */


#ifdef USER_CFG_USE_strncpy
char *strncpy (char *pdest, XCONST char *psource, size_t length)
{
  char *p_return;
  p_return = pdest;
  while ((*psource != 0) && (length-- > 0)) {
    *pdest++ = *psource++;
  }
  while (length-- > 0) {
    *pdest++ = '\0';
  }
  return p_return;
}
#endif /* USER_CFG_USE_strncpy */


#ifdef USER_CFG_USE_strcmp
int strcmp (XCONST char *mem_p1, XCONST char *mem_p2)
{
  unsigned char mem_c1, mem_c2;
  do {
    mem_c1 = (unsigned char)*mem_p1++;
    mem_c2 = (unsigned char)*mem_p2++;
    if (mem_c1 == '\0') {
      return (mem_c1 - mem_c2);
    }
  } while (mem_c1 == mem_c2);
  return mem_c1 - mem_c2;
}
#endif /* USER_CFG_USE_strcmp */

