/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __UML_KERNEL_H_
#define __UML_KERNEL_H_

#ifndef XSCT_CMICRO
#define XSCT_CMICRO
#endif


/****+***************************************************************
     Scaling facilities
********************************************************************/
/* The following file is to be filled up by the user.
   Do your manual scalings here. This file should also include
   the file with automatic scalings, that is auto_cfg.h */
#include "uml_cfg.h"


/****+***************************************************************
     Utility and general macros
********************************************************************/

#define COMMENT(P)
   /* to be used for inserting comments in in-line C-code in UML. */
   /* the syntax is:  COMMENT(( your free format comment text ))   */

/* General purpose */
#ifndef xOffsetOf
#define xOffsetOf(type, field)  ((xptrint) &((type *) 0)->field)
#endif
#define XPP(p)  p


#define xbool   unsigned char
#define xTrue   1
#define xFalse  0


#define STDERR  stderr
#define STDOUT  stdout


#if _MSC_VER >= 1400
#pragma warning (disable : 4996)  // _CRT_SECURE_NO_DEPRECATE
#endif

/****+***************************************************************
     Dependent #ifdef
********************************************************************/

#ifdef CFG_USED_SIGNAL_WITH_DYN_PARAMS
  #ifndef USER_CFG_SIGNALS_NEVER_DISCARDED
    #define XFREESIGNALFUNCS
  #endif
#endif

#ifdef USER_CFG_USE_NUMBER_FREE_INST
  #define CFG_USE_NUMBER_FREE_INST  USER_CFG_USE_NUMBER_FREE_INST
#else
  #define CFG_USE_NUMBER_FREE_INST  5
#endif

#ifdef USER_CFG_USE_SIGNAL_PRIORITIES
  #ifdef USER_CFG_TIMER_PRIO
    #define CFG_TIMER_PRIO  USER_CFG_TIMER_PRIO
  #else
    #define CFG_TIMER_PRIO  50
  #endif
  #ifdef USER_CFG_CREATE_PRIO
    #define CFG_CREATE_PRIO  USER_CFG_CREATE_PRIO
  #else
    #define CFG_CREATE_PRIO  50
  #endif
  #ifdef USER_CFG_DEFAULT_PRIO
    #define xDefaultPrioSignal  USER_CFG_DEFAULT_PRIO
  #else
    #define xDefaultPrioSignal  50
  #endif
#endif

#if (defined(USER_CFG_ADD_STDIO)) || (defined(USER_CFG_UML_TRACE_STDOUT)) || \
    (defined(USER_CFG_ERROR_MESS_STDOUT)) || (defined(USER_CFG_ERROR_MESS_STDERR))
  #define CFG_ADD_STDIO
#endif


/****+***************************************************************
     Error handling configuration
********************************************************************/

#ifdef USER_CFG_ERR_CHECK_BASIC
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
#endif

#ifdef USER_CFG_ERR_CHECK_INDEX
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
  #ifndef XTESTF
    #define XTESTF
  #endif
  #define XEINDEX
#endif

#ifdef USER_CFG_ERR_CHECK_RANGE
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
  #ifndef XTESTF
    #define XTESTF
  #endif
  #define XERANGE
#endif

#ifdef USER_CFG_ERR_CHECK_PREDEF_OP
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
  #ifdef USER_CFG_USE_ERR_MESS
    #define XECSOP
    extern void xSDLOpError (char* String1, char* String2);
  #else
    #define xSDLOpError(p1,p2) ErrorHandler(ERR_N_PREDEFINED_OPERATOR_CALL)
  #endif
#endif

#ifdef USER_CFG_ERR_CHECK_DECISION
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
  #define XEDECISION
#endif

#ifdef USER_CFG_ERR_CHECK_NULL_PTR
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
  #define XCHECK_REF(VALUE,SORTIDNODE,REF_SORT) \
    if ((void *)(VALUE) == 0) { \
      ErrorHandler (ERR_N_NULL_POINTER_VALUE_USED); \
    }
  #define XCHECK_OREF(VALUE,REF_TYPEINFO,REF_SORT) \
    if ((void *)(VALUE) == 0) { \
      ErrorHandler (ERR_N_NULL_POINTER_VALUE_USED); \
    }
  #define XCHECK_OREF2(VALUE)
  #define XCHECK_OWN(VALUE,REF_TYPEINFO,REF_SORT) \
    if ((void *)(VALUE) == 0) { \
      ErrorHandler (ERR_N_NULL_POINTER_VALUE_USED); \
    }
#else
  #define XCHECK_REF(VALUE,SORTIDNODE,REF_SORT)
  #define XCHECK_OREF(VALUE,REF_TYPEINFO,REF_SORT)
  #define XCHECK_OREF2(VALUE)
  #define XCHECK_OWN(VALUE,REF_TYPEINFO,REF_SORT)
#endif

#ifdef USER_CFG_ERR_CHECK_MEMORY_PACK
  #ifndef CFG_USE_ERR_CHECK
    #define CFG_USE_ERR_CHECK
  #endif
#endif


/****+***************************************************************
     C Compiler section
********************************************************************/

#if defined(USER_CFG_COMPHDEF)

  #include "comphdef.h"

#else

  /* Use default (ISO-C) */
  #include <string.h>
  #include <stdlib.h>
  #include <limits.h>
  #include <stdarg.h>
  #ifdef CFG_ADD_STDIO
    #include <stdio.h>
  #endif

  #if (defined(__cplusplus)) && (defined(_MSC_VER))
    #include <cstddef>
  #else
    #include <stddef.h>
  #endif

#endif


/*---+---------------------------------------------------------------
     Final setting
-------------------------------------------------------------------*/

#ifdef __cplusplus
  typedef char * xSpecial;
  extern void * operator new (size_t pp, xSpecial vv);
#endif

#ifndef XCONST
  #define XCONST const
#endif
#ifdef CFG_USED_UNLIMITED_INSTANCES
  #define XCONST_INST
#else
  #define XCONST_INST  XCONST
#endif

#ifndef xuint8
  #define xuint8 unsigned char
#endif
#ifndef xuint16
  #if (USHRT_MAX >= 65535)
    #define xuint16 unsigned short
  #else
    #define xuint16 unsigned int
  #endif
#endif
#ifndef xuint32
  #if (UINT_MAX >= 4294967295U)
    #define xuint32 unsigned int
  #else
    #define xuint32 unsigned long
  #endif
#endif

#ifndef xint32
  #if (INT_MAX >= 2147483647)
    #define xint32 int
  #else
    #define xint32 long
  #endif
#endif


#define xMax_SDL_Integer INT_MAX

/* Define xptrint to be an unsigned type of same size as a pointer.
   Assume long int and ptr to be same size but prefer use of int.
   If this calculation is not true define xptrint previously in
   compiler section */
#ifndef xptrint
  #if (ULONG_MAX != UINT_MAX)
    #define xptrint unsigned long
  #else
    #define xptrint unsigned
  #endif
#endif

/* Define a type to represent 'unsigned long long int' and 'long long int' from BasicCTypes.pr */
#ifndef XNOUSE_LONG_LONG
    #ifdef _MSC_VER
        #if _MSC_VER < 1300
            #define xlonglong __int64
        #else
            #define xlonglong long long
        #endif
    #else
        #define xlonglong long long
    #endif
#endif

/* Used to support language concept any */
#ifndef GETINTRAND
#define GETINTRAND      rand()
#endif
#ifndef GETINTRAND_MAX
#define GETINTRAND_MAX  RAND_MAX
#endif


/****+***************************************************************
     Model macro expansions
********************************************************************/

/* ---------------------------- Output --------------------------- */
#ifdef USER_CFG_USE_SIGNAL_PRIORITIES
#define XOUTPUT_PRIO(P) ,P
#else
#define XOUTPUT_PRIO(P)
#endif

#ifdef CFG_USED_SIGNAL_WITH_PARAMS
#define XOUTPUT_SPARAM(P) ,P
#else
#define XOUTPUT_SPARAM(P)
#endif

#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
#define XOUTPUT_REUSE(P) ,P
#else
#define XOUTPUT_REUSE(P)
#endif



/* ---------------------------- Timers --------------------------- */
#ifdef CFG_USED_TIMER_WITH_PARAMS
  #define TIMER_CPARA(P)  ,P
#else
  #define TIMER_CPARA(P)
#endif


/* ---- Macros for run-time support of union, choice, optional --- */
#define XCHECK_UNION_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)\
   if (NEQTAG((TAG),(VALUE))) { \
     ASSTAG((TAG),(VALUE),XASS_MR_ASS_NF); \
   }
#define XCHECK_UNION_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME, \
                              CURR_VALUE,TYPEINFO) \
   if (NEQTAG((TAG),(VALUE))) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG((TAG),(VALUE),XASS_MR_ASS_NF); \
   }
#define XCHECK_UNION_TAG_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)
#define XCHECK_OPTIONAL_USAGE(PRESENT_VAR,COMPNAME)
#define XSET_CHOICE_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG((TAG),(VALUE))) { \
     ASSTAG((TAG),(VALUE),XASS_MR_ASS_NF); \
   }
#define XSET_CHOICE_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME, \
                             CURR_VALUE,TYPEINFO) \
   if (NEQTAG((TAG),(VALUE))) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG((TAG),(VALUE),XASS_MR_ASS_NF); \
     GenericDefault((void *)((xptrint)&(TAG)+((tSDLChoiceInfo *)TYPEINFO)->OffsetToUnion), ((tSDLChoiceInfo *)TYPEINFO)->Components[(int)(TAG)].CompSort); \
   }
#define XCHECK_CHOICE_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO)


/****+***************************************************************
     Predefined data types
********************************************************************/

#include "sctpred.h"


/****+***************************************************************
     Execution API includes
********************************************************************/

#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  struct _xSystemData;  /* forward ref */

  /* struct is used to store thread properties */
  typedef struct {
    unsigned int StackSize;
    unsigned int Prio;
    unsigned int User1;
    unsigned int User2;
  } xThreadData;

  extern XCONST xThreadData ThreadData[];    /* From generated code */
#endif


#if defined(USER_CFG_RTAPIDEF)

  #include "rtapidef.h"

#else

  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    #if (defined(_MSC_VER)) || (defined(__BORLANDC__))
      #include "RTOS\Win32\rtapidef.h"
    #else
      #include "RTOS/POSIX/rtapidef.h"
    #endif
  #else
    #include <time.h>
    #if (defined(_MSC_VER)) || (defined(__BORLANDC__))
      #include <sys\timeb.h>
    #else
      #include <sys/time.h>
    #endif
    #define xInitSystime()
    extern SDL_Time xNow (void);
  #endif
#endif


/*
The macros XBEGIN_CRITICAL_PATH and XEND_CRITICAL_PATH are only to be used
in non-threaded applications. In threaded applications other mechanisms
are used.
If the macros below are empty, it is not possible to send signals
to the system inside interrupt routines. In that case the signal sending
must take place in the xInEnv function. The structure for the macros should
be:
#define XBEGIN_CRITICAL_PATH \
        UserCodeToDisableInterrupts;

#define XEND_CRITICAL_PATH \
        UserCodeToEnableInterrupts;
*/

#ifndef XBEGIN_CRITICAL_PATH
  #define XBEGIN_CRITICAL_PATH
#endif
#ifndef XEND_CRITICAL_PATH
  #define XEND_CRITICAL_PATH
#endif


/* Some utility macros */
#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  #define XSYSD         xSysDP->
  #define XSYSDPROT     , xSystemData *
  #define XSYSDPROT1    xSystemData *
  #define XSYSDPARA     , xSystemData *xSysDP
  #define XSYSDPARA1    xSystemData *xSysDP
  #define XSYSDP        , xSysDP
  #define XSYSDP1       xSysDP
#else
  #define XSYSD         xSysD.
  #define XSYSDPROT
  #define XSYSDPROT1    void
  #define XSYSDPARA
  #define XSYSDPARA1    void
  #define XSYSDP
  #define XSYSDP1
#endif


/****+***************************************************************
     Signal identities
********************************************************************/

#if (CFG_NUMBER_SIGNALS >= 65536-2)
  typedef xuint32 xSignalId;
  #define XCREATEID 0xffffffff
  #define XASTERISK 0xfffffffe
#elif (CFG_NUMBER_SIGNALS >= 256-2)
  typedef xuint16 xSignalId;
  #define XCREATEID 0xffff
  #define XASTERISK 0xfffe
#else
  typedef xuint8 xSignalId;
  #define XCREATEID 0xff
  #define XASTERISK 0xfe
#endif

/* XCREATEID : Id for signal used at create action */
/* XASTERISK : StateIndexTable repr of save *, input * */


/****+***************************************************************
     Data structures for parts (not containing other parts)
********************************************************************/

/* Symbol number */
#ifdef CFG_USED_GUARD
  /* use one bit to determine if guard in this transition */
  #if (CFG_MAX_ACTIONS >= 32768-2)
    typedef xuint32 xActionId;
    #define XSAVE          (xActionId)0x7fffffff
    #define XDISCARD       (xActionId)0x7ffffffe
    #define XCREATE        (xActionId)0
    #define XIS_GUARD(P)   ((P) & 0x80000000)
    #define XGET_STMT(P)   ((P) & 0x7fffffff)
    #define XSET_GUARD(P)  ((P) | 0x80000000)
  #elif (CFG_MAX_ACTIONS >= 128-2)
    typedef xuint16 xActionId;
    #define XSAVE          (xActionId)0x7fff
    #define XDISCARD       (xActionId)0x7ffe
    #define XCREATE        (xActionId)0
    #define XIS_GUARD(P)   ((P) & 0x8000)
    #define XGET_STMT(P)   ((P) & 0x7fff)
    #define XSET_GUARD(P)  ((P) | 0x8000)
  #else
    typedef xuint8 xActionId;
    #define XSAVE          (xActionId)0x7f
    #define XDISCARD       (xActionId)0x7e
    #define XCREATE        (xActionId)0
    #define XIS_GUARD(P)   ((P) & 0x80)
    #define XGET_STMT(P)   ((P) & 0x7f)
    #define XSET_GUARD(P)  ((P) | 0x80)
  #endif
#else
  #if (CFG_MAX_ACTIONS >= 65536-2)
    typedef xuint32 xActionId;
    #define XSAVE       (xActionId)0xffffffff
    #define XDISCARD    (xActionId)0xfffffffe
    #define XCREATE     (xActionId)0
  #elif (CFG_MAX_ACTIONS >= 256-2)
    typedef xuint16 xActionId;
    #define XSAVE       (xActionId)0xffff
    #define XDISCARD    (xActionId)0xfffe
    #define XCREATE     (xActionId)0
  #else
    typedef xuint8 xActionId;
    #define XSAVE       (xActionId)0xff
    #define XDISCARD    (xActionId)0xfe
    #define XCREATE     (xActionId)0
  #endif
#endif


/* State */
#if (CFG_MAX_STATES >= 65536-3)
  typedef xuint32 xStateId;
  #define XSTARTUP   (xStateId)0x00000000
  #define XDORMANT   (xStateId)0xffffffff
  #define XCREATION  (xStateId)0xfffffffe
  #define XDASHSTATE (xStateId)0xfffffffd
#elif (CFG_MAX_STATES >= 256-3)
  typedef xuint16 xStateId;
  #define XSTARTUP   (xStateId)0x0000
  #define XDORMANT   (xStateId)0xffff
  #define XCREATION  (xStateId)0xfffe
  #define XDASHSTATE (xStateId)0xfffd
#else
  typedef xuint8 xStateId;
  #define XSTARTUP   (xStateId)0x00
  #define XDORMANT   (xStateId)0xff
  #define XCREATION  (xStateId)0xfe
  #define XDASHSTATE (xStateId)0xfd
#endif

/* XSTARTUP   : start state for static inst.  */
/* XDORMANT   : available instances           */
/* XCREATION  : start state for dynamic inst. */
/* XDASHSTATE : represents nextstate -        */


#if (CFG_MAX_INSTANCES == 1)
  #if (CFG_NUMBER_PARTS >= 65536-2)
    typedef xuint32 xInstanceId;
    typedef xuint32 xPartId;
    typedef xuint32 SDL_Pid;
    #define SDL_NULL  0xffffffff
    #define ENV       0xfffffffe
  #elif (CFG_NUMBER_PARTS >= 256-2)
    typedef xuint16 xInstanceId;
    typedef xuint16 xPartId;
    typedef xuint16 SDL_Pid;
    #define SDL_NULL  0xffff
    #define ENV       0xfffe
  #else
    typedef xuint8 xInstanceId;
    typedef xuint8 xPartId;
    typedef xuint8 SDL_Pid;
    #define SDL_NULL  0xff
    #define ENV       0xfe
  #endif
  #define XPID(ptype,pinst)    (ptype)
  #define XPART(globalpid)     (globalpid)
  #define XINST(globalpid)     0

#elif (CFG_NUMBER_PARTS < 256-2) && (CFG_MAX_INSTANCES < 256)
  typedef xuint8  xInstanceId;
  typedef xuint8  xPartId;
  typedef xuint16 SDL_Pid;
  #define SDL_NULL  0xffff
  #define ENV       0xfffe
  #define XPID(ptype,pinst)   (((SDL_Pid)(ptype)) | ((SDL_Pid)(((SDL_Pid)(pinst))) << 8))
  #define XPART(globalpid)    ((xuint8) (globalpid) & 0xff)
  #define XINST(globalpid)    ((xuint8) ((globalpid) >> 8) & 0xff)

#elif (CFG_NUMBER_PARTS < 65536-2) && (CFG_MAX_INSTANCES < 65536)
  typedef xuint16  xInstanceId;
  typedef xuint16  xPartId;
  typedef xuint32  SDL_Pid;
  #define SDL_NULL  0xffffffff
  #define ENV       0xfffffffe
  #define XPID(ptype,pinst)   (((SDL_Pid)(ptype)) | ((SDL_Pid)(((SDL_Pid)(pinst))) << 16))
  #define XPART(globalpid)    ((xuint16) (globalpid) & 0xffff)
  #define XINST(globalpid)    ((xuint16) ((globalpid) >> 16) & 0xffff)

#else
  #error
#endif

#define SDL_PId                SDL_Pid
#define xEq_SDL_PId(pid1,pid2) ((pid1)==(pid2))
#define xEq_SDL_PIdNULL(pid)   ((pid)==(SDL_NULL))
#define yAssF_SDL_PId(V,E,A)   V = E
#define yEqF_SDL_PId(E1,E2)    ((E1)==(E2))
#define yNEqF_SDL_PId(E1,E2)   ((E1)!=(E2))

/* Instance data "pointers" */
typedef struct {
  xStateId State;
  #ifdef CFG_USED_OFFSPRING
    SDL_Pid Offspring;
  #endif
  #ifdef CFG_USED_PARENT
    SDL_Pid Parent;
  #endif
  #ifdef CFG_USED_RPC
    xSignalId ExpectedRPCReply;
    xActionId RPCReplyAction;
  #endif
  #ifdef CFG_USED_DYNAMIC_THREADS
    struct _xSystemData *xSysDInst;
  #endif
} xInstanceData;
typedef xptrint xInstanceDataLength;


/* state index table */
#if (CFG_MAX_STATE_INDEX_ENTRY > 65536-3)
  typedef xuint32 xStateIndexTable;
#elif (CFG_MAX_STATE_INDEX_ENTRY > 256-3)
  typedef xuint16 xStateIndexTable;
#else
  typedef xuint8 xStateIndexTable;
#endif

typedef struct {
  xSignalId  SignalID;
  xActionId  SymbolNr;
} xTransitionTable;


typedef struct _xSystemData {
  SDL_Pid               CurrentPid;
  xActionId             CurrentSymbolNr;
  xInstanceData        *CurrentData;
  struct _xSignal      *CurrentSignal;
  SDL_Pid               CurrentSender;
  struct _xSignal      *SignalQueue;
  struct _xSignal      *ExternSignalQueue;
  struct _xSignal      *OutputSignal;
  #ifdef CFG_USED_TIMER
    struct _xTimer     *TimerQueue;
  #endif
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadVars         ThreadVars;
  #endif
} xSystemData;


#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  typedef unsigned char xThreadNumber;
#endif

typedef xbool    (*xGuardFunc)(XSYSDPROT1);
typedef void     (*xIniFunc)(void *);
typedef xStateId (*xTransFunc)(XSYSDPROT1);
typedef struct {
  xInstanceData           *InstanceData;
  xInstanceDataLength      DataLength;
  xInstanceId              MaxInstances;
  xInstanceId              InitialInstances;
  #ifdef CFG_USED_UNLIMITED_INSTANCES
    xbool                  DynamicInst;
  #endif
  xIniFunc                 yIni_Function;
  xTransFunc               yPAD_Function;
  XCONST xTransitionTable *TransitionTable;
  XCONST xStateIndexTable *StateIndexTable;
  #ifdef CFG_USED_GUARD
    xGuardFunc             GuardFunc;
  #endif
  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    xThreadNumber          ThreadNumber;
  #endif
} xPartTable;


/* Data structure used to find and access public attributes */
typedef struct {
  xPartId Part;
  xptrint Offset;
} xRemoteVarDef;


/****+***************************************************************
     Data structures for signals
********************************************************************/

#if defined(USER_CFG_MSG_BORDER_LEN)
  #define CFG_MSG_BORDER_LEN  USER_CFG_MSG_BORDER_LEN
#elif defined(CFG_USED_SIGNAL_WITH_PARAMS)
  #define CFG_MSG_BORDER_LEN  4
#else
  #define CFG_MSG_BORDER_LEN  0
#endif

typedef struct _xSignal
{
  struct _xSignal  *Next;
  xSignalId         Sid;
  SDL_Pid           Receiver;
  SDL_Pid           Sender;
  #ifdef CFG_USED_SAVE
    xStateId        SaveState;
  #endif
  #ifdef USER_CFG_USE_SIGNAL_PRIORITIES
    xuint8          Prio;
  #endif
  #ifdef CFG_USED_SIGNAL_WITH_PARAMS
    void           *ParPtr; /* pointer to either ParArea or to allocated memory */
    #if (CFG_MSG_BORDER_LEN > 0)
      unsigned char ParArea[CFG_MSG_BORDER_LEN];
    #endif
  #endif
} xSignal;


#ifdef CFG_USED_TIMER
typedef struct _xTimer
{
  struct _xTimer * Next;
  xSignalId  Sid;
  SDL_Pid    Owner;
  SDL_Time   Time;
  #ifdef CFG_USED_TIMER_WITH_PARAMS
    SDL_Integer TimerParValue;
  #endif
} xTimer;
#endif


/****+***************************************************************
     Variables
********************************************************************/

#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  extern xSystemData    xSysD[];
#else
  extern xSystemData    xSysD;
#endif

extern XCONST_INST xPartTable *xPartData[]; /* From generated code */


/****+***************************************************************
     Exported functions for the state machine
********************************************************************/

extern void xInsertSignal (xSignal *Signal);
extern void xRemoveSignal (xSignal *Signal);
#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  extern xSignal *xGetSignal (xSignalId Sid
                              XOUTPUT_SPARAM(int ParaLength),
                              xSignal **InSig);
#else
  extern xSignal *xGetSignal (xSignalId Sid
                              XOUTPUT_SPARAM(int ParaLength));
#endif
extern void xReturnSignal (xSignal *Signal);
extern void xOutputSimple (xSignalId Sid
                           XOUTPUT_PRIO(xuint8 Prio),
                           SDL_Pid Receiver
                           XSYSDPROT);
#ifdef CFG_USED_SIGNAL_WITH_PARAMS
  extern void xOutput (xSignal *Signal
                       XOUTPUT_PRIO(xuint8 Prio),
                       SDL_Pid Receiver
                       XSYSDPROT);
#endif
extern void xENVOutput (xSignal *Signal
                        XOUTPUT_PRIO(xuint8 Prio),
                        SDL_Pid Receiver);
#if (CFG_MAX_INSTANCES > 1)
  extern SDL_Pid xFindReceiver (xPartId PartId);
#endif

#ifdef CFG_USED_TIMER
  extern void xTimerSet (SDL_Time Time,
                         xSignalId Sid
                         TIMER_CPARA(SDL_Integer TimerParValue)
                         XSYSDPROT);
  extern void xTimerReset (xSignalId Sid
                           TIMER_CPARA(SDL_Integer TimerParValue)
                           XSYSDPROT);
  extern xbool xTimerActive (xSignalId Sid
                             TIMER_CPARA(SDL_Integer TimerParValue)
                             XSYSDPROT);
  extern void xCheckTimer (XSYSDPROT1);
#endif

#ifdef CFG_USED_CREATE
  extern xInstanceId xCreate (xPartId PartId,
                              xSignal *Signal
                              XSYSDPROT);
#endif
#ifdef CFG_USED_STOP
  extern void xStop (XSYSDPROT1);
#endif

#ifdef CFG_USED_RPC
  extern xStateId xRPCWaitState(xSignalId ExpectedRPCReply,
                                xActionId RPCReplyAction
                                XSYSDPROT);
#endif

extern void * xGetAttr(xRemoteVarDef *Attr, SDL_Pid P);
extern void * xGetAttr2(xRemoteVarDef *Attr);

#if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
  extern void xMainLoop (xSystemData *xSysDP);
#else
  extern void xMainLoop (void);
#endif

extern void xInit (void);



/****+***************************************************************
     Error handling
********************************************************************/

#ifdef CFG_USE_ERR_CHECK
  #define ERR_N_NO_FREE_SIGNAL_ERR        1
  #define ERR_N_CREATE_NO_MEM             2
  #define ERR_N_PARAMETER_MEM_ALLOC       3
  #define ERR_N_xOutEnv                   4
  #define ERR_RECEIVER_IS_NULL            5
  #define ERR_RECEIVER_IS_NOT_RUNNING     6
  #define ERR_SIGNAL_DISCARD              7
  #define ERR_N_NO_FREE_TIMER             8
  #define ERR_N_CREATE_INSTANCE           9
  #define ERR_N_PREDEFINED_OPERATOR_CALL 10
  #define ERR_N_NULL_POINTER_VALUE_USED  11
  #define ERR_DECISION_ELSE              12
  #define ERR_RANGE                      13
  #define ERR_INDEX                      14
  #define ERR_MEM_NO_FREE                15
  #define ERR_MEM_ILLMBLOCK              16
  #define ERR_ACCESS_ATTR_FROM_NULL      17
  #define ERR_ACCESS_ATTR_FROM_STOPPED   18
  #define ERR_ACCESS_ATTR_NOT_FOUND      19

  extern void ErrorHandler (unsigned char ErrorNumber);

  #ifdef USER_CFG_WARN_ACTION
    extern void xUserWarnAction (unsigned char WarningNumber);
  #endif

  #ifdef USER_CFG_ERR_ACTION
    extern void xUserErrAction (unsigned char ErrorNumber);
  #endif

#else

  #define ErrorHandler(errnum)

#endif /* CFG_USE_ERR_CHECK */


/****+***************************************************************
     Tracing
********************************************************************/

#ifdef USER_CFG_UML_TRACE_STDOUT

  #define XTRACE
  extern void xTraceTransition(char *P1  XSYSDPROT);
  extern void xTraceStart(void);
  extern void xTraceTrigger(char *P1  XSYSDPROT);
  extern void xTraceSet(char *P1, xSignalId P2, SDL_Time T);
  extern void xTraceReset(char *P1, xSignalId P2);
  extern void xTraceDiscard(xSignal *Sig, SDL_Pid Rec, xStateId State);
  extern void xTraceOutput(char *P1, xSignalId P2);
  extern void xTraceOutput2(SDL_Pid Receiver);
  extern void xTraceCreate(char *P1);
  extern void xTraceCreate2(SDL_Pid Created);
  extern void xTraceTask(char *P1);
  extern void xTraceAssign(char *P1);
  extern void xTraceAlg(char *P1);
  extern void xTraceDecision(char *P1);
  extern void xTraceCall(char *P1);
  extern void xTraceNextstate(char *P1, xStateId P2);
  extern void xTraceDashstate(void);
  extern void xTraceStop(void);

#else

  #if (CFG_NUMBER_THREADS > 0) || (defined(CFG_USED_DYNAMIC_THREADS))
    #define xTraceTransition(P1, P2)
    #define xTraceTrigger(P1, P2)
  #else
    #define xTraceTransition(P1)
    #define xTraceTrigger(P1)
  #endif
  #define xTraceStart()
  #define xTraceSet(P1, P2, P3)
  #define xTraceReset(P1, P2)
  #define xTraceDiscard(P1, P2, P3)
  #define xTraceOutput(P1, P2)
  #define xTraceOutput2(P1)
  #define xTraceCreate(P1)
  #define xTraceCreate2(P1)
  #define xTraceTask(P1)
  #define xTraceAssign(P1)
  #define xTraceAlg(P1)
  #define xTraceDecision(P1)
  #define xTraceCall(P1)
  #define xTraceNextstate(P1, P2)
  #define xTraceDashstate()
  #define xTraceStop()
#endif


/****+***************************************************************
     Memory management
********************************************************************/

#ifdef USER_CFG_USE_MEMORY_PACK
  #define xAlloc(Size) xMemCalloc(Size)
  #define xFree(Ptr)   if (*(Ptr)) {xMemFree(*(Ptr)); *(Ptr)=0;}
  extern void xMemInit (void);
  extern void *xMemMalloc (size_t MemSize);
  extern void *xMemCalloc (size_t MemSize);
  extern void xMemFree (void *Mem);
#else
  extern void *xAlloc (unsigned int Size);
  extern void xFree (void **Ptr);
#endif

/* The following is used to allocate memory for predefined sorts */
#define XALLOC(size,idnode) ((size)>0 ? xAlloc(size) : 0)
#define XFREE(p,size)       xFree(p)


/****+***************************************************************
     Standard C library functions
********************************************************************/

#ifdef USER_CFG_USE_memset
  extern void * memset (void *mem_p, int val, size_t length);
#endif

#ifdef USER_CFG_USE_memcpy
  extern void * memcpy (void *dest, XCONST void *source, size_t length);
#endif

#ifdef USER_CFG_USE_strlen
  extern size_t strlen (XCONST char *mem_p);
#endif

#ifdef USER_CFG_USE_strcpy
  extern char * strcpy (char *pdest, XCONST char *psource);
#endif

#ifdef USER_CFG_USE_strncpy
  extern char * strncpy (char *pdest, XCONST char *psource, size_t length);
#endif

#ifdef USER_CFG_USE_strcmp
  extern int strcmp (XCONST char *mem_p1, XCONST char *mem_p2);
#endif


/****+***************************************************************
     Environment functions
********************************************************************/

/* SDL Environment functions to be filled out by user */  
#ifdef USER_CFG_USE_xInitEnv
  extern void xInitEnv (void);
#endif
#ifdef USER_CFG_USE_xCloseEnv
  extern void xCloseEnv (void);
#endif
#ifdef USER_CFG_USE_xInEnv
  extern void xInEnv (void);
#endif
#ifdef USER_CFG_USE_xOutEnv
  extern void xOutEnv (xSignal *SignalOut);
#endif


/****+***************************************************************
     Functions in generated code
********************************************************************/

#ifdef CFG_USED_INITFUNC
  extern void yInit (void);
#endif
#if (defined(CFG_USED_SIGNAL_WITH_DYN_PARAMS)) && \
    ( !defined(USER_CFG_SIGNALS_NEVER_DISCARDED) )
  extern void xFreeSignalPara (xSignal *Signal);
#endif


#endif /* __UML_KERNEL_H_ */

