/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __cucf_h
#define __cucf_h

#include "cucf_cfg.h"

typedef struct sCoder tCoder;
typedef tCoder* tBuffer;

/* EMS */

typedef struct
{
  int           ErrorCode;
  jmp_buf       ReturnPoint;
  unsigned char IsAssigned;
} tEMS;

#define EMSReset(coder) \
  { (coder)->EMS.ErrorCode = 0; \
    (coder)->EMS.IsAssigned = 0; }

#include "ems/ems.h"


/* MMS */

struct sMMSItem;
typedef struct sMMSItem tMMSItem;

struct sMMSItem
{
  void*     MemPtr;
  tMMSItem* Next;
};

typedef struct
{
  tMMSItem* MMSFirst;
} tMMS;

#define MMSReset(coder) \
  (coder)->MMS.MMSFirst = NULL;

#include "mms/mms.h"


/* BMS */

typedef void (*tBufAppendBufFunc)(tCoder* Coder, unsigned int len);

typedef unsigned char tBMSMode;

#include "bms/bms.h"

#ifdef CODER_BMS_SMALLBUF
typedef tBMSSmallBuffer tBMSBuffer;
#elif defined(CODER_BMS_USERBUF)
typedef tBMSUserBuffer tBMSBuffer;
#else
typedef tBMSBaseBuffer tBMSBuffer;
#endif

typedef struct {
  tBufAppendBufFunc AppendFunc;
  tBMSMode          Mode;
  tBMSBuffer        BMSBuffer;
} tBMS;

#define BMSReset(coder) \
  { (coder)->BMS.AppendFunc = NULL; \
    (coder)->BMS.Mode = bms_NoMode; }


/* VMS */

#include "vms/vms.h"
#include "vms/vms_type.h"
#include "vms/vms_base.h"
#include "vms/vms_print.h"
#include "vms/vms_macro.h"
#include "vms/vms_export.h"


/* ER */

typedef unsigned long tERRule;

typedef struct
{
  tERRule        Rule;
  unsigned long  ValueBitLength;
  unsigned char* MemStart;
  unsigned char* MemEnd;
  unsigned char* DataEnd;
  unsigned char* DataCurr;
  unsigned char  BitEnd;
  unsigned char  BitCurr;
} tER;

#define ERReset(coder) \
  { (coder)->ER.Rule = CUCF_ER_DEFAULT; \
    (coder)->ER.ValueBitLength = 0; }

#include "cucf_er.h"


/* Coder */

struct sCoder {
  tEMS          EMS;
  tMMS          MMS;
  tBMS          BMS;
  tER           ER;
  unsigned char IsAssigned;
};


#ifdef CODER_VMS_SDT
#include "cucf_er_sdt.h"
#endif

#ifdef CODER_VMS_TTCN
#include "cucf_er_ttcn.h"
#endif

#endif /* __cucf_h */

