/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"

/**************************************************
 * 
 * NAME: ERSetRule
 *
 *
 */
void
ERSetRule(tCoder* Coder, unsigned long Rule)
{
#ifdef CODER_DEBUG_BMS
  fprintf(stdout, "BaseBufSetRule\n");
#endif
  
  switch (Rule)
    {
#if !defined(CODER_REMOVE_BER)
    case er_BER:
      Coder->ER.Rule = (er_BER | CUCF_BER_LENGTH);
      break;
    case (er_BER | er_Definite):
    case (er_BER | er_Indefinite):
      Coder->ER.Rule = Rule;
      break;
#endif

#if !defined(CODER_REMOVE_PER)
    case er_PER:
      Coder->ER.Rule = (er_PER | CUCF_PER_VARIANT);
      break;
    case (er_PER | er_Aligned):
    case (er_PER | er_Unaligned):
    case (er_PER | er_NoEndPad):
#endif

#if defined(CODER_USE_UER)
    case er_UER:
#endif
    case er_NoRule:
      Coder->ER.Rule = Rule;
      break;
    }
}

int
ASN1Encode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  switch ((Coder->ER.Rule) & 0xF00)
    {

#if !defined(CODER_REMOVE_BER)
    case er_BER:
      return BEREncode(Coder, Type, Val);
#endif

#if !defined(CODER_REMOVE_PER)
    case er_PER:
      return PEREncode(Coder, Type, Val);
#endif

#if defined(CODER_USE_UER)
    case er_UER:
      return UER_ENCODE(Coder, Type, Val);
#endif

    default: break;
    }
  return ec_SUCCESS;
}

int
ASN1Decode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  switch ((Coder->ER.Rule) & 0xF00)
    {

#if !defined(CODER_REMOVE_BER)
    case er_BER:
      return BERDecode(Coder, Type, Val);
#endif

#if !defined(CODER_REMOVE_PER)
    case er_PER:
      return PERDecode(Coder, Type, Val);
#endif

#if defined(CODER_USE_UER)
    case er_UER:
      return UER_DECODE(Coder, Type, Val);
#endif

    default: break;
    }

  return ec_SUCCESS;
}
