/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/


#include "cucf_er_sdt.h"

int
ASN1EncodeOctet(SDL_Octet_String *b, tASN1TypeInfo* Type, void *val)
{
  int result;
  tBuffer Buf = NULL;
  tBMSUserMemory UserMemory;
  unsigned long length;
  int res;

  result = BufInitBuf(Buf, bms_SmallBuffer);
  if (result != ec_SUCCESS) return result;
  result = ASN1Encode(Buf, Type, val);
  res = BufCloseBufToMemory(Buf, &UserMemory);

  /* buf to octet_string */
  if (result == ec_SUCCESS) 
    length = UserMemory.DataLength;
  else
    length = 0;

  if (b->Length > 0)
    XFREE((void **)&(b->Bits), b->Length);
  b->Bits = (unsigned char *)XALLOC((xptrint)length, xSrtN_SDL_Octet_String);
  b->IsAssigned = 1;
  b->Length = (int)length;
  memcpy(b->Bits, UserMemory.MemPtr, length);
  CUCF_FREE(UserMemory.MemPtr, UserMemory.MemSize, 0);

  if (result != ec_SUCCESS)
    return result;
  else
    return res;
}

int
ASN1DecodeOctet(SDL_Octet_String b, tASN1TypeInfo *Type, void *val)
{
  int result;
  tBuffer Buf = NULL;
  tBMSUserMemory UserMemory;
  int res;

  /* octet_string to buf */
  UserMemory.MemPtr = b.Bits;
  UserMemory.MemSize = (unsigned long)b.Length;
  UserMemory.DataLength = (unsigned long)b.Length;

  result = BufInitBufWithMemory(Buf, bms_SmallBuffer, &UserMemory);
  if (result != ec_SUCCESS) return result;

  if (NEEDSFREE((tSDLTypeInfo*)Type->VRType))
    GenericFreeSort((void**)val, (tSDLTypeInfo*)Type->VRType);  
  result = ASN1Decode(Buf, Type, val);
  if (NEEDSFREE((tSDLTypeInfo*)Type->VRType))
    (void)GenericAssignSort(val, val, XASS_AR_ASS_FR,
                            (tSDLTypeInfo*)Type->VRType);
  res = BufCloseBuf(Buf);

  if (result != ec_SUCCESS)
    return result;
  else
    return res;
}

int
ASN1DecodeCoderBuf(tCoder *b, tASN1TypeInfo *Type, void *val)
{
  int result;

  if (NEEDSFREE((tSDLTypeInfo *)Type->VRType))
    GenericFreeSort((void**)val, (tSDLTypeInfo *)Type->VRType);
  result = ASN1Decode(b, Type, val);
  if (NEEDSFREE((tSDLTypeInfo *)Type->VRType))
    (void)GenericAssignSort(val, val, XASS_AR_ASS_FR,
                            (tSDLTypeInfo *)Type->VRType);
  return result;
}
