/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"

#ifdef CODER_EO_SDT

#ifdef _MSC_VER
#define snprintf _snprintf
#define vsnprintf _vsnprintf
#endif

void
SDTErrorOutputFunc(int ErrorCode, va_list ap)
{
#ifdef XECODER
#define allocatedBytes  256
  {
    char messageType[allocatedBytes];
    char messageInfo[allocatedBytes];

    messageType[allocatedBytes - 1] = 0;
    messageInfo[allocatedBytes - 1] = 0;
    snprintf(messageType, 
             allocatedBytes-1, 
             "\nERROR %d: ", 
             ErrorCode);
    vsnprintf(messageInfo,
              allocatedBytes-1, 
              ErrorMessageArray[ErrorCode], 
              ap);
    xCoderError(messageType, messageInfo);
  }
#undef allocatedBytes
#endif
}

#ifdef _MSC_VER
#undef snprintf
#undef vsnprintf
#endif



#if defined(HPUXANSICC) || (defined(__STRICT_ANSI__) && ! defined(__linux)) || (defined(__BORLANDC__) && (__BORLANDC__ <= 0x530))

static void dopr( char *buffer, char *, const char* format,va_list args );
static void fmtstr (char *end,char **output,char *value, int ljust, int len, int zpad, int maxwidth);
static void fmtnum (char *end, char **output, long value, int base, int dosign, int ljust, int len, int zpad);
static void dostr ( char *, char **, char * , int );
static void dopr_outch (char *end, char **output, int c );

int snprintf(char *str, size_t count, const char *fmt, ...)
{
  int len;
  va_list ap;

  va_start(ap, fmt);
  len = vsnprintf(str, count, fmt, ap);
  va_end(ap);
  return len;
}

int vsnprintf(char *str, size_t count, const char *fmt, va_list args)
{
  char *end;
  str[0] = 0;
  end = str + count - 1;
  dopr( str, end, fmt, args );
  if (count > 0)
    end[0] = 0;
  return strlen(str);
}

static void
dopr( char *buffer, char *end, const char* format, va_list args )
{
  int ch;
  long value;
  int longflag  = 0;
  int pointflag = 0;
  int maxwidth  = 0;
  char *strvalue;
  int ljust;
  int len;
  int zpad;
  char *output;

  output = buffer;
  while( (ch = *format++) ){
    switch( ch )
      {
      case '%':
        ljust = len = zpad = maxwidth = 0;
        longflag = pointflag = 0;
      nextch:
        ch = *format++;
        switch( ch ){
        case 0:
          dostr( end, &output, "**end of format**" , 0);
          return;
        case '-': ljust = 1; goto nextch;
        case '0': /* set zero padding if len not set */
          if(len==0 && !pointflag) zpad = '0';
        case '1': case '2': case '3':
        case '4': case '5': case '6':
        case '7': case '8': case '9':
          if (pointflag)
            maxwidth = maxwidth*10 + ch - '0';
          else
            len = len*10 + ch - '0';
          goto nextch;
        case '*': 
          if (pointflag)
            maxwidth = va_arg( args, int );
          else
            len = va_arg( args, int );
          goto nextch;
        case '.': pointflag = 1; goto nextch;
        case 'l': longflag = 1; goto nextch;
        case 'u': case 'U':
          /*fmtnum(value,base,dosign,ljust,len,zpad) */
          if( longflag ){
            value = va_arg( args, long );
          } else {
            value = va_arg( args, int );
          }
          fmtnum( end, &output, value, 10,0, ljust, len, zpad ); break;
        case 'o': case 'O':
          /*fmtnum(value,base,dosign,ljust,len,zpad) */
          if( longflag ){
            value = va_arg( args, long );
          } else {
            value = va_arg( args, int );
          }
          fmtnum(end, &output, value, 8,0, ljust, len, zpad ); break;
        case 'd': case 'D':
          if( longflag ){
            value = va_arg( args, long );
          } else {
            value = va_arg( args, int );
          }
          fmtnum( end, &output, value, 10,1, ljust, len, zpad ); break;
        case 'x':
          if( longflag ){
            value = va_arg( args, long );
          } else {
            value = va_arg( args, int );
          }
          fmtnum( end, &output,value, 16,0, ljust, len, zpad ); break;
        case 'X':
          if( longflag ){
            value = va_arg( args, long );
          } else {
            value = va_arg( args, int );
          }
          fmtnum(end, &output, value,-16,0, ljust, len, zpad ); break;
        case 's':
          strvalue = va_arg( args, char *);
          if (maxwidth > 0 || !pointflag) {
            if (pointflag && len > maxwidth)
              len = maxwidth; /* Adjust padding */
            fmtstr(end, &output, strvalue,ljust,len,zpad, maxwidth);
          }
          break;
        case 'c':
          ch = va_arg( args, int );
          dopr_outch(end, &output, ch ); break;
        case '%': dopr_outch(end, &output, ch ); continue;
        default:
          dostr( end, &output,  "???????" , 0);
        }
        break;
      default:
        dopr_outch(end, &output, ch );
        break;
      }
  }
  *output = 0;
}

static void
fmtstr( char* end, char** output, char* value,int ljust,int len,int zpad,int maxwidth )
{
  int padlen, strlen;     /* amount to pad */

  if( value == 0 ){
    value = "<NULL>";
  }
  for( strlen = 0; value[strlen]; ++ strlen ); /* strlen */
  if (strlen > maxwidth && maxwidth)
    strlen = maxwidth;
  padlen = len - strlen;
  if( padlen < 0 ) padlen = 0;
  if( ljust ) padlen = -padlen;
  while( padlen > 0 ) {
    dopr_outch(end, output, ' ' );
    --padlen;
  }
  dostr( end, output, value, maxwidth );
  while( padlen < 0 ) {
    dopr_outch(end, output, ' ' );
    ++padlen;
  }
}

static void
fmtnum(char*  end,char** output,long value,int base,int dosign,int ljust,int len,int zpad )
{
  int signvalue = 0;
  unsigned long uvalue;
  char convert[20];
  int place = 0;
  int padlen = 0; /* amount to pad */
  int caps = 0;

  uvalue = value;
  if( dosign ){
    if( value < 0 ) {
      signvalue = '-';
      uvalue = -value;
    }
  }
  if( base < 0 ){
    caps = 1;
    base = -base;
  }
  do{
    convert[place++] =
      (caps? "0123456789ABCDEF":"0123456789abcdef")
      [uvalue % (unsigned)base  ];
    uvalue = (uvalue / (unsigned)base );
  }while(uvalue);
  convert[place] = 0;
  padlen = len - place;
  if( padlen < 0 ) padlen = 0;
  if( ljust ) padlen = -padlen;
  if( zpad && padlen > 0 ){
    if( signvalue ){
      dopr_outch(end, output, signvalue );
      --padlen;
      signvalue = 0;
    }
    while( padlen > 0 ){
      dopr_outch(end, output, zpad );
      --padlen;
    }
  }
  while( padlen > 0 ) {
    dopr_outch( end, output,' ' );
    --padlen;
  }
  if( signvalue ) dopr_outch( end, output,signvalue );
  while( place > 0 ) dopr_outch( end, output,convert[--place] );
  while( padlen < 0 ){
    dopr_outch( end, output,' ' );
    ++padlen;
  }
}

static void
dostr(char* end,char** output,char* str ,int cut)
{
  if (cut) {
    while(*str && cut-- > 0) dopr_outch(end, output,*str++);
  } else {
    while(*str) dopr_outch(end, output,*str++);
  }
}

static void
dopr_outch(char* end,char** output,int c )
{
  char *out;
  out = *output;
  if( end == 0 || out < end )
    {
      *out++ = (char)c;
      *output = out;
    }
}

#endif /* defined(HPUXANSICC) || defined(__BORLANDC__) */

#endif /* CODER_EO_SDT */
