/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_ASCII

#include "cucf.h"

#ifndef CODER_ASCII_REAL_DECIMALS
#define CODER_ASCII_REAL_DECIMALS 13
#endif

#define NULLPTR 0

#ifndef CODER_ASCII_FLOAT_DECIMALS
#define CODER_ASCII_FLOAT_DECIMALS 7
#endif

#if defined(XTIMEASINT_SECS)
#define LOCAL_TIME_INT SDL_Duration
#elif defined(XTIMEASINT_TICKS)
#define LOCAL_TIME_INT SDL_Duration
#else
#define LOCAL_TIME_INT xint32
#endif

/* Hooks for encoding of types with unknown/varying implementation (UnionC, UnserDef, ...) */
tEncodeFunc AsciiUserEncode = NULLPTR;
tDecodeFunc AsciiUserDecode = NULLPTR;

/* Hooks for modifying default encoding */
tEncodeFunc AsciiUserPreEncode = NULLPTR;
tDecodeFunc AsciiUserPreDecode = NULLPTR;

extern tSDLTypeInfo  ySDL_SDL_Boolean;


/* ---- macros for error management ----------*/

#define ASCII_ENC_ERROR(coder,errorcode) \
  ASCII_ERROR_HANDLER(coder,NO_ACTION,errorcode,NO_ARGS)

#define ASCII_DEC_ERROR(coder,errorcode) \
  ASCII_ERROR_HANDLER(coder,NO_ACTION,errorcode,NO_ARGS)

#define ASCII_CHECK_ERROR(expression,coder,errorcode) \
  ASCII_ERROR_HANDLER_EXP(expression,coder,NO_ACTION,errorcode,NO_ARGS)


/* ---- macros for buffer management ----------*/

void ASCIIPutByte(tCoder* Coder, unsigned char iByte)
{
  if (Coder->ER.DataCurr == Coder->ER.MemEnd)
    {
      tVMSULong DataEnd = Coder->ER.DataEnd - Coder->ER.MemStart;
      tVMSULong DataCurr = Coder->ER.DataCurr - Coder->ER.MemStart;
      tVMSULong MemEnd = Coder->ER.MemEnd - Coder->ER.MemStart;
      Coder->ER.MemStart = BufAppendMemory(Coder, 8192);
      Coder->ER.MemEnd = Coder->ER.MemStart + MemEnd + 8192;
      Coder->ER.DataEnd = Coder->ER.MemStart + DataEnd;
      Coder->ER.DataCurr = Coder->ER.MemStart + DataCurr;
    }
  *(Coder->ER.DataCurr) = iByte;
  Coder->ER.DataCurr++;
}

unsigned char ASCIIGetByte(tCoder* Coder)
{
  unsigned char oByte;
  if (Coder->ER.DataCurr == Coder->ER.DataEnd)
    {
      tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);
      if (AppendFunc)
        {
          AppendFunc(Coder, 1);
          Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
        }
      if (Coder->ER.DataCurr == Coder->ER.DataEnd)
        {
          ASCII_DEC_ERROR(Coder,ec_BUF_NoMoreDataForRead);
        }
    }
  oByte = *(Coder->ER.DataCurr);
  Coder->ER.DataCurr++;
  return oByte;
}

unsigned char ASCIIPeekByte(tCoder* Coder)
{
  if (Coder->ER.DataCurr == Coder->ER.DataEnd)
    {
      tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);
      if (AppendFunc)
        {
          AppendFunc(Coder, 1);
          Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
        }
      if (Coder->ER.DataCurr == Coder->ER.DataEnd)
        {
          ASCII_DEC_ERROR(Coder,ec_BUF_NoMoreDataForRead);
        }
    }
  return *(Coder->ER.DataCurr);
}


/* ---- macros for encode integer value ----------*/

#define ENCODE_INT(INTTYPE,VALUE,CODER) \
{ \
  INTTYPE i,invalue,Digit; \
  invalue=(VALUE); \
  i=invalue; \
  Digit=1; \
  if (i<0) { \
    while (i < -9) { \
      Digit = (INTTYPE)(10*Digit); \
      i = (INTTYPE)(i/10); \
    } \
    i=invalue; \
    ASCIIPutByte(CODER, '-'); \
    for (; Digit>0; Digit = (INTTYPE)(Digit/10)) { \
      ASCIIPutByte(CODER, (unsigned char)(-(i/Digit)+'0')); \
      i = (INTTYPE)(i%Digit); \
    } \
  } \
  else { \
    while (i > 9) { \
      Digit = (INTTYPE)(10*Digit); \
      i = (INTTYPE)(i/10); \
    } \
    i=invalue; \
    for (; Digit>0; Digit = (INTTYPE)(Digit/10)) { \
      ASCIIPutByte(CODER, (unsigned char)(i/Digit+'0')); \
      i = (INTTYPE)(i%Digit); \
    } \
  } \
}

#define ENCODE_UNSIGNED_INT(INTTYPE,VALUE,CODER) \
{ \
  INTTYPE i,Digit; \
  i=(VALUE); \
  Digit=1; \
  while (i > 9) { \
    Digit = (INTTYPE)(10*Digit); \
    i = (INTTYPE)(i/10); \
  } \
  i=(VALUE); \
  for (; Digit>0; Digit = (INTTYPE)(Digit/10)) { \
    ASCIIPutByte(CODER, (unsigned char)(i/Digit+'0')); \
    i = (INTTYPE)(i%Digit); \
  } \
}



/* ---- macros for decoding integer value ----------*/

#define DECODE_INT(INTTYPE,VALUE,CODER) \
{ \
  INTTYPE i; \
  unsigned char b,sign; \
  sign='+'; \
  i = 0; \
  b = ASCIIPeekByte(CODER); \
  if (b == '-') { \
    sign = ASCIIGetByte(CODER); \
    b = ASCIIPeekByte(CODER); \
  } \
  if(b<'0' || '9'<b) \
     ASCII_DEC_ERROR(CODER,ec_ERROR_DECODING_INTEGER); \
  for( ; '0'<=b && b<='9'; b=ASCIIPeekByte(CODER)) { \
    b=ASCIIGetByte(CODER); \
    i = (INTTYPE)(i*10 + (b-'0')); \
  } \
  if (sign == '-') i = (INTTYPE)(-i); \
  (VALUE) = i; \
}

#define DECODE_UNSIGNED_INT(INTTYPE,VALUE,CODER) \
{ \
  INTTYPE i; \
  unsigned char b; \
  i = 0; \
  b = ASCIIPeekByte(CODER); \
  if(b<'0' || '9'<b) \
     ASCII_DEC_ERROR(CODER,ec_ERROR_DECODING_INTEGER); \
  for( ; '0'<=b && b<='9'; b=ASCIIPeekByte(CODER)) { \
    b=ASCIIGetByte(CODER); \
    i = (INTTYPE)(i*10 + (b-'0')); \
  } \
  (VALUE) = i; \
}

/* ---- macros for encode real (float) value ----------*/

#define ENCODE_REAL(REALTYPE,VALUE,NRDECIMALS,CODER) \
{ \
  REALTYPE r,m; \
  int ival,j,exp,exp_sign; \
  r = (REALTYPE)(VALUE); \
  if (r < 0) { \
	 r = -r; \
	 ASCIIPutByte(CODER, '-'); \
  }; \
  if (r < (REALTYPE)1.0) { \
	 m = (REALTYPE)10.0; \
	 exp_sign = -1; \
  } \
  else { \
	 m = (REALTYPE)0.1; \
	 exp_sign = +1; \
  } \
  exp = 0; \
  if (r > 0.0) { \
     while (r < 1.0 || r >= 10.0) { \
	r = r*m; \
	++exp; \
     } \
  } \
  ival = (int)r; \
  ASCIIPutByte(CODER, (unsigned char)(ival+'0')); \
  ASCIIPutByte(CODER, '.'); \
  r = r-ival; \
  for (j=0; j<NRDECIMALS; j++) { \
     r = r*(REALTYPE)10.0; \
     ival = (int)r; \
     ASCIIPutByte(CODER, (unsigned char)(ival+'0')); \
     r = r-ival; \
  } \
  ASCIIPutByte(CODER, 'e'); \
  if (exp_sign < 0) ASCIIPutByte(CODER, '-'); \
  ENCODE_INT(int,exp,CODER); \
}

/* ---- macros for decoding real (float) value ----------*/

#define DECODE_REAL(REALTYPE,VALUE,CODER) \
{ \
  REALTYPE r,m,p; \
  unsigned char b,sign; \
  int j,exp; \
  sign = '+'; \
  b = ASCIIGetByte(CODER); \
  if (b == '-') { \
	 sign = '-'; \
	 b = ASCIIGetByte(CODER); \
  } \
  if (b<'0' || '9'<b) \
     ASCII_DEC_ERROR(CODER,ec_ERROR_DECODING_REAL); \
  r = (REALTYPE)(b-'0'); \
  b = ASCIIGetByte(CODER); \
  while('0'<=b && b<='9') { \
	 r = r*(REALTYPE)10.0 + ((REALTYPE)(b-'0')); \
	 b = ASCIIGetByte(CODER); \
  } \
  if (b != '.') \
     ASCII_DEC_ERROR(CODER,ec_ERROR_DECODING_REAL); \
  m = (REALTYPE)0.1; \
  b = ASCIIGetByte(CODER); \
  while('0'<=b && b<='9') { \
	 r = r + ((REALTYPE)(b-'0'))*m; \
	 m = m*(REALTYPE)0.1; \
	 b = ASCIIGetByte(CODER); \
  } \
  if (b != 'e') \
     ASCII_DEC_ERROR(CODER,ec_ERROR_DECODING_REAL); \
  if (ASCIIPeekByte(CODER) == '-') { \
	 p=(REALTYPE)0.1; \
	 (void)ASCIIGetByte(CODER); \
  } \
  else p=(REALTYPE)10.0; \
  m=(REALTYPE)1.0; \
  DECODE_INT(int,exp,CODER); \
  for (j=0; j<exp; j++) \
	 m=m*p; \
  r = r * m; \
  if (sign == '-') r = -r; \
  (VALUE) = r; \
}

/*-Internal procedure for taking from puffer and put-*/
/*-in temporary char strings ------------------------*/
#define ASCII_FIRST_SIZE 256
#define ASCII_INCREMENT_FACTOR 4

void CopyToTempStr(tCoder* Coder, unsigned char ** tempStr, 
                   unsigned char * firstStr, int firstSize,
                   int checkDouble, int* len, int* freeTemp )
{ 
  int i,more,size,oldSize;
  unsigned char b;
  unsigned char * oldStr;

  *tempStr = firstStr;
  size = firstSize;
  *freeTemp = 0;
  i = 0;
  more = 1;
  while( more ) {
    b = ASCIIGetByte(Coder);
    if ( b == '\'' ) {
      if (!checkDouble ) 
	more = 0;
      else if ( ASCIIPeekByte(Coder) != '\'' )
	more = 0;
      else b = ASCIIGetByte(Coder);
    };
    if (more) {
      if (i==size) {
	oldStr = *tempStr;
	oldSize = size;
	size = size*ASCII_INCREMENT_FACTOR;
	*tempStr = (unsigned char *)CUCFAlloc(Coder,size, 0);
	(void)memcpy(*tempStr,oldStr,oldSize);
        if ( *freeTemp )
	  CUCFFree(Coder,oldStr,0,0);
	*freeTemp = 1;
      };
      (*tempStr)[i++] = b;
    }
  }
  *len = i;
}

/* Size macros for array to store REF pointers */
#define ASCII_REF_FIRST_SIZE 64
#define ASCII_REF_INCREMENT_FACTOR 4

struct tStoredRefsStruct {
  void**    storedArr;
  int       size;
  int       lastindex;
}; /* typedef in ascii.h: tStoredRefs */


/*-Internal function for initializing an array with --*/
/*-stored REF pointers----------------------------*/
tStoredRefs* InitRefArray(tCoder* Coder)
{
  int i;
  tStoredRefs * storedRefs;
  storedRefs = (tStoredRefs *)CUCFAlloc(Coder,sizeof(tStoredRefs), 0);
  storedRefs->size = ASCII_REF_FIRST_SIZE;
  storedRefs->storedArr = (void**)CUCFAlloc(Coder,sizeof(void*)*ASCII_REF_FIRST_SIZE, 0);
  storedRefs->lastindex = -1;
  for (i=0; i<storedRefs->size; i++ )
    storedRefs->storedArr[i]=NULLPTR;
  return storedRefs;
}

/*-Internal function for finding an element in the array with --*/
/*-stored REF pointers------------------------------------------*/
int GetRefIndex( tStoredRefs * storedRefs, void * addr)
{
  int i;
  for (i=storedRefs->lastindex;i>=0;i--)
    if (addr==storedRefs->storedArr[i]) return i;
  return -1;
} 

/*-Internal function for storing an element in the array with --*/
/*-stored REF pointers------------------------------------------*/
int StoreRefAddr( tStoredRefs * storedRefs, void * addr, int decIndex, tCoder* Coder)
{
  int i;
  int retIndex;

  if ( ((decIndex<0) && (storedRefs->lastindex>=(storedRefs->size-1))) ||
       ((decIndex>=0) && (decIndex>=(storedRefs->size-1))) ) {
    int newsize;
    void ** newArr;
    newsize = storedRefs->size*ASCII_REF_INCREMENT_FACTOR;
    newArr = (void**)CUCFAlloc(Coder,sizeof(void*)*newsize, 0);
    for (i=0;i<storedRefs->size;i++)
      newArr[i]=storedRefs->storedArr[i];
    for (i=storedRefs->size;i<newsize;i++)
      newArr[i]=NULLPTR;
    CUCFFree(Coder,storedRefs->storedArr,0,0);
    storedRefs->storedArr=newArr;
    storedRefs->size=newsize;
  }
  if (decIndex<0) {
    storedRefs->lastindex++;
    storedRefs->storedArr[storedRefs->lastindex]=addr;
    retIndex = storedRefs->lastindex;
  }
  else {
    storedRefs->lastindex=decIndex;
    storedRefs->storedArr[decIndex]=addr;
    retIndex = decIndex;
  }
  return retIndex;
} 

/*-Internal function for getting a pointer value in the array--*/
/*-stored REF pointers-----------------------------------------*/
void * GetRefAddr( tStoredRefs * storedRefs, int index )
{
  void * addr = NULLPTR;
  if ((index>=0) && (index<=storedRefs->lastindex) )
    addr = storedRefs->storedArr[index]; 
  return addr;
}

/*-Internal function for freeing the memory used for ----------*/
/*-stored REF pointers-----------------------------------------*/
void FreeStoredRefs( tStoredRefs * storedRefs, tCoder* Coder)
{
  CUCFFree(Coder,storedRefs->storedArr,0,0);
  CUCFFree(Coder,storedRefs,0,0);
}

/*---------------- Encode procedure -------------------*/


/* defaultValue is returned on no match! */
static T_CONST char*
GetEnumName(int value, tSDLEnumLiteralInfo* A, int Alen,
            T_CONST char* defaultName)
{
  int i;

  for (i = 0; i < Alen; ++i)
    if (value == A[i].LiteralValue)
      return A[i].LiteralName;
  return defaultName;
}

/* Returns index in A of match (>=0), or -1 for no match */
static int GetEnumIndex(T_CONST char* name, tSDLEnumLiteralInfo* A, int Alen)
{
  int i;

  for (i = 0; i < Alen; ++i) {
    if (!strcmp(name, A[i].LiteralName)) {
      return i;
    }
  }
  return -1;
}

void AsciiEncVal(tCoder* Coder, tSDLTypeInfo* TypeNode, void* Value, tStoredRefs ** sRefs )
{
  if (AsciiUserPreEncode) {
    int errorcode;
    errorcode = AsciiUserPreEncode(Coder,TypeNode,Value);
    if (errorcode==ec_SUCCESS) {
      /* encoding managed by AsciiUserPreEncode */
      return;
    }
   /* encoding not managed by AsciiUserPreEncode, continue with default encoding */
  }

  switch (TypeNode->TypeClass) {
  case type_SDL_Integer:
    ENCODE_INT(SDL_Integer,*(SDL_Integer *)Value,Coder);
    return;

  case type_SDL_Natural:
    ENCODE_UNSIGNED_INT(SDL_Natural,*(SDL_Natural *)Value,Coder);
    return;

  case type_SDL_ShortInt:
    ENCODE_INT(short int,*(short int *)Value,Coder);
    return;

  case type_SDL_LongInt:
    ENCODE_INT(long int,*(long int *)Value,Coder);
    return;

  case type_SDL_UnsignedShortInt:
    ENCODE_UNSIGNED_INT(unsigned short,*(unsigned short *)Value,Coder);
    return;

  case type_SDL_UnsignedInt:
    ENCODE_UNSIGNED_INT(unsigned,*(unsigned *)Value,Coder);
    return;

  case type_SDL_UnsignedLongInt:
    ENCODE_UNSIGNED_INT(unsigned long,*(unsigned long *)Value,Coder);
    return;

#ifndef XNOUSE_LONG_LONG
  case type_SDL_LongLongInt:
    ENCODE_INT(xlonglong,*(xlonglong *)Value,Coder);
    return;

  case type_SDL_UnsignedLongLongInt:
    ENCODE_UNSIGNED_INT(unsigned xlonglong,*(unsigned xlonglong *)Value,Coder);
    return;
#endif

#ifndef XNOUSEOFREAL
  case type_SDL_Real:
    ENCODE_REAL(SDL_Real,*(SDL_Real *)Value,CODER_ASCII_REAL_DECIMALS,Coder);
    return;
#endif /* ifndef XNOUSEOFREAL */

  case type_SDL_Float:
    ENCODE_REAL(float,*(float *)Value,CODER_ASCII_FLOAT_DECIMALS,Coder);
    return;

  case type_SDL_Boolean:
    if (*(SDL_Boolean *)Value)
      ASCIIPutByte(Coder, 'T');
    else ASCIIPutByte(Coder, 'F');
    return;

  case type_SDL_Character:
    ASCIIPutByte(Coder, *(SDL_Character *)Value);
    return;

  case type_SDL_Time:
  case type_SDL_Duration:
    {
      LOCAL_TIME_INT  l_sec;
      LOCAL_TIME_INT  l_nsec;

#if defined(XTIMEASINT_SECS)
      l_sec = *(SDL_Duration*)Value;
      l_nsec = 0;
#elif defined(XTIMEASINT_TICKS)
      l_sec = *(SDL_Duration*)Value/SDT_TICKPERSEC;
      l_nsec =(*(SDL_Duration*)Value%SDT_TICKPERSEC)* SDT_NANOSECPERTICK;
#else /* not XTIMEASINT_SECS and not XTIMEASINT_TICKS */
      l_sec  = ((SDL_Duration*)Value)->s;
      l_nsec = ((SDL_Duration*)Value)->ns;
#endif /* !defined(XTIMEASINT_TICKS) && !defined(XTIMEASINT_SECS) */

      ASCIIPutByte(Coder, '{');
      ENCODE_INT(LOCAL_TIME_INT,l_sec,Coder);
      ASCIIPutByte(Coder, ',');
      ENCODE_INT(LOCAL_TIME_INT,l_nsec,Coder);
      ASCIIPutByte(Coder, '}');
    }
    return;

#ifndef XNOUSEOFCHARSTRING
  case type_SDL_Charstring:
  case type_SDL_IA5String:
  case type_SDL_NumericString:
  case type_SDL_PrintableString:
  case type_SDL_VisibleString:
    {
#ifdef XRMTDBG
      xbool isInvalid;
#endif
      SDL_Charstring c;
      c = *(SDL_Charstring *)Value;
#ifdef XRMTDBG
      /* Null pointer is okay for Charstring, means "" */
      isInvalid = c && !xAddrIsReadable(c, 1);
      if (isInvalid) {
	ASCII_ENC_ERROR(Coder,ec_ERROR_DECODING_CHARSTRING);
	return;
      }
#endif
      ASCIIPutByte(Coder, '\'');
      if (c) {
	for (c++; *c != '\0'; c++) {
	  if (*c == '\'') ASCIIPutByte(Coder, '\'');
	  ASCIIPutByte(Coder, *c);
	}
      }
      ASCIIPutByte(Coder, '\'');
    }
    return;
#endif /* ifndef XNOUSEOFCHARSTRING */

  case type_SDL_Bit:
    {
      if (*(SDL_Bit *)Value == 0) 
	ASCIIPutByte(Coder, '0');
      else ASCIIPutByte(Coder, '1');
    }
    return;

#ifndef XNOUSEOFOCTETBITSTRING
  case type_SDL_Bit_string:
    {
      int i;

      ASCIIPutByte(Coder, '\'');
      for (i=0; i<((SDL_Bit_String *)Value)->Length; i++) {
	if (((SDL_Bit_String *)Value)->Bits[i] == (SDL_Bit)0) 
	  ASCIIPutByte(Coder, '0');
	else ASCIIPutByte(Coder, '1');
      }
      ASCIIPutByte(Coder, '\'');
    }
    return;
#endif /* ifndef XNOUSEOFOCTETBITSTRING */

#ifndef XNOUSEOFOCTETBITSTRING
  case type_SDL_Octet:
    {
      int oct;

      oct = ((int)(*(SDL_Octet *)Value)) / 16;
      if (oct <= 9)
	ASCIIPutByte(Coder, (unsigned char)(oct+'0'));
      else ASCIIPutByte(Coder, (unsigned char)(oct-10+'a'));
      oct = ((int)(*(SDL_Octet *)Value)) % 16;
      if (oct <= 9)
	ASCIIPutByte(Coder, (unsigned char)(oct+'0'));
      else ASCIIPutByte(Coder, (unsigned char)(oct-10+'a'));
    }
    return;
#endif /* ifndef XNOUSEOFOCTETBITSTRING */ 

#ifndef XNOUSEOFOCTETBITSTRING
  case type_SDL_Octet_string:
    {
      int i, oct;

      ASCIIPutByte(Coder, '\'');
      for (i=0; i<((SDL_Octet_String *)Value)->Length; i++) {
	oct = (int)(((SDL_Octet_String *)Value)->Bits[i] / 16);
	if (oct <= 9)
	  ASCIIPutByte(Coder, (unsigned char)(oct+'0'));
	else ASCIIPutByte(Coder, (unsigned char)(oct-10+'a'));
	oct = (int)(((SDL_Octet_String *)Value)->Bits[i] % 16);
	if (oct <= 9)
	  ASCIIPutByte(Coder, (unsigned char)(oct+'0'));
	else ASCIIPutByte(Coder, (unsigned char)(oct-10+'a'));
      }
      ASCIIPutByte(Coder, '\'');
    }
    return;
#endif /* ifndef XNOUSEOFOCTETBITSTRING */

  case type_SDL_NULL:
    ENCODE_INT(SDL_Null,*(SDL_Null *)Value,Coder);
    return;

  case type_SDL_SignalId:
    {
      unsigned char * c;
      c = (unsigned char *)Value;
      ASCIIPutByte(Coder, '\'');
      if (c)
	for (; *c != '\0'; c++)
	  ASCIIPutByte(Coder, *c);
      ASCIIPutByte(Coder, '\'');
    }
    return;

  case type_SDL_Syntype:
  case type_SDL_Inherits:
    AsciiEncVal(Coder, ((tSDLGenInfo *)TypeNode)->CompOrFatherSort, Value, sRefs);
    return;

  case type_SDL_Enum:
#ifdef ENUM_AS_INT
    ENCODE_INT(int,*(int*)Value,Coder);
#else
    {
      const char * c;

      c = GetEnumName(
                      *(int*)Value,
                      ((tSDLEnumInfo*)TypeNode)->LiteralList,
                      ((tSDLEnumInfo*)TypeNode)->NoOfLiterals,
                      "Enumeration type out of range");
      for (; *c != '\0'; c++)
        ASCIIPutByte(Coder, *c);
    }
#endif
    return;

#ifndef XNOUSE_STRUCT
  case type_SDL_Struct:
    {
      void * PresentAddr = 0;
      xbool isPresent;
      int i;
      
      ASCIIPutByte(Coder, '{');
      for (i = 0; i < ((tSDLStructInfo *)TypeNode)->NumOfComponents; i++) {
	if (i>0) ASCIIPutByte(Coder, ',');
        if (((tSDLStructInfo *)TypeNode)->Components[i].Offset == (xptrint)~0) {
          /* Bit field */
          int bf_val = 0;          /* bit field value */
          if (((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo &&
              (((tSDLFieldBitFInfo*)(((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo))->GetTag)) {
            bf_val = ((tSDLFieldBitFInfo*)
                      (((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo))->GetTag(Value);
          }
          ENCODE_INT(int, bf_val, Coder);
          continue;
        }

	isPresent = (xbool)1;
	if (((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo != NULL) {
	  if (((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo->OffsetPresent > 0) {
	    PresentAddr = (void *)((xptrint)Value +
				   ((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo->OffsetPresent);

	    AsciiEncVal(Coder, &ySDL_SDL_Boolean, PresentAddr, sRefs);
	    if ( ((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo->DefaultValue )
	      isPresent = (xbool)1;
	    else if (*(SDL_Boolean *)(PresentAddr))
	      isPresent = (xbool)1;
	    else isPresent = (xbool)0;
	    if (isPresent) ASCIIPutByte(Coder,',');
	  }
	}

	if (isPresent)
	  AsciiEncVal(Coder, ((tSDLStructInfo *)TypeNode)->Components[i].CompSort,
		      (void *)((xptrint)Value + ((tSDLStructInfo *)TypeNode)->Components[i].Offset),sRefs);
      }
      ASCIIPutByte(Coder, '}');
    }
    return;
#endif /* XNOUSE_STRUCT */

  case type_SDL_Signal:
    {
      int i;
      
      ASCIIPutByte(Coder, '{');
      for (i = 0; i < ((tSDLSignalInfo *)TypeNode)->NoOfPara; i++) {
	if (i>0) ASCIIPutByte(Coder, ',');
	AsciiEncVal(Coder, ((tSDLSignalInfo *)TypeNode)->Param[i].ParaSort,
		    (void *)((xptrint)Value + ((tSDLSignalInfo *)TypeNode)->Param[i].Offset), 
		    sRefs);
      }
      ASCIIPutByte(Coder, '}');
    }
    return;

#if !defined(XNOUSE_CHOICE) || !defined(XNOUSE_UNION)
  case type_SDL_Choice:
  case type_SDL_Union:
    {
      int tag_index;

      tag_index = GenericGetValue(((tSDLChoiceInfo *)TypeNode)->TagSortSize, Value);
      ASCIIPutByte(Coder, '{');
      ENCODE_INT(int,tag_index,Coder);
      ASCIIPutByte(Coder, ',');
      AsciiEncVal(Coder, ((tSDLChoiceInfo *)TypeNode)->Components[tag_index].CompSort,
		  (void *)((xptrint)Value + ((tSDLChoiceInfo *)TypeNode)->OffsetToUnion),
		  sRefs);
      ASCIIPutByte(Coder, '}');
    }
    return;
#endif/* if !defined(XNOUSE_CHOICE) || !defined(XNOUSE_UNION) */

  case type_SDL_Powerset:
    {
      int             i,j,nLongs;
      unsigned long * longArr;
      unsigned long   curLong;
      int             first = 1;
      unsigned long   TValue;
      void*           valPtr = (void*)&TValue;

      nLongs = ((tSDLPowersetInfo *)TypeNode)->SortSize / sizeof(unsigned long);
      longArr = (unsigned long *)Value;
      ASCIIPutByte(Coder, '{');
      for (i=0; i<nLongs; i++) {
	curLong = longArr[i];
	for (j = 0; j<32; j++) {
	  if (curLong%2 == 1) {
            if (!first) {
              ASCIIPutByte(Coder, ',');
            }
            else {
              first = 0;
            }
            GenericSetValue(((tSDLPowersetInfo *)TypeNode)->CompSort->SortSize,
                            valPtr, 
                            (((unsigned) i) << 5 ) +j+((tSDLPowersetInfo *)TypeNode)->LowestValue);
            AsciiEncVal(Coder, ((tSDLPowersetInfo *)TypeNode)->CompSort,
                        valPtr, sRefs);
          }
	  curLong = curLong / 2;
	};
      };
      ASCIIPutByte(Coder, '}');
    }
    return;

#ifndef XNOUSE_BAG_GENERATOR
  case type_SDL_Bag:
    {
      xBag_Type * hPtr;
      xBag_yrec * ptr;
      int         no;
      
      hPtr = (xBag_Type *)Value;
      ASCIIPutByte(Coder, '{');
      if (hPtr->Length == 0) 
	ptr = NULLPTR;
      else ptr = hPtr->First;
      while(ptr != NULLPTR) {
        for (no = 1; no <= ptr->NoOfItems; no++) {
          if (ptr != hPtr->First || no > 1)
            ASCIIPutByte(Coder, ',');
          AsciiEncVal(Coder, ((tSDLGenListInfo *)TypeNode)->CompSort,
                      (void *)((xptrint)ptr+((tSDLGenListInfo *)TypeNode)->yrecDataOffset),
                      sRefs);
        }
	if (ptr == hPtr->Last)
	  ptr = NULLPTR;
	else
	  ptr = ptr->Suc;
      }
      ASCIIPutByte(Coder, '}');
    }
    return;
#endif /* ifndef XNOUSE_BAG_GENERATOR */

  case type_SDL_Object_identifier:
  case type_SDL_GPowerset:
  case type_SDL_String:
    {
      xString_Type * hPtr;
      xString_yrec * ptr;
      
      hPtr = (xString_Type *)Value;
      ASCIIPutByte(Coder, '{');
      if (hPtr->Length == 0) 
	ptr = NULLPTR;
      else ptr = hPtr->First;
      while(ptr != NULLPTR) {
	if (ptr != hPtr->First)
	  ASCIIPutByte(Coder, ',');
	AsciiEncVal(Coder, ((tSDLGenListInfo *)TypeNode)->CompSort,
		    (void *)((xptrint)ptr+((tSDLGenListInfo *)TypeNode)->yrecDataOffset),
		    sRefs);
	if (ptr == hPtr->Last)
	  ptr = NULLPTR;
	else
	  ptr = ptr->Suc;
      }
      ASCIIPutByte(Coder, '}');
    }
    return;

#ifndef XNOUSE_LSTRING_GENERATOR
  case type_SDL_LString:
    {
      int i;
      int len;
      void * CurrAddr;

      ASCIIPutByte(Coder,'{');
      CurrAddr = (void *)((xptrint)Value + ((tSDLLStringInfo *)TypeNode)->DataOffset); 
      len = ((xLString_Type*)Value)->Length;
      for ( i=0; i<len; i++ ) {
	if (i > 0) ASCIIPutByte(Coder, ',');
	AsciiEncVal(Coder, ((tSDLLStringInfo *)TypeNode)->CompSort,CurrAddr, sRefs);
	CurrAddr = (void*)((xptrint)CurrAddr + ((tSDLLStringInfo *)TypeNode)->CompSort->SortSize);
      }
      ASCIIPutByte(Coder,'}');
    }
    return;
#endif /* ifndef XNOUSE_LSTRING_GENERATOR */

#if !defined(XNOUSE_ARRAY_GENERATOR) || !defined(XNOUSE_CARRAY_GENERATOR)
  case type_SDL_Array:
  case type_SDL_Carray:
    {
      void * CurrAddr;
      int i;
      
      CurrAddr = Value;
      ASCIIPutByte(Coder, '{');
      for (i=0; i < ((tSDLArrayInfo *)TypeNode)->Length; i++) {
	if (i > 0) ASCIIPutByte(Coder, ',');
	AsciiEncVal(Coder, ((tSDLArrayInfo *)TypeNode)->CompSort,CurrAddr, sRefs);
	CurrAddr = (void *)((xptrint)CurrAddr + ((tSDLArrayInfo *)TypeNode)->CompSort->SortSize);
      }
      ASCIIPutByte(Coder, '}');
    }
    return;
#endif /* if !defined(XNOUSE_ARRAY_GENERATOR) || !defined(XNOUSE_CARRAY_GENERATOR) */

#ifndef XNOUSE_GARRAY_GENERATOR
  case type_SDL_GArray:
    {
      xGArray_yrec * ptr;
      
      ASCIIPutByte(Coder, '{');
      ASCIIPutByte(Coder, ':');
      AsciiEncVal(Coder, ((tSDLGArrayInfo *)TypeNode)->CompSort,
		  (void *)((xptrint)Value+((tSDLGArrayInfo *)TypeNode)->arrayDataOffset),
		  sRefs);
      ptr = ((xGArray_Type *)Value)->First;
      while(ptr != NULLPTR) {
	ASCIIPutByte(Coder, ',');
	AsciiEncVal(Coder, ((tSDLGArrayInfo *)TypeNode)->IndexSort,
		    (void *)((xptrint)ptr+((tSDLGArrayInfo *)TypeNode)->yrecIndexOffset),
		    sRefs);
	ASCIIPutByte(Coder, ':');
	AsciiEncVal(Coder, ((tSDLGArrayInfo *)TypeNode)->CompSort,
		    (void *)((xptrint)ptr+((tSDLGArrayInfo *)TypeNode)->yrecDataOffset),
		    sRefs);
	if (ptr == ((xGArray_Type *)Value)->Last)
	  ptr = NULLPTR;
	else
	  ptr = ptr->Suc;
      }
      ASCIIPutByte(Coder, '}');
    }
    return;
#endif /* ifndef XNOUSE_GARRAY_GENERATOR */

#if !defined(XNOUSE_OWN_GENERATOR) || !defined(XNOUSE_REF_GENERATOR)
  case type_SDL_Own:
  case type_SDL_Oref:
  case type_SDL_Ref:
    {
      int index;
      int encvalue;
      void * addr;

      addr = (void *)(*(xptrint *)Value);
      if ( addr == NULLPTR ) {
	ASCIIPutByte(Coder, '{');
	ASCIIPutByte(Coder, '}');
	return;
      }

      if ( *sRefs == NULLPTR ) *sRefs = InitRefArray(Coder);
      encvalue = 0;
      index = GetRefIndex(*sRefs,addr);
      if ( index < 0 ) {
	encvalue = 1;
        index = StoreRefAddr(*sRefs,addr,-1,Coder);
      }
      ASCIIPutByte(Coder, '{');
      ENCODE_INT(int,index,Coder);
      if ( encvalue ) {
	ASCIIPutByte(Coder, 'V');
	AsciiEncVal(Coder, ((tSDLGenInfo *)TypeNode)->CompOrFatherSort,addr,sRefs);
      }
      else 
	ASCIIPutByte(Coder, 'A');
      ASCIIPutByte(Coder, '}');
    }
    return;
#endif /* if !defined(XNOUSE_OWN_GENERATOR) || !defined(XNOUSE_REF_GENERATOR) */

#ifdef THREADLIGHT
  case type_SDL_Pid:
    {
      ASCIIPutByte(Coder,'{');
      ENCODE_INT(int, ((SDL_PId*)Value)->GlobalNodeNr,Coder);
      ASCIIPutByte(Coder,',');
      ENCODE_UNSIGNED_INT(xptrint,(xptrint)(((SDL_PId*)Value)->LocalPId),Coder);
      ASCIIPutByte(Coder,'}');
    }
    return;
#endif

  case type_SDL_Voidstar:     /* Encode */
    {
      char Buffer[200];
      char *c;

      sprintf(Buffer, "%x", *(void**)Value);
      ASCIIPutByte(Coder, '\'');
      for (c = Buffer; *c != '\0'; c++) {
        ASCIIPutByte(Coder, *c);
      }
      ASCIIPutByte(Coder, '\'');
      ASCIIPutByte(Coder, 'h');
    }
    return;

  case type_SDL_Charstar:
  case type_SDL_Userdef:     /* Encode */
    if ( ! strcmp(TypeNode->Name, "ptr_char") ) {
      SDL_Charstring c;
      c = *(SDL_Charstring *)Value;
      ASCIIPutByte(Coder, '\'');
      if (c) {
	for (c; *c != '\0'; c++) {
	  if (*c == '\'') ASCIIPutByte(Coder, '\'');
	  ASCIIPutByte(Coder, *c);
	}
      }
      ASCIIPutByte(Coder, '\'');
    }
    return;

  case type_SDL_UnionC:
#ifndef THREADLIGHT
  case type_SDL_Pid:
#endif
  case type_SDL_Voidstarstar:
    {
      int errorcode;
      ASCIIPutByte(Coder, '{');
      ASCII_CHECK_ERROR(AsciiUserEncode==NULLPTR,Coder,
			ec_ERROR_DECODING_USERDEF);
      errorcode = AsciiUserEncode(Coder,TypeNode,Value);
      ASCII_CHECK_ERROR(errorcode!=ec_SUCCESS,Coder,errorcode);
      ASCIIPutByte(Coder, '}');
    }
    return;

  default:
    /* error */
    ASCII_ENC_ERROR(Coder,ec_ERROR_UNKNOWN_TYPE_NODE);
  };
}



void AsciiDecVal(tCoder* Coder, tSDLTypeInfo* TypeNode, void* Value,
                 tStoredRefs ** sRefs)
{
  if (AsciiUserPreDecode) {
    int errorcode;
    errorcode = AsciiUserPreDecode(Coder,TypeNode,Value);
    if (errorcode==ec_SUCCESS) {
      /* decoding managed by AsciiUserPreDecode */
      return;
    }
   /* decoding not managed by AsciiUserPreDecode, continue with default encoding */
  }

  switch (TypeNode->TypeClass) {
  case type_SDL_Integer:
    DECODE_INT(SDL_Integer,*(SDL_Integer *)Value,Coder);
    return;

  case type_SDL_Natural:
    DECODE_UNSIGNED_INT(SDL_Natural,*(SDL_Natural *)Value,Coder);
    return;

  case type_SDL_ShortInt:
    DECODE_INT(short int,*(short int *)Value,Coder);
    return;

  case type_SDL_LongInt:
    DECODE_INT(long int,*(long int *)Value,Coder);
    return;

  case type_SDL_UnsignedShortInt:
    DECODE_UNSIGNED_INT(unsigned short,*(unsigned short *)Value,Coder);
    return;

  case type_SDL_UnsignedInt:
    DECODE_UNSIGNED_INT(unsigned,*(unsigned *)Value,Coder);
    return;

  case type_SDL_UnsignedLongInt:
    DECODE_UNSIGNED_INT(unsigned long,*(unsigned long *)Value,Coder);
    return;

#ifndef XNOUSE_LONG_LONG
  case type_SDL_LongLongInt:
    DECODE_INT(xlonglong,*(xlonglong *)Value,Coder);
    return;

  case type_SDL_UnsignedLongLongInt:
    DECODE_UNSIGNED_INT(unsigned xlonglong,*(unsigned xlonglong *)Value,Coder);
    return;
#endif

#ifndef XNOUSEOFREAL
  case type_SDL_Real:
    DECODE_REAL(SDL_Real,*(SDL_Real *)Value,Coder);
    return;
#endif /* ifndef XNOUSEOFREAL */

  case type_SDL_Float:
    DECODE_REAL(float,*(float *)Value,Coder);
    return;

  case type_SDL_Voidstar:      /* Decode */
    {
      char Buffer[200];
      unsigned char b;
      unsigned int i = 0;

      if (ASCIIGetByte(Coder) != '\'')
        ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);
      b = ASCIIPeekByte(Coder);
      if ( ! ('a'<=b && b<='f' || 'A'<=b && b<='F' || '0'<=b && b<='9') )
        ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_INTEGER);
      for( ;
           'a'<=b && b<='f' || 'A'<=b && b<='F' || '0'<=b && b<='9';
           b = ASCIIPeekByte(Coder)) {
        Buffer[i++] = ASCIIGetByte(Coder);
      }
      Buffer[i] = '\0';
      if (ASCIIGetByte(Coder) != '\'')
        ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);
      if (ASCIIGetByte(Coder) != 'h')
        ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);
      sscanf(Buffer, "%x", Value);
      return;
    }

  case type_SDL_Boolean:
    {
      unsigned char b;
      b = ASCIIGetByte(Coder);
      if (b=='T')
	*(SDL_Boolean *)Value = (xbool)1;
      else if (b=='F')
	*(SDL_Boolean *)Value = (xbool)0;
      else
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BOOLEAN);
    }
    return;

  case type_SDL_Character:
    *(SDL_Character *)Value = ASCIIGetByte(Coder);
    return;

  case type_SDL_Time:
  case type_SDL_Duration:
    {
      LOCAL_TIME_INT  l_sec;
      LOCAL_TIME_INT  l_nsec;
      if (ASCIIGetByte(Coder) != '{') 
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_TIME);
      DECODE_INT(LOCAL_TIME_INT,l_sec,Coder);
      if (ASCIIGetByte(Coder) != ',')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_TIME);
      DECODE_INT(LOCAL_TIME_INT,l_nsec,Coder);
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_TIME);

#if defined(XTIMEASINT_SECS)
      *(SDL_Duration*)Value = l_sec;
#elif defined(XTIMEASINT_TICKS)
      *(SDL_Duration*)Value = (SDL_Duration)(l_sec*SDT_TICKPERSEC+l_nsec/SDT_NANOSECPERTICK);
#else /* not XTIMEASINT_SECS and not XTIMEASINT_TICKS */
      ((SDL_Duration*)Value)->s  = l_sec;
      ((SDL_Duration*)Value)->ns = l_nsec;
#endif /* !defined(XTIMEASINT_TICKS) && !defined(XTIMEASINT_SECS) */
    }
    return;

#ifndef XNOUSEOFCHARSTRING
  case type_SDL_Charstring:
  case type_SDL_IA5String:
  case type_SDL_NumericString:
  case type_SDL_PrintableString:
  case type_SDL_VisibleString:
    {
      int len,freeTemp;
      unsigned char tempSeg[ASCII_FIRST_SIZE];
      unsigned char * tempStr;

      if (ASCIIGetByte(Coder) != '\'')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_CHARSTRING);

      CopyToTempStr(Coder,&tempStr,tempSeg,sizeof(tempSeg),
		    1,&len,&freeTemp);

      *(SDL_Charstring*)Value = (SDL_Charstring)CUCFAlloc(Coder,len+2, 0);
      (*(SDL_Charstring*)Value)[0]='V';
      (void)memcpy(&((*(SDL_Charstring*)Value)[1]),tempStr,len);
      if (freeTemp) CUCFFree(Coder,tempStr,0,0);
      (*(SDL_Charstring*)Value)[len+1]='\0';
    }
    return;
#endif /* ifndef XNOUSEOFCHARSTRING */

  case type_SDL_Bit:
    {
      unsigned char b;
      b = ASCIIGetByte(Coder);
      if (b == '0') 
	*(SDL_Bit *)Value = (SDL_Bit)0;
      else if (b == '1') 
	*(SDL_Bit *)Value = (SDL_Bit)1;
      else
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BIT);
    }
    return;

#ifndef XNOUSEOFOCTETBITSTRING
  case type_SDL_Bit_string:
    {
      int i,len,freeTemp;
      unsigned char tempSeg[ASCII_FIRST_SIZE];
      unsigned char * tempStr;

      if (ASCIIGetByte(Coder) != '\'')
 	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BITSTRING);

      CopyToTempStr(Coder,&tempStr,tempSeg,sizeof(tempSeg),
		    0,&len,&freeTemp);

      ((SDL_Bit_String *)Value)->Length = len;
      ((SDL_Bit_String *)Value)->IsAssigned = (xbool)1;
      if (len == 0)
	((SDL_Bit_String *)Value)->Bits = NULLPTR;
      else {
	((SDL_Bit_String *)Value)->Bits = (SDL_Bit *)CUCFAlloc(Coder,len, 0);
      }

      for (i=0; i<len; i++) {
	if (tempStr[i] == '0') 
	  ((SDL_Bit_String *)Value)->Bits[i]= (SDL_Bit)0;
	else if (tempStr[i] == '1') 
	  ((SDL_Bit_String *)Value)->Bits[i]= (SDL_Bit)1;
	else
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BITSTRING);
      }
      if (freeTemp) CUCFFree(Coder,tempStr,0,0);
    }
    return;
#endif /* ifndef XNOUSEOFOCTETBITSTRING */ 

#ifndef XNOUSEOFOCTETBITSTRING
  case type_SDL_Octet:
    {
      unsigned char b;
      int oct=0;

      b = ASCIIGetByte(Coder);
      if ('a' <= b && b <= 'f')
	oct = b - 'a' + 10;
      else if ('0' <= b && b <= '9')
	oct = b - '0';
      else ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTET);
      oct = oct * 16;
      b = ASCIIGetByte(Coder);
      if ('a' <= b && b <= 'f')
	oct = oct + b - 'a' + 10;
      else if ('0' <= b && b <= '9')
	oct = oct + b - '0';
      else ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTET);
      *(SDL_Octet *)Value = (SDL_Octet)oct;
    }
    return;
#endif /* ifndef XNOUSEOFOCTETBITSTRING */

#ifndef XNOUSEOFOCTETBITSTRING
  case type_SDL_Octet_string:
    {
      int i,index,len,freeTemp,oct=0;
      unsigned char b;
      unsigned char tempSeg[ASCII_FIRST_SIZE];
      unsigned char * tempStr;

      if (ASCIIGetByte(Coder) != '\'')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);

      CopyToTempStr(Coder,&tempStr,tempSeg,sizeof(tempSeg),
		    0,&len,&freeTemp);

      if ( len % 2)
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);

      len = len / 2; /* two ascii chars for each octet */

      ((SDL_Octet_String *)Value)->Length = len;
      ((SDL_Octet_String *)Value)->IsAssigned = (xbool)1;
      if (len == 0)
	((SDL_Octet_String *)Value)->Bits = NULLPTR;
      else {
	((SDL_Octet_String *)Value)->Bits = (SDL_Octet *)CUCFAlloc(Coder,len, 0);
      }

      index = 0;
      for (i=0; i<len; i++) {
	b = tempStr[index++];
	if ('a' <= b && b <= 'f')
	  oct = b - 'a' + 10;
	else if ('0' <= b && b <= '9')
	  oct = b - '0';
	else ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);
    	oct = oct * 16;
	b = tempStr[index++];
	if ('a' <= b && b <= 'f')
	  oct = oct + b - 'a' + 10;
	else if ('0' <= b && b <= '9')
	  oct = oct + b - '0';
	else ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_OCTETSTRING);
	((SDL_Octet_String *)Value)->Bits[i] = (SDL_Octet)oct;
      }
      if (freeTemp) CUCFFree(Coder,tempStr,0,0);
    }
    return;
#endif /* ifndef XNOUSEOFOCTETBITSTRING */

  case type_SDL_NULL:
    DECODE_INT(SDL_Null,*(SDL_Null *)Value,Coder);
    return;

  case type_SDL_SignalId:
    {
      int i;
      unsigned char b;

      if (ASCIIGetByte(Coder) != '\'')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_SIGNALID);

      i=0;
      while((b=ASCIIGetByte(Coder))!='\'') {
	((unsigned char *)Value)[i++] = b;
      }

      ((unsigned char *)Value)[i]='\0';
    }
    return;

  case type_SDL_Syntype:
  case type_SDL_Inherits:
    AsciiDecVal(Coder, ((tSDLGenInfo *)TypeNode)->CompOrFatherSort, Value, sRefs);
    return;

  case type_SDL_Enum:
#ifdef ENUM_AS_INT
    DECODE_INT(int,*(int*)Value,Coder);
#else
    {
      int i;
      char tempStr[ASCII_FIRST_SIZE+1];
      unsigned char b;

      i = 0;
      b = ASCIIPeekByte(Coder);
      while (b != '}' && b != ',' && i < ASCII_FIRST_SIZE) {
        tempStr[i++] = ASCIIGetByte(Coder);
        b = ASCIIPeekByte(Coder);
      }
      tempStr[i] = '\0';
      i = GetEnumIndex( tempStr, 
                        ((tSDLEnumInfo*)TypeNode)->LiteralList,
                        ((tSDLEnumInfo*)TypeNode)->NoOfLiterals );
      if ( i < 0 )
        ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_INTEGER);

      *(int*)Value = ((tSDLEnumInfo*)TypeNode)->LiteralList[i].LiteralValue;
    }
#endif
    return;
 
#ifndef XNOUSE_STRUCT
  case type_SDL_Struct:
    {
      int     i;
      void *           PresentAddr = NULL;
      tSDLStructInfo * structNode;
      xbool            isPresent;

      structNode = (tSDLStructInfo *)TypeNode;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);

      for (i = 0; i < structNode->NumOfComponents; i++) {
	isPresent = (xbool)1;
	if (i>0)
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
        if (structNode->Components[i].Offset == (xptrint)~0) {
          /* Bit field */
          int bf_val = 0;          /* bit field value */
          AsciiDecVal(Coder, structNode->Components[i].CompSort, (void*)&bf_val, sRefs);
          /* Real assign of bit fields */
          ((tSDLFieldBitFInfo*)(structNode->Components[i].ExtraInfo))->AssTag(Value, bf_val);
          continue;
        }

	if (structNode->Components[i].ExtraInfo != NULL ) {
	  if (structNode->Components[i].ExtraInfo->OffsetPresent > 0) {
	    PresentAddr = (void *)((xptrint)Value + structNode->Components[i].ExtraInfo->OffsetPresent);
	    AsciiDecVal(Coder,&ySDL_SDL_Boolean,PresentAddr,sRefs);
	    if ( ((tSDLStructInfo *)TypeNode)->Components[i].ExtraInfo->DefaultValue ) {
	      isPresent = (xbool)1;
	      if (ASCIIGetByte(Coder) != ',')
		ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
	    }
            else if(*(SDL_Boolean *)(PresentAddr)){
	      isPresent = (xbool)1;
	      if (ASCIIGetByte(Coder) != ',')
		ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
	    }
	    else {
	      isPresent = (xbool)0;
	      (void)memset((void *)((xptrint)Value + structNode->Components[i].Offset),
			   0, 
			   structNode->Components[i].ExtraInfo->OffsetPresent-structNode->Components[i].Offset);
	    }
	  }
	}
	if (isPresent)
	  AsciiDecVal(Coder, structNode->Components[i].CompSort,
		      (void *)((xptrint)Value + structNode->Components[i].Offset),
		      sRefs);
          
      }
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
    }
    return;
#endif /* ifndef XNOUSE_STRUCT */

 case type_SDL_Signal:
    {
      int     i;
      tSDLSignalInfo * sigNode;

      sigNode = (tSDLSignalInfo *)TypeNode;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
      for (i = 0; i < sigNode->NoOfPara; i++) {
	if (i>0)
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
	AsciiDecVal(Coder, sigNode->Param[i].ParaSort,
		    (void *)((xptrint)Value + sigNode->Param[i].Offset),
		    sRefs);
      }
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRUCT);
    }
    return;


#if !defined(XNOUSE_CHOICE) || !defined(XNOUSE_UNION)
  case type_SDL_Choice:
  case type_SDL_Union:
    {
      int tag_index;
      
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_CHOICE);

      DECODE_INT(int,tag_index,Coder);
      GenericSetValue(((tSDLChoiceInfo *)TypeNode)->TagSortSize, Value, tag_index);
      if (ASCIIGetByte(Coder) != ',')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_CHOICE);
      AsciiDecVal(Coder, ((tSDLChoiceInfo *)TypeNode)->Components[tag_index].CompSort,
		  (void *)((xptrint)Value + (((tSDLChoiceInfo *)TypeNode)->OffsetToUnion)),
		  sRefs);
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_CHOICE);
    }
    return;
#endif /* if !defined(XNOUSE_CHOICE) || !defined(XNOUSE_UNION) */    

  case type_SDL_Powerset:
    {
      int             i,j;
      unsigned long * longArr;
      int             i_max = ((tSDLPowersetInfo*)TypeNode)->Length;
      unsigned long   TValue;
      void*           valPtr = (void*)&TValue;
      xbool           isFirst = 1;

      longArr = (unsigned long *)Value;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_POWERSET);
      /* Clear the bit mask */
      for ( i = 0, j = 0; i < i_max; i += 32, ++j ) {
        longArr[j] = 0;
      }
      while(ASCIIPeekByte(Coder) != '}') {
	if (isFirst)
	  isFirst = 0;
	else
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BAG);
	AsciiDecVal(Coder, ((tSDLPowersetInfo *)TypeNode)->CompSort,
		    valPtr, sRefs);
        i = GenericGetValue(((tSDLPowersetInfo *)TypeNode)->CompSort->SortSize, valPtr);
        i -= ((tSDLPowersetInfo*)TypeNode)->LowestValue;
        if ( i < 0 || i >= i_max)
          ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BAG);
        longArr[ ( (unsigned)i) >> 5 ] |= 1U << ( ((unsigned)i) & 0x1f );
      }
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_POWERSET);
    }
    return;
    
#ifndef XNOUSE_BAG_GENERATOR
  case type_SDL_Bag:
    {
      xBag_Type * hPtr;
      void * Item;
      xbool          isFirst;

      hPtr = (xBag_Type *)Value;
      hPtr->First = NULLPTR;
      hPtr->Last = NULLPTR;
      hPtr->IsAssigned = (xbool)0;
      hPtr->Length = 0;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BAG);
      isFirst = 1;
      /* Create a temporary Item */
      Item = (void *)CUCFAlloc(Coder, ((tSDLGenListInfo *)TypeNode)->CompSort->SortSize, 0);
      while(ASCIIPeekByte(Coder) != '}') {
	if (isFirst)
	  isFirst = 0;
	else
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BAG);
	AsciiDecVal(Coder, ((tSDLGenListInfo *)TypeNode)->CompSort,
		    Item,
		    sRefs);
        GenBag_Incl2( Item, hPtr, (tSDLGenListInfo*)TypeNode );
      }
      CUCFFree(Coder, Item, 0, 0);
      hPtr->IsAssigned = (xbool)1;
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_BAG);
    }
    return;
#endif /* ifndef XNOUSE_BAG_GENERATOR */    

  case type_SDL_Object_identifier:
  case type_SDL_GPowerset:
  case type_SDL_String:
    {
      xString_Type * hPtr;
      xString_yrec * ptr;
      xbool          isFirst;
      
      hPtr = (xString_Type *)Value;
      hPtr->First = NULLPTR;
      hPtr->Last = NULLPTR;
      hPtr->IsAssigned = (xbool)1;
      hPtr->Length = 0;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
      isFirst = 1;
      while(ASCIIPeekByte(Coder) != '}') {
	if (isFirst)
	  isFirst = 0;
	else
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
	ptr = (xString_yrec *)CUCFAlloc(Coder,((tSDLGenListInfo *)TypeNode)->yrecSize, 0);
	ptr->Suc = NULLPTR;
	if (hPtr->First == NULLPTR) hPtr->First = ptr;
	if (hPtr->Last != NULLPTR) hPtr->Last->Suc = ptr;
	hPtr->Last = ptr;
	hPtr->Length++;
	AsciiDecVal(Coder, ((tSDLGenListInfo *)TypeNode)->CompSort,
		    (void *)((xptrint)ptr+((tSDLGenListInfo *)TypeNode)->yrecDataOffset),
		    sRefs);
      }
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
    }
    return;

#ifndef XNOUSE_LSTRING_GENERATOR
  case type_SDL_LString:
    {
      void * CurrAddr;
      xbool isFirst;
      
      ((xLString_Type*)Value)->Length = 0;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
      
      CurrAddr = (void *)((xptrint)Value + ((tSDLLStringInfo *)TypeNode)->DataOffset);
      isFirst = 1;
      while( ASCIIPeekByte(Coder) != '}' ) {
	if (isFirst)
	  isFirst = 0;
	else
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
        if (((xLString_Type*)Value)->Length>=((tSDLLStringInfo*)TypeNode)->MaxLength)
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
	AsciiDecVal(Coder, ((tSDLLStringInfo *)TypeNode)->CompSort,CurrAddr,sRefs);
	((xLString_Type*)Value)->Length++;
	CurrAddr = (void *)((xptrint)CurrAddr + ((tSDLLStringInfo *)TypeNode)->CompSort->SortSize);
      }
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_STRING);
    }
    return;
#endif /* ifndef XNOUSE_LSTRING_GENERATOR */


#if !defined(XNOUSE_ARRAY_GENERATOR) || !defined(XNOUSE_CARRAY_GENERATOR)
  case type_SDL_Array:
  case type_SDL_Carray:
    {
      void * CurrAddr;
      int i;
      
      CurrAddr = Value;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
      for (i=0; i < ((tSDLArrayInfo *)TypeNode)->Length; i++) {
	if (i > 0)
	  if (ASCIIGetByte(Coder) != ',')
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
	AsciiDecVal(Coder, ((tSDLArrayInfo *)TypeNode)->CompSort,CurrAddr,sRefs);
	CurrAddr = (void *)((xptrint)CurrAddr + ((tSDLArrayInfo *)TypeNode)->CompSort->SortSize);
      }
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
    }
    return;
#endif /* if !defined(XNOUSE_ARRAY_GENERATOR) || !defined(XNOUSE_CARRAY_GENERATOR) */

#ifndef XNOUSE_GARRAY_GENERATOR
  case type_SDL_GArray:
    {
      xGArray_Type * hPtr;
      xGArray_yrec * ptr;

      hPtr = (xGArray_Type *)Value;
      hPtr->First = NULLPTR;
      hPtr->Last = NULLPTR;
      hPtr->IsAssigned = (xbool)1;
      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
      if (ASCIIGetByte(Coder) != ':')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
      AsciiDecVal(Coder,((tSDLGArrayInfo *)TypeNode)->CompSort,
		  (void *)((xptrint)Value+((tSDLGArrayInfo *)TypeNode)->arrayDataOffset),
		  sRefs);
      
      while (ASCIIPeekByte(Coder) != '}') {
	if (ASCIIGetByte(Coder) != ',')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
	ptr = (xGArray_yrec *)CUCFAlloc(Coder,((tSDLGArrayInfo *)TypeNode)->yrecSize, 0);
	ptr->Suc = NULLPTR;
	if (hPtr->First == NULLPTR) hPtr->First = ptr;
	if (hPtr->Last != NULLPTR) hPtr->Last->Suc = ptr;
	hPtr->Last = ptr;
	AsciiDecVal(Coder, ((tSDLGArrayInfo *)TypeNode)->IndexSort,
		    (void *)((xptrint)ptr+((tSDLGArrayInfo *)TypeNode)->yrecIndexOffset),
		    sRefs);
	if (ASCIIGetByte(Coder) != ':')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
	AsciiDecVal(Coder,((tSDLGArrayInfo *)TypeNode)->CompSort,
		    (void *)((xptrint)ptr+((tSDLGArrayInfo *)TypeNode)->yrecDataOffset),
		    sRefs);
      }
      if (ASCIIGetByte(Coder) != '}')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_ARRAY);
    }
    return;
#endif /* ifndef XNOUSE_GARRAY_GENERATOR */

#if !defined(XNOUSE_OWN_GENERATOR) || !defined(XNOUSE_REF_GENERATOR)
  case type_SDL_Own:
  case type_SDL_Oref:
  case type_SDL_Ref:
    {
      int index;
      unsigned char c;
      void * addr=NULL;

      if (ASCIIGetByte(Coder) != '{')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_REF);
      if (ASCIIPeekByte(Coder) == '}') {
	*(xptrint *)Value = NULLPTR;
      }
      else {
	if ( *sRefs == NULLPTR ) *sRefs = InitRefArray(Coder);
	DECODE_INT(int,index,Coder);
	c = ASCIIGetByte(Coder); 
	if ( c=='A' ) {
	  addr = GetRefAddr(*sRefs,index);
	  if (addr==NULLPTR)
	    ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_REF);
	}
	else if ( c=='V' ) {
	  addr = (void *)CUCFAlloc(Coder,((tSDLGenInfo *)TypeNode)->CompOrFatherSort->SortSize, 0);
	  (void)StoreRefAddr(*sRefs,addr,index,Coder);
	  AsciiDecVal(Coder,((tSDLGenInfo *)TypeNode)->CompOrFatherSort,addr,sRefs);
        }
	else
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_REF);
	*(xptrint *)Value = (xptrint)addr;
      }

      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_REF);
    }
    return;
#endif /* if !defined(XNOUSE_OWN_GENERATOR) || !defined(XNOUSE_REF_GENERATOR) */

#ifdef THREADLIGHT
  case type_SDL_Pid:
    {
      int nodenr;
      xptrint localptr;

      if (ASCIIGetByte(Coder) != '{') 
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_USERDEF); /* Wrong message */
      DECODE_INT(int,nodenr,Coder);
      ((SDL_PId*)Value)->GlobalNodeNr = nodenr;
      if (ASCIIGetByte(Coder) != ',') 
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_USERDEF); /* Wrong message */
      DECODE_UNSIGNED_INT(xptrint,localptr,Coder);
      ((SDL_PId*)Value)->LocalPId = (xLocalPIdNode)localptr;
      if (ASCIIGetByte(Coder) != '}') 
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_USERDEF); /* Wrong message */
    }
    return;
#endif

  case type_SDL_Charstar:
  case type_SDL_Userdef:     /* Decode */
    if ( ! strcmp(TypeNode->Name, "ptr_char") ) {
      int len, freeTemp;
      unsigned char tempSeg[ASCII_FIRST_SIZE];
      unsigned char * tempStr;

      if (ASCIIGetByte(Coder) != '\'')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_CHARSTRING);

      CopyToTempStr(Coder,&tempStr,tempSeg,sizeof(tempSeg),
		    1,&len,&freeTemp);
      *(SDL_Charstring*)Value = (SDL_Charstring)CUCFAlloc(Coder, len+1, 0);
      (void)memcpy(&((*(SDL_Charstring*)Value)[0]), tempStr, len);
      if (freeTemp) CUCFFree(Coder,tempStr,0,0);
      (*(SDL_Charstring*)Value)[len]='\0';
    }
    return;

  case type_SDL_UnionC:
#ifndef THREADLIGHT
  case type_SDL_Pid:
#endif
  case type_SDL_Voidstarstar:
    {
      int errorcode;
      if (ASCIIGetByte(Coder) != '{')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_USERDEF);
      ASCII_CHECK_ERROR(AsciiUserEncode==NULLPTR,Coder,
			ec_ERROR_DECODING_USERDEF);
      errorcode = AsciiUserDecode(Coder,TypeNode,Value);
      ASCII_CHECK_ERROR(errorcode!=ec_SUCCESS,Coder,errorcode);
      if (ASCIIGetByte(Coder) != '}')
	  ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_USERDEF);;
    }
    return;

  default:
    /* error */
    ASCII_DEC_ERROR(Coder,ec_ERROR_UNKNOWN_TYPE_NODE);
  };
}

int AsciiEncode(tCoder* Coder, tSDLTypeInfo* TypeNode, void* Value)
{
  int retCode;
  tStoredRefs * sRefs;

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;

      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = Coder->ER.DataEnd;

      sRefs = NULLPTR;

      ASCIIPutByte(Coder, '{');
      AsciiEncVal(Coder, TypeNode, Value,&sRefs);
      if (sRefs!=NULLPTR) FreeStoredRefs(sRefs,Coder);
      ASCIIPutByte(Coder, '}');

      BufSetDataEnd(Coder, Coder->ER.DataCurr - Coder->ER.DataEnd, 7);
      Coder->ER.ValueBitLength = Coder->ER.DataCurr - Coder->ER.DataEnd;

      retCode = ec_SUCCESS;
    }
  else
    {
      retCode = Coder->EMS.ErrorCode;
    }
  Coder->EMS.IsAssigned = 0;
  return retCode;
}

int AsciiDecode(tCoder* Coder, tSDLTypeInfo* TypeNode, void* Value)
{
  int retCode;
  tStoredRefs * sRefs;

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;
      unsigned char* DataCurr;

      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = BufGetDataCurr(Coder, &Coder->ER.BitCurr);
      DataCurr           = Coder->ER.DataCurr;

      sRefs = NULLPTR;

      if (ASCIIGetByte(Coder) != '{')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_PARSTART);
      AsciiDecVal(Coder, TypeNode, Value,&sRefs);
      if (sRefs!=NULLPTR) FreeStoredRefs(sRefs,Coder);
      if (ASCIIGetByte(Coder) != '}')
	ASCII_DEC_ERROR(Coder,ec_ERROR_DECODING_PAREND);

      BufSetDataCurr(Coder, Coder->ER.DataCurr - DataCurr, 7);
      Coder->ER.ValueBitLength = Coder->ER.DataCurr - DataCurr;

      retCode = ec_SUCCESS;
    }
  else
    {
      retCode = Coder->EMS.ErrorCode;
    }
  Coder->EMS.IsAssigned = 0;
  return retCode;
}

#endif /* !CODER_REMOVE_ASCII */
