/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_BER

#include "er/ber/ber_base.h"

/**************************************************/
/************** Buffers operations ****************/
/**************************************************/

/**************************************************
 * NAME: BERAppendBufMemory
 *       
 *
 */

void
BERAppendBufMemory(tCoder* Coder, tVMSULong Length)
{
  tVMSULong EDataLen = Coder->ER.MemEnd - Coder->ER.DataCurr;
  tVMSULong DataEnd = Coder->ER.DataEnd - Coder->ER.MemStart;
  tVMSULong MemEnd = Coder->ER.MemEnd - Coder->ER.MemStart;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERAppendBufMemory\n");
#endif

  Coder->ER.MemStart = BufAppendMemory(Coder, Length);
  Coder->ER.MemEnd = Coder->ER.MemStart + MemEnd + Length;
  Coder->ER.DataEnd = Coder->ER.MemStart + DataEnd;

  memmove(Coder->ER.MemEnd - EDataLen, Coder->ER.MemStart + (MemEnd - EDataLen), EDataLen);
  Coder->ER.DataCurr = Coder->ER.MemEnd - EDataLen;
}

/**************************************************
 * NAME: BERBufErrorHandlerFunc
 *       
 *
 */

void 
BERBufErrorHandlerFunc(tCoder* Coder, tVMSULong Length, int ErrorCode)
{
  tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERBufErrorHandlerFunc\n");
#endif

  if (AppendFunc)
    {
      AppendFunc(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      Coder->ER.DataEnd = BufGetDataEnd(Coder, &(Coder)->ER.BitEnd);
    }
  if ((long)(Coder->ER.DataEnd - Coder->ER.DataCurr) < (long)Length)
    {
      CUCFErrorOutput(stderr, ErrorCode);
      Coder->EMS.ErrorCode = ErrorCode;
      if (Coder->EMS.IsAssigned) longjmp(Coder->EMS.ReturnPoint, ErrorCode);
    }
}

/**************************************************/
/*************** Identifier Octet *****************/
/**************************************************/

/**************************************************
 * NAME: BEREncodeIdentifierOctet
 *       
 *
 */

void
BEREncodeIdentifierOctet(tCoder* Coder, unsigned char EncForm, tASN1Tag* Tag)
{
  unsigned char Len = 0;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeIdentifierOctet\n");
#endif

  if (Tag->Number > 0x1E)
    {
      Len = 1;
      if (Tag->Number & 0xFFFFFF80)
        {
          Len = 2;
          if (Tag->Number & 0xFFFFC000)
            {
              Len = 3;
              if (Tag->Number & 0xFFE00000)
                {
                  Len = 4;
                  if (Tag->Number & 0xF0000000)
                    {
                      Len = 5;
                      if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len)
                        BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);
                        
                      *(Coder->ER.DataCurr - 4) = (unsigned char)((Tag->Number >> 28) | 0x80);
                    }
                  else
                  if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len)
                    BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);

                  *(Coder->ER.DataCurr - 3) = (unsigned char)((Tag->Number >> 21) | 0x80);
                }
              else
              if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len)
                BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);
              
              *(Coder->ER.DataCurr - 2) = (unsigned char)((Tag->Number >> 14) | 0x80);
            }
          else
          if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len)
            BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);
          
          *(Coder->ER.DataCurr - 1) = (unsigned char)((Tag->Number >> 7) | 0x80);
        }
      else
      if (Coder->ER.DataCurr ==  Coder->ER.DataEnd)
        BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);

      *(Coder->ER.DataCurr) = (unsigned char)(Tag->Number & 0x7F);
      *(Coder->ER.DataCurr - Len) = (unsigned char)(Tag->Class | EncForm | 0x1F);
    }
  else
    {
      if (Coder->ER.DataCurr == Coder->ER.DataEnd)
        BERAppendBufMemory(Coder, 1);
      *(Coder->ER.DataCurr) = (unsigned char)(Tag->Class | EncForm | Tag->Number);
    }
  
  Coder->ER.DataCurr -= Len + 1;
}

/**************************************************
 * NAME: BERPeekIdentifierOctet
 *       
 *
 */

void 
BERPeekIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag)
{
  unsigned char* CurrByte = Coder->ER.DataCurr;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERPeekIdentifierOctet\n");
#endif

  if (CurrByte == Coder->ER.DataEnd)
    {
      tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);
      if (AppendFunc)
        {
          AppendFunc(Coder, 1);
          Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
        }

      if (CurrByte == Coder->ER.DataEnd)
        BERBUF_ERROR_HANDLER(Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
    }

  Tag->Number = (tASN1TagClassNumber)(*CurrByte & 0x1F);
  Tag->Class = (tASN1TagClass)(*CurrByte & 0xC0);
  *EncForm = (unsigned char)(*CurrByte & 0x20);

  if (Tag->Number == 0x1F)
    {
      CurrByte++;
      if (CurrByte == Coder->ER.DataEnd)
        {
          tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);
          if (AppendFunc)
            {
              AppendFunc(Coder, 1);
              Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
            }
          if (CurrByte == Coder->ER.DataEnd)          
            BERBUF_ERROR_HANDLER(Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
        }

      Tag->Number = 0;
      while (((*CurrByte & 0x80) != 0) && (CurrByte - Coder->ER.DataCurr < 6))
        {
          Tag->Number |= (tASN1TagClassNumber)(*CurrByte & 0x7F);
          Tag->Number <<= 7;
          CurrByte++;
          if (CurrByte == Coder->ER.DataEnd)
            {
              tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);
              if (AppendFunc)
                {
                  AppendFunc(Coder, 1);
                  Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
                }
              if (CurrByte == Coder->ER.DataEnd)
                BERBUF_ERROR_HANDLER(Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
            }
        }
     
      Tag->Number |= *CurrByte;

      DECODING_ERROR_HANDLER_EXP(((CurrByte - Coder->ER.DataCurr >= 6) && ((*CurrByte & 0x80) != 0)),
                                 Coder, return, ec_DEC_TooBigTagNumber, NO_ARGS);
    }
}

/**************************************************
 * NAME: BERDecodeIdentifierOctet
 *       
 *
 */

void
BERDecodeIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeIdentifierOctet\n");
#endif

  BERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

  Tag->Number = (tASN1TagClassNumber)(*(Coder->ER.DataCurr) & 0x1F);
  Tag->Class = (tASN1TagClass)(*(Coder->ER.DataCurr) & 0xC0);
  *EncForm = (unsigned char)(*(Coder->ER.DataCurr) & 0x20);

  if (Tag->Number == 0x1F)
    {
      unsigned char CurrByte = 1;

      Coder->ER.DataCurr++;
      BERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

      Tag->Number = 0;
      while (((*(Coder->ER.DataCurr) & 0x80) != 0) && (CurrByte < 6))
        {
          Tag->Number |= (tASN1TagClassNumber)(*(Coder->ER.DataCurr) & 0x7F);
          Tag->Number <<= 7;
          Coder->ER.DataCurr++;
          BERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
        }

      Tag->Number |= *(Coder->ER.DataCurr);

      DECODING_ERROR_HANDLER_EXP(((CurrByte >= 6) && ((*(Coder->ER.DataCurr) & 0x80) != 0)),
                                 Coder, return, ec_DEC_TooBigTagNumber, NO_ARGS);
    }

  Coder->ER.DataCurr++;
}

/**************************************************/
/******************** Length **********************/
/**************************************************/

/**************************************************
 * NAME: BEREncodeDefiniteLength
 *       
 *
 */

void
BEREncodeDefiniteLength(tCoder* Coder, tVMSULong Length)
{
  unsigned char Len = 0;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeDefiniteLength\n");
#endif

  if (Length & 0xFFFFFF80)
    {
      Len = 1;
      if (Length & 0xFFFFFF00)
        {
          Len = 2;
          if (Length & 0xFFFF0000)
            {
              Len = 3;
              if (Length & 0xFF000000)
                {
                  Len = 4;
                  
                  if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len + 1)
                    BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);

                  *(Coder->ER.DataCurr - 3) = (unsigned char)(Length >> 24);
                }
              else
              if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len + 1)
                BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);

              *(Coder->ER.DataCurr - 2) = (unsigned char)(Length >> 16);
            }
          else
          if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len + 1)
            BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);

          *(Coder->ER.DataCurr - 1) = (unsigned char)(Length >> 8);
        }
      else
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < Len + 1)
        BERAppendBufMemory(Coder, Len - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);

      *(Coder->ER.DataCurr) = (unsigned char)Length;
      
      *(Coder->ER.DataCurr - Len) = (unsigned char)(0x80 | Len);
    }
  else
    {
      if (Coder->ER.DataCurr == Coder->ER.DataEnd)
        BERAppendBufMemory(Coder, 1);
          
      *(Coder->ER.DataCurr) = (unsigned char)Length;          
    }

  Coder->ER.DataCurr -= Len + 1;
}

/**************************************************
 * NAME: BERDecodeDefiniteLength
 *       
 *
 */

tVMSULong
BERDecodeDefiniteLength(tCoder* Coder, tVMSULong* Length)
{
  tVMSULong DecLength = 1;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeDefiniteLength\n");
#endif

  BERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

  if (*(Coder->ER.DataCurr) <= 0x80)
    *Length = *(Coder->ER.DataCurr);
  else
    {
      unsigned char i;

      DecLength += (*(Coder->ER.DataCurr) & 0x7F);
      BERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, DecLength, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

      for (i = 1, *Length = 0; i < DecLength; i++)
        {
          *Length <<= 8;
          *Length |= *(Coder->ER.DataCurr + i);
        }
    }

  Coder->ER.DataCurr += DecLength;

  return DecLength;
}

#endif /* !CODER_REMOVE_BER */
