/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __ber_base_h
#define __ber_base_h

#ifndef CODER_REMOVE_BER

#include "cucf.h"

/**************************************************************/
/******************* Buffers operations ***********************/
/**************************************************************/

void BERAppendBufMemory(tCoder* Coder, tVMSULong Length);
void BERBufErrorHandlerFunc(tCoder* Coder, tVMSULong Length, int ErrorCode);


#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_BUFFER)
#define BERBUF_ERROR_HANDLER_EXP(exp, len, coder, errorcode, args) \
if ((long)(exp) < (long)(len)) \
  BERBufErrorHandlerFunc(coder, len, errorcode);

#define BERBUF_ERROR_HANDLER(coder, errorcode, args) \
{ \
  CUCFErrorOutput(stderr, errorcode args); \
  (coder)->EMS.ErrorCode = errorcode; \
  if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
  else { NO_ACTION ; } \
}
#else
#define BERBUF_ERROR_HANDLER_EXP(expression, len, coder, errorcode, args) /* ???? */
#define BERBUF_ERROR_HANDLER(coder, errorcode, args) /* ???? */
#endif

/************************************/
/************** Bytes ***************/
/************************************/

/* Should be updated */

#define BERPutByte(Coder, iByte) \
{ \
  if (Coder->ER.DataCurr < Coder->ER.DataEnd) \
    BERAppendBufMemory(Coder, Coder->ER.DataEnd - Coder->ER.DataCurr); \
  *(Coder->ER.DataCurr) = iByte; \
  Coder->ER.DataCurr--; \
}

/************************************/

#define BERGetByte(Coder, oByte) \
{ \
  BERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS); \
  oByte = *(Coder->ER.DataCurr); \
  Coder->ER.DataCurr++; \
}

/************************************/
/************** Segment *************/
/************************************/

#define BERSkipSeg(Coder, Len) \
{ \
  if (Len > 0) \
    { \
      BERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), Len, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS); \
      Coder->ER.DataCurr += Len; \
    } \
}

/**************************************************************/
/********************* Encoding Form **************************/
/**************************************************************/

enum
{
  bef_Primitive,
  bef_Constructed = (1 << 5)
};


enum
{
  tk_Explicit,
  tk_Implicit
}; 

typedef unsigned char tASN1TagKind;

/**************************************************************/
/******************** Identifier Octet ************************/
/**************************************************************/

typedef struct
{
  tASN1TagClass         Class;
  tASN1TagClassNumber   Number;
} tBERTag;


void BEREncodeIdentifierOctet(tCoder* Coder, unsigned char EncForm, tASN1Tag* Tag);
void BERPeekIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag);
void BERDecodeIdentifierOctet(tCoder* Coder, unsigned char* EncForm, tBERTag* Tag);

/**************************************************************/
/********************* Definite Length ************************/
/**************************************************************/

void      BEREncodeDefiniteLength(tCoder* Coder, tVMSULong Length);
tVMSULong BERDecodeDefiniteLength(tCoder* Coder, tVMSULong* Length);

/**************************************************************/
/******************** Indefinite Length ***********************/
/**************************************************************/

#define BEREncodeEOC(Coder) \
{ \
  if (Coder->ER.DataCurr - Coder->ER.DataEnd < 2) \
    BERAppendBufMemory(Coder, 2 - (Coder->ER.DataCurr - Coder->ER.DataEnd)); \
  *(Coder->ER.DataCurr) = 0; \
  *(Coder->ER.DataCurr - 1) = 0; \
  Coder->ER.DataCurr -= 2; \
}

#define BERIsEOC(Coder) ((*(Coder->ER.DataCurr) == 0) && (*(Coder->ER.DataCurr + 1) == 0))

#define BERDecodeEOC(Coder) \
  Coder->ER.DataCurr += 2

/**************************************************************/
/************************ String Value ************************/
/**************************************************************/

typedef void (*tBEREncodePrimStringFunc)(tCoder* Coder, tVMSULong Length, tVMSString_Value Val);
typedef void (*tBERDecodePrimStringFunc)(tCoder* Coder, tVMSString* Val );

typedef const struct
{
  tBEREncodePrimStringFunc EncPrim;
  tBERDecodePrimStringFunc DecPrim;
} tBERStringInfo;

/**************************************************************/
/*************************** SHARED ***************************/
/**************************************************************/

#define BERGetLengthValueOfInteger(InVal, OutLength) CUCFGetLengthValueOfInteger(InVal, OutLength)

#endif /* !CODER_REMOVE_BER */

#endif /* __ber_base_h */

