/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"

/************************************************/

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
static void CUCFFreeObjectOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal);
static int CUCFEqualObjectOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val);
#endif

/************************************************/

#if !defined (CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static void CUCFFreeObjectStruct(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal);
static int  CUCFEqualObjectStructComps(tCoder* Coder, tASN1TypeInfo* Type, unsigned char KindOfComps, void*** CurrInlField, void* Val);
#endif

#ifndef CODER_NOUSE_SEQUENCE
#define CUCFFreeObjectSEQUENCE(Coder, Type, InlVal) CUCFFreeObjectStruct(Coder, Type, InlVal)
#define CUCFEqualObjectSEQUENCEComps(Coder, Type, KindOfComps, CurrInlField, Val) \
        CUCFEqualObjectStructComps(Coder, Type, KindOfComps, CurrInlField, Val)
#endif

#ifndef CODER_NOUSE_SET
#define CUCFFreeObjectSET(Coder, Type, InlVal) CUCFFreeObjectStruct(Coder, Type, InlVal)
#define CUCFEqualObjectSETComps(Coder, Type, KindOfComps, CurrInlField, Val) \
        CUCFEqualObjectStructComps(Coder, Type, KindOfComps, CurrInlField, Val)
#endif

/************************************************/

#if !defined(CODER_NOUSE_SEQUENCE_OF) || !defined(CODER_NOUSE_SET_OF)
static void CUCFFreeObjectSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal);
#define CUCFFreeObjectSET_OF(Coder, Type, InlVal) CUCFFreeObjectSEQUENCE_OF(Coder, Type, InlVal)
#endif

/************************************************/

#ifndef CODER_NOUSE_SEQUENCE_OF
static int CUCFEqualObjectSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val);
#endif

/************************************************/

#ifndef CODER_NOUSE_SET_OF
static int CUCFEqualObjectSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val);
#endif

/************************************************/

#ifndef CODER_NOUSE_CHOICE
static void CUCFFreeObjectCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal);
static int CUCFEqualObjectCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val);
#endif

/************************************************/

#ifndef CODER_NOUSE_OPEN
static void CUCFFreeObjectOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal);
static int CUCFEqualObjectOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val);
#endif

/************************************************/

#ifndef CODER_NOUSE_REAL
/************************************************/
/************************************************/
/************************************************/
void
CUCFGetLengthValueOfInteger(long IntVal, unsigned char* Length)
{
  tVMSULong Mask = (0x7f80 << ((sizeof(unsigned long) - 2) << 3));

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "CUCFGetLengthValueOfInteger\n");
#endif

  *Length = sizeof(unsigned long);

  if (IntVal < 0)
    for (; (*Length > 1) && ((IntVal & Mask) == Mask); (*Length)--, Mask >>= 8);
  else
    for (; (*Length > 1) && ((IntVal & Mask) == 0); (*Length)--, Mask >>= 8);
}
#endif /* CODER_NOUSE_REAL */ 

#ifndef CODER_NOUSE_OPEN
/************************************************/
/************** Open Type List ******************/
/************************************************/

void
CUCFPutOpenId(tCoder* Coder, tVMSOpenTypeList* List, tASN1TypeInfo* Type, void* Val)
{
  tVMSOpenIdList* NewId;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "CUCFPutOpenId\n");
#endif

  NewId = (tVMSOpenIdList*)CUCFAlloc(Coder, sizeof(tVMSOpenIdList), 0);

  NewId->Type = (void*)Type;
  NewId->Val = Val;
  NewId->Next = List->Ids;
  List->Ids = NewId;
}

/************************************************/

void
CUCFPutOpenBody(tCoder* Coder, tVMSOpenTypeList* List, tVMSOpenTypeInfo* OTInfo, tASN1TypeInfo* Type, void* vOpen)
{
  tVMSOpenBodyList *NewBody;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "CUCFPutOpenBody\n");
#endif

  NewBody = (tVMSOpenBodyList*)CUCFAlloc(Coder, sizeof(tVMSOpenBodyList), 0);

  NewBody->DataPtr = OTInfo->DataPtr;
  NewBody->AddInfo = OTInfo->AddInfo;
  NewBody->Type = (void*)Type;
  NewBody->Val = vOpen;
  NewBody->Next = List->Bodies;
  List->Bodies = NewBody;
}

/************************************************/
/************* Open Type Objects ****************/
/************************************************/

tASN1Object*
CUCFGetOpenTypeObject(tCoder* Coder, tASN1TypeInfo* Type, tVMSULong* ObjIndex, void* Val)
{
  tASN1Object* CurrObj = ((tASN1Open*)Type)->Objects;
  tVMSULong NumOfObjs = ((tASN1Open*)Type)->NumOfObjects;
  tASN1TypeInfo* BaseType = ((tASN1Open*)Type)->OpenIdType;
  int IsEqual = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "CUCFGetOpenTypeObject\n");
#endif

  while ((BaseType->TypeClass == type_ASN1_OPEN_ID) || 
         (BaseType->TypeClass == type_ASN1_DEFINED) ||
         (BaseType->TypeClass == type_ASN1_TAGGED))
    BaseType = ((tASN1Defined*)BaseType)->BaseType;

  switch (BaseType->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      {
        tVMSBoolean vBool;
        VMSGetBOOLEAN(Coder, Val, BaseType, vBool);
        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            if ((long)(CurrObj->InitFunc) == vBool)
              {
                IsEqual = 1;
                break;
              }
          }
      }
      break;
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      IsEqual = 1;
      break;
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
        {
          void* vObjId_Id = CurrObj->InitFunc(Coder);
          IsEqual = CUCFEqualObjectOBJECT_IDENTIFIER(Coder, BaseType, vObjId_Id, Val);
          CUCFFreeObject(Coder, BaseType, vObjId_Id);

          if (IsEqual != 0) break;
        }
      break;
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      {
        tVMSReal vReal;
        VMSGetREAL(Coder, Val, BaseType, vReal);
        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            tVMSReal* vRealId = (tVMSReal*)(CurrObj->InitFunc(Coder));
            
            if (vRealId->Kind != vReal.Kind) return 0;
            if (vReal.Kind == rk_Value)
              {
                if ((double)(vRealId->Mantissa) *
                    pow((double)(vRealId->Base),
                        (double)(vRealId->Exponent)) ==
                    (double)vReal.Mantissa *
                    pow((double)vReal.Base,
                        (double)vReal.Exponent))
                  {
                    IsEqual = 1;
                    CUCFFreeObject(Coder, BaseType, vRealId);
                    break;
                  }
              }
            CUCFFreeObject(Coder, BaseType, vRealId);
          }   
      }   
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      {
        tVMSInteger vInt;
        VMSGetINTEGER(Coder, Val, BaseType, vInt);
        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            if ((tVMSInteger)(CurrObj->InitFunc) == vInt)
              {
                IsEqual = 1;
                break;
              }
          }
      }
      break;
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      {
        tVMSString vBitString;
        VMSGetBIT_STRING(Coder, Val, BaseType, vBitString);
        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            if (strlen((char*)(CurrObj->InitFunc)) == 0)
              {
                if (vBitString.Length == 0)
                  IsEqual = 1;
              }
            else
              {
                tVMSString vBitStringId;
                CUCFInitObjectBIT_STRING(Coder, &vBitStringId, (tVMSString_Value)(CurrObj->InitFunc), 
                                         strlen((char*)(CurrObj->InitFunc)));
                
                if (vBitString.Length == vBitStringId.Length)
                  {
                    if (memcmp(vBitStringId.Value, vBitString.Value, vBitString.Length) == 0)
                      IsEqual = 1;
                  }
                
                if (vBitStringId.IsAssigned == 0)
                  {
                    CUCFFree(Coder, vBitStringId.Value, ((vBitStringId.Length - 1) >> 3) + 1, 0);
                  }
              }
            if (IsEqual == 1)
              break;
          }
        VMSFreeString(Coder, vBitString);
      }
      break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      {
        tVMSString vOctetString;
        VMSGetOCTET_STRING(Coder, Val, BaseType, vOctetString);
        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            if (strlen((char*)(CurrObj->InitFunc)) == 0)
              {
                if (vOctetString.Length == 0)
                  IsEqual = 1;
              }
            else
              {
                tVMSString vOctetStringId;
                CUCFInitObjectOCTET_STRING(Coder, &vOctetStringId, (tVMSString_Value)(CurrObj->InitFunc), 
                                           strlen((char*)(CurrObj->InitFunc)));

                if (vOctetString.Length == vOctetStringId.Length)
                  {                
                    if (memcmp(vOctetStringId.Value, vOctetString.Value, vOctetString.Length) == 0)
                      IsEqual = 1;
                  }

                if (vOctetStringId.IsAssigned == 0)
                  {
                    CUCFFree(Coder, vOctetStringId.Value, (vOctetStringId.Length + 1) >> 1, 0);
                  }                
              }
            
            if (IsEqual == 1)
              break;
          }
        VMSFreeString(Coder, vOctetString);
      }
      break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
    case type_ASN1_PrintableString:
    case type_ASN1_IA5String:
    case type_ASN1_VisibleString:
    case type_ASN1_UTCTime:
    case type_ASN1_GeneralizedTime:
      {        
        tVMSString vCharString;

        switch (BaseType->TypeClass)
          {
          case type_ASN1_NumericString:
            VMSGetNumericString(Coder, Val, BaseType, vCharString);
            break;
          case type_ASN1_PrintableString:
            VMSGetPrintableString(Coder, Val, BaseType, vCharString);
            break;
          case type_ASN1_IA5String:
            VMSGetIA5String(Coder, Val, BaseType, vCharString);
            break;
          case type_ASN1_VisibleString:
            VMSGetVisibleString(Coder, Val, BaseType, vCharString);
            break;
          case type_ASN1_UTCTime:
            VMSGetUTCTime(Coder, Val, BaseType, vCharString);
            break;
          case type_ASN1_GeneralizedTime:
            VMSGetGeneralizedTime(Coder, Val, BaseType, vCharString);
          default: 
            break;
          }

        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            tVMSULong vCharStringId_Length = strlen((char*)(CurrObj->InitFunc));

            if (vCharStringId_Length == 0)
              {
                if (vCharString.Length == 0)
                  IsEqual = 1;
              }
            else
            if (vCharString.Length == vCharStringId_Length)
              {
                if (memcmp((char*)(CurrObj->InitFunc), vCharString.Value, vCharString.Length) == 0)
                  IsEqual = 1;
              }

            if (IsEqual == 1)
              break;
          }
        VMSFreeString(Coder, vCharString);
      }
      break;
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:      
      {
        tVMSEnumerated_Index vEnumIndex;

        VMSGetIndexENUMERATED(Coder, Val, BaseType, vEnumIndex);
        for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
          {
            if ((tVMSEnumerated_Index)(CurrObj->InitFunc) == vEnumIndex)
              {
                IsEqual = 1;
                break;
              }
          }
      }
      break;
#endif
    default:
      IsEqual = -1;
      break;
    }

  if (IsEqual == -1)
    {
      for (; NumOfObjs > 0; CurrObj++, NumOfObjs--)
        {
          void* ObjVal = CurrObj->InitFunc(Coder);
          IsEqual = CUCFEqualObject(Coder, BaseType, ObjVal, Val);
          CUCFFreeObject(Coder, BaseType, ObjVal);
          if (IsEqual != 0) break;
        }
    }

  *ObjIndex = (((tASN1Open*)Type)->NumOfObjects - NumOfObjs);
  
  if (NumOfObjs == 0) return NULL;

  return CurrObj;
}

/************************************************/
/************************************************/
/************************************************/
#endif /* CODER_NOUSE_OPEN */

#ifndef CODER_NOUSE_BOOLEAN
/************************************************/
/***************** BOOLEAN **********************/
/************************************************/

void*
CUCFInitObjectBOOLEAN(tCoder* Coder, tVMSBoolean Boolean)
{
  void* retVal = CUCFAlloc(Coder, sizeof(tVMSBoolean), 0);
  *(tVMSBoolean*)retVal = Boolean;
  return retVal;
}
#endif /* CODER_NOUSE_BOOLEAN */

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
/************************************************/
/************* OBJECT IDENTIFIER ****************/
/************************************************/
void*
CUCFInitObjectOBJECT_IDENTIFIER(tCoder* Coder, tVMSULong NumberOfComponents, ...)
{
  va_list Components;
  tVMSULong i;
  tVMSULong* pSubIdent;
  tVMSStruct* pStruct = (tVMSStruct*)CUCFAlloc(Coder, sizeof(tVMSStruct), 0);
  pStruct->Components = CUCFAlloc(Coder, sizeof(tVMSULong) * NumberOfComponents, 0);
  pStruct->NumberOfComponents = (CODER_NumOf_TYPE)NumberOfComponents;
  pSubIdent = (tVMSULong*)pStruct->Components;

  va_start(Components, NumberOfComponents);
  for (i = 0; i < NumberOfComponents; i++)
    pSubIdent[i] = va_arg(Components, tVMSULong);
  va_end(Components);
  return (void*)pStruct;
}

/************************************************/

static void
CUCFFreeObjectOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal)
{
  tVMSStruct* pStruct = (tVMSStruct*)InlVal;
  CUCFFree(Coder, pStruct->Components, sizeof(tVMSULong) * NumberOfComponents, 0);
  CUCFFree(Coder, pStruct, sizeof(tVMSStruct), 0);
}

/************************************************/

static int
CUCFEqualObjectOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val)
{
  tVMSStruct* pStruct;
  tVMSULong inlNumOfComp;
  tVMSULong NumOfComp;
  tVMSObjId_Component CurrComp = 0;
  tVMSULong i;
  pStruct = (tVMSStruct*)InlVal;
  inlNumOfComp = pStruct->NumberOfComponents;
  VMSGetSizeOBJECT_IDENTIFIER(Coder, Val, Type, NumOfComp);
  if (inlNumOfComp != NumOfComp) return 0;
  for (i = 0; i < NumOfComp; i++)
    {
      VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, i, CurrComp);
      if (((tVMSULong*)(pStruct->Components))[i] != CurrComp) return 0;
    }
  return 1;
}
#endif /* CODER_NOUSE_OBJECT_IDENTIFIER */

#ifndef CODER_NOUSE_REAL
/************************************************/
/******************** REAL **********************/
/************************************************/

void*
CUCFInitObjectREAL(tCoder* Coder, tVMSReal_Kind Kind, ...)
{
  va_list RealArgs;
  tVMSReal* pReal = (tVMSReal*)CUCFAlloc(Coder, sizeof(tVMSReal), 0);
  pReal->Kind = Kind;
  if (Kind == rk_Value)
    {
      va_start(RealArgs, Kind);
      pReal->Mantissa = va_arg(RealArgs, tVMSULong);
      pReal->Base = (tVMSReal_Base)va_arg(RealArgs, tVMSULong);
      pReal->Exponent = va_arg(RealArgs, tVMSULong);
      va_end(RealArgs);
    }
  return (void*)pReal;
}
#endif /* CODER_NOUSE_REAL */

#ifndef CODER_NOUSE_INTEGER
/************************************************/
/***************** INTEGER **********************/
/************************************************/

void*
CUCFInitObjectINTEGER(tCoder* Coder, tVMSInteger Integer)
{
  void* retVal = CUCFAlloc(Coder, sizeof(tVMSInteger), 0);
  *(tVMSInteger*)retVal = Integer;
  return retVal;
}
#endif /* CODER_NOUSE_INTEGER */

#ifndef CODER_NOUSE_BIT_STRING
/************************************************/
/**************** BIT STRING ********************/
/************************************************/

void*
CUCFInitObjectBIT_STRING(tCoder* Coder,  tVMSString* vString, tVMSString_Value Value, tVMSULong Length)
{
  tVMSString* pString = (vString == NULL ? (tVMSString*)CUCFAlloc(Coder, sizeof(tVMSString), 0) : vString);

  pString->Length = Length;
  if (Length == 0)
    {
      pString->Value = NULL;
      pString->IsAssigned = 1;
    }
  else
    {
#ifdef CODER_VMS_SDT
      unsigned char* CurrByte;
      pString->Value = (tVMSString_Value)CUCFAlloc(Coder, Length, 0);
      memcpy(pString->Value, Value, Length);
      for (CurrByte = pString->Value; Length > 0; Length--, CurrByte++)
        *CurrByte -= (unsigned char)'0';
      pString->IsAssigned = 0;
#else
      pString->Value = Value;
      pString->IsAssigned = 1;
#endif
    }

  return (void*)pString;
}
#endif /* CODER_NOUSE_BIT_STRING */

#ifndef CODER_NOUSE_OCTET_STRING
/************************************************/
/**************** OCTET STRING ******************/
/************************************************/
void*
CUCFInitObjectOCTET_STRING(tCoder* Coder, tVMSString* vString, tVMSString_Value Value, tVMSULong Length)
{
  tVMSString* pString = (vString == NULL ? (tVMSString*)CUCFAlloc(Coder, sizeof(tVMSString), 0) : vString);

  pString->Length = (Length + 1) >> 1;
  if (Length == 0)
    {
      pString->Value = NULL;
      pString->IsAssigned = 1;
    }
  else
    {
      unsigned char *CurrByte;
      unsigned char *CurrHex;
      tVMSULong i;

      CurrHex = (unsigned char *)Value;
      pString->Value = (tVMSString_Value)CUCFAlloc(Coder, pString->Length, 0);
      CurrByte = (unsigned char *)pString->Value;
      for (i = 0; i < Length; i++)
        {
          *CurrByte = (unsigned char)((*CurrHex - ((*CurrHex < 'A') ? '0' : 'A' - 10)) << 4);
          CurrHex++;
          i++;
          if (i == Length) break;
          *CurrByte |= (unsigned char)(*CurrHex - ((*CurrHex < 'A') ? '0' : 'A' - 10));
          CurrHex++;
          CurrByte++;
        }
      pString->IsAssigned = 0;
    }
  return (void*)pString;
}
#endif /* CODER_NOUSE_OCTET_STRING */


#ifndef CODER_NOUSE_CHARACTER_STRING
/************************************************/
/************* CHARACTER STRING *****************/
/************************************************/

void*
CUCFInitObjectCHARACTER_STRING(tCoder* Coder, tVMSString_Value Value, tVMSULong Length)
{
  tVMSString* pString = (tVMSString*)CUCFAlloc(Coder, sizeof(tVMSString), 0);
  pString->Value = Value;
  pString->Length = Length;
  pString->IsAssigned = 1;
  return (void*)pString;
}
#endif /* CODER_NOUSE_CHARACTER_STRING */

#ifndef CODER_NOUSE_ENUMERATED
/************************************************/
/***************** ENUMERATED *******************/
/************************************************/

void*
CUCFInitObjectENUMERATED(tCoder* Coder, tVMSEnumerated_Index Enumerated_Index)
{
  void* retVal = CUCFAlloc(Coder, sizeof(tVMSEnumerated_Index), 0);
  *(tVMSEnumerated_Index*)retVal = Enumerated_Index;
  return retVal;
}
#endif /* CODER_NOUSE_ENUMERATED */


#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
/************************************************/
/******************* STRUCT *********************/
/************************************************/

void*
CUCFInitObjectStruct(tCoder* Coder, CODER_NumOf_TYPE NumberOfComponents, ...)
{
  va_list Components;
  CODER_NumOf_TYPE i;
  tVMSStruct* pStruct = (tVMSStruct*)CUCFAlloc(Coder, sizeof(tVMSStruct), 0);
  register void** CurrInlField;
  pStruct->Components = CUCFAlloc(Coder, sizeof(void*) * NumberOfComponents, 0);
  pStruct->NumberOfComponents = NumberOfComponents;
  CurrInlField = (void**)(pStruct->Components);

  va_start(Components, NumberOfComponents);
  for (i = 0; i < NumberOfComponents; i++, CurrInlField++)
    *CurrInlField = va_arg(Components, void*);

  va_end(Components);
  return (void*)pStruct;
}

/************************************************/

static void
CUCFFreeObjectStruct(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal)
{
  CODER_NumOf_TYPE i;
  tASN1Component* CurrComp = NULL;
  tVMSStruct* pStruct = (tVMSStruct*)InlVal;
  void** CurrInlField = (void**)(pStruct->Components);
  if (((tASN1Struct*)Type)->NumOfRC1 > 0)
    for (i = 0, CurrComp = ((tASN1Struct*)Type)->RootComps1; i < ((tASN1Struct*)Type)->NumOfRC1; CurrComp++, CurrInlField++, i++)
      if (*CurrInlField != NULL)
        CUCFFreeObject(Coder, CurrComp->TypeInfo,  *CurrInlField);

  if (((tASN1Struct*)Type)->NumOfEAC > 0)
    for (i = 0, CurrComp = ((tASN1Struct*)Type)->ExtAddComps; i < ((tASN1Struct*)Type)->NumOfEAC; CurrComp++, i++)
      {
        if (*CurrInlField != NULL)
          CUCFFreeObject(Coder, CurrComp->TypeInfo, *CurrInlField);
        if (CurrComp->Type != ct_Group) CurrInlField++;
      }

  if (CurrComp != NULL)
    for (i = 0, CurrComp = ((tASN1Struct*)Type)->RootComps1; i < ((tASN1Struct*)Type)->NumOfRC2; CurrComp++, CurrInlField++, i++)
      if (*CurrInlField != NULL)
        CUCFFreeObject(Coder, CurrComp->TypeInfo, *CurrInlField);

  CUCFFree(Coder, pStruct->Components, sizeof(void*) * NumOfComp, 0);
  CUCFFree(Coder, pStruct, sizeof(tVMSStruct), 0);
}

/************************************************/

static int
CUCFEqualObjectStructComps(tCoder* Coder, tASN1TypeInfo* Type, unsigned char KindOfComps, void*** CurrInlField, void* Val)
{
  register tASN1Component* CurrComp;
  register CODER_NumOf_TYPE i, NumOfComps;
  register void* CurrField;

  switch (KindOfComps)
    {
    case 1:
      CurrComp = ((tASN1Sequence*)Type)->RootComps1;
      NumOfComps = ((tASN1Sequence*)Type)->NumOfRC1;
      break;
    case 2:
      CurrComp = ((tASN1Sequence*)Type)->ExtAddComps;
      NumOfComps = ((tASN1Sequence*)Type)->NumOfEAC;
      break;
    default:
      CurrComp = ((tASN1Sequence*)Type)->RootComps2;
      NumOfComps = ((tASN1Sequence*)Type)->NumOfRC2;
      break;
    }

  for (i = 0; i < NumOfComps; CurrComp++, (*CurrInlField)++, i++)
    {
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          if (KindOfComps != 2)
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (!CUCFEqualObject(Coder, CurrComp->TypeInfo, **CurrInlField, CurrField))
                return 0;
              break;
            }
          /* break; not needed */
        case ct_Optional:
          VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              if (**CurrInlField != NULL)
                {
                  if (!CUCFEqualObject(Coder, CurrComp->TypeInfo, **CurrInlField, CurrField))
                    return 0;
                }
              else
                INTERNAL_ERROR_HANDLER(Coder, return 0, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                
            }
          else
            {
              INTERNAL_ERROR_HANDLER_EXP(**CurrInlField != NULL, Coder, return 0, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          break;
        case ct_Default:
          VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              if (**CurrInlField != NULL)
                {
                  if (!CUCFEqualObject(Coder, CurrComp->TypeInfo, **CurrInlField, CurrField))
                    return 0;
                }
              else
                INTERNAL_ERROR_HANDLER(Coder, return 0, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          else
            {
              INTERNAL_ERROR_HANDLER_EXP(**CurrInlField != NULL, Coder, return 0, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          break;
        default:
          break;
        }
    }
  return 1;
}

#endif /* !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) */

#if !defined(CODER_NOUSE_SEQUENCE_OF) || !defined(CODER_NOUSE_SET_OF)
/************************************************/
/**************** STRUCT OF *********************/
/************************************************/

static void
CUCFFreeObjectSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal)
{
  tVMSStruct* pStruct;
  tVMSULong inlNumOfComp;
  tVMSULong i;
  pStruct = (tVMSStruct*)InlVal;
  inlNumOfComp = pStruct->NumberOfComponents;
  for (i = 0; i < inlNumOfComp; i++)
    {
      CUCFFreeObject(Coder,
                     ((tASN1SequenceOf*)Type)->BaseType,
                     ((void**)(pStruct->Components))[i]);
    }
  CUCFFree(Coder, pStruct->Components, sizeof(void*) * inlNumOfComp, 0);
  CUCFFree(Coder, pStruct, sizeof(tVMSStruct), 0);
}
#endif /* !defined(CODER_NOUSE_SEQUENCE_OF) || !defined(CODER_NOUSE_SET_OF) */


#ifndef CODER_NOUSE_SEQUENCE_OF
/************************************************/
/**************** SEQUENCE OF *******************/
/************************************************/

static int
CUCFEqualObjectSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val)
{
  tVMSStruct* pStruct;
  tVMSULong inlNumOfComp;
  tVMSULong NumOfComp = 0;
  void* CurrComp = NULL;
  tVMSULong i;
  pStruct = (tVMSStruct*)InlVal;
  inlNumOfComp = pStruct->NumberOfComponents;
  VMSGetSizeSEQUENCE_OF(Coder, Val, Type, NumOfComp);
  if (inlNumOfComp != NumOfComp) return 0;
  for (i = 0; i < NumOfComp; i++)
    {
      VMSGetComponentSEQUENCE_OF(Coder, Val, Type, i, CurrComp);
      if (!CUCFEqualObject(Coder,
                           ((tASN1SequenceOf*)Type)->BaseType,
                           ((void**)(pStruct->Components))[i],
                           CurrComp))
        return 0;
    }
  return 1;
}
#endif

#ifndef CODER_NOUSE_SET_OF
/************************************************/
/******************* SET OF *********************/
/************************************************/

static int
CUCFEqualObjectSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val)
{
  tVMSStruct* pStruct;
  tVMSULong inlNumOfComp;
  tVMSULong NumOfComp;
  void* CurrComp = NULL;
  tVMSULong i, j;
  char* CompFlags;
  int IsEqual = 1;
  pStruct = (tVMSStruct*)InlVal;
  inlNumOfComp = pStruct->NumberOfComponents;
  VMSGetSizeSET_OF(Coder, Val, Type, NumOfComp);
  if (inlNumOfComp != NumOfComp) return 0;
  CompFlags = (char*)CUCFAlloc(Coder, sizeof(char) * NumOfComp, 0);
  memset(CompFlags, 0, NumOfComp);
  for (i = 0; i < NumOfComp; i++)
    {
      VMSGetComponentSET_OF(Coder, Val, Type, i, CurrComp);
      for (j = 0; j < NumOfComp; j++)
        {
          if ((CompFlags[j] == 0) &&
              CUCFEqualObject(Coder,
                               ((tASN1SetOf*)Type)->BaseType,
                               ((void**)(pStruct->Components))[j],
                               CurrComp))
            {
              CompFlags[j] = 1;
              break;
            }
        }
    }
  for (i = 0; i < NumOfComp; i++)
    {
      if (CompFlags[i] == 0) IsEqual = 0;
    }
  CUCFFree(Coder, CompFlags, sizeof(char) * NumOfComp, 0);
  return IsEqual;
}
#endif /* CODER_NOUSE_SET_OF */

#if !defined(CODER_NOUSE_CHOICE) || !defined(CODER_NOUSE_OPEN)
/************************************************/
/************************************************/
/************************************************/
void*
CUCFInitObjectCHOICE(tCoder* Coder, CODER_NumOf_TYPE Index, void* Alternative)
{
  tVMSChoice* pChoice = (tVMSChoice*)CUCFAlloc(Coder, sizeof(tVMSChoice), 0);
  pChoice->Alternative = Alternative;
  pChoice->Index = Index;
  return (void*)pChoice;
}
#endif /* !defined(CODER_NOUSE_CHOICE) || !defined(CODER_NOUSE_OPEN) */

#ifndef CODER_NOUSE_CHOICE
/************************************************/
/******************* CHOICE *********************/
/************************************************/
static void
CUCFFreeObjectCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal)
{
  tVMSChoice* pChoice;
  pChoice = (tVMSChoice*)InlVal;
  CUCFFreeObject(Coder,
                 ((tASN1Choice*)Type)->Alternatives[pChoice->Index].TypeInfo,
                 pChoice->Alternative);
  CUCFFree(Coder, pChoice, sizeof(tVMSChoice), 0);
}

/************************************************/

static int
CUCFEqualObjectCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val)
{
  tASN1Alternative* AltInfo = NULL;
  tVMSChoice* pChoice;
  void* Alternative;
  pChoice = (tVMSChoice*)InlVal;
  VMSGetAlternativeCHOICE(Coder, Val, Type, AltInfo, Alternative);
  if (pChoice->Index != AltInfo->Index) return 0;
  if (!CUCFEqualObject(Coder,
                       AltInfo->TypeInfo,
                       pChoice->Alternative,
                       Alternative))
    return 0;
  return 1;
}
#endif /* CODER_NOUSE_CHOICE */

#ifndef CODER_NOUSE_OPEN
/************************************************/
/******************** OPEN **********************/
/************************************************/

static void
CUCFFreeObjectOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal)
{
  tVMSOpen* pOpen;
  pOpen = (tVMSOpen*)InlVal;
  CUCFFreeObject(Coder,
                 ((tASN1Open*)Type)->Objects[pOpen->Index].TypeInfo,
                 pOpen->Alternative);
  CUCFFree(Coder, pOpen, sizeof(tVMSOpen), 0);
}

/************************************************/

static int
CUCFEqualObjectOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val)
{
  tASN1Object* ObjInfo = NULL;
  tVMSOpen* pOpen;
  void* Object;
  pOpen = (tVMSOpen*)InlVal;
  VMSGetObjectOPEN(Coder, Val, Type, ObjInfo, Object);
  if (pOpen->Index != ObjInfo->Index) return 0;
  if (!CUCFEqualObject(Coder,
                       ObjInfo->TypeInfo,
                       pOpen->Alternative,
                       Object))
    return 0;
  return 1;
}
#endif /* CODER_NOUSE_OPEN */

/************************************************/
/*************** MAIN FUNCTIONS *****************/
/************************************************/

void
CUCFFreeObject(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal)
{
  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      CUCFFree(Coder, InlVal, sizeof(tVMSBoolean), 0);
      break;
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      break;
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      CUCFFreeObjectOBJECT_IDENTIFIER(Coder, Type, InlVal);
      break;
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      CUCFFree(Coder, InlVal, sizeof(tVMSReal), 0);
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      CUCFFree(Coder, InlVal, sizeof(tVMSInteger), 0);
      break;
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      if (((tVMSString*)InlVal)->IsAssigned == 0)
        {
          CUCFFree(Coder, ((tVMSString*)InlVal)->Value, ((((tVMSString*)InlVal)->Length - 1) >> 3) + 1, 0);
        }
      CUCFFree(Coder, InlVal, sizeof(tVMSString), 0);
      break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      if (((tVMSString*)InlVal)->IsAssigned == 0)
        {
          CUCFFree(Coder, ((tVMSString*)InlVal)->Value, ((tVMSString*)InlVal)->Length, 0);
        }
      CUCFFree(Coder, InlVal, sizeof(tVMSString), 0);
      break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
    case type_ASN1_PrintableString:
    case type_ASN1_IA5String:
    case type_ASN1_VisibleString:
    case type_ASN1_UTCTime:
    case type_ASN1_GeneralizedTime:
      if (((tVMSString*)InlVal)->IsAssigned == 0)
        {
          CUCFFree(Coder, ((tVMSString*)InlVal)->Value, ((tVMSString*)InlVal)->Length, 0);
        }
      CUCFFree(Coder, InlVal, sizeof(tVMSString), 0);
      break;
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      CUCFFree(Coder, InlVal, sizeof(tVMSEnumerated_Index), 0);
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
      CUCFFreeObjectSEQUENCE(Coder, Type, InlVal);
      break;
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
      CUCFFreeObjectSET(Coder, Type, InlVal);
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      CUCFFreeObjectSEQUENCE_OF(Coder, Type, InlVal);
      break;
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      CUCFFreeObjectSET_OF(Coder, Type, InlVal);
      break;
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      CUCFFreeObjectCHOICE(Coder, Type, InlVal);
      break;
#endif
    case type_ASN1_DEFINED:
      CUCFFreeObject(Coder, ((tASN1Defined*)Type)->BaseType, InlVal);
      break;
    case type_ASN1_TAGGED:
      CUCFFreeObject(Coder, ((tASN1Tagged*)Type)->BaseType, InlVal);
      break;
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      CUCFFreeObject(Coder, ((tASN1OpenId*)Type)->BaseType, InlVal);
      break;
    case type_ASN1_OPEN:
      CUCFFreeObjectOPEN(Coder, Type, InlVal);
      break;
#endif
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_UnsupportedType, NO_ARGS);
    }
}

/************************************************/

int
CUCFEqualObject(tCoder* Coder, tASN1TypeInfo* Type, void* InlVal, void* Val)
{
  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      {
        tVMSBoolean inlBool = *(tVMSBoolean*)InlVal;
        tVMSBoolean vBool;

        VMSGetBOOLEAN(Coder, Val, Type, vBool);
        if (inlBool != vBool) return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      break;
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      if (!CUCFEqualObjectOBJECT_IDENTIFIER(Coder, Type, InlVal, Val)) return 0;
      break;
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      {
        tVMSReal vReal;

        VMSGetREAL(Coder, Val, Type, vReal);
        if (((tVMSReal*)InlVal)->Kind != vReal.Kind) return 0;
        if (vReal.Kind == rk_Value)
          {
            if ((double)((tVMSReal*)InlVal)->Mantissa *
                pow((double)((tVMSReal*)InlVal)->Base,
                    (double)((tVMSReal*)InlVal)->Exponent) !=
                (double)vReal.Mantissa *
                pow((double)vReal.Base,
                    (double)vReal.Exponent))
              return 0;
          }
      }      
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      {
        tVMSInteger inlInt = *(tVMSInteger*)InlVal;
        tVMSInteger vInt;

        VMSGetINTEGER(Coder, Val, Type, vInt);
        if (inlInt != vInt) return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      {
        tVMSString inlBitString = *(tVMSString*)InlVal;
        tVMSString vBitString;
        int IsEqual = 1;
        
        VMSGetBIT_STRING(Coder, Val, Type, vBitString);
        if (inlBitString.Length != vBitString.Length ||
            memcmp(inlBitString.Value, vBitString.Value, vBitString.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vBitString);
        if (IsEqual == 0) return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      {
        tVMSString inlOctetString = *(tVMSString*)InlVal;
        tVMSString vOctetString;
        int IsEqual = 1;

        VMSGetOCTET_STRING(Coder, Val, Type, vOctetString);
        if (inlOctetString.Length != vOctetString.Length) return 0;
        if (memcmp(inlOctetString.Value, vOctetString.Value, ((tVMSString*)InlVal)->Length))
          IsEqual = 0;
        VMSFreeString(Coder, vOctetString);
        if (IsEqual == 0) return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
      {
        tVMSString inlNumericString = *(tVMSString*)InlVal;
        tVMSString vNumericString;
        int IsEqual = 1;

        VMSGetNumericString(Coder, Val, Type, vNumericString);
        if (inlNumericString.Length != vNumericString.Length) IsEqual = 0;

        if (memcmp(inlNumericString.Value, vNumericString.Value, vNumericString.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vNumericString);
        if (IsEqual == 0) return 0;
      }
      break;
    case type_ASN1_PrintableString:
      {
        tVMSString inlPrintableString = *(tVMSString*)InlVal;
        tVMSString vPrintableString;
        int IsEqual = 1;

        VMSGetPrintableString(Coder, Val, Type, vPrintableString);
        if (inlPrintableString.Length != vPrintableString.Length) IsEqual = 0;
        if (memcmp(inlPrintableString.Value, vPrintableString.Value, vPrintableString.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vPrintableString);
        if (IsEqual == 0) return 0;
      }
      break;
    case type_ASN1_IA5String:
      {
        tVMSString inlIA5String = *(tVMSString*)InlVal;
        tVMSString vIA5String;
        int IsEqual = 1;

        VMSGetIA5String(Coder, Val, Type, vIA5String);
        if (inlIA5String.Length != vIA5String.Length) IsEqual = 0;
        if (memcmp(inlIA5String.Value, vIA5String.Value, vIA5String.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vIA5String);
        if (IsEqual == 0) return 0;
      }
      break;
    case type_ASN1_VisibleString:
      {
        tVMSString inlVisibleString = *(tVMSString*)InlVal;
        tVMSString vVisibleString;
        int IsEqual = 1;

        VMSGetVisibleString(Coder, Val, Type, vVisibleString);
        if (inlVisibleString.Length != vVisibleString.Length) IsEqual = 0;
        if (memcmp(inlVisibleString.Value, vVisibleString.Value, vVisibleString.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vVisibleString);
        if (IsEqual == 0) return 0;
      }
      break;
    case type_ASN1_UTCTime:
      {
        tVMSString inlUTCTime = *(tVMSString*)InlVal;
        tVMSString vUTCTime;
        int IsEqual = 1;

        VMSGetUTCTime(Coder, Val, Type, vUTCTime);
        if (inlUTCTime.Length != vUTCTime.Length) IsEqual = 0;
        if (memcmp(inlUTCTime.Value, vUTCTime.Value, vUTCTime.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vUTCTime);
        if (IsEqual == 0) return 0;
      }
      break;
    case type_ASN1_GeneralizedTime:
      {
        tVMSString inlGeneralizedTime = *(tVMSString*)InlVal;
        tVMSString vGeneralizedTime;
        int IsEqual = 1;

        VMSGetGeneralizedTime(Coder, Val, Type, vGeneralizedTime);
        if (inlGeneralizedTime.Length != vGeneralizedTime.Length) IsEqual = 0;
        if (memcmp(inlGeneralizedTime.Value, vGeneralizedTime.Value, vGeneralizedTime.Length))
          IsEqual = 0;
        VMSFreeString(Coder, vGeneralizedTime);
        if (IsEqual == 0) return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      {
        tVMSEnumerated_Index inlEnumIndex = *(tVMSEnumerated_Index*)InlVal;
        tVMSEnumerated_Index vEnumIndex;

        VMSGetIndexENUMERATED(Coder, Val, Type, vEnumIndex);
        if (inlEnumIndex != vEnumIndex) return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
#endif
#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
      {
        void** CurrInlField = (void**)(((tVMSStruct*)InlVal)->Components);
        if (((tASN1Struct*)Type)->NumOfRC1 > 0)
          if (!CUCFEqualObjectStructComps(Coder, Type, 1, &CurrInlField, Val))
            return 0;
        if (((tASN1Sequence*)Type)->NumOfEAC > 0)
          if (!CUCFEqualObjectStructComps(Coder, Type, 2, &CurrInlField, Val))
            return 0;
        if (((tASN1Sequence*)Type)->NumOfRC2 > 0)
          if (!CUCFEqualObjectStructComps(Coder, Type, 3, &CurrInlField, Val))
            return 0;
      }
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      if (!CUCFEqualObjectSEQUENCE_OF(Coder, Type, InlVal, Val)) return 0;
      break;
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      if (!CUCFEqualObjectSET_OF(Coder, Type, InlVal, Val)) return 0;
      break;
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      if (!CUCFEqualObjectCHOICE(Coder, Type, InlVal, Val)) return 0;
      break;
#endif
    case type_ASN1_DEFINED:
      if (!CUCFEqualObject(Coder, ((tASN1Defined*)Type)->BaseType, InlVal, Val)) return 0;
      break;
    case type_ASN1_TAGGED:
      if (!CUCFEqualObject(Coder, ((tASN1Tagged*)Type)->BaseType, InlVal, Val)) return 0;
      break;
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      if (!CUCFEqualObject(Coder, ((tASN1OpenId*)Type)->BaseType, InlVal, Val)) return 0;
      break;
    case type_ASN1_OPEN:
      if (!CUCFEqualObjectOPEN(Coder, Type, InlVal, Val)) return 0;
      break;
#endif
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_UnsupportedType, NO_ARGS);
    }
  return 1;
}

/************************************************/

#ifdef CODER_VMS_SDT

#ifndef CODER_NOUSE_SET_OF

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static void
SDLFinalizeValueStructComps(tCoder* Coder, tASN1TypeInfo* Type, tASN1Component* Comps, CODER_NumOf_TYPE NumOfComps,
                            void* Val, char FreeFlag)
{
  register tASN1Component* CurrComp = Comps;
  
  for (; NumOfComps > 0; CurrComp++, NumOfComps--)
    {
      void* CurrField;

      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          if ((((tASN1Struct*)Type)->NumOfEAC == 0) || (Comps != ((tASN1Struct*)Type)->ExtAddComps))
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              SDLFinalizeValue(Coder, CurrComp->TypeInfo, CurrField, FreeFlag);
              break;
            }
        case ct_Optional:
          VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            SDLFinalizeValue(Coder, CurrComp->TypeInfo, CurrField, FreeFlag);
          break;
        case ct_Default:
          VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            SDLFinalizeValue(Coder, CurrComp->TypeInfo, CurrField, FreeFlag);
          break;
        default:
          break;
        }
    }
}
#endif

/************************************************/

#ifndef CODER_NOUSE_SEQUENCE_OF
static void
SDLFinalizeValueSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val, char FreeFlag)
{
  tVMSULong i, NumOfComp = 0;
  void* CurrComp = NULL;

  VMSGetSizeSEQUENCE_OF(Coder, Val, Type, NumOfComp);
  for (i = 0; i < NumOfComp; i++)
    {
      VMSGetComponentSEQUENCE_OF(Coder, Val, Type, i, CurrComp);
      SDLFinalizeValue(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrComp, FreeFlag);
    }
  if (FreeFlag)
    {
      tSDLTypeInfo* Sort = (tSDLTypeInfo*)(Type->VRType);
      switch (Sort->TypeClass)
        {
        case type_SDL_LString:
          break;
        case type_SDL_String:
          {
            tSDLStringComponent* CurrItem = ((tSDLSequenceOf*)Val)->First;
            tSDLStringComponent* PrevItem;

            while (CurrItem != NULL)
              {
                PrevItem = CurrItem;
                CurrItem = CurrItem->Suc;
                CUCF_FREE(PrevItem,  VRStructOf->Size + sizeof(tSDLStringComponent) - sizeof(int), 0);
              }
          }
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
    }
}
#endif

/************************************************/

#ifndef CODER_NOUSE_SET_OF
static void
SDLFinalizeValueSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val, char FreeFlag)
{
  tSDLBagComponent* CurrItem = ((tSDLSetOf*)Val)->First;
  tSDLBagComponent* PrevItem;

  tSDLGenListInfo* Sort = (tSDLGenListInfo*)(Type->VRType);

  if (FreeFlag == 0)
    {
      memset(Val, 0, sizeof(tSDLSetOf));
      ((tSDLSetOf*)Val)->IsAssigned = 8;
      while (CurrItem != NULL)
        {
          SDLFinalizeValue(Coder, ((tASN1SetOf*)Type)->BaseType, (void*)&(CurrItem->Data), 0);
          GenBag_Incl2((void*)&(CurrItem->Data), (xBag_Type *)Val, Sort);
          SDLFinalizeValue(Coder, ((tASN1SetOf*)Type)->BaseType, (void*)&(CurrItem->Data), 1);
          PrevItem = CurrItem;
          CurrItem = CurrItem->Suc;
          CUCF_FREE(PrevItem,  VRStructOf->Size + sizeof(tSDLBagComponent) - sizeof(int), 0);
        }
    }
  else
    {
      while (CurrItem != NULL)
        {
          SDLFinalizeValue(Coder, ((tASN1SetOf*)Type)->BaseType, (void*)&(CurrItem->Data), 1);
          PrevItem = CurrItem;
          CurrItem = CurrItem->Suc;
          CUCF_FREE(PrevItem,  VRStructOf->Size + sizeof(tSDLBagComponent) - sizeof(int), 0);
        }
    }
}
#endif

/************************************************/

void
SDLFinalizeValue(tCoder* Coder, tASN1TypeInfo* Type, void* Val, char FreeFlag)
{
  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
#endif
#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
      {
        if (((tASN1Sequence*)Type)->NumOfRC1 > 0)
          SDLFinalizeValueStructComps(Coder, Type, ((tASN1Struct*)Type)->RootComps1, ((tASN1Struct*)Type)->NumOfRC1, Val, FreeFlag);
        if (((tASN1Sequence*)Type)->NumOfEAC > 0)
          SDLFinalizeValueStructComps(Coder, Type, ((tASN1Struct*)Type)->ExtAddComps, ((tASN1Struct*)Type)->NumOfEAC, Val, FreeFlag);
        if (((tASN1Sequence*)Type)->NumOfRC2 > 0)
          SDLFinalizeValueStructComps(Coder, Type, ((tASN1Struct*)Type)->RootComps2, ((tASN1Struct*)Type)->NumOfRC2, Val, FreeFlag);
      }
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      SDLFinalizeValueSEQUENCE_OF(Coder, Type, Val, FreeFlag);
      break;
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      SDLFinalizeValueSET_OF(Coder, Type, Val, FreeFlag);
      break;
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      {
        tASN1Alternative* AltInfo = NULL;
        void* Alternative;
        VMSGetAlternativeCHOICE(Coder, Val, Type, AltInfo, Alternative);
        SDLFinalizeValue(Coder, AltInfo->TypeInfo, Alternative, FreeFlag);
      }
      break;
#endif
    case type_ASN1_DEFINED:
      SDLFinalizeValue(Coder, ((tASN1Defined*)Type)->BaseType, Val, FreeFlag);
      break;
    case type_ASN1_TAGGED:
      SDLFinalizeValue(Coder, ((tASN1Tagged*)Type)->BaseType, Val, FreeFlag);
      break;
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      SDLFinalizeValue(Coder, ((tASN1OpenId*)Type)->BaseType, Val, FreeFlag);
      break;
    case type_ASN1_OPEN:
      {
        tASN1Object* ObjInfo = NULL;
        void* Object;
        VMSGetObjectOPEN(Coder, Val, Type, ObjInfo, Object);
        SDLFinalizeValue(Coder, ObjInfo->TypeInfo, Object, FreeFlag);
      }
      break;
#endif
    default:
      break;
    }

  if (FreeFlag)
    {
      switch(Type->TypeClass)
        {
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
        case type_ASN1_OBJECT_IDENTIFIER:
          {
            SDL_Object_Identifier_yrec* CurrItem = ((SDL_Object_Identifier*)Val)->First;
            SDL_Object_Identifier_yrec* PrevItem;

            while (CurrItem != NULL)
              {
                PrevItem = CurrItem;
                CurrItem = CurrItem->Suc;
                CUCF_FREE(PrevItem,  sizeof(SDL_Object_Identifier_yrec), 0);
              }
            break;
          }
#endif
#ifndef CODER_NOUSE_BIT_STRING
        case type_ASN1_BIT_STRING:
          if (((SDL_Bit_String*)Val)->Length > 0)
            CUCF_FREE(((SDL_Bit_String*)Val)->Bits, ((SDL_Bit_String*)Val)->Length, 0);
          break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
        case type_ASN1_OCTET_STRING:
          if (((SDL_Octet_String*)Val)->Length > 0)
            CUCF_FREE(((SDL_Octet_String*)Val)->Bits, ((SDL_Octet_String*)Val)->Length, 0);
          break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
        case type_ASN1_NumericString:
        case type_ASN1_PrintableString:
        case type_ASN1_IA5String:
        case type_ASN1_VisibleString:
        case type_ASN1_UTCTime:
        case type_ASN1_GeneralizedTime:
          CUCF_FREE(*(SDL_Charstring*)Val, strlen(*(SDL_Charstring*)Val), 0);
          break;
#endif
        default:
          break;
        }
    }
}

#endif /* CODER_NOUSE_SET_OF */

#endif /* CODER_VMS_SDT */
