/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "vms/vms_check.h"

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_VALUE)

/************************************************/

#ifndef CODER_NOUSE_INTEGER
int
CUCFCheckINTEGER(tCoder* Coder, tASN1TypeInfo* Type, tVMSInteger* Integer)
{
  const tASN1IntegerConstraint* IntegerConstraint = &((tASN1Integer*)Type)->IntegerConstraint;
  if (IntegerConstraint->ExtMarker == em_Absent)
    {
      if (((((tASN1Integer*)Type)->ConstraintMask & 0x10) && (IntegerConstraint->pLBound > *Integer)) ||
          ((((tASN1Integer*)Type)->ConstraintMask & 0x01) && (IntegerConstraint->pUBound < *Integer)))
        return ec_VAL_WrongConstrainedValue;
    }
  return ec_SUCCESS;
}
#endif

/************************************************/

#ifndef CODER_NOUSE_BIT_STRING
int
CUCFCheckBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, tVMSString* String)
{
  const tASN1SizeConstraint* SizeConstraint = &((tASN1String*)Type)->SizeConstraint;
  if (SizeConstraint->ExtMarker == em_Absent)
    {
      if (((tVMSULong)SizeConstraint->LBound > String->Length) ||
          ((((tASN1String*)Type)->ConstraintMask) && ((tVMSULong)SizeConstraint->pUBound < String->Length)))
        return ec_VAL_WrongConstrainedLength;
    }
    return ec_SUCCESS;
}
#endif

/************************************************/

#ifndef CODER_NOUSE_OCTET_STRING
int
CUCFCheckOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, tVMSString* String)
{
  const tASN1SizeConstraint* SizeConstraint = &((tASN1String*)Type)->SizeConstraint;
  if (SizeConstraint->ExtMarker == em_Absent)
    {
      if (((tVMSULong)SizeConstraint->LBound > String->Length) ||
          ((((tASN1String*)Type)->ConstraintMask) && ((tVMSULong)SizeConstraint->pUBound < String->Length)))
        return ec_VAL_WrongConstrainedLength;
    }
    return ec_SUCCESS;
}
#endif

/************************************************/

#ifndef CODER_NOUSE_CHARACTER_STRING
int
CUCFCheckCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, tVMSString* String)
{
  if (((tASN1CharString*)Type)->SizeConstraint.ExtMarker == em_Absent)
    {
      if (((tVMSULong)(((tASN1CharString*)Type)->SizeConstraint.LBound) > String->Length) ||
          ((((tASN1CharString*)Type)->ConstraintMask) && ((tVMSULong)(((tASN1CharString*)Type)->SizeConstraint.pUBound) < String->Length)))
        return ec_VAL_WrongConstrainedLength;
    }
  if (((tASN1CharString*)Type)->AlphabetLen > 0)
    {
      tVMSULong i, j;

      for (i = 0; i < String->Length; i++)
        {
          unsigned char CurrChar = String->Value[i];
          for (j = 0; (j < ((tASN1CharString*)Type)->AlphabetLen) && (CurrChar != ((tASN1CharString*)Type)->Alphabet[j]); j++);

          if (j == ((tASN1CharString*)Type)->AlphabetLen)
            return ec_VAL_WrongConstrainedAlphabet;
        }
    }
  return ec_SUCCESS;
}
#endif

/************************************************/

#ifndef CODER_NOUSE_SEQUENCE_OF
int
CUCFCheckSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSULong NumOfComp = 0;
  VMSGetSizeSEQUENCE_OF(Coder, Val, Type, NumOfComp);
  if (((tASN1StructOf*)Type)->SizeConstraint.ExtMarker == em_Absent)
    {
      if (((tVMSULong)(((tASN1StructOf*)Type)->SizeConstraint.LBound) > NumOfComp) ||
          ((((tASN1StructOf*)Type)->ConstraintMask) && ((tVMSULong)(((tASN1StructOf*)Type)->SizeConstraint.pUBound) < NumOfComp)))
        return ec_VAL_WrongConstrainedLength;
    }
  return ec_SUCCESS;
}
#endif

/************************************************/

#ifndef CODER_NOUSE_SET_OF
int
CUCFCheckSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSULong NumOfComp;
  VMSGetSizeSET_OF(Coder, Val, Type, NumOfComp);
  if (((tASN1StructOf*)Type)->SizeConstraint.ExtMarker == em_Absent)
    {
      if (((tVMSULong)(((tASN1StructOf*)Type)->SizeConstraint.LBound) > NumOfComp) ||
          ((((tASN1StructOf*)Type)->ConstraintMask) && ((tVMSULong)(((tASN1StructOf*)Type)->SizeConstraint.pUBound) < NumOfComp)))
        return ec_VAL_WrongConstrainedLength;
    }
  return ec_SUCCESS;
}
#endif

/************************************************/

#endif
