/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"

void
PrintBinaryString(FILE* f, char* String, tVMSULong Length)
{
  tVMSULong i;
  unsigned char j;
        
  for (i = 0; i < Length; i++)
    {
      for (j = 0; j < 8; j++)
        if ((String[i] >> (7 - (j % 8))) & 0x1)
          fputc('1', f);
        else
          fputc('0', f);
      fputc(' ', f);
    }
  fputc('\n', f);
}

#ifdef CODER_VMS_PRINT

const static char numToHexCharTbl[16] = 
  { '0', '1', '2', '3', '4', '5', '6', '7', 
    '8', '9', 'A', 'B', 'C', 'D' ,'E', 'F' };

#define TO_HEX(fourBits) (numToHexCharTbl[(fourBits) & 0x0f])

/************************************************/

static void ASN1PrintTypeBody(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, char TagFlag, unsigned short indent);
static void ASN1PrintBody(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent);

/************************************************/

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
static void ASN1PrintBodyOBJECT_IDENTIFIER(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent);
#endif

/************************************************/

#ifndef CODER_NOUSE_CHARACTER_STRING
static void ASN1PrintCHARACTER_STRING(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, tVMSString* vString, unsigned short indent);
#endif

/************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static void ASN1PrintTypeBodyStructComps(FILE* f, tCoder* Coder, CODER_NumOf_TYPE NumOfComps, tASN1Component* Component,
                                         unsigned short indent);
static unsigned char ASN1PrintBodyStructComps(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, unsigned char KindOfComps,
                                              void* Val, unsigned short indent);
#endif

/************************************************/

#ifndef CODER_NOUSE_SEQUENCE_OF
static void ASN1PrintBodySEQUENCE_OF(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent);
#endif

/************************************************/

#ifndef CODER_NOUSE_SET_OF
static void ASN1PrintBodySET_OF(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent);
#endif

/************************************************/

#ifndef CODER_NOUSE_CHOICE
static void ASN1PrintBodyCHOICE(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent);
#endif

/************************************************/

#ifndef CODER_NOUSE_OPEN
static void ASN1PrintBodyOPEN(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent);
#endif

/************************************************/

int
ASN1PrintType(FILE* f, tASN1TypeInfo* Type)
{
  int ErrorCode;
  tCoder Coder;

  CUCFSetErrorCatcher(&Coder, ErrorCode);
  if (ErrorCode == 0)
    {
      fprintf(f, "%s ::= ", GetASCIITypeName(Type));
      ASN1PrintTypeBody(f, &Coder, Type, 1, 0);
      fputc('\n', f);
    }

  Coder.EMS.IsAssigned = 0;

  return ErrorCode;
}

/************************************************/

int
ASN1Print(FILE* f, tASN1TypeInfo *Type, void* val)
{
  int ErrorCode;
  tCoder Coder;

  CUCFSetErrorCatcher(&Coder, ErrorCode);
  if (ErrorCode == 0)
    {
      fprintf(f, "value %s ::= ",
              GetASCIITypeName(Type));
      ASN1PrintBody(f, &Coder, Type, val, 0);
      fputc('\n', f);
    }

  Coder.EMS.IsAssigned = 0;

  return ErrorCode;
}

/************************************************/

char*
GetASCIITypeName(tASN1TypeInfo* Type)
{
  return Type->TypeName + 6;
}

/************************************************/

char*
GetASCIITypeKind(tASN1TypeInfo* Type)
{
  switch (Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      return (char*)"BOOLEAN";
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      return (char*)"NULL";
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      return (char*)"OBJECT IDENTIFIER";
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      return (char*)"REAL";
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      return (char*)"INTEGER";
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      return (char*)"BIT STRING";
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      return (char*)"OCTET STRING";
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
      return (char*)"NumericString";
    case type_ASN1_PrintableString:
      return (char*)"PrintableString";
    case type_ASN1_IA5String:
      return (char*)"IA5String";
    case type_ASN1_VisibleString:
      return (char*)"VisibleString";
    case type_ASN1_UTCTime:
      return (char*)"UTCTime";
    case type_ASN1_GeneralizedTime:
      return (char*)"GeneralizedTime";
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      return (char*)"ENUMERATED";
#endif
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
      return (char*)"SEQUENCE";
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
      return (char*)"SET";
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      return (char*)"SEQUENCE OF";
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      return (char*)"SET OF";
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      return (char*)"CHOICE";
#endif
    case type_ASN1_DEFINED:
      return (char*)"DEFINED";
    case type_ASN1_TAGGED:
      return (char*)"TAGGED";
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      return (char*)"OPEN identifier";
    case type_ASN1_OPEN:
      return (char*)"OPEN";
#endif
    default:
      return (char*)"unknown type";
    }
}

/************************************************/

char*
GetASCIITagClass(tASN1Tag* Tag)
{
  switch (Tag->Class)
    {
    case tc_UT:
      return (char*)"UNIVERSAL ";
    case tc_AP:
      return (char*)"APPLICATION ";
    case tc_CS:
      return (char*)""; /* context-specific */
    case tc_PR:
      return (char*)"PRIVATE ";
    }
  return (char*)"";
}

/************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
char*
GetASCIIComponentType(tASN1Component* Component)
{
  switch (Component->Type)
    {
    case ct_Required:
      return (char*)"";
    case ct_Optional:
    case ct_Present:
    case ct_Absent:
      return (char*)" OPTIONAL";
    case ct_Default:
      return (char*)" DEFAULT none-value";
    }
  return (char*)"";
}
#endif

/************************************************/

void
Indent(FILE* f, unsigned short indent)
{
  unsigned int i;

  for (i = 0; i < indent; i++)
    fprintf(f, " ");
}

/************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static void
ASN1PrintTypeBodyStructExtGroup(FILE* f, tCoder* Coder, tASN1Component** Component, unsigned short indent)
{
  register tASN1Component* CurrComp = (*Component + 1);
  CODER_NumOf_TYPE i;

  fprintf(f, "[[");
  indent = (unsigned short)(indent + INIT_INDENT);

  for (i = 0; i < (*Component)->Index; i++, CurrComp++)
    {
      if (i != 0)
        fprintf(f, ",");
      fprintf(f, "\n");

      Indent(f, indent);
      fprintf(f, "%s ", CurrComp->Name);
      ASN1PrintTypeBody(f, Coder, CurrComp->TypeInfo, 0, indent);
    }

  indent = (unsigned short)(indent - INIT_INDENT);
  fprintf(f, "\n");
  Indent(f, indent);
  fprintf(f, "]]");
  *Component = CurrComp - 1;
}

/************************************************/

static void
ASN1PrintTypeBodyStructComps(FILE* f, tCoder* Coder, CODER_NumOf_TYPE NumOfComps, tASN1Component* Component, unsigned short indent)
{
  tASN1Component* CurrComp = Component;
  register CODER_NumOf_TYPE i;
  
  for (i = 0; i < NumOfComps; CurrComp++, i++)
    {
      if (i != 0)
        fprintf(f, ",");
      fprintf(f, "\n");

      Indent(f, indent);
      if (CurrComp->Type == ct_Group)
        {
          i = (CODER_NumOf_TYPE)(i + CurrComp->Index);
          ASN1PrintTypeBodyStructExtGroup(f, Coder, &CurrComp, indent);
        }
      else
        {
          fprintf(f, "%s ", CurrComp->Name);
          ASN1PrintTypeBody(f, Coder, CurrComp->TypeInfo, 0, indent);
        }
    }
}
#endif

/************************************************/

static void
ASN1PrintTypeBody(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, char TagFlag, unsigned short indent)
{
  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL 1] ");
#endif
      fprintf(f, "BOOLEAN");
      break;
#endif

#ifndef CODER_NOUSE_NULL      
    case type_ASN1_NULL:
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL 5] ");
#endif
      fprintf(f, "NULL");
      break;
#endif

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL 6] ");
#endif
      fprintf(f, "OBJECT IDENTIFIER");
      break;
#endif

#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL 9] ");
#endif
      fprintf(f, "REAL");
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL 2] ");
#endif
      fprintf(f, "INTEGER");
      if ((((tASN1Integer*)Type)->ConstraintMask & 0x10) || (((tASN1Integer*)Type)->ConstraintMask & 0x01))
        {
          if (((tASN1Integer*)Type)->ConstraintMask & 0x10)
            fprintf(f, " (%d ", (int)(((tASN1Integer*)Type)->IntegerConstraint.pLBound));
          else
            fprintf(f, "MIN ");

          if (((tASN1Integer*)Type)->ConstraintMask & 0x01)
            fprintf(f, ".. %d", (int)(((tASN1Integer*)Type)->IntegerConstraint.pUBound));
          else
            fprintf(f, ".. MAX");

          if (((tASN1Integer*)Type)->IntegerConstraint.ExtMarker == em_Present)
            fprintf(f, ", ...");

          fprintf(f, ")");
        }
      else
      if (((tASN1Integer*)Type)->IntegerConstraint.ExtMarker == em_Present)
        fprintf(f, " (...)");
      break;
#endif

#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
#endif
#if !defined (CODER_NOUSE_OCTET_STRING) || !defined(CODER_NOUSE_BIT_STRING)
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL %d] ", (int)(Type->TypeClass));
#endif
      fprintf(f, "%s", GetASCIITypeKind(Type));
      if (((tASN1String*)Type)->ConstraintMask)
        {
          fprintf(f, " ( SIZE (");
          if (((tASN1String*)Type)->SizeConstraint.LBound != ((tASN1String*)Type)->SizeConstraint.pUBound)
            fprintf(f, "%ld .. %ld", ((tASN1String*)Type)->SizeConstraint.LBound, ((tASN1String*)Type)->SizeConstraint.pUBound);
          else
            fprintf(f, "%ld", ((tASN1String*)Type)->SizeConstraint.LBound);
          if (((tASN1String*)Type)->SizeConstraint.ExtMarker == em_Present)
            fprintf(f, ", ...");

          fprintf(f, ") )");
        }
      else
      if (((tASN1String*)Type)->SizeConstraint.ExtMarker == em_Present)
        fprintf(f, " ( SIZE (...) )");
      break;
#endif

#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
    case type_ASN1_PrintableString:
    case type_ASN1_IA5String:
    case type_ASN1_VisibleString:
      {
        const unsigned char* Alphabet = ((tASN1CharString*)Type)->Alphabet;
        tVMSULong i, AlphabetLen      = ((tASN1CharString*)Type)->AlphabetLen;

#ifndef CODER_REMOVE_BER
        if (TagFlag) fprintf (f, "[UNIVERSAL %d] ", (int)(Type->TypeClass & 0x1F));
#endif
        fprintf(f, "%s", GetASCIITypeKind(Type));
        if (AlphabetLen > 0)
          {
            fprintf(f, "( FROM (\"");
            for (i = 0; i < AlphabetLen; i++)
              fprintf(f, "%c", isprint((int)Alphabet[i]) ? Alphabet[i] : '.');

            fprintf(f, "\") ");
          }
        if (((tASN1CharString*)Type)->ConstraintMask)
          {
            if (AlphabetLen > 0)
              fprintf(f, "^ SIZE (");
            else 
              fprintf(f, " ( SIZE (");
            if (((tASN1CharString*)Type)->SizeConstraint.LBound != ((tASN1CharString*)Type)->SizeConstraint.pUBound)
                fprintf(f, "%ld .. %ld", ((tASN1CharString*)Type)->SizeConstraint.LBound, 
                                         ((tASN1CharString*)Type)->SizeConstraint.pUBound);
            else
              fprintf(f, "%ld", ((tASN1CharString*)Type)->SizeConstraint.LBound);

            if (((tASN1CharString*)Type)->SizeConstraint.ExtMarker == em_Present)
              fprintf(f, ", ...");

            fprintf(f, ") )");
          }
        else if (((tASN1CharString*)Type)->SizeConstraint.ExtMarker == em_Present)
          {
            if (AlphabetLen > 0)
              fprintf(f, "^ SIZE (...) )");
            else
              fprintf(f, "( SIZE (...) )");
          }
      }
      break;

    case type_ASN1_UTCTime:
    case type_ASN1_GeneralizedTime:
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL %d] ", (int)(Type->TypeClass));
#endif
      fprintf(f, "%s", GetASCIITypeKind(Type));
      break;
#endif

#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      {
        tVMSULong i, len = ((tASN1Enumerated*)Type)->NumOfItems;

#ifndef CODER_REMOVE_BER
        if (TagFlag) fprintf (f, "[UNIVERSAL 10] ");
#endif
        fprintf(f, "ENUMERATED {");
        indent = (unsigned short)(indent + INIT_INDENT);
        for (i = 0; i < len; i++)
          {
            if (i > 0)
              fprintf(f, ",");
            fprintf(f, "\n");
            if (((tASN1Enumerated*)Type)->ExtMarker == (long)i)
              {
                Indent(f, indent);
                fprintf(f, "...,\n");
              }
            Indent(f, indent);
            fprintf(f, "%s(%d)", ((tASN1Enumerated*)Type)->Items[i].Name, (int)(((tASN1Enumerated*)Type)->Items[i].Value));
          }
        if (((tASN1Enumerated*)Type)->ExtMarker == (long)i)
          {
            if (i > 0)
              fprintf(f, ",");
            Indent(f, indent);
            fprintf(f, "\n...");
          }
        fprintf(f, "\n");
        indent = (unsigned short)(indent - INIT_INDENT);
        Indent(f, indent);
        fprintf(f, "}");
      }
      break;
#endif

#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
#endif
#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
      {
#ifndef CODER_REMOVE_BER
        if (TagFlag) fprintf (f, "[UNIVERSAL %d] ", (int)(Type->TypeClass));
#endif
        fprintf(f, "%s {", GetASCIITypeKind(Type));
        indent = (unsigned short)(indent + INIT_INDENT);
        if (((tASN1Struct*)Type)->NumOfRC1 > 0)
          ASN1PrintTypeBodyStructComps(f, Coder, ((tASN1Struct*)Type)->NumOfRC1, ((tASN1Struct*)Type)->RootComps1, indent);
        if (((tASN1Sequence*)Type)->RootExtFlags &  0x01)
          {
            if (((tASN1Struct*)Type)->NumOfRC1 > 0)
              fprintf(f, ",");

            if (((tASN1Struct*)Type)->NumOfEAC > 0)
              {
                fprintf(f, "\n");
                Indent(f, indent);
                fprintf(f, "...,");
                ASN1PrintTypeBodyStructComps(f, Coder, ((tASN1Struct*)Type)->NumOfEAC, ((tASN1Struct*)Type)->ExtAddComps, indent);
                fprintf(f, ",");
              }
            fprintf(f, "\n");
            Indent(f, indent);
            fprintf(f, "...");

            if (((tASN1Struct*)Type)->NumOfRC2 > 0)
              fprintf(f, ",");
          }
        else
        if ((((tASN1Struct*)Type)->NumOfRC1 > 0) && (((tASN1Struct*)Type)->NumOfRC2 > 0))
          fprintf(f, ",");
        if (((tASN1Struct*)Type)->NumOfRC2 > 0)
          ASN1PrintTypeBodyStructComps(f, Coder, ((tASN1Struct*)Type)->NumOfRC2, ((tASN1Struct*)Type)->RootComps2, indent);
        fprintf(f, "\n");
        indent = (unsigned short)(indent - INIT_INDENT);
        Indent(f, indent);
        fprintf(f, "}");
      }
      break;
#endif

#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
#endif

#if !defined(CODER_NOUSE_SEQUENCE_OF) || !defined(CODER_NOUSE_SET_OF)
#ifndef CODER_REMOVE_BER
      if (TagFlag) fprintf (f, "[UNIVERSAL %d] ", (int)(Type->TypeClass & 0x1F));
#endif
      switch (Type->TypeClass)
        {
#ifndef CODER_NOUSE_SEQUENCE_OF
        case type_ASN1_SEQUENCE_OF:
          fprintf(f, "SEQUENCE ");
          break;
#endif
#ifndef CODER_NOUSE_SET_OF
        case type_ASN1_SET_OF:
          fprintf(f, "SET ");
          break;
#endif
        default:
          break;
        }
      if (((tASN1StructOf*)Type)->ConstraintMask)
        {
          fprintf(f, " SIZE (%ld .. %ld", ((tASN1StructOf*)Type)->SizeConstraint.LBound,
                  (((tASN1StructOf*)Type)->SizeConstraint.pUBound));
          if (((tASN1StructOf*)Type)->SizeConstraint.ExtMarker == em_Present)
            fprintf(f, ", ...");

          fprintf(f, ") ");
        }
      else if (((tASN1StructOf*)Type)->SizeConstraint.ExtMarker == em_Present)
        {
          fprintf(f, " SIZE (...) ");
        }
      fprintf(f, "OF ");
      ASN1PrintTypeBody(f, Coder, ((tASN1StructOf*)Type)->BaseType, 0, (unsigned short)(indent + INIT_INDENT));
      break;
#endif

#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      {
        unsigned char FirstFlag = 0;
        CODER_NumOf_TYPE i, GroupAlts = 0;
        tASN1Alternative* CurrAlt = ((tASN1Choice*)Type)->Alternatives;

        fprintf(f, "%s {", GetASCIITypeKind(Type));
        indent = (unsigned short)(indent + INIT_INDENT);
        for (i = 0; i < ((tASN1Choice*)Type)->NumOfAlts; i++, CurrAlt++)
          {      
            if (((tASN1Choice*)Type)->ExtMarker == (long)i)
              {
                if (FirstFlag == 0)
                  {
                    fprintf (f, "\n");
                    Indent(f, indent);
                    fprintf (f, "...");
                    FirstFlag = 1;
                  }
                else
                  {
                    fprintf (f, ",\n");
                    Indent(f, indent);
                    fprintf (f, "...");
                  }
              }

            if (FirstFlag == 0)
              FirstFlag = 1;
            else
              fprintf(f, ",");
            fprintf(f, "\n");
            Indent(f, indent);

            switch (CurrAlt->Type)
              {
              case ct_Required:
              case ct_Absent:
                {
                  fprintf(f, "%s ", CurrAlt->Name);
                  ASN1PrintTypeBody(f, Coder, CurrAlt->TypeInfo, 0, indent);
                  if (GroupAlts > 0)
                    {
                      GroupAlts--;
                      if (GroupAlts == 0)
                        {
                          fprintf(f, "]]");
                          indent = (unsigned short)(indent - INIT_INDENT);
                        }
                    }
                }
                break;
              case ct_Group:
                GroupAlts = CurrAlt->Index;
                FirstFlag = 0;
                fprintf(f, "[[");
                indent = (unsigned short)(indent + INIT_INDENT);
                break;
              default:
                break;
              }


          }
        fprintf(f, "\n");
        indent = (unsigned short)(indent - INIT_INDENT);
        Indent(f, indent);
        fprintf(f, "}");
      }
      break;
#endif

    case type_ASN1_DEFINED:
      ASN1PrintTypeBody(f, Coder, ((tASN1Defined*)Type)->BaseType, TagFlag, indent);
      break;

    case type_ASN1_TAGGED:
#ifndef CODER_REMOVE_BER
      if (TagFlag)
        {
          CODER_NumOf_TYPE i;
          for (i = 0; i < (CODER_NumOf_TYPE)((tASN1Tagged*)Type)->NumOfTags; i++)
            fprintf(f, "[%s%d] ", GetASCIITagClass(&((tASN1Tagged*)Type)->Tags[i]), (int)((tASN1Tagged*)Type)->Tags[i].Number);
        }
#endif
      ASN1PrintTypeBody(f, Coder, ((tASN1Tagged*)Type)->BaseType, 0, indent);
      break;

#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      ASN1PrintTypeBody(f, Coder, ((tASN1OpenId*)Type)->BaseType, TagFlag, indent);
      break;
    case type_ASN1_OPEN:
      {
        tASN1Open* Open = (tASN1Open*)Type;
        CODER_NumOf_TYPE len = Open->NumOfObjects, i;

        fprintf(f, "%s {\n", GetASCIITypeKind(Type));
        indent = (unsigned short)(indent + INIT_INDENT);
        for (i = 0; i < len; i++)
          {
            if (i > 0)
              fprintf(f, ",\n");
            Indent(f, indent);
            fprintf(f, "%s ", Open->Objects[i].Name);
            ASN1PrintTypeBody(f, Coder, Open->Objects[i].TypeInfo, 0, indent);
          }
        indent = (unsigned short)(indent + INIT_INDENT);
        fprintf(f, "\n");
        Indent(f, indent);
        fprintf(f, "}");
      }
      break;
#endif
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_UnsupportedType, NO_ARGS);
    }
}

/************************************************/

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
static void
ASN1PrintBodyOBJECT_IDENTIFIER(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent)
{
  tVMSULong NumOfComp, i;
  tVMSObjId_Component CurrComp = 0;

  VMSGetSizeOBJECT_IDENTIFIER(Coder, Val, Type, NumOfComp);
  VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, 0, CurrComp);
  fprintf(f, "{ %u ", (unsigned int)CurrComp);
  VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, 1, CurrComp);
  fprintf(f, "%u", (unsigned int)CurrComp);
  for (i = 2; i < NumOfComp; i++)
    {
      VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, i, CurrComp);
      fprintf(f, " %u", (unsigned int)CurrComp);
    }
  fprintf(f, " }");
}
#endif

/************************************************/

#ifndef CODER_NOUSE_CHARACTER_STRING
static void
ASN1PrintCHARACTER_STRING(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, tVMSString* vString, unsigned short indent)
{
  tVMSULong i;

  fprintf(f, "\"");
  for (i = 0; i < vString->Length; i++)
    fprintf(f, "%c", vString->Value[i]);

  fprintf(f, "\"");
  fprintf(f, "  -- '");
  for (i = 0; i < vString->Length; i++)
    {
      unsigned char Byte = vString->Value[i];
      fprintf(f, "%c%c", TO_HEX(Byte >> 4), TO_HEX(Byte));
    }
  fprintf(f, "'H --");
}
#endif

/************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static unsigned char
ASN1PrintBodyStructComps(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, unsigned char KindOfComps, void* Val, unsigned short indent)
{
  register tASN1Component* CurrComp;
  register CODER_NumOf_TYPE NumOfComps, i;
  register void* CurrField = NULL;
  unsigned char PrintFlag = KindOfComps;

  KindOfComps &= 0x03;
  switch (KindOfComps)
    {
    case 1:
      CurrComp = ((tASN1Struct*)Type)->RootComps1;
      NumOfComps = ((tASN1Struct*)Type)->NumOfRC1;
      break;
    case 2:
      CurrComp = ((tASN1Struct*)Type)->ExtAddComps;
      NumOfComps = ((tASN1Struct*)Type)->NumOfEAC;
      break;
    default:
      CurrComp = ((tASN1Struct*)Type)->RootComps2;
      NumOfComps = ((tASN1Struct*)Type)->NumOfRC2;
      break;
    }

  for (i = 0; i < NumOfComps; CurrComp++, i++)
    {
      if ((CurrComp->Type != ct_Group) && (CurrComp->Type != ct_Absent))
        {
          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              if (KindOfComps != 2)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  break;
                }
              /* break; not needed !!! */
            case ct_Optional:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              break;
            case ct_Default:
              VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              break;
            default:
              break;
            }

          if (CurrField != NULL)
            {
              if (PrintFlag > 0x0F)
                fprintf(f, ",\n");
              else
                {
                  fprintf(f, "\n");
                  PrintFlag = 0x10;
                }
              Indent(f, indent);
              fprintf(f, "%s ", CurrComp->Name);
              ASN1PrintBody(f, Coder, CurrComp->TypeInfo, CurrField, indent);
            }
        }
    }

  return PrintFlag;
}
#endif

/************************************************/

#ifndef CODER_NOUSE_SEQUENCE_OF
static void
ASN1PrintBodySEQUENCE_OF(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent)
{
  tVMSULong NumOfComp = 0;

  VMSGetSizeSEQUENCE_OF(Coder, Val, Type, NumOfComp);
  fprintf(f, "{");
  if (NumOfComp > 0)
    {
      tVMSULong i;
      void* CurrComp = NULL;

      indent = (unsigned short)(indent + INIT_INDENT);
      for (i = 0; i < NumOfComp; i++)
        {
          if (i > 0)
            fprintf(f, ",");
          fprintf(f, "\n");
          Indent(f, (unsigned short)indent);
          VMSGetComponentSEQUENCE_OF(Coder, Val, Type, i, CurrComp);
          ASN1PrintBody(f, Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrComp, indent);
        }
      fprintf(f, "\n");
      indent = (unsigned short)(indent - INIT_INDENT);
      Indent(f, indent);
    }
  else
    fprintf(f, " ");
  fprintf(f, "}");
}
#endif

/************************************************/

#ifndef CODER_NOUSE_SET_OF
static void
ASN1PrintBodySET_OF(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent)
{
  tVMSULong NumOfComp;

  VMSGetSizeSET_OF(Coder, Val, Type, NumOfComp);
  fprintf(f, "{");
  if (NumOfComp > 0)
    {
      tVMSULong i;
      void* CurrComp = NULL;

      indent = (unsigned short)(indent + INIT_INDENT);
      for (i = 0; i < NumOfComp; i++)
        {
          if (i > 0)
            fprintf(f, ",");
          fprintf(f, "\n");
          Indent(f, (unsigned short)indent);
          VMSGetComponentSET_OF(Coder, Val, Type, i, CurrComp);
          ASN1PrintBody(f, Coder, ((tASN1SetOf*)Type)->BaseType, CurrComp, indent);
        }
      fprintf(f, "\n");
      indent = (unsigned short)(indent - INIT_INDENT);
      Indent(f, indent);
    }
  else
    fprintf(f, " ");
  fprintf(f, "}");
}
#endif

/************************************************/

#ifndef CODER_NOUSE_CHOICE
static void
ASN1PrintBodyCHOICE(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent)
{
  tASN1Alternative* AltInfo = NULL;
  void* Alternative;
  VMSGetAlternativeCHOICE(Coder, Val, Type, AltInfo, Alternative);
  fprintf(f, "%s : ", AltInfo->Name);
  ASN1PrintBody(f, Coder, AltInfo->TypeInfo, Alternative, indent);
}
#endif

/************************************************/

#ifndef CODER_NOUSE_OPEN
static void
ASN1PrintBodyOPEN(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent)
{
  tASN1Object* ObjInfo = NULL;
  void* Object;
  VMSGetObjectOPEN(Coder, Val, Type, ObjInfo, Object);
  fprintf(f, "%s : ", ObjInfo->Name);
  ASN1PrintBody(f, Coder, ObjInfo->TypeInfo, Object, indent);
}
#endif

/************************************************/

static void
ASN1PrintBody(FILE* f, tCoder* Coder, tASN1TypeInfo* Type, void* Val, unsigned short indent)
{
  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      {
        tVMSBoolean vBool;

        VMSGetBOOLEAN(Coder, Val, Type, vBool);
        if (vBool)
          fprintf(f, "TRUE");
        else
          fprintf(f, "FALSE");
      }
      break;
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      fprintf(f, "NULL");
      break;
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      ASN1PrintBodyOBJECT_IDENTIFIER(f, Coder, Type, Val, indent);
      break;
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      {
        tVMSReal vReal;

        VMSGetREAL(Coder, Val, Type, vReal);
        switch (vReal.Kind)
          {
          case rk_Zero:
            fprintf(f, "0");
            break;
          case rk_MINUS_INFINITY:
            fprintf(f, "MINUS_INFINITY");
            break;
          case rk_PLUS_INFINITY:
            fprintf(f, "PLUS_INFINITY");
            break;
          case rk_Value:
            fprintf(f, "{ mantissa %d, base %u, exponent %d }",
                    (int)vReal.Mantissa,
                    (unsigned int)vReal.Base,
                    (int)vReal.Exponent);
            
            break;
          }
      }      
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      {
        tVMSInteger vInt;

        VMSGetINTEGER(Coder, Val, Type, vInt);
        fprintf(f, "%d", (int)vInt);
      }
      break;
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      {
        tVMSString vBitString;
        tVMSULong i;
        
        VMSGetBIT_STRING(Coder, Val, Type, vBitString);
        fprintf(f, "'");
        for (i = 0; i < vBitString.Length;)
          {
            char j;
            for (j = 7; j >= 0 && i < vBitString.Length; j--, i++)
              fprintf(f, "%c", (vBitString.Value[i >> 3] & (1 << j))? '1' : '0');
          }
        fprintf(f, "'B");
        fprintf(f, "  -- '");
        if (vBitString.Length > 0)
          {
            tVMSULong hexLength = ((vBitString.Length - 1) >> 3) + 1;
            for (i = 0; i < hexLength; i++)
              {
                unsigned char Byte = vBitString.Value[i >> 3];
                fprintf(f, "%c%c", TO_HEX(Byte >> 4), TO_HEX(Byte));
              }
          }
        fprintf(f, "'H --");
        VMSFreeString(Coder, vBitString);
      }
      break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      {
        tVMSString vOctetString;
        tVMSULong i;

        VMSGetOCTET_STRING(Coder, Val, Type, vOctetString);
        fprintf(f, "'");
        for (i = 0; i < vOctetString.Length; i += 2)
          {
            unsigned char Byte = vOctetString.Value[i >> 1];
            fprintf(f, "%c", TO_HEX(Byte >> 4));
            /*            i++;*/
            if (i + 1 < vOctetString.Length)
              fprintf(f, "%c", TO_HEX(Byte));
          }
        fprintf(f, "'H");
        VMSFreeString(Coder, vOctetString);
      }
      break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
      {
        tVMSString vNumericString;

        VMSGetNumericString(Coder, Val, Type, vNumericString);
        ASN1PrintCHARACTER_STRING(f, Coder, Type, &vNumericString, indent);
        VMSFreeString(Coder, vNumericString);
      }
      break;
    case type_ASN1_PrintableString:
      {
        tVMSString vPrintableString;

        VMSGetPrintableString(Coder, Val, Type, vPrintableString);
        ASN1PrintCHARACTER_STRING(f, Coder, Type, &vPrintableString, indent);
        VMSFreeString(Coder, vPrintableString);
      }
      break;
    case type_ASN1_IA5String:
      {
        tVMSString vIA5String;

        VMSGetIA5String(Coder, Val, Type, vIA5String);
        ASN1PrintCHARACTER_STRING(f, Coder, Type, &vIA5String, indent);
        VMSFreeString(Coder, vIA5String);
      }
      break;
    case type_ASN1_VisibleString:
      {
        tVMSString vVisibleString;

        VMSGetVisibleString(Coder, Val, Type, vVisibleString);
        ASN1PrintCHARACTER_STRING(f, Coder, Type, &vVisibleString, indent);
        VMSFreeString(Coder, vVisibleString);
      }
      break;
    case type_ASN1_UTCTime:
      {
        tVMSString vUTCTime;

        VMSGetUTCTime(Coder, Val, Type, vUTCTime);
        ASN1PrintCHARACTER_STRING(f, Coder, Type, &vUTCTime, indent);
        VMSFreeString(Coder, vUTCTime);
      }
      break;
    case type_ASN1_GeneralizedTime:
      {
        tVMSString vGeneralizedTime;

        VMSGetGeneralizedTime(Coder, Val, Type, vGeneralizedTime);
        ASN1PrintCHARACTER_STRING(f, Coder, Type, &vGeneralizedTime, indent);
        VMSFreeString(Coder, vGeneralizedTime);
      }
      break;
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      {
        tVMSEnumerated_Index vEnumIndex;

        VMSGetIndexENUMERATED(Coder, Val, Type, vEnumIndex);
        fprintf(f, "%s  -- %d --",
          ((tASN1Enumerated*)Type)->Items[vEnumIndex].Name,
          (int)((tASN1Enumerated*)Type)->Items[vEnumIndex].Value);
      }
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
#endif
#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
      {
        unsigned char FirstFlag = 0;
        fprintf(f, "{");
        indent = (unsigned short)(indent + INIT_INDENT);
        if (((tASN1Struct*)Type)->NumOfRC1 > 0)
          FirstFlag = ASN1PrintBodyStructComps(f, Coder, Type, 1, Val, indent);
        if (((tASN1Struct*)Type)->NumOfEAC > 0)
          FirstFlag = ASN1PrintBodyStructComps(f, Coder, Type, (unsigned char)(FirstFlag | 2), Val, indent);
        if (((tASN1Struct*)Type)->NumOfRC2 > 0)
          ASN1PrintBodyStructComps(f, Coder, Type, (unsigned char)(FirstFlag | 3), Val, indent);
        fprintf(f, "\n");
        indent = (unsigned short)(indent - INIT_INDENT);
        Indent(f, indent);
        fprintf(f, "}");
      }
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      ASN1PrintBodySEQUENCE_OF(f, Coder, Type, Val, indent);
      break;
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      ASN1PrintBodySET_OF(f, Coder, Type, Val, indent);
      break;
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      ASN1PrintBodyCHOICE(f, Coder, Type, Val, indent);
      break;
#endif
    case type_ASN1_DEFINED:
      ASN1PrintBody(f, Coder, ((tASN1Defined*)Type)->BaseType, Val, indent);
      break;
    case type_ASN1_TAGGED:
      ASN1PrintBody(f, Coder, ((tASN1Tagged*)Type)->BaseType, Val, indent);
      break;
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      ASN1PrintBody(f, Coder, ((tASN1OpenId*)Type)->BaseType, Val, indent);
      break;
    case type_ASN1_OPEN:
      ASN1PrintBodyOPEN(f, Coder, Type, Val, indent);
      break;
#endif
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_UnsupportedType, NO_ARGS);
    }
}

#endif /* CODER_VMS_PRINT */
