/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#define REQID_SEPARATOR ':'

/* Messages that the Debug Agent can send */
typedef enum {
        xDAMsgReady,
        xDAMsgBusy,
        xDAMsgTrace, /* trace not related to a specific command */
        xDAMsgAck /* reaction (traces) to a command */
} xDAMsgKind;

#ifndef DEBUG_INSTRUMENT_SIDE
/************************************************************************/

#include <assert.h>

#include "scttypes.h"
#include "sctdacom.h"
#include "sctdamsgcode.h"
#include "sctdamsg.h"

static int AgentCounter = 0;

struct xDAMsgCtx_struct {
	struct ComCtx_struct *comctx;
	Charbuf xDAMsgOutBufVar;
	Charbuf xDAMsgTmpOutBufVar;
	Charbuf *xDAMsgOutBuf;
	unsigned long BytesSent;
	xbool SyncAckReceived;
	char SkipChar;
};

xDAMsgCtx *
xDAMsgInit(struct ComCtx_struct *comctx)
{
	xDAMsgCtx *res;
	res = (xDAMsgCtx*)calloc(1,sizeof(*res));
	res->comctx = comctx;
	res->xDAMsgOutBuf = &res->xDAMsgOutBufVar;
	CB_init(res->xDAMsgOutBuf);
	CB_init(&res->xDAMsgTmpOutBufVar);
	res->BytesSent = 0;
	res->SyncAckReceived = 0;
	res->SkipChar = 0;
	return res;
}

/* one should have a xDAMPoll() function wrapping xDAMsgPoll() to avoid this */
void
xDAMSyncAckReceived(xDAMsgCtx *ctx)
{
    ctx->SyncAckReceived = 1;
}

/*----------------------------------------------------------------------*/
/*
Temporary buffer handling:
make it possible to use xDAMEnc*** functions, and get encoded result
to insert it in an other buffer (e.g. MSC trace buffer).
Note that user is responsible to avoid calls to Flush, etc...
*/

void
xDAMsgStartTmpBuf(xDAMsgCtx *ctx)
{
    assert(ctx->xDAMsgOutBuf==&ctx->xDAMsgOutBufVar);
    ctx->xDAMsgOutBuf = &ctx->xDAMsgTmpOutBufVar;
    CB_clear(ctx->xDAMsgOutBuf);
}

void
xDAMsgEndTmpBuf(xDAMsgCtx *ctx)
{
    assert(ctx->xDAMsgOutBuf==&ctx->xDAMsgTmpOutBufVar);
    CB_clear(ctx->xDAMsgOutBuf);
    /* switch back to normal buffer */
    ctx->xDAMsgOutBuf = &ctx->xDAMsgOutBufVar;
}

const char *
xDAMsgTmpResult(xDAMsgCtx *ctx, int *length)
/* to be called before xDAMsgEndTmpBuf() */
{
    assert(ctx->xDAMsgOutBuf==&ctx->xDAMsgTmpOutBufVar);
    /* return contents of temporary buffer */
    if (length) *length = ctx->xDAMsgOutBuf->writing;
    return ctx->xDAMsgOutBuf->buf;
}

/*----------------------------------------------------------------------*/
/* Encoding */

extern void
xDAMEncChar(xDAMsgCtx *ctx,char c)
{
	if(ctx->SkipChar && c==ctx->SkipChar)
	{
		ctx->SkipChar = 0;
		return;
	}
	CB_putc(ctx->xDAMsgOutBuf,c);
}

extern void
xDAMEncStr(xDAMsgCtx *ctx,char *str)
{
	if(ctx->SkipChar && str[0]==ctx->SkipChar)
	{
		ctx->SkipChar = 0;
		++str;
	}
	CB_puts(ctx->xDAMsgOutBuf,str);
}

extern void
xDAMEncText(xDAMsgCtx *ctx,const char *str)
{
	char c;
        xDAMEncChar(ctx,xDAEncBeginStruct_CODE);
	while((c = *str++))
	{
		xDAMEncChar(ctx,c);
        	if(c==xDAEncEndStruct_CODE) xDAMEncChar(ctx,c);
	}
        xDAMEncChar(ctx,xDAEncEndStruct_CODE);
}

extern void
xDAMEncStrN(xDAMsgCtx *ctx,char *str,int l)
{
	if(ctx->SkipChar && l!=0 && str[0]==ctx->SkipChar)
	{
		ctx->SkipChar = 0;
		--l;
		if(l==0) return;
		++str;
	}
	CB_nputc(ctx->xDAMsgOutBuf,str,l);
}

extern void
xDAMUnEncChar(xDAMsgCtx *ctx,char c)
{
	CB_unputc(ctx->xDAMsgOutBuf,c);
}

extern void
xDAMEncSkipChar(xDAMsgCtx *ctx,char c)
{
	ctx->SkipChar = c;
}

#define xDAMEncChar(ctx,c) CB_putc(ctx->xDAMsgOutBuf,c)
#define xDAMEncStr(ctx,s) CB_puts(ctx->xDAMsgOutBuf,s)
#define xDAMEncClear(ctx) CB_clear(ctx->xDAMsgOutBuf)
#define xDAMEncIsEmpty(ctx) (ctx->xDAMsgOutBuf->writing==0)
#define xDAMEncLength(ctx) (ctx->xDAMsgOutBuf->writing)
#define xDAMEncResult(ctx) (ctx->xDAMsgOutBuf->buf)

XCONST struct xSignalIdStruct ySigR_DummyStartUp = {xSignalEC/*xStartUpSignalEC*/
  xSymbTLink((xIdNode)0, (xIdNode)0), (xIdNode)xSymbolTableRoot xIdNames("StartUp")
  xIdNumber(0) XCOMMON_EXTRAS, 0 /*(xptrint)sizeof()*/, NULL/*&ySigA_...*/, 0
  xFreS(0) SIGCODE(STARTUPSIGNAL)
  xBreakB("#SDTREF(FILE,/dev/null)")
  xSigPrioPar(xDefaultPrioSignal) XSIG_EXTRAS};


extern void xDAMEncSep(xDAMsgCtx *ctx) { CB_putc(ctx->xDAMsgOutBuf,xDAEncSeparator_CODE); }

extern void
xDAMEncNum(xDAMsgCtx *ctx,long n)
{
	char buf[32];
	sprintf(buf,"%ld",n);
	xDAMEncStr(ctx,buf);
}

static void
xDAMEncKind(xDAMsgCtx *ctx,const struct xIdStruct *Obj)
{
	switch(Obj->EC)
	{
	case xPackageEC:
		xDAMEncChar(ctx,xDAEncPackage);
		break;
	case xSystemEC:
		xDAMEncChar(ctx,xDAEncSystem);
		break;
	case xBlockEC:
		xDAMEncChar(ctx,xDAEncBlock);
		break;
	case xBlockTypeEC:
		xDAMEncChar(ctx,xDAEncBlockType);
		break;
	case xProcessEC:
		xDAMEncChar(ctx,xDAEncProcess);
		break;
	case xProcessTypeEC:
		xDAMEncChar(ctx,xDAEncProcessType);
		break;
	case xProcedureEC:
        case xCompoundStmtEC:
		xDAMEncChar(ctx,xDAEncProcedure);
		break;
	case xStateEC:
		xDAMEncChar(ctx,xDAEncState);
		break;
	case xSignalEC:
	case xStartUpSignalEC:
	case xRPCSignalEC:
		xDAMEncChar(ctx,xDAEncSignal);
		break;
	case xTimerEC:
		xDAMEncChar(ctx,xDAEncTimer);
		break;
	case xOperatorEC:
		xDAMEncChar(ctx,xDAEncOperator);
		break;
	default: assert(0);
	}
}



/* x-elena@38866 */
static void
xDAMEncFormalParameters(xDAMsgCtx *ctx, const struct xIdStruct *Obj)
{
    if ( Obj->EC == xSignalEC || Obj->EC == xTimerEC )
    {
        xIdNode    Param;
        for ( Param = Obj->First; Param != (xIdNode)0; Param = Param->Suc )
        {
            if ( Param->EC == xSignalParEC )
            {
                xDAMEncChar(ctx,'@');
                xDAMEncStr(ctx,((xVarIdNode)Param)->TypeNode->Name);
            }
        }
        xDAMEncChar(ctx,'@');
    }
}



static void
xDAMEncPath(xDAMsgCtx *ctx,const struct xIdStruct *Obj)
{
	xIdNode parent, child;
	const char *name;
	unsigned long OperatorNum;
	if(Obj==xSymbolTableRoot) return;
	parent = Obj->Parent;
	if(parent)
	{
		xDAMEncPath(ctx,parent);
	}
	xDAMEncChar(ctx,'/'); /* so "root" objects with NULL parent have a "/" path */
	xDAMEncKind(ctx,Obj);
	name = Obj->Name;
	/* use other names in case of names with spaces */
	if(Obj->EC==xStateEC && Obj==(struct xIdStruct *)&xStartStateIdRec) name = "start";
	if(Obj->EC==xStateEC && Obj==(struct xIdStruct *)&xErrorStateIdRec) name = "error";
	if(Obj->EC==xOperatorEC)
	{
		/* additional information to make the difference between homonyms:
		position of the operator among the list of children of its parent
		(Operator children only)
		*/
		OperatorNum = 0;
		assert(parent);
		for (child = parent->First; child != (xIdNode)0; child = child->Suc )
		{
			if (child->EC!=xOperatorEC) continue;
			++OperatorNum;
			if(child==Obj) break;
		}
		assert(child==Obj);
		xDAMEncNum(ctx,OperatorNum);
		xDAMEncChar(ctx,'/');
	}
	xDAMEncStr(ctx,name);
        xDAMEncFormalParameters(ctx,Obj);
}

static void
xDAMEncGnum(xDAMsgCtx *ctx,xGnum i)
{
	char buf[32];
	xDAMEncChar(ctx,xDAEncGnum_CODE);
	sprintf(buf,"%ld",(long)i);
	xDAMEncStr(ctx,buf);
}

void
xDAMEncId(xDAMsgCtx *ctx,struct xIdStruct *Obj)
{
	switch(Obj->EC)
	{
	case xSystemEC:
#define obj ((xSystemIdNode)Obj)
		if(!obj->Gnum)
		{
			xDAMEncPath(ctx,Obj);
			obj->Gnum = ++AgentCounter;
		}
		xDAMEncGnum(ctx,obj->Gnum);
#undef obj
		break;
	case xBlockEC:
#define obj ((xBlockIdNode)Obj)
		if(!obj->Gnum)
		{
			xDAMEncPath(ctx,Obj);
			obj->Gnum = ++AgentCounter;
		}
		xDAMEncGnum(ctx,obj->Gnum);
#undef obj
		break;
	case xProcessEC:
	case xProcessTypeEC:
#define obj ((xPrsIdNode)Obj)
		if(!obj->Gnum)
		{
			xDAMEncPath(ctx,Obj);
			obj->Gnum = ++AgentCounter;
		}
		xDAMEncGnum(ctx,obj->Gnum);
#undef obj
		break;
	case xProcedureEC:
        case xCompoundStmtEC:
	case xOperatorEC:
#define obj ((xPrdIdNode)Obj)
		if(!obj->Gnum)
		{
			xDAMEncPath(ctx,Obj);
			obj->Gnum = ++AgentCounter;
		}
		xDAMEncGnum(ctx,obj->Gnum);
#undef obj
		break;
	case xFormalParEC:
#define obj ((xVarIdNode)Obj)
		if(!obj->Gnum)
		{
			xDAMEncPath(ctx,Obj);
			obj->Gnum = ++AgentCounter;
		}
		xDAMEncGnum(ctx,obj->Gnum);
#undef obj
		break;
	case xStateEC:
#define obj ((xStateIdNode)Obj)
		if(Obj==(struct xIdStruct *)&xStartStateIdRec)
		{
			/* global node without "Parent" */
			xDAMEncChar(ctx,xDAEncStart_CODE);
		}else if(Obj==(struct xIdStruct *)&xRPCWaitStateIdRec)
		{
			/* global node without "Parent" */
			xDAMEncChar(ctx,xDAEncRPCWait_CODE);
		}else if(Obj==(struct xIdStruct *)&xErrorStateIdRec)
		{
			/* global node without "Parent" */
			xDAMEncChar(ctx,xDAEncErrorState_CODE);
		}else{
			if(!obj->Gnum)
			{
				xDAMEncPath(ctx,Obj);
				obj->Gnum = ++AgentCounter;
			}
			xDAMEncGnum(ctx,obj->Gnum);
		}
#undef obj
		break;
	case xSignalEC:
	case xTimerEC:
	case xRPCSignalEC:
#define obj ((xSignalIdNode)Obj)
		if(!obj->Gnum)
		{
			xDAMEncPath(ctx,Obj);
			obj->Gnum = ++AgentCounter;
		}
		xDAMEncGnum(ctx,obj->Gnum);
#undef obj
		break;
	case xStartUpSignalEC:
		/* these signals are all named "-", and are in the same scope
		as the corresponding process (not inside the process),
		so there is no way to recognise them by their path.
		As there is no link from xSignalIdRec to the process node,
		it is even not possible to send a patched name which would
		include the process name.
		Workaround: invent a global signal "/StartUp"
		(that does not convey parameters)
		*/
		xDAMEncId(ctx,(struct xIdStruct *)&ySigR_DummyStartUp);
		break;
	default: assert(0);
	}
}

void
xDAMEncExternalPid(xDAMsgCtx *ctx,long nodenr,void *ppid)
{
	xDAMEncChar(ctx,xDAEncExternalPid_CODE);
	xDAMEncNum(ctx,nodenr);
	xDAMEncChar(ctx,xDAEncSeparator_CODE);
	xDAMEncNum(ctx,(long)ppid);
}

void
xDAMsgSendReady(xDAMsgCtx *ctx)
{
	xDAMsgFlush(ctx); /* finish current Trace message */

	xDAMEncChar(ctx,xDAMsgReady_CODE);
	xDAMsgFlush(ctx);
}

void
xDAMsgSendBusy(xDAMsgCtx *ctx)
{
	xDAMsgFlush(ctx); /* finish current Trace message */

	xDAMEncChar(ctx,xDAMsgBusy_CODE);
	xDAMsgFlush(ctx);
}

void
xDAMsgSendAck(xDAMsgCtx *ctx,const char *reqid)
{
	xDAMsgFlush(ctx); /* finish current Trace message */

	xDAMEncChar(ctx,xDAMsgAck_CODE);
	xDAMEncStr(ctx,reqid);

	xDAMsgFlush(ctx);
}

/* encode xDAMsgTrace message(s) */
void
xDAMsgTraceStr(xDAMsgCtx *ctx,const char *str)
{
	if(xDAMEncIsEmpty(ctx))
	{
		/* encode 'Trace' message header */
		xDAMEncChar(ctx,xDAMsgTrace_CODE);
	}

	xDAMEncStr(ctx,str);

	xDAMsgFlush(ctx);
}

void
xDAMsgStartMscTrace(xDAMsgCtx *ctx)
{
	xDAMsgFlush(ctx); /* finish current Trace message */
	xDAMEncChar(ctx,xDAMsgStartMscTrace_CODE);
	xDAMsgFlush(ctx);
}

/* encode xDAMsgMscTrace message(s) */
void
xDAMsgMscTrace(xDAMsgCtx *ctx,const char *str)
{
	xDAMsgFlush(ctx); /* finish current Trace message */
	xDAMEncChar(ctx,xDAMsgMscTrace_CODE);
	xDAMEncStr(ctx,str);
	xDAMsgFlush(ctx);
}

/* encode xDAMsgGRTrace message(s) */
void
xDAMsgTracking(xDAMsgCtx *ctx,const char *str)
{
	xDAMsgFlush(ctx); /* finish current Trace message */
	xDAMEncChar(ctx,xDAMsgTracking_CODE);
	xDAMEncStr(ctx,str);
	xDAMsgFlush(ctx);
}

extern void
xDAMsgReqIDBegin(xDAMsgCtx *ctx,const char *reqid,int code)
{
	xDAMsgFlush(ctx); /* finish current Trace message */
	xDAMEncChar(ctx,(char)code);
	xDAMEncStr(ctx,reqid);
	xDAMEncChar(ctx,xDAEncReqIDEnd_CODE);
}

/* force sending of buffered xDAMsgTrace strings (or other messages ?) */
void
xDAMsgFlush(xDAMsgCtx *ctx)
{
	int/*xbool*/ st;

	if(xDAMEncIsEmpty(ctx)) return;

	/* keep track of amount of bytes sent */
	ctx->BytesSent += xDAMEncLength(ctx);

	xDAMEncChar(ctx,0); /* add ending zero */
	st = xDAComSend(ctx->comctx,xDAMEncResult(ctx));
	/* ignore case where the socket is broken while data are already buffered */
	/* assert(st); */

	/* get ready for new data */
	xDAMEncClear(ctx);
}

/*-------------------------------------------------------------------------*/
/* Synchronisation */

#define XDA_ASYNC_SIZE 1000 /* amount of "asynchonism" */

void
xDAMSync(xDAMsgCtx *ctx,void (*cb)(/*nodelete*/ char *req,/*nodelete*/ char *reqid))
{
  if(ctx->BytesSent < XDA_ASYNC_SIZE) return;

  /* force synchronisation */

  /* finish current trace message (if any) */
  xDAMsgFlush(ctx);

  /* send synchronisation request */
  xDAMEncChar(ctx,xDAMsgSync_CODE);
  xDAMsgFlush(ctx);

  ctx->BytesSent = 0;

  /* wait for acknowledgement */
  while( ! ctx->SyncAckReceived ) {
    xDAComPoll(ctx->comctx,cb,10000/*miliseconds*/);
  }
  ctx->SyncAckReceived = 0;
}

/*----------------------------------------------------------------------*/
/* Decoding commands */


static void
xDAMsgHandleMessage(char *msg,void (*cb)(/*nodelete*/ char *cmd,/*nodelete*/ char *reqid))
{
	char *cmd;
	/* split into request-id part and command part */
	cmd = strchr(msg,REQID_SEPARATOR);
	assert(cmd);
	*cmd = 0;
	++cmd;
	(*cb)(cmd,*msg?msg:NULL);
}

static Charbuf xDAMsgInBufVar;
static Charbuf *xDAMsgInBuf = NULL;

/* decode data from the Debugger (command) */
void xDAMsgHandleData(const char *data,int length,void (*cb)(/*nodelete*/ char *cmd,/*nodelete*/ char *reqid))
{
    const char *startstr, *endstr;
    int i;

    if(!xDAMsgInBuf)
    {
	xDAMsgInBuf = &xDAMsgInBufVar;
	CB_init(xDAMsgInBuf);
    }

    /* re-assemble or split into 0-ended strings */
    startstr = data;
    for(i=0,endstr=data;i<length;++i,++endstr)
    {
        if(*endstr==0)
        {
            /* end of string found */
	    CB_nputc(xDAMsgInBuf,startstr,endstr-startstr+1);
            xDAMsgHandleMessage(xDAMsgInBuf->buf,cb);
	    CB_clear(xDAMsgInBuf);
            startstr = endstr+1;
        }
    }
    /* keep incomplete ending string */
    if(startstr!=endstr)
    {
             CB_nputc(xDAMsgInBuf,startstr,endstr-startstr);
    }
}

#else
/************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "sctdacom.h"
#include "sctdamsg.h"
#include "sctdamsgcode.h"

/*----------------------------------------------------------------------*/
/* Decoding */

/* move DbgInstrument.cpp-DbgRcv() and Rcv() here ? */
/* and the thread creation too ? */

/* see DbgInstrument::React() */

/*----------------------------------------------------------------------*/
/* Encoding (commands) */

/* utilities to build a command from bits */
/* hide the implementation (could be sending on the fly or when complete) */

struct DbgReqCtx_struct {
	Charbuf cb;
	/* identifier of the command to which this is a reply */
	ReqId req;
};

DbgReqCtx *
DbgReqCmd_Start(ReqId req)
{
	return DbgReq_Start(req,xDAReqCmd);
}

DbgReqCtx *
DbgReq_Start(ReqId req,int kind)
{
	DbgReqCtx *res;
	res = (DbgReqCtx *)calloc(1,sizeof(*res));
	CB_init(&res->cb);
	res->req = req;
	if(req)
	{
		/* let us encode it immediately in the buffer */
		assert(!strchr(req,REQID_SEPARATOR));
		DbgReq_AddStr(res,req);
	}
	DbgReq_AddChar(res,REQID_SEPARATOR);
	DbgReq_AddChar(res,(char)kind);
	return res;
}

int/*xbool*/
DbgReq_Send(DbgReqCtx **pctx,struct DbgComCtx *comctx)
{
	int st;
	DbgReqCtx *ctx = *pctx;
	DbgReq_AddChar(ctx,'\n');
	DbgReq_AddChar(ctx,0);
	st = DbgSendReq(comctx,ctx->cb.buf);
	CB_reset(&ctx->cb);
	*pctx = NULL;
	free(ctx);
	return st;
}

void
DbgReq_AddChar(DbgReqCtx *ctx,char c)
{
	CB_putc(&ctx->cb,c);
}

void
DbgReq_AddStr(DbgReqCtx *ctx,const char *str)
{
	CB_puts(&ctx->cb,str);
}


/************************************************************************/
#endif

