/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/* Standard includes */
#include <stdlib.h>
#include <stdio.h>

/* Communication module includes */
#include "tcpipcomm.h"
#include "tcpipthr.h"
#include "tcpipsock.h"

/* SDL specific includes */
#include "scttypes.h"

/* Coder library */
#include "cucf.h"


/* Hook for including routing functionality */
#ifdef XROUTING_INC
  #include XROUTING_INC
#endif

/* Server-side port number */
#ifndef XSERVPORT
#define XSERVPORT                   5000
#endif


/* Variables */
SCM_GLOBAL_THREAD_VARS
SCM_THREAD                          xReceiverThread;
SCM_THREAD_MUTEX                    xReceiverMutex;

int                                 xSCMInitialized;
int                                 xMutexInitialized;


/* Type variables for encoding/decoding */
extern tSDLTypeInfo ySDL_SDL_Integer;
extern tSDLTypeInfo ySDL_SDL_PId;
extern tSDLTypeInfo ySDL_SignalId;

extern tSDLSignalInfo * xSignalList[];
extern xSignalIdNode xSignalIdList[];

/*
  Internal function. Called from xReceiveSignal

  Returns the tSDLSignalInfo node with name xSignalName
  If no tSDLSignalInfo node is found, 0 is returned.
*/
tSDLSignalInfo* xGetSignalTypeInfo(char *xSignalName)
{
  tSDLSignalInfo *xTypeInfoNode;

  int xFound = 0;
  int xIndex = 0;

  while (!xFound)
  {
    xTypeInfoNode = xSignalList[xIndex];

    if (xTypeInfoNode != 0)
    {
      if (strcmp(xSignalName, xTypeInfoNode->Name) == 0)
      {
        xFound = -1;
      }
      else
        xIndex++;
    }
    else
      xFound = -1; /* A signal with name xSignalName was not found */
  }

  return xTypeInfoNode;
}


/*
  Internal function. Called from xReceiveSignal

  Returns the xSignalIdNode with name xSignalName

  Searches the xSignalList for a tSDLSignalInfo node with the correct name.
  The xSignalIdNode with the corresponding index is returned.
  If the data is not found, 0 is returned.
*/
xSignalIdNode xGetSignalIdNode(char *xSignalName)
{
  tSDLSignalInfo *xTypeInfoNode;

  int xFound = 0;
  int xIndex = 0;
  int xNotFoundInList = 0;

  while (!xFound)
  {
    xTypeInfoNode = xSignalList[xIndex];

    if (xTypeInfoNode != 0)
    {
      if (strcmp(xSignalName, xTypeInfoNode->Name) == 0)
      {
        xFound = -1;
      }
      else
        xIndex++;
    }
    else
    {
      xFound = -1;
      xNotFoundInList = -1;
    }
  }
  
  if (!xNotFoundInList)
    return xSignalIdList[xIndex];
  else
    return 0; /* A signal with name xSignalName was not found */
}


/*
  Internal function [thread]. Started from xWaitForSignal
  - Receives encoded signal data over a socket
  - Decodes the signal data using Ascii decoding
  - Inserts the signal into the signal queue using SDL_Output (thread-safe)
*/
#ifdef THREADWIN32
void xReceiveSignal(void *xSocket)
#elif THREADOSE
OS_PROCESS (xReceiveSignal)
#elif THREADVXWORKS
void xReceiveSignal(int xSocket)
#else
void* xReceiveSignal(void *xSocket)
#endif
{
  SCM_SOCKET xRecvSocket;
  SCM_FDSET xRecvMask;

  int xSelectRes;

  int xBufSize = SCM_RECVBUF_MAXSIZE;
  
  SCM_TIMEVAL xTimeOut = {5,0};
  int xRecvRes = 0;
  int xTotRecvRes = 0;

  tBuffer xSigBuf;
  int xDecodeRes;
  char xSignalId[128];
  int xSDLSP_Ver;
  tSDLSignalInfo *xSignalType;
  xSignalNode xInSignal;
  xSignalIdNode xSigIdNode;

  char *xRecvBuf = (char*)malloc(xBufSize);
  char *xBufPos = xRecvBuf;

#ifdef THREADOSE
  SCM_GET_THREAD_VAR(xRecvSocket);
#elif THREADVXWORKS
  xRecvSocket = xSocket;
#else
  xRecvSocket = (SCM_SOCKET)xSocket;
#endif

#ifdef THREADLIGHT_TRACE
  printf("xReceiveSignal thread starts ", xRecvSocket );
#endif

#ifndef XEXCLUDE_SELECT
  SCM_FD_ZERO(&xRecvMask);
  SCM_FD_SET(xRecvSocket, &xRecvMask);

  xSelectRes = SCM_SELECT(xRecvSocket+1, &xRecvMask, 0, 0, &xTimeOut);

  if (xSelectRes == SCM_SOCKET_ERROR)
  {
    free(xRecvBuf);
    SCM_CLOSE(xRecvSocket);
    SCM_ERROR_REPORT("ERROR xReceiveSignal/SCM_SELECT: %d\n", SCM_GET_ERROR)
    SCM_EXIT_THREAD
  }
  else if (xSelectRes == 0)
  {
    free(xRecvBuf);
    SCM_CLOSE(xRecvSocket);
    SCM_ERROR_REPORT("INFO xReceiveSignal/SCM_SELECT: timed out after %d seconds.\n", xTimeOut.tv_sec)
    SCM_EXIT_THREAD
  }

  if (SCM_FD_ISSET(xRecvSocket, &xRecvMask)){
#endif

  xSigBuf = 0;
  BufInitBuf(xSigBuf, bms_SmallBuffer);
/*  BufInitBuf(xSigBuf, SML_BUF);*/
  memset(xSignalId, 0, 128);

  memset(xRecvBuf, 0, xBufSize);
  xRecvRes = SCM_RECV(xRecvSocket, xBufPos, xBufSize, 0);
  xTotRecvRes += xRecvRes;
  
  while ((xRecvRes!= SCM_SOCKET_ERROR) && (xRecvRes != 0))
  {

#ifdef THREADLIGHT_TRACE
    printf("Received: %d %s\n", xRecvRes, xBufPos);
    printf("Receive buffer: %s\n", xRecvBuf);
#endif

    xBufPos += xRecvRes;
    
    if ((xBufPos - xRecvBuf) == xBufSize)
    {
      /* The receive buffer is full and there is data left to receive - reallocate the buffer */
      xBufSize = 2 * xBufSize;
      xRecvBuf = (char*)realloc(xRecvBuf, xBufSize);
      xBufPos = xRecvBuf + xRecvRes;
      memset(xBufPos, 0, xBufSize - xTotRecvRes);

      if (xRecvBuf == 0)
      {
        free(xRecvBuf);
	SCM_CLOSE(xRecvSocket);
        SCM_ERROR_REPORT("ERROR xReceiveSignal/realloc failed for receive buffer: %d\n", 0)
        SCM_EXIT_THREAD
      }
    }

    xRecvRes = SCM_RECV(xRecvSocket, xBufPos, xBufSize, 0);
    xTotRecvRes += xRecvRes;
  }

  if (xRecvRes == SCM_SOCKET_ERROR)
  {
    /* Error */
    free(xRecvBuf);
    SCM_CLOSE(xRecvSocket);
    SCM_ERROR_REPORT("ERROR xReceiveSignal/SCM_RECV: %d\n", SCM_GET_ERROR)
    SCM_EXIT_THREAD
  }

  /* When xRecvRes == 0, the whole message has been received */

  /* Close the socket descriptor */
  if (SCM_CLOSE(xRecvSocket) == SCM_SOCKET_ERROR)
  {
    free(xRecvBuf);
    SCM_ERROR_REPORT("ERROR xReceiveSignal/SCM_CLOSE: %d\n", SCM_GET_ERROR)
    SCM_EXIT_THREAD
  }

  BufInitWriteMode(xSigBuf);
  BufPutSeg(xSigBuf, xRecvBuf, xTotRecvRes);
  BufCloseWriteMode(xSigBuf);

  BufInitReadMode(xSigBuf);

  /* Decode the protocol version */
  xDecodeRes = AsciiDecode(xSigBuf, (tSDLTypeInfo *)&ySDL_SDL_Integer, (void *)&xSDLSP_Ver);
  if (xDecodeRes != 0)
  {
    BufCloseReadMode(xSigBuf);
    BufCloseBuf(xSigBuf);
    free(xRecvBuf);
    SCM_ERROR_REPORT("ERROR xReceiveSignal/AsciiDecode: Unknown data format. %d\n", xDecodeRes)
    SCM_EXIT_THREAD
  }

  /* Decode the signal identifier */
  xDecodeRes = AsciiDecode(xSigBuf, (tSDLTypeInfo *)&ySDL_SignalId, (void *)xSignalId);
  if (xDecodeRes != 0)
  {
    BufCloseReadMode(xSigBuf);
    BufCloseBuf(xSigBuf);
    free(xRecvBuf);
    SCM_ERROR_REPORT("ERROR xReceiveSignal/AsciiDecode: %d\n", xDecodeRes)
    SCM_EXIT_THREAD
  }

  /* Find the corresponding tSDLSignalInfo node */
  xSignalType = xGetSignalTypeInfo(xSignalId);

  if (xSignalType == 0)
  {
    SCM_ERROR_REPORT("ERROR xReceiveSignal: No signal RTTI found %d\n", 0)
    SCM_EXIT_THREAD
  }

  /* Find the corresponding xSignalIdNode */
  xSigIdNode = xGetSignalIdNode(xSignalId);

  if (xSigIdNode == 0)
  {
    SCM_ERROR_REPORT("ERROR xReceiveSignal: No SignalIDNode found %d\n", 0)
    SCM_EXIT_THREAD
  }

  /* Allocate a new signal using xGetSignal */
  /* No PId:s are transferred */
  xInSignal = xGetSignal(xSigIdNode, xNotDefPId, xEnv);

  /* Decode signal-specific parameters */
  xDecodeRes = AsciiDecode(xSigBuf, (tSDLTypeInfo *)xSignalType, (void *)xInSignal);
  if (xDecodeRes != 0)
  {
    BufCloseReadMode(xSigBuf);
    BufCloseBuf(xSigBuf);
    free(xRecvBuf);
    SCM_ERROR_REPORT("ERROR xReceiveSignal/AsciiDecode: %d\n", xDecodeRes)
    SCM_EXIT_THREAD
  }

  BufCloseReadMode(xSigBuf);

  /* Insert it into the SDL signal queue (thread-safe) */
  SDL_Output(xInSignal, (xIdNode *)0);

  BufCloseBuf(xSigBuf);
  free(xRecvBuf);
  
#ifdef THREADLIGHT_TRACE
  printf("xReceiveSignal thread exits\n");
#endif

  SCM_EXIT_THREAD

#ifndef XEXCLUDE_SELECT
  }
#endif
}


/*
  Internal function [thread]. Started from xInitSignalReceiver

  Sets up a TCP/IP socket server which waits for connection attempts
  For each connection, a dedicated thread for receiving and decoding data is started
*/
#ifdef THREADWIN32
void xWaitForSignal(void* xNotUsed)
#elif THREADOSE
OS_PROCESS (xWaitForSignal)
#else
void* xWaitForSignal(void* xNotUsed)
#endif
{
  int xSockOptionOn = 1;
  int xSockOptionOff = 0;

  int BindRes;

  SCM_SOCKET xHostSocket;
  SCM_SOCKET xNewConnectionSocket;
  SCM_SOCKET_ADDR xHostAddress;

  SCM_THREAD_VARS
  SCM_THREAD xNewThread;

#ifdef THREADLIGHT_TRACE
  /*  printf("WaitForSignal thread started. Using port %d\n", XSERVPORT); */
#endif

  /* Protect initialization by a mutex */
  SCM_LOCK_THREAD_MUTEX(xReceiverMutex)


  memset((char*)&xHostAddress, 0, sizeof(xHostAddress));
  xHostAddress.sin_family = AF_INET;
  xHostAddress.sin_addr.s_addr = SCM_HTONL(INADDR_ANY);

  /* Convert to network byte order */
#ifdef THREADVXWORKS
  xHostAddress.sin_len = sizeof(struct sockaddr_in);
  xHostAddress.sin_port = (unsigned short)XSERVPORT;
#else
  xHostAddress.sin_port = SCM_HTONS((unsigned short)XSERVPORT);
#endif

  /* Create socket */
  xHostSocket = SCM_CREATE_SOCKET(AF_INET, SOCK_STREAM, 0);
  if (xHostSocket == SCM_INVALID_SOCKET)
  {
    /* Error */
    SCM_ERROR_REPORT("ERROR xWaitForSignal/SCM_CREATE_SOCKET: %d\n", SCM_GET_ERROR)
    SCM_EXIT_THREAD
  }

  /* Make socket port reusable immediately
     (Convenient when restoring broken connections quickly) */
  if (SCM_SETSOCKOPT(xHostSocket , SOL_SOCKET, SO_REUSEADDR, (char*)&xSockOptionOn, sizeof(xSockOptionOn)) == SCM_SOCKET_ERROR)
  {
    /* Error */
    SCM_ERROR_REPORT("ERROR xWaitForSignal/SCM_SETSOCKOPT: %d\n", SCM_GET_ERROR)
    SCM_CLOSE(xHostSocket);
    SCM_EXIT_THREAD
  }


  /* bind */
  BindRes = SCM_BIND(xHostSocket, SCM_PTR_SOCK_ADDR &xHostAddress, sizeof(xHostAddress));
  if (BindRes == -1)  
  /*
    if (SCM_BIND(xHostSocket, SCM_PTR_SOCK_ADDR &xHostAddress, sizeof(xHostAddress)) == SCM_SOCKET_ERROR)*/
  {
    /* Error */
    SCM_ERROR_REPORT("ERROR xWaitForSignal/SCM_BIND: %d\n", SCM_GET_ERROR)
    SCM_CLOSE(xHostSocket);
    SCM_EXIT_THREAD
  }

  /* Initialization finished - unlock mutex */
  SCM_UNLOCK_THREAD_MUTEX(xReceiverMutex)


  /* listen */
  if (SCM_LISTEN(xHostSocket) == SCM_SOCKET_ERROR)
  {
    /* Error */
    SCM_ERROR_REPORT("ERROR xWaitForSignal/SCM_LISTEN: %d\n", SCM_GET_ERROR)
    SCM_CLOSE(xHostSocket);
    SCM_EXIT_THREAD
  }

  while (1)
  {
    /* Accept incoming connection attempts */
    int xAddrSize = sizeof(xHostAddress);

    xNewConnectionSocket = SCM_ACCEPT(xHostSocket, SCM_PTR_SOCK_ADDR &xHostAddress, &xAddrSize);

    if (xNewConnectionSocket == SCM_SOCKET_ERROR)
    {
      /* Error */
      SCM_ERROR_REPORT("ERROR xWaitForSignal/SCM_ACCEPT: %d\n", SCM_GET_ERROR)
    }
    else
    {
      /* Create a thread to receive the data */
      SCM_START_THREAD(xNewThread, xReceiveSignal, xNewConnectionSocket, XRECVTHRSTACK, XRECVTHRPRIO)

    }
  }
    
}


/* Client-side initialization */
void xInitSignalSender()
{
  SCM_STARTUP

}


/* Server-side initialization */
void xInitSignalReceiver()
{
  SCM_THREAD_VARS
  SCM_STARTUP

  /* Initialize mutex*/
  if (!xMutexInitialized)
  {
    SCM_INIT_THREAD_MUTEX(xReceiverMutex)

    xMutexInitialized = 1;
  }
  SCM_START_THREAD(xReceiverThread, xWaitForSignal, 0, XRECVTHRSTACK, XRECVTHRPRIO)
}


/* 
  Internal function. Called from xSendSignal
  Sends a buffer on a TCP/IP connection    
  - Accepts both hostnames and dotted decimal (e.g. 132.33.45.23)
  - Assumes that the port number is valid
  - Uses a blocking socket
  - Closes down the connection when the signal is sent    
  
  Returns 0 if successful, otherwise a platform-dependent error code
*/
int xSendBuf(char *signal, int xSignalLength, char *xHostName, int xPortNbr)
{

  SCM_SOCKET xClientSocket;
  
  SCM_SOCKET_ADDR    xHostAddress;
  SCM_HOST_ENTRY     xHostEntry;

  int xSockOptionOn = 1;
  int xSockOptionOff = 0;

  int xLengthSent;

  /* Check that the host is correct */
  xHostEntry = SCM_GETHOSTBYNAME(xHostName);
#ifdef THREADVXWORKS
  if (xHostEntry == ERROR)
#else
  if ((char*)xHostEntry == NULL)
#endif
  {
    /* Error */
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_GETHOSTBYNAME: %d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }

  memset((char*)&xHostAddress, 0, sizeof(xHostAddress));
  xHostAddress.sin_family = AF_INET;

#ifdef THREADVXWORKS
  xHostAddress.sin_addr.s_addr = xHostEntry;
#else
  memcpy(&xHostAddress.sin_addr, xHostEntry->h_addr, xHostEntry->h_length);
#endif

#ifdef THREADOSE
  free((union SIGNAL**)&xHostEntry);
#endif

  /* The port number is assumed to be correct */
  /* Convert to network byte order */
  xHostAddress.sin_port = SCM_HTONS((unsigned short)xPortNbr);


  /* Create socket */
  xClientSocket = SCM_CREATE_SOCKET(AF_INET, SOCK_STREAM, 0);
  if (xClientSocket == SCM_INVALID_SOCKET)
  {
    /* Error */
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_CREATE_SOCKET: d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }

#ifdef THREADLIGHT_TRACE
  printf("Socket created\n");
#endif

  /* Make socket port reusable immediately
    (Convenient when restoring broken connections quickly) */
  if (SCM_SETSOCKOPT(xClientSocket , SOL_SOCKET, SO_REUSEADDR, (char*)&xSockOptionOn, sizeof(xSockOptionOn)) == SCM_SOCKET_ERROR)
  {
    /* Error */
    SCM_CLOSE(xClientSocket);
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_SETSOCKOPT: %d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }

  /* Connect to the receiver */
  if (SCM_CONNECT(xClientSocket, SCM_PTR_SOCK_ADDR &xHostAddress, sizeof(xHostAddress)) == SCM_SOCKET_ERROR)
  {
    /* Error */
    SCM_CLOSE(xClientSocket);
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_CONNECT: %d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }

#ifdef THREADLIGHT_TRACE
  printf("Connection accepted\n");
#endif

  /* Send the signal on the socket
     Check that everything was sent */

  xLengthSent = SCM_SEND(xClientSocket, signal, xSignalLength, 0);
  
  if ( xLengthSent == SCM_SOCKET_ERROR)
  {
    /* Error */
    SCM_CLOSE(xClientSocket);
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_SEND: %d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }
  else if (xLengthSent < xSignalLength)
  {
    /* Only part of the message was sent */
    SCM_CLOSE(xClientSocket);
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_SEND - Not whole message sent: %d\n", SCM_GET_ERROR)
    return -1;
  }

#ifdef THREADLIGHT_TRACE
  printf("Signal sent: %s\n", signal);
#endif

  /* SCM_SEND has returned xSignalLength. The whole message was successfully sent. */

  /* shutdown of read and write */
  if (SCM_SHUTDOWN(xClientSocket, SCM_SHUT_SENDRECV) == SCM_SOCKET_ERROR)
  {
    SCM_CLOSE(xClientSocket);
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_SHUTDOWN: %d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }


  /* Close the connection */
  if (SCM_CLOSE(xClientSocket) == SCM_SOCKET_ERROR)
  {
    SCM_ERROR_REPORT("ERROR xSendBuf/SCM_CLOSE: %d\n", SCM_GET_ERROR)
    return SCM_GET_ERROR;
  }

  return 0;
}


/*
  Client-side signal sending function
  - Encodes the signal using Ascii encoding
  - Contains a macro hook for signal routing
  - calls xSendBuf, which handles the tcp/ip connection.

  Returns 0 if successful, otherwise a platform-dependent error code

  Please note:
    Sender and receiver Pid information is transferred unmodified
    between distributed components. Care must be taken so that Pid:s from one component
    are not used for addressing an SDL process in an external component.
    This depends entirely on the design and deployment of the SDL system.
*/
void xSendSignal(xSignalNode *xOutSignal, char *xSignalName)
{
  tBuffer xSendBuffer;
  char *xBuf;
  tSDLSignalInfo *xSignalType;

  int xBufLength;
  int xRetCode;

  char xDestIP[128];
  int xDestPort;

  int xEncodeRes;

  int xSDLSP_Ver = 1; /* SDLSP = SDL Signal Protocol */

  /* SDLSP Version 1 
     <Version><SignalName><SignalData>
  */

  /* Find the destination. Save the IP and port number in xDestIP and xDestPort */
#ifdef XFINDDEST
  XFINDDEST(xOutSignal, xSignalName, xDestIP, &xDestPort);
#else
  strcpy(xDestIP, "localhost\0");
  xDestPort = XSERVPORT;
#endif

#ifdef THREADLIGHT_TRACE
  printf("Destination found: %s %d\n", xDestIP, xDestPort);
#endif

  xSendBuffer = 0;
  BufInitBuf(xSendBuffer, bms_SmallBuffer);

  /* Encode the signal parameters */

  BufInitWriteMode(xSendBuffer);

  /* Parameters that are common for all signals (name, priority, sender, receiver) */
  /* The name of the signal is used as an identifier on the receiving side */
  /* As a first parameter, the protocol version number is encoded */
  xEncodeRes = AsciiEncode(xSendBuffer, (tSDLTypeInfo *)&ySDL_SDL_Integer, (void *)&xSDLSP_Ver);
  if (xEncodeRes != 0)
  {
    BufCloseWriteMode(xSendBuffer);
    BufCloseBuf(xSendBuffer);
    SCM_ERROR_REPORT("ERROR xSendSignal/AsciiEncode: %d\n", xEncodeRes) return;
  }

  /* The signal name is encoded */
  xEncodeRes = AsciiEncode(xSendBuffer, (tSDLTypeInfo *)&ySDL_SignalId, (void *)(xSignalName));
  if (xEncodeRes != 0)
  {
    BufCloseWriteMode(xSendBuffer);
    BufCloseBuf(xSendBuffer);
    SCM_ERROR_REPORT("ERROR xSendSignal/AsciiEncode: %d\n", xEncodeRes) return;
  }

  /* Signal encoded */
  xSignalType = xGetSignalTypeInfo(xSignalName);

  if (xSignalType == 0)
  {
    SCM_ERROR_REPORT("ERROR xSendSignal: No signal RTTI found %d\n", 0) return;
  }

  xEncodeRes = AsciiEncode(xSendBuffer, (tSDLTypeInfo *)xSignalType, (void *)(*xOutSignal));
  if (xEncodeRes != 0)
  {
    BufCloseWriteMode(xSendBuffer);
    BufCloseBuf(xSendBuffer);
    SCM_ERROR_REPORT("ERROR xSendSignal/AsciiEncode: %d\n", xEncodeRes) return;
  }

  BufCloseWriteMode(xSendBuffer);

#ifdef THREADLIGHT_TRACE
  printf("Signal encoded\n");
#endif

  BufInitReadMode(xSendBuffer);

  xBufLength = BufGetDataLen(xSendBuffer);
  xBuf = BufGetSeg(xSendBuffer, xBufLength);

  /* Error handling is taken care of in xSendBuf: no check on return value */
  xRetCode = xSendBuf(xBuf, xBufLength, xDestIP, xDestPort);
  
  BufCloseReadMode(xSendBuffer);
  BufCloseBuf(xSendBuffer);

  return;
}










