<!-- ***************************************** -->
<!-- XSLT transformation for converting from   -->
<!-- U2 XML storage format 1.7 to 1.8          -->
<!-- ***************************************** -->

<xsl:transform version="1.1"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- Change file format version number to 1.8 -->

<xsl:template match="u2">
  <xsl:copy>
    <xsl:for-each select="@*">
    <xsl:call-template name="transform-u2-attributes"/>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template name="transform-u2-attributes">
      <xsl:choose>
        <xsl:when test="local-name()='OMVersion'">
          <xsl:attribute name="OMVersion">2.0</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy/>
        </xsl:otherwise>
      </xsl:choose>
</xsl:template>

<xsl:template match="StateMachine">
  <xsl:copy>
    <xsl:for-each select="@*">
    <xsl:call-template name="delete-operationkind-attribute"/>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="Operation">
  <xsl:copy>
    <xsl:for-each select="@*">
    <xsl:call-template name="delete-operationkind-attribute"/>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template name="delete-operationkind-attribute">
      <xsl:choose>
        <xsl:when test="local-name()='OperationKind'">
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy/>
        </xsl:otherwise>
      </xsl:choose>
</xsl:template>

<!-- Default rule -->

<xsl:template match="*">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template name="copy-all-attributes">
  <xsl:for-each select="@*">
    <xsl:copy/>
  </xsl:for-each>
</xsl:template>

</xsl:transform>