# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
proc make_path_absolute {file} {
  if {![regexp {^doors:} $file]} {
    if {[file pathtype $file] == "relative"} {
      return [file join [pwd] $file]
    }
  }
  return $file;
}

#init variables
set filelist ""
set retValue "false"

#default arguments for u2::Compare and u2::Merge
set forceVersion leaveUnresolved
set reviewDialog reviewDifferencesAlways
set suppressSetup suppressSetupNever

#save resfile option
if { [set ind [lsearch -exact $argv "-resfile"]] != -1 } {
  set resultFile [make_path_absolute [lindex $argv [expr $ind + 1]]]
  set argv [lreplace $argv $ind [expr $ind + 1]]
}

#remove any unsupported -fname options
while { [set ind [lsearch -exact $argv "-fname"]] != -1 } {
  set argv [lreplace $argv $ind [expr $ind + 1]]
}

#remove unsupported -qall option
while { [set ind [lsearch -exact $argv "-qall"]] != -1 } {
  set argv [lreplace $argv $ind $ind]
}

#open empty u2 file
std::OpenDocument [file join [std::GetInstallationDirectory] etc u2typemngr.u2]

catch {set model [lindex $U2 0]}
if { ($model != "") } {
  #
  # xcompare
  #
  if { [string equal [lindex $argv 0] "xcompare"] == 1 } {
    set command ""

    #process file arguments
    set ver1File [make_path_absolute [lindex $argv 1]]
    foreach f [lrange $argv 1 2] {
      set filelist [concat $filelist \{[make_path_absolute $f]\}]
    }

    #load version 1 file
    set ver1Resource ""
    catch { set ver1Resource [u2::LoadFile $U2 "$ver1File"] } loadError
    if { ($loadError != "") && ($loadError != $ver1Resource) } {
      std::MessageDialog -name "Could not load file" -message $loadError -style ok -icon stop
      set retValue 1
    } else {
      if { ($ver1Resource != "") } {
        output "Comparing\n"
        output "Version 1: [lindex $filelist 0]\n"
        output "Version 2: [lindex $filelist 1]\n"

        #launch compare
        catch {set retValue [u2::Compare $model "$filelist" "" $forceVersion $reviewDialog $suppressSetup]}
      }
    }

    #
    # xmerge
    #
  } elseif { [string equal [lindex $argv 0] "xmerge"] == 1 } {
    set command "u2::Merge"

    #find ancestor
    set ind [lsearch -exact $argv "-base"]
    if { $ind != -1 } {
      set anc1File [make_path_absolute [lindex $argv [expr $ind + 1]]]
      set argv [lreplace $argv $ind [expr $ind + 1]]
    }

    #find out file
    set ind [lsearch -exact $argv "-out"]
    if { $ind != -1 } {
      set toFile [make_path_absolute [lindex $argv [expr $ind + 1]]]
      set argv [lreplace $argv $ind [expr $ind + 1]]
    }

    #process file arguments
    set ver1File [make_path_absolute [lindex $argv 2]]
    foreach f [lrange $argv 1 2] {
      set filelist [concat \{[make_path_absolute $f]\} $filelist]
    }
    set filelist [concat $filelist \{$anc1File\}]

    #load version 1 file
    set ver1Resource ""
    catch { set ver1Resource [u2::LoadFile $U2 "$ver1File"] } loadError
    if { ($loadError != "") && ($loadError != $ver1Resource) } {
      std::MessageDialog -name "Could not load file" -message $loadError -style ok -icon stop
      set retValue 1
    } else {
      if { $ver1Resource != "" } {
        output "Merging\n"
        output "Version 1: [lindex $filelist 0]\n"
        output "Version 2: [lindex $filelist 1]\n"
        output "Common ancestor: [lindex $filelist 2]\n"

        catch {set retValue [u2::Merge $model "$filelist" "" $forceVersion $reviewDialog $suppressSetup]}

        if { $retValue } {
          if {[info exists toFile]} {
	    u2::SetValue $ver1Resource "Uri" $toFile
          }
          u2::SaveResource $ver1Resource
        }
      }
    }
#
# wrong arguments
#
  } else {
    output "ERROR: command not supported\n"
  }
} else {
  output "ERROR: could not load empty model\n"
}

# Save tcl log
if { [info exists resultFile] } {
  if { $retValue } {
    catch { file delete $resultFile }
  } else {
    OutputLog now TCL "$resultFile" " "
  }
}

std::Quit

