set result {}

proc CollectCalledOperations { entity } {
  global result

  if { [u2::IsKindOf $entity "CallExpr"] } {
    set op [u2::GetEntity $entity "Called"]
    if { $op != 0 } {
      lappend result $op
    }
  }
}

proc GetCalledOperations { triggeredBy timing context server agentParameters } { 
  upvar 1 $agentParameters ap
  global result

  if {![u2::IsKindOf $context "Implementation"]} {
    std::Output "Error: Expected model context is an Implementation (e.g. an OperationBody).\n"
    return
  }

  u2::MetaVisit $context CollectCalledOperations

  # Note that in case just one entity was found we must add an additional NULL entry to
  # make sure Tcl will interpret the result as a list (as opposed to one single result entity).
  if { [llength $result] > 0 } {
    set result [concat $result 0]
  }

  set $ap [lset ap 0 $result] 
}

