proc OnEnableGetTimeStamp {Ident} {
    set sel [std::GetSelection]
    
    if {[llength $sel] != 1} {
        return 0
    }

    if { ([GetKind $sel] == "U2") && [u2::IsKindOf $sel "Element"] } {
	return 1
    }

    return 0
}

proc OnActivateGetTimeStamp { command } {
    set sel [std::GetSelection]

    if { $sel == 0} {
      return
    }

    # Find the GetTimeStamp agent by looking up its Guid
    set agent [u2::FindByGuid [u2::GetModel $sel ] "FiYEOE3dS*5LzhhaFLBQrWzL"]
    if {$agent != 0} {
        u2::InvokeAgent [u2::GetModel $sel ] $agent $sel
    }
}

###########################################
# Declaration and registration of commands
###########################################
package require commands

Declare addcommand -variable cmdGetTimeStamp -name "Get Timestamp for selection" -statusmessage "Prints the timestamp for the selected entity in the Messages tab." -tooltip "" -accelerator "" -onactivatecommand OnActivateGetTimeStamp -onenablecommand OnEnableGetTimeStamp

AddCommand cmdGetTimeStamp

AddMenu -variable mnuTimeStamp -commands { separator cmdGetTimeStamp } -path {&Tools} -position {last}

u2::LoadLibrary "urn:u2useraddins:TimeStamp/Etc/TimeStamp.u2"
