// CalculatorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CalculatorGUI.h"
#include "CalculatorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalculatorDlg dialog


CCalculatorDlg::CCalculatorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalculatorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalculatorDlg)
	m_DigitField = _T("0");
	//}}AFX_DATA_INIT
}


void CCalculatorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalculatorDlg)
	DDX_Text(pDX, IDC_DIGITFIELD, m_DigitField);
	//}}AFX_DATA_MAP
}

bool CCalculatorDlg::receive(tor::Event* e) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());

    if (Displayer::Run_Dispatcher_KeypadEventHandler* pRunSignal = tor::cast<Displayer::Run_Dispatcher_KeypadEventHandler*>(e)) {
	// Popup the dialog
	m_pDispatcher = pRunSignal->d;
	m_pKeypadEventHandler = pRunSignal->keh;
	int status = DoModal();
	return true;	
    }
    else if (Displayer::Display_Charstring* pDisplaySignal = tor::cast<Displayer::Display_Charstring*>(e)) {
	// Display a new value in the digit field
	tor::Charstring str = pDisplaySignal->s;
	m_DigitField = str;
	UpdateData(FALSE);
    }

    return false; // Didn't handle the event
}


BEGIN_MESSAGE_MAP(CCalculatorDlg, CDialog)
	//{{AFX_MSG_MAP(CCalculatorDlg)
	ON_BN_CLICKED(IDC_DIGIT0, OnDigit0)
	ON_BN_CLICKED(IDC_DIGIT1, OnDigit1)
	ON_BN_CLICKED(IDC_DIGIT2, OnDigit2)
	ON_BN_CLICKED(IDC_DIGIT3, OnDigit3)
	ON_BN_CLICKED(IDC_DIGIT4, OnDigit4)
	ON_BN_CLICKED(IDC_DIGIT5, OnDigit5)
	ON_BN_CLICKED(IDC_DIGIT6, OnDigit6)
	ON_BN_CLICKED(IDC_DIGIT7, OnDigit7)
	ON_BN_CLICKED(IDC_DIGIT8, OnDigit8)
	ON_BN_CLICKED(IDC_DIGIT9, OnDigit9)
	ON_BN_CLICKED(IDC_EQUAL, OnEqual)
	ON_BN_CLICKED(IDC_SUB, OnSub)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalculatorDlg message handlers

void CCalculatorDlg::OnDigit0() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(0), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit1() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(1), m_pKeypadEventHandler);
    m_pDispatcher->run();	
}

void CCalculatorDlg::OnDigit2() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(2), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit3() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(3), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit4() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(4), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit5() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(5), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit6() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(6), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit7() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(7), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit8() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(8), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnDigit9() 
{
    tor::sendTo(new KeypadEventHandler::Digit_Natural(9), m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnEqual() 
{
    tor::sendTo(new KeypadEventHandler::Equals, m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnSub() 
{
    tor::sendTo(new KeypadEventHandler::Subtraction, m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnAdd() 
{
    tor::sendTo(new KeypadEventHandler::Addition, m_pKeypadEventHandler);
    m_pDispatcher->run();
}

void CCalculatorDlg::OnClear() 
{
    tor::sendTo(new KeypadEventHandler::Clear, m_pKeypadEventHandler);
    m_pDispatcher->run();	
}
