proc CollectClasses { cls } {  
    if { [u2::IsKindOf $cls "Class"] } {    
        global classes
        lappend classes $cls
    }
} 

proc GenerateCopyMethods { triggeredBy timing context server agentParameters } {  
    upvar 1 $agentParameters ap  
    set messageList [lindex $ap 0]  
    set roots [lindex $ap 2]  
    set model [lindex $ap 3]  
    foreach r $roots {    
        if { $r == 0} {
            continue
        }

        u2::MetaVisit $r CollectClasses
        
        global classes
        foreach cls $classes {
            ## Generate copy constructor
            set className [u2::GetValue $cls "Name"]
            set originalClass [u2::FindByGuid $model [u2::GetValue $cls Guid] ]
            set copyConstructorSyntax "public void 'initialize' ( $className otherBean )\{"
            set copyMethodSyntax "public void copy( $className otherBean )\{if (otherBean != null)\{"

            set attributes [u2::GetEntities $cls "Attribute"]
            if {[llength $attributes] > 0 } {
                append copyConstructorSyntax "'this'("
                set first 1
                foreach att $attributes {
                    set getterName "get[string toupper [u2::GetValue $att Name] 0 0]"
                    set setterName "set[string toupper [u2::GetValue $att Name] 0 0]"
                    if {$first != 1} {
                        append copyConstructorSyntax ", "
                    }
                    set first 0
                    append copyConstructorSyntax "otherBean. $getterName ()"
                    append copyMethodSyntax "this. $setterName ( otherBean . $getterName ());"
                }
                append copyConstructorSyntax ");"
            }
            append copyConstructorSyntax "\}"
            append copyMethodSyntax "\}\}"

            set constructor [lindex [u2::Parse $model $copyConstructorSyntax] 0]
            u2::SetEntity $cls "OwnedMember" $constructor

            set copyMethod [lindex [u2::Parse $model $copyMethodSyntax] 0]
            u2::SetEntity $cls "OwnedMember" $copyMethod

            u2::AddMessage $messageList "Added copy constructor and copy method for class" Information -subject $originalClass
        }
    }               
}