proc CollectSerializableClasses { cls } {  
    if { [u2::IsKindOf $cls "Class"] && [u2::HasAppliedStereotype $cls "serializable"] } {    
        global serializableClasses
        lappend serializableClasses $cls
    }
} 


proc HandleSerializable { triggeredBy timing context server agentParameters } {  
    upvar 1 $agentParameters ap  
    set messageList [lindex $ap 0]  
    set roots [lindex $ap 2]  
    set model [lindex $ap 3]  
    foreach r $roots {    
        if { $r == 0} {
            continue
        }

        u2::MetaVisit $r CollectSerializableClasses

        global serializableClasses
        foreach cls $serializableClasses {
            set originalClass [u2::FindByGuid $model [u2::GetValue $cls Guid] ]

            ## Add inheritance to java.io.Serializable

            set gen [u2::Create $cls "Generalization"]
            u2::SetValue $gen "Parent" "ref:java::io::Serializable"
            set implementsStereotype [u2::FindByGuid $model "@Java@implements"]
            u2::ApplyStereotype $gen $implementsStereotype GUID

            ## Add serialVersionUID attribute
            set uid [u2::GetTaggedValue $cls "serializable (. uid .)"]
            set uid_val [u2::GetValue $uid "Value"]
            set att [u2::Parse $model "private static const long serialVersionUID = '$uid_val';"]
            u2::SetEntity $cls "OwnedMember" $att

            u2::AddMessage $messageList "Transformed serializable class" Information -subject $originalClass
        }
    }               
}
