/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
// ITtdModelAccess interface
// -------------------------

#ifndef ITTDMODELACCESS_H
#define ITTDMODELACCESS_H

#include "TauAPICommon.h"

namespace u2dll {
    class Cu2Entity;
    class Cu2Resource;
    class Cu2PresentationElement;
    class Cu2Symbol;
    class Cu2Session;    
}

namespace u2 {
    class ITtdModel; class _ITtdModel;
    class ITtdEntity; class _ITtdEntity;
    class ITtdResource; class _ITtdResource;
    class ITtdPresentationElement; class _ITtdPresentationElement;
    class ITtdSymbol; class _ITtdSymbol;
    class ITtdMessageList;

    // Interface to a singleton object serving with various functions for getting access
    // to a TAU UML2 model (either by loading one from file, creating a new model, or from an already loaded project).
    class _CU2_EXT_DATA ITtdModelAccess : public IUnknown 
    {
    public:
        // Loads the project stored in the specified project file (or URI).
        // If the project file does not exist, or a load error occurs, an APIError will be thrown.
        // By default the loaded model will be bound, but that can be avoided by setting bBind to false.
        // Note that the function only fails in case of load errors, not binding errors.
        // If a message list is provided all messages that are produced during loading and binding will be added to it.
        // The message list expected by this function can be obtained by calling GetMessageList()
        virtual ITtdModel* LoadProject(const tstring& strProject, bool bBind = true, ITtdMessageList* pMessages = 0) throw(APIError) = 0;

        // Loads the specified .u2 file (or URI).
        // If the file does not exist, or a load error occurs, an APIError will be thrown.
        // If bLibrary is true, the file will be loaded as a library.
        virtual ITtdModel* LoadFile(const tstring& strFile, bool bLibrary = false) throw(APIError) = 0;

        // Creates a new empty model. An APIError will be thrown if creation fails.
        virtual ITtdModel* CreateModel() throw(u2::APIError) = 0;

        // Returns the number of projects (i.e. models) that are currently available in
        // the open workspace.
        // If this function is used when the IDE is not available, an APIError will be thrown.
        virtual long GetProjectCount() throw(APIError) = 0;

        // Returns the index:th project (i.e. model) in the open workspace.
        // If the index is out of range, or if this function is used when the IDE is not available, 
        // an APIError will be thrown.
        virtual ITtdModel* GetProjectItem(long index) throw(APIError) = 0;

        // Returns the project (i.e. model) that is currently active in the open workspace.
        // If this function is used when the IDE is not available, an APIError will be thrown.
        virtual ITtdModel* GetActiveProject() throw(APIError) = 0;

        // Writes a message to the default message area (typically to stdout in a batch environment,
        // or to the Message tab in the IDE).
        virtual void WriteMessage(const tstring& strMessage) throw(APIError) = 0;

        // Requests a license for the specified feature. If successful, the license is taken.
        // If not, an APIError will be thrown.
        virtual void GetLicense(const tstring& strFeature) throw(APIError) = 0;

        // Creates and returns a new message list.
        // The caller is responsible for deleting the returned message list when it won't be used anymore.
        virtual ITtdMessageList* GetMessageList() = 0;

        // Returns a default message list appropriate for using in the current execution environment.
        // For example, in the context of a code generator the returned message list is mapped to the build log.
        virtual ITtdMessageList* GetDefaultMessageList() = 0;

        // Wrapper interface access
        virtual _ITtdEntity* GetWrapperInterface(u2dll::Cu2Entity* pEntity) = 0;
        virtual const _ITtdEntity* GetWrapperInterface(const u2dll::Cu2Entity* pEntity) = 0;
        virtual _ITtdModel* GetWrapperInterface(u2dll::Cu2Session* pSession) = 0;
        virtual const _ITtdModel* GetWrapperInterface(const u2dll::Cu2Session* pSession) = 0;
        virtual _ITtdResource* GetWrapperInterface(u2dll::Cu2Resource* pResource) = 0;
        virtual const _ITtdResource* GetWrapperInterface(const u2dll::Cu2Resource* pResource) = 0;
        virtual _ITtdPresentationElement* GetWrapperInterface(u2dll::Cu2PresentationElement* pPresentationElement) = 0;
        virtual const _ITtdPresentationElement* GetWrapperInterface(const u2dll::Cu2PresentationElement* pPresentationElement) = 0;
        virtual _ITtdSymbol* GetWrapperInterface(u2dll::Cu2Symbol* pSymbol) = 0;
        virtual const _ITtdSymbol* GetWrapperInterface(const u2dll::Cu2Symbol* pSymbol) = 0;

        static const GUID guid;
    };
}

#endif // ITTDMODELACCESS_H
