/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
// IBM Rational Tau Access C++ API
// ----------------------------
// Include this file and link with corresponding library to access 
// a running Tau application.

#ifndef TAUACCESS_H
#define TAUACCESS_H

#include <list>

#ifdef WIN32
#ifndef _TAU_ACCESS_EXT_DATA
#define _TAU_ACCESS_EXT_DATA __declspec(dllimport)
#endif
#else
#ifndef _TAU_ACCESS_EXT_DATA
#define _TAU_ACCESS_EXT_DATA
#endif 
#endif


#ifdef _MSC_VER 
#pragma warning(push)
#pragma warning(disable: 4290)	// __declspec(nothrow)
#endif

#include "TauAPICommon.h"

namespace u2
{
#ifdef _MSC_VER
    typedef unsigned long PID; 
#else
    typedef pid_t PID;
#endif

    class ITtdStudioAccess;

    class _TAU_ACCESS_EXT_DATA ITtdTauAccess
    {
    public:
        // Get the list of Tau applications currently running on the machine.
        // If a problem appears while accessing this list, an APIError will be thrown.
        virtual void GetRunningTauApplications(std::list<ITtdStudioAccess*>& instances) throw (u2::APIError) = 0;

        // Get the list of Tau applications currently running on the machine and that are using ports in range [portRangeBegin,portRangeEnd].
        // If a problem appears while accessing this list, an APIError will be thrown.
        virtual void GetRunningTauApplicationsInRange(std::list<ITtdStudioAccess*>& instances, unsigned int portRangeBegin, unsigned int portRangeEnd) throw (u2::APIError) = 0;

        // Start a new Tau application on the machine.
        // If Tau cannot be started an APIError will be thrown.
        virtual ITtdStudioAccess* StartNewTauApplication() throw (u2::APIError) = 0;

        // Get the Tau application with the specified PID.
        // Returns NULL if a Tau application with that PID isn't running on the machine.
        virtual ITtdStudioAccess* GetTauApplicationWithPID(PID pid) = 0;

        // Get the Tau application that is running on the specified network location.
        // Returns NULL is no Tau application is running at the specified location.
        virtual ITtdStudioAccess* GetTauApplicationAtNetworkLocation(const tstring& host, unsigned int port) = 0;
    };

    // Returns an object realizing the ITtdTauAccess interface.
    _TAU_ACCESS_EXT_DATA ITtdTauAccess* GetTauAccess();

    // Initializes the TauAccess API. This should be done before starting to use it - otherwise some parts
    // of the API will not be working as expected.
    _TAU_ACCESS_EXT_DATA void InitializeTauAccess() throw(u2::APIError);

    // Finalizes the TauAccess API. This should be done after having completed the use of the API.
    _TAU_ACCESS_EXT_DATA void FinalizeTauAccess();

}

#endif // TAUACCESS_H
