/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
// IBM Rational TAU Agent C++ API
// ---------------------------
// Use this header file together with the library U2DLLU.lib
// of the TAU Developer installation.

#ifndef U2AGENT_H
#define U2AGENT_H

#include "TauAPICommon.h"

namespace u2 {
    class ITtdEntity;
    class IUnknown;
    class ITtdMessageList;
}

namespace u2dll {
    class Cu2Changer;
}

#include <string>
#include <list>

#ifdef WIN32
#ifndef _CU2_EXT_DATA
#define _CU2_EXT_DATA __declspec(dllimport)
#endif
#else
#ifndef _CU2_EXT_DATA
#define _CU2_EXT_DATA
#endif 
#endif

#define AGENT_PARAMETERS const u2::ITtdEntity* pTriggeredBy, u2::EventTiming timing, u2::ITtdEntity* pContext, u2::IUnknown* pServer, u2::AgentParameters& agentParameters, u2dll::Cu2Changer& changer
#define AGENT_SIGNATURE(name) void name(AGENT_PARAMETERS)

#ifdef _MSC_VER 
#pragma warning(push)
#pragma warning(disable: 4275)	// dll export on stl
#pragma warning(disable: 4290)	// __declspec(nothrow)
#pragma warning(disable: 4251)	// class needs to have dll interface
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT 
#endif

// Use this macro to define the implementation of an agent as an exported function.
#define AGENT_IMPL(name) extern "C" DLLEXPORT AGENT_SIGNATURE(name)

namespace u2 {

    // An agent parameter of variant type.
    // Instances of this class should be dynamically allocated by the caller that invokes the agent,
    // and put in an AgentParameters list (see below).
    // In order to access (in/)out parameters after the agent invocation these should be located in the AgentParameter
    // list after the call. Attempts to reuse an AgentParameter allocated before the call, or to allocate an AgentParameter
    // on the caller's stack may give unexpected (even disastrous) results depending on the implementation technology
    // of the agent.
    class _CU2_EXT_DATA AgentParameter {
    public:
        // Parameter types
        enum _String { String };
        enum _UnknownInterface { UnknownInterface };
        enum _EntityList { EntityList, OwnedEntityList }; // OwnedEntityList -> deletion responsibility is passed to the AgentParameter
        enum _Integer { Integer };
        enum _Boolean { Boolean };
        enum _Any { Any };

    protected:
	// Direct construction not allowed for clients. Instead use the Create functions below.
	AgentParameter();

	// Direct deletion not allowed for clients. An agent parameter belongs to an AgentParameters list
	// and should never be deleted by a client.
	virtual ~AgentParameter();

	// Neither do we allow copying or assignment
	AgentParameter& operator= (const AgentParameter& other);
	AgentParameter(const AgentParameter& other);

    public:
        // Construction from various types. 
        // In case of ambiguities, use the optional 'type' parameter to disambiguate.
        // N.B. When the input data won't be copied (see below) it must remain valid throughout
        // the entire lifetime of the agent parameter. For these parameters it is usually best
        // to let the caller of the agent allocate the parameter data.
        static AgentParameter* Create(const tstring& strValue, _String type = String);                       // Copy
        static AgentParameter* Create(const tstring::value_type* pString, _String type = String);            // Copy
        static AgentParameter* Create(const IUnknown* pUnknown, _UnknownInterface type = UnknownInterface);  // No copy
        static AgentParameter* Create(std::list<ITtdEntity*>& entityList, _EntityList type = EntityList);    // No copy
        static AgentParameter* Create(std::list<ITtdEntity*>* pEntityList, _EntityList type = EntityList);   // No copy
        static AgentParameter* Create(long l, _Integer type = Integer);                                      // Copy
        static AgentParameter* Create(bool bBoolean, _Boolean type = Boolean);                               // Copy
        static AgentParameter* Create(void* any, _Any type);                                                 // No copy
        // N.B. The above constructor has no default value for type to avoid unwanted conversions to void*
        // from pointer types on mix-in classes (that do not inherit ITtdEntity!       

        // Functions for setting values of (in/)out parameters.
        // N.B. Setting the value might change the type of the parameter.
        void Set(const tstring& pstrValue, _String type = String);
        void Set(const tstring::value_type* pString, _String type = String);
        void Set(const IUnknown* pUnknown, _UnknownInterface type = UnknownInterface);
        void Set(std::list<ITtdEntity*>& entityList, _EntityList type = EntityList);
        void Set(std::list<ITtdEntity*>* pEntityList, _EntityList type = EntityList);
        void Set(long l, _Integer type = Integer);
        void Set(bool bBoolean, _Boolean type = Boolean);
        void Set(void* any, _Any type);
        // N.B. The above function has no default value for type to avoid unwanted conversions to void*
        // from pointer types on mix-in classes (that do not inherit ITtdEntity!

        typedef int ETypeMismatch; // Exception type (RTTI-free for Unix's sake)

        // Access methods (can also be used as a means for checking the type of a property
        // since they throw ETypeMismatch if actual type does not match requested type).
        virtual const tstring::value_type* GetString() const throw(ETypeMismatch);
	virtual IUnknown* GetUnknownInterface() const throw(ETypeMismatch);
        virtual std::list<ITtdEntity*>& GetEntityList() const throw(ETypeMismatch);
        virtual long GetInteger() const throw(ETypeMismatch);
        virtual bool GetBoolean() const throw(ETypeMismatch);
        virtual void* GetAny() const throw(ETypeMismatch);

    protected:
        AgentParameter* m_pImpl;

	friend class AgentParameters;
    };

    // A list of agent parameters.
    // This list should be allocated on the caller's stack as an automatic variable.
    // An ordinary client should only add agent parameters to the list before an agent is invoked,
    // and extract agent parameters from the list after the agent has been invoked. All other manipulation is reserved for
    // the agent framework exclusively. This policy avoids memory leaks and memory access faults when agent parameters
    // are mapped to data in non-C++ languages.
    // Agent parameters that are added to the list should be dynamically allocated and the responsibility
    // for their deletion belongs to the list.
    class _CU2_EXT_DATA AgentParameters : public std::list<AgentParameter*> 
    {
    public:
	// Delete all owned agent parameters upon destruction!
	~AgentParameters();

        // Deletes all agent parameters from the list.
	// This function should only be used by code in the agent framework. Normal clients should not use it!
        void deleteAll();
    };

    enum EventTiming { before_processing, after_processing }; // Applicable when an agent is triggered by a tool event

    extern _CU2_EXT_DATA AgentParameters noParameters; // default empty list

    // Some utilities for implementing agents

    // Validates actual agent parameters in 'agentParameters' against the definition of the agent.
    // If bReportErrors is true, parameter validation errors are reported in the message list if provided, 
    // otherwise to the default message output stream.
    // Returns true if the number and type of the actual agent parameters match the formal agent parameters defined for pAgent,
    // otherwise false.
    _CU2_EXT_DATA bool ValidateAgentActualParameters(const ITtdEntity* pAgent, AgentParameters& agentParameters, bool bReportErrors, 
                                                     ITtdMessageList* pMessageList = 0);

    // This is a helper usable for implementors of query agents. It extracts the expected result list 
    // parameter from the specified list of agent parameters. In case no such result list can be obtained, 
    // NULL is returned.
    _CU2_EXT_DATA std::list<ITtdEntity*>* GetQueryResultParameter(AgentParameters& agentParameters);

    // This is a helper usable for implementors of predicate agents. It extracts the expected boolean result
    // parameter from the specified list of agent parameters. In case no such result parameter can be obtained, 
    // NULL is returned.
    _CU2_EXT_DATA AgentParameter* GetPredicateResultParameter(AgentParameters& agentParameters);

    // This is a helper usable when agent parameters have been textually specified in U2 call syntax. By parsing
    // such a text with the U2 Expression parser and passing the resulting call expression to this function as 'pCallExpr'
    // the 'pars' list will be populated by agent parameters of a type corresponding to the kind of actual arguments
    // in the call expression.
    // If the translation succeeds NULL is returned. Otherwise the expression that failed to be translated
    // into an agent parameter will be returned. The typical cause for such an error is that the kind of U2
    // expression cannot be represented as an agent parameter. In that case 'pars' will only contain agent parameters
    // for expressions up to the point when the offending expression was detected.
    // If available 'pAgent' should be the agent intended to be called.
    _CU2_EXT_DATA ITtdEntity* TranslateCallArgsToAgentParameters(const ITtdEntity* pCallExpr, AgentParameters& pars, const u2::ITtdEntity* pAgent = 0);
}

#ifdef _MSC_VER 
#pragma warning(pop)
#endif

#endif // U2AGENT_H

