/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
// IBM Rational TAU Model Access C++ API
// ----------------------------------
// Include this file to access a TAU Developer UML2 model
// from your C++ application. Link with U2DLLU.lib from
// the TTD installation bin directory.

#ifndef U2MODELACCESS_H
#define U2MODELACCESS_H

#include <list>
#include "TauAPICommon.h"

#ifdef WIN32
#ifndef _CU2_EXT_DATA
#define _CU2_EXT_DATA __declspec(dllimport)
#endif
#else
#ifndef _CU2_EXT_DATA
#define _CU2_EXT_DATA
#endif 
#endif

#ifdef _MSC_VER 
#pragma warning(push)
#pragma warning(disable: 4290)	// __declspec(nothrow)
#pragma warning(disable: 4251)	// class needs to have dll interface
#endif

#include "TtdModelAccess.h"

namespace u2dll {
    class CeMetaFeature;
    class CeMetaClass;
    class Cu2Entity;
    class Cu2Expression;
    class Cu2Session;
    class Cu2Ident;
    class Cu2Resource;
}

namespace u2 {
    class _ITtdEntity;
    class _ITtdModel;
    class _ITtdResource;
    class _ITtdPresentationElement;
    class _ITtdSymbol;
}

// C++ API for UML2 model access. This class realizes the ITtdModelAccess interface.
// In addition it also provides a number of static functions, that provide functionality
// that is more or less a strict subset of the interface-based API.

class _CU2_EXT_DATA Cu2ModelAccess : public u2::IRefCountedImpl_NoRefCount<u2::ITtdModelAccess> 
{
public:
    // IUnknown implementation
    virtual void QueryInterface(const u2::GUID& g, void** ppObject);
    virtual inline void* GetImplementingObject() { return 0; }
    virtual inline const void* GetImplementingObject() const { return 0; }

    // ITtdModelAccess interface implementation
    virtual u2::ITtdModel* LoadProject(const tstring& strProject, bool bBind = true, u2::ITtdMessageList* pMessages = 0) throw(u2::APIError);
    virtual u2::ITtdModel* LoadFile(const tstring& strFile, bool bLibrary = false) throw(u2::APIError);
    virtual u2::ITtdModel* CreateModel() throw(u2::APIError);
    virtual long GetProjectCount() throw(u2::APIError);
    virtual u2::ITtdModel* GetProjectItem(long index) throw(u2::APIError);
    virtual u2::ITtdModel* GetActiveProject() throw(u2::APIError);
    virtual void WriteMessage(const tstring& strMessage) throw(u2::APIError);
    virtual void GetLicense(const tstring& strFeature) throw(u2::APIError);
    virtual u2::ITtdMessageList* GetMessageList();
    virtual u2::ITtdMessageList* GetDefaultMessageList();

    virtual u2::_ITtdEntity* GetWrapperInterface(u2dll::Cu2Entity* pEntity);
    virtual const u2::_ITtdEntity* GetWrapperInterface(const u2dll::Cu2Entity* pEntity);
    virtual u2::_ITtdModel* GetWrapperInterface(u2dll::Cu2Session* pSession);
    virtual const u2::_ITtdModel* GetWrapperInterface(const u2dll::Cu2Session* pSession);
    virtual u2::_ITtdResource* GetWrapperInterface(u2dll::Cu2Resource* pResource);
    virtual const u2::_ITtdResource* GetWrapperInterface(const u2dll::Cu2Resource* pResource);
    virtual u2::_ITtdPresentationElement* GetWrapperInterface(u2dll::Cu2PresentationElement* pPresentationElement);
    virtual const u2::_ITtdPresentationElement* GetWrapperInterface(const u2dll::Cu2PresentationElement* pPresentationElement);
    virtual u2::_ITtdSymbol* GetWrapperInterface(u2dll::Cu2Symbol* pSymbol);
    virtual const u2::_ITtdSymbol* GetWrapperInterface(const u2dll::Cu2Symbol* pSymbol);


    /////////////////////////////////////////////////////////////////////
    /////////////////////////R E A D   A P I/////////////////////////////
    /////////////////////////////////////////////////////////////////////

    // Get family of functions: Gets the value of the metafeature for pEntity.
    // The obtained value can be of different types; please use the correct overload below depending on
    // the type.
    // If no metafeature has the specified name, a u2::APIError exception will be thrown.

    // This version encodes the value as a string. Use it for metafeatures with single or multiple
    // multiplicity. In the case of multiple multiplicity use the index to specify which entity to get.
    // The value of metafeatures of non-value type is the string encoding of the untyped link
    // that represents the metafeature internally. In that case, the metafeature must not
    // be derived or an ownerlink (since such metafeatures have no internal representation that can
    // be encoded as a string).
    // N.B. index is an index starting at 1, and E_POSITION_END (==0) always specifies the last entity
    static void Get(const u2::ITtdEntity* pEntity, const tstring& strMetaFeature, tstring& strValue,
        u2dll::eposition index = E_POSITION_END) throw(u2::APIError);

    // As above, but with metafeature pointer instead of name.
    static void Get(const u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature, tstring& strValue,
        u2dll::eposition index = E_POSITION_END) throw(u2::APIError);

    // This version returns the value as a pointer to an entity. Use it for metafeatures of metaclass 
    // type that have either single or multiple multiplicity. In the case of multiple multiplicity
    // use the index to specify which entity to get.
    // N.B. If the metafeature is unbound, pValue will be NULL. You may then want to use the above Get 
    // function to get the value as a string representation instead, or GetReference to obtain the
    // representation of the reference.
    // N.B. index is an index starting at 1, and E_POSITION_END (==0) always specifies the last entity
    static void Get(const u2::ITtdEntity* pEntity, const tstring& strMetaFeature, u2::ITtdEntity*& pValue,
        u2dll::eposition index = E_POSITION_END) throw(u2::APIError);

    // As above, but with metafeature pointer instead of name.
    static void Get(const u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature, u2::ITtdEntity*& pValue,
        u2dll::eposition index = E_POSITION_END) throw(u2::APIError);

    // This version returns the value as a list of entity pointers. Use it for metafeatures of metaclass 
    // type that have either single or multiple multiplicity.
    // N.B. listValue may contain NULL entries as a result of individual unbound untyped links within
    // the metafeature. This, however, guarantees that the position of each result in the list
    // is the original position in the metafeature. 
    static void Get(const u2::ITtdEntity* pEntity, const tstring& strMetaFeature, 
        std::list<u2::ITtdEntity*>& listValue) throw(u2::APIError);

    // As above, but with metafeature pointer instead of name.
    static void Get(const u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature, 
        std::list<u2::ITtdEntity*>& listValue) throw(u2::APIError);

    // Returns the identifier representation of a metafeature reference. In the case of multiple 
    // multiplicity use the index to specify which entity to get.    
    // N.B. index is an index starting at 1, and E_POSITION_END (==0) always specifies the last entity
    static u2dll::Cu2Ident* GetReference(const u2::ITtdEntity* pEntity, const tstring& strMetaFeature,
        u2dll::eposition index = E_POSITION_END) throw(u2::APIError);

    // As above, but with metafeature pointer instead of name.
    static u2dll::Cu2Ident* GetReference(const u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature,
        u2dll::eposition index = E_POSITION_END) throw(u2::APIError);

    // Returns the composition owner of pEntity. If pEntity has no owner NULL is returned.
    static u2::ITtdEntity* GetOwner(const u2::ITtdEntity* pEntity);

    // Finds the name of the metaclass of pEntity and puts it in strMetaClassName.
    static void GetMetaClassName(const u2::ITtdEntity* pEntity, tstring& strMetaClassName);

    // Finds the metaclass with the specified name.
    // If no metaclass has the specified name, a u2::APIError exception will be thrown.
    static const u2dll::CeMetaClass* GetMetaClass(const tstring& strMetaClassName) throw(u2::APIError);

    // Finds out what entities that refer to pEntity through the given metafeature.
    // A pointer to these refering entities will be put in the list.
    static void GetReferingEntities(const u2::ITtdEntity* pEntity, const tstring& strMetaFeature,
        std::list<u2::ITtdEntity*>& listReferee);

    // As above, but with metafeature pointer instead of name.
    static void GetReferingEntities(const u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature,
        std::list<u2::ITtdEntity*>& listReferee);

    // Returns the expression representing the tagged value selected by the selector for pEntity.
    // pEntity should be either an element (in which case the tagged value is looked for among the
    // applied stereotype instances of the element) or an instance expression (in which case the tagged
    // value is looked for in that particular instance only).
    // A selector is a pattern specifying the path from pEntity to the tagged value using the textual
    // U2 syntax of an instance expression. 
    // The function will check that the pattern matches both the instance tree (by structure) and the 
    // corresponding signatures (by name or GUID).
    // If bIdentsAreGuids is true, identifiers of the pattern will be interpreted as GUIDs. Otherwise
    // they will be interpreted as names.
    // If no tagged value is selected by the selector pattern, NULL is returned.
    //
    // Some selector pattern examples: 
    // "T1 (. .)"                  will return the first instance of the applied T1 stereotype
    // "T1 (. x .)"                will return the tagged value of the attribute x in the T1 stereotype
    // "T1 (. a1 = T2 (. a2 .) .)" will return the value of a2 in a T2 instance being the value of T1.a1.
    static u2dll::Cu2Expression* GetTaggedValue(const u2::ITtdEntity* pEntity, const tstring& strSelector,
        bool bIdentsAreGuids = false);

    // Returns true if pEntity is of the specified kind, i.e. if it is an instance of the 
    // metaclass or of one of its subclasses.
    static bool IsKindOf(const u2::ITtdEntity* pEntity, const tstring& strMetaClassName);

    // Finds the entity with the given GUID. If no matching entity is found
    // NULL will be returned.
    static u2::ITtdEntity* FindByGuid(const u2::ITtdModel* pSession, const tstring& strGuid);

    // Puts the XML encoding of pEntity in strXMLEncoding. If an error occurs, a u2::APIError
    // exception will be thrown.
    static void XMLEncode(const u2::ITtdEntity* pEntity, tstring& strXMLEncoding) throw(u2::APIError);

    /////////////////////////////////////////////////////////////////////
    /////////////////////////W R I T E   A P I///////////////////////////
    /////////////////////////////////////////////////////////////////////

    // Decodes strXMLEncoding into entities that will be put in the entities list. If an error occurs, a 
    // u2::APIError exception will be thrown.
    static void XMLDecode(const tstring& strXMLEncoding, std::list<u2::ITtdEntity*>& entities) throw(u2::APIError);

    // Set family of functions: Sets the value of the metafeature for pEntity.
    // If the function fails a u2::APIError exception will be thrown.
    // The value to set can be of different types; please use the correct overload below depending on
    // the type.
    // The model modification is performed by using a changer.

    // This version takes the value encoded as a string. Use it for all writable metafeatures.
    // The value of metafeatures of non-value type should be the string encoding of the untyped link
    // that represents the metafeature internally. In that case, the metafeature must not
    // be an ownerlink (since such a metafeature has no internal representation that can
    // be encoded as a string).
    // If the metafeature has non-single multiplicity, the insertPos argument can be used to insert
    // the value before the value at the specified position.
    static void Set(u2::ITtdEntity* pEntity, const tstring& strMetaFeature, const tstring& strValue,
        u2dll::Cu2Changer& changer = u2dll::defaultChanger, 
        u2dll::eposition insertPos = E_POSITION_END) throw(u2::APIError);

    // As above, but with metafeature pointer instead of name.
    static void Set(u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature, const tstring& strValue,
        u2dll::Cu2Changer& changer = u2dll::defaultChanger, 
        u2dll::eposition insertPos = E_POSITION_END) throw(u2::APIError);

    // This version takes the value as a pointer to an entity. Use it for all writable metafeatures of metaclass type.
    // N.B. If pValue is NULL, the metafeature will be made unbound (doesn't apply for owner links).
    // If the metafeature has non-single multiplicity, the insertPos argument can be used to insert
    // the value before the value at the specified position.
    static void Set(u2::ITtdEntity* pEntity, const tstring& strMetaFeature, const u2::ITtdEntity* pValue,
        u2dll::Cu2Changer& changer = u2dll::defaultChanger, u2dll::eposition insertPos = E_POSITION_END) throw(u2::APIError);

    // As above, but with metafeature pointer instead of name.
    static void Set(u2::ITtdEntity* pEntity, const u2dll::CeMetaFeature* pMetaFeature, const u2::ITtdEntity* pValue,
        u2dll::Cu2Changer& changer = u2dll::defaultChanger, u2dll::eposition insertPos = E_POSITION_END) throw(u2::APIError);

    // Sets the tagged value of the attribute selected by the selector pattern. See GetTaggedValue
    // for the format of this pattern. pEntity can either be an element with applied stereotypes
    // or any instance expression. In the latter case the pattern is matched against the instance
    // expression, while in the former case the first matching applied stereotype instance will
    // be used.
    // By default an existing value for the selected attribute will be overwritten, but if 
    // bOverwrite is false this will not be the case.
    // The model modification is performed by using the changer.
    // Note that, in order to be able to overwrite an existing value for the specified attribute, the
    // instance expression must be bound to the Signature of which it is an instance.
    // If that is not the case, a u2::APIError exception will be thrown.
    // After the new value has been set all references in pEntity is attempted to be bound,
    // so that the set value can be accessed by GetTaggedValue directly after the call to this 
    // function.
    static void SetTaggedValue(u2::ITtdEntity* pEntity, const tstring& strSelector,
        const tstring& strValue, u2dll::Cu2Changer& changer = u2dll::defaultChanger, bool bOverwrite = true) throw(u2::APIError);

    // Creates an instance of the metaclass with the specified name. If the creation fails
    // a u2::APIError exception will be thrown.
    static u2::ITtdEntity* New(const tstring& strMetaClass) throw(u2::APIError);

    // As above, but with metaclass pointer instead of name.
    static u2::ITtdEntity* New(const u2dll::CeMetaClass* pMetaClass) throw(u2::APIError);

    // Deletes pEntity. The model modification is made by the changer.
    static void Delete(u2::ITtdEntity* pEntity, u2dll::Cu2Changer& changer = u2dll::defaultChanger);

    // Binds the metafeature of pEntity. If no metafeature of pEntity has the specified name, 
    // a u2::APIError exception will be thrown.
    static void Bind(u2::ITtdEntity* pEntity, const tstring& strMetaFeature) throw(u2::APIError);

    // Binds pEntity (all of its metafeatures) and all entities directly or indirectly owned by pEntity.
    static void Bind(u2::ITtdEntity* pEntity);

    // Loads the U2 data file specified by strFileName into the given Session.
    // If the file is loaded then its Resource is returned.
    // If the file cannot be loaded, a u2::APIError will be thrown.
    static u2::ITtdResource* LoadFile(u2::ITtdModel* pSession, const tstring& strFileName, bool bProfile,
        u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(u2::APIError);
};

namespace u2 {
    // Initializes the ModelAccess API. This should be done before starting to use it - otherwise some parts
    // of the API will not be working as expected.
    _CU2_EXT_DATA void InitializeModelAccess() throw(u2::APIError);

    // Finalizes the ModelAccess API. This should be done after having completed the use of the API.
    _CU2_EXT_DATA void FinalizeModelAccess() throw(u2::APIError);

    // Returns an object realizing the ITtdModelAccess interface. Which object that is returned depends
    // on the execution environment (batch or GUI).
    _CU2_EXT_DATA ITtdModelAccess* GetModelAccess();

}

#ifdef _MSC_VER 
#pragma warning(pop)
#endif

#endif /* U2MODELACCESS_H */

