#! /bin/sh
#

# Set MWARCH correctly

setupmwarch () {

case `uname` in

  SunOS) case `uname -m` in
    sun4*)
    # Try to auto-detect 64 or 32-bit version
    # If there is 64-bit perl but no 32-bit, this is 64-bit version.
    if [ ! -x "$MWHOME/bin-sparc_sunos5/mwperl" -a \
           -x "$MWHOME/bin-sparcv9_sunos5/mwperl" ]; then
      MW64BIT=1 export MW64BIT
    fi
    if [ ! -z "${MW64BIT:-}" ]; then
      MWARCH=sparcv9
    else
      MWARCH=sparc
    fi
    ;;
    i86pc) if [ ! -z "${MW64BIT:-}" ]; then
      MWARCH=amd64
    else
      MWARCH=i86
    fi
    ;;
    *)     echo "Machine under sunos must be sparc Solaris" 1>&2
  esac;;

  HP-UX) case `uname -r` in
    [AB].11*) case `uname -m` in
      9000/[78]*) MWARCH=hp700;;
      ia64) MWARCH=ia64;;
      *) echo "HP-UX machine must be 9000/700 series" 1>&2
    esac;;
    *) echo "Unknown HP-UX version" 1>&2
  esac;;

  AIX) case `uname -v` in
    4|5) if [ ! -z "${MW64BIT:-}" ]; then
      MWARCH=power64
    else
      MWARCH=rs6000
    fi
    ;;
    *) echo "Unknown version of AIX" 1>&2;;
  esac;;

  Linux) case `arch` in
    i*86) MWARCH=i86;;
    ia64) MWARCH=ia64;;
    s390) MWARCH=s390;;
    x86_64)
      export MW32BIT MW64BIT
      # Try to auto-detect 64 or 32-bit version, if not set explicitly
      # If there is 32-bit perl but no 64-bit, this is 32-bit version.
      if [ ! -z "${MW64BIT:-}" ]; then
	MWARCH=amd64
      elif [ ! -z "${MW32BIT:-}" ]; then
        MWARCH=i86
      elif [ ! -x "$MWHOME/bin-amd64_linux/mwperl" -a \
	       -x "$MWHOME/bin-i86_linux/mwperl" ]; then
	MWARCH=i86
	MW32BIT=1
      else
        MWARCH=amd64
	MW64BIT=1
      fi
      ;;
    *) echo "Unknown Linux architecture";;
  esac;;
  *) echo "Unknown architecture and operating system." 1>&2

esac

MWARCH_OS="${MWARCH}_${MWOS}"

if [ ! -z "${PRINTARCH:-}" ];then
    echo "Architecture for Visual MainWin is ${MWARCH_OS}"
fi

export MWARCH_OS MWARCH
}
